<?php
	if ( defined( 'API_Ops_update_itr' ) ) { return ; }
	define( 'API_Ops_update_itr', true ) ;

	FUNCTION Ops_update_itr_IdleOps( &$dbh )
	{
		global $CONF ; global $VALS ; global $deptinfo ; global $deptid ;
		global $VARS_EXPIRED_OPS ;
		$VARS_MOBILE_EXPIRED_OPS = ( isset( $VALS["MOBILE_EXPIRED_OPS"] ) ) ? $VALS["MOBILE_EXPIRED_OPS"] : 10 ;
		/************************************************/
		// mobile app idle feature inactive at this time.
		/************************************************/
		$VARS_MOBILE_EXPIRED_OPS = 2160 ; // 3 months for now (hours) basically disabled
		$now = time() ; $m = date( "m", $now ) ; $d = date( "j", $now ) ; $y = date( "Y", $now ) ; $hour_now = date( "G", $now ) ;
		$idle = $now - $VARS_EXPIRED_OPS ;
		$idle_mapp = $now - (60*60*$VARS_MOBILE_EXPIRED_OPS) ;

		$query = "SELECT opID, mapp FROM p_operators WHERE ( ( lastactive < $idle AND mapp = 0 ) OR ( lastactive < $idle_mapp AND mapp <> 0 ) ) AND status = 1 AND lastactive <> 0" ;
		database_mysql_query( $dbh, $query ) ;

		if ( $dbh[ 'ok' ] )
		{
			if ( database_mysql_nresults( $dbh ) )
			{
				$operators = Array() ;
				while( $data = database_mysql_fetchrow( $dbh ) ) { $operators[] = $data ; }
				$query = "UPDATE p_operators SET status = 0 WHERE ( ( lastactive < $idle AND mapp = 0 ) OR ( lastactive < $idle_mapp AND mapp <> 0 ) ) AND status = 1 AND lastactive <> 0" ;
				database_mysql_query( $dbh, $query ) ;

				$ops_offline = "" ; // for logging purposes
				for( $c = 0; $c < count( $operators ); ++$c )
				{
					$operator = $operators[$c] ;
					$opid = $operator["opID"] ;
					$ops_offline .= "$opid, " ;

					$query = "INSERT IGNORE INTO p_opstatus_log VALUES( $now, $opid, 0, 0 )" ;
					database_mysql_query( $dbh, $query ) ;
					$query = "UPDATE p_dept_ops SET status = 0 WHERE opID = $opid" ;
					database_mysql_query( $dbh, $query ) ;

					Util_Format_CleanDeptOnline( "", $opid ) ;

					if ( $operator["mapp"] )
					{
						$op_inactive_mapp_processed = false ;
						if ( $operator["mapp"] && !is_file( "$CONF[TYPE_IO_DIR]/{$opid}.mapp" ) )
						{
							$op_inactive_mapp_processed = Util_Format_Mapp_Check( $opid ) ;
						}
						if ( $op_inactive_mapp_processed || is_file( "$CONF[TYPE_IO_DIR]/{$opid}.mapp" ) )
						{
							include_once( "$CONF[DOCUMENT_ROOT]/mapp/API/Util_MAPP.php" ) ;
							Util_MAPP_Publish( $opid, "system", "You are offline.  Mobile app has not been accessed in $VARS_MOBILE_EXPIRED_OPS hours." ) ;
							if ( is_file( "$CONF[TYPE_IO_DIR]/{$opid}.mapp" ) )
								@unlink( "$CONF[TYPE_IO_DIR]/{$opid}.mapp" ) ;
							if ( is_file( "$CONF[TYPE_IO_DIR]/{$opid}_flag.mapp" ) )
								@unlink( "$CONF[TYPE_IO_DIR]/{$opid}_flag.mapp" ) ;
						}
						$query = "UPDATE p_operators SET ses = 'mapp_idle' WHERE opID = $opid" ;
						database_mysql_query( $dbh, $query ) ;
					}
				}
			}
		}
		// process mapp auto offline since console not opened
		$dir_files = glob( $CONF["TYPE_IO_DIR"].'/*.mapp', GLOB_NOSORT ) ;
		$total_dir_files = count( $dir_files ) ; $opids = Array() ;
		if ( $total_dir_files )
		{
			for ( $c = 0; $c < $total_dir_files; ++$c )
			{
				$opid = str_replace( "$CONF[TYPE_IO_DIR]", "", $dir_files[$c] ) ; $opid = preg_replace( "/[\\/]|(.mapp)/", "", $opid ) ;
				if ( !is_numeric( $opid ) ) { $opid = preg_replace( "/_flag/", "", $opid ) ; }
				if ( $opid && is_numeric( $opid ) && !isset( $opids[$opid] ) ) { $opids[$opid] = 1 ; }
			} $total_dir_files = count( $opids ) ;
		}
		if ( $total_dir_files )
		{
			$auto_offline = ( isset( $VALS["AUTO_OFFLINE"] ) && $VALS["AUTO_OFFLINE"] ) ? unserialize( $VALS["AUTO_OFFLINE"] ) : Array() ;
			if ( is_array( $auto_offline ) && count( $auto_offline ) )
			{
				foreach ( $opids as $opid => $null )
				{
					$query = "SELECT * FROM p_dept_ops WHERE opID = $opid" ;
					database_mysql_query( $dbh, $query ) ;
					$op_depts_status_hash = Array() ; $online_counter = $auto_offline_counter = 0 ;
					while ( $data = database_mysql_fetchrow( $dbh ) )
					{
						if ( $data["status"] ) { ++$online_counter ; }
						$op_depts_status_hash[$data["deptID"]] = $data["status"] ;
					}

					foreach ( $auto_offline as $this_deptid => $value )
					{
						if ( isset( $op_depts_status_hash[$this_deptid] ) && $op_depts_status_hash[$this_deptid] && preg_match( "/,/", $auto_offline[$this_deptid] ) )
						{
							LIST( $offline_hour, $offline_min, $offline_duration, $offline_rewind ) = explode( ",", $auto_offline[$this_deptid] ) ;
							if ( $hour_now && ( $hour_now <= $offline_rewind ) ) { $offline_time_start = mktime( $offline_hour, $offline_min, 0, $m, $d-1, $y ) ; }
							else { $offline_time_start = mktime( $offline_hour, $offline_min, 0, $m, $d, $y ) ; }
							$offline_time_end = $offline_time_start + ( 60*60*$offline_duration ) ;
							if ( ( $now >= $offline_time_start ) && ( $now <= $offline_time_end ) )
							{
								++$auto_offline_counter ;
								$query = "UPDATE p_dept_ops SET status = 0 WHERE opID = $opid AND deptID = $this_deptid" ;
								database_mysql_query( $dbh, $query ) ;
							}
						}
					}
					if ( $auto_offline_counter && ( $online_counter == $auto_offline_counter ) )
					{
						$query = "INSERT IGNORE INTO p_opstatus_log VALUES( $now, $opid, 0, 0 )" ;
						database_mysql_query( $dbh, $query ) ;
						$query = "UPDATE p_operators SET status = 0 WHERE opID = $opid" ;
						database_mysql_query( $dbh, $query ) ;
						if ( is_file( "$CONF[TYPE_IO_DIR]/{$opid}_flag.mapp" ) || is_file( "$CONF[TYPE_IO_DIR]/{$opid}.mapp" ) )
						{
							include_once( "$CONF[DOCUMENT_ROOT]/mapp/API/Util_MAPP.php" ) ;
							Util_MAPP_Publish( $opid, "system", "You are offline.  It is past regular chat support hours." ) ;
							if ( is_file( "$CONF[TYPE_IO_DIR]/{$opid}.mapp" ) )
								@unlink( "$CONF[TYPE_IO_DIR]/{$opid}.mapp" ) ;
							if ( is_file( "$CONF[TYPE_IO_DIR]/{$opid}_flag.mapp" ) )
								@unlink( "$CONF[TYPE_IO_DIR]/{$opid}_flag.mapp" ) ;
						}
					}
				}
			}
		} return true ;
	}
?>