<?php
	/***************************************/
	//
	//
	// PHP Live! Support
	//
	// https://www.phplivesupport.com
	//
	/***************************************/
	if ( defined( 'API_Util_Announcements' ) ) { return ; }	
	define( 'API_Util_Announcements', true ) ;

	FUNCTION Util_Announcements_get_Announcements( &$dbh,
					$deptids,
					$status,
					$order_by,
					$limit )
	{
		if ( !is_numeric( $limit ) || !is_numeric( $status ) )
			return Array() ;
		global $now ;

		$dept_string = ( $deptids && preg_match( "/,/", $deptids ) ) ? "AND deptID IN( ".substr_replace( $deptids, "", -1 )." )" : "" ;
		if ( !$order_by ) { $order_by = "display ASC, t_up DESC, created DESC" ; }
	
		LIST( $deptids, $status ) = database_mysql_quote( $dbh, $deptids, $status ) ;

		$status_string = ( $status == -1 ) ? "status IN (0, 1)" : "status = 1" ;

		$query = "SELECT * FROM p_anno_resp WHERE $status_string $dept_string ORDER BY $order_by LIMIT $limit" ;
		database_mysql_query( $dbh, $query ) ;

		$total = 0 ;
		$responses = Array() ;
		if ( $dbh[ 'ok' ] )
		{
			$response_query = "" ;
			while( $data = database_mysql_fetchrow( $dbh ) )
			{
				$responses[] = $data ;
				$response_query .= "$data[respID]," ;
			}
		}
		return $responses ;
	}

	FUNCTION Util_Announcements_get_AnnouncementByID( &$dbh,
					$respid )
	{
		if ( !is_numeric( $respid  ) )
			return false ;
	
		LIST( $respid  ) = database_mysql_quote( $dbh, $respid  ) ;

		$query = "SELECT * FROM p_anno_resp WHERE respID = $respid LIMIT 1" ;
		database_mysql_query( $dbh, $query ) ;

		if ( $dbh[ 'ok' ] )
		{
			$data = database_mysql_fetchrow( $dbh ) ;
			if ( isset( $data["respID"] ) )
				return $data ;
		}
		return false ;
	}

	FUNCTION Util_Announcements_put_Response( &$dbh,
					$respid,
					$deptid,
					$status,
					$display,
					$start_time,
					$end_time,
					$title,
					$message )
	{
		if ( !is_numeric( $respid ) || !is_numeric( $deptid ) || !is_numeric( $status ) || !is_numeric( $display ) || !is_numeric( $start_time ) || !is_numeric( $end_time ) || !$title || !$message )
			return false ;
		global $now ; global $VARS_FREEV ;

		if ( !$respid ) { $respid = "NULL" ; }

		$plain = strip_tags( $message ) ;

		LIST( $respid, $deptid, $status, $display, $start_time, $end_time, $title, $plain, $message ) = database_mysql_quote( $dbh, $respid, $deptid, $status, $display, $start_time, $end_time, $title, $plain, $message ) ;

		$query = "SELECT count(*) AS total FROM p_anno_resp" ;
		database_mysql_query( $dbh, $query ) ;

		if ( $dbh[ 'ok' ] )
		{
			$data = database_mysql_fetchrow( $dbh ) ;
			$total = isset( $data["total"] ) ? $data["total"] : 0 ;
			if ( ( $respid == "NULL" ) && $VARS_FREEV && ( $total >= 3 ) )
				$dbh["error"] = "Max announcements have been reached for the free version." ;
			else if ( ( $respid == "NULL" ) && ( $total >= 50 ) )
				$dbh["error"] = "Max announcements have been reached (50)." ;
			else
			{
				$query = "INSERT INTO p_anno_resp VALUES ( $respid, $now, $status, $start_time, $end_time, $deptid, $display, 0, 0, 0, '$title', '$message' ) ON DUPLICATE KEY UPDATE status = $status, deptID = $deptid, title = '$title', message = '$message'" ;
				database_mysql_query( $dbh, $query ) ;

				if ( $dbh[ 'ok' ] )
				{
					$id = ( $respid && ( $respid != "NULL" ) ) ? $respid : database_mysql_insertid( $dbh ) ;
					return $id ;
				}
			}
		}
		return false ;
	}

	FUNCTION Util_Announcements_update_AnnouncementValues( &$dbh,
					  $respid,
					  $fields )
	{
		if ( !is_numeric( $respid ) || !$respid || !is_array( $fields ) || !count( $fields ) )
			return false ;

		$fields_query = "" ;
		foreach( $fields as $tbl_name => $value )
		{
			LIST( $value ) = database_mysql_quote( $dbh, $value ) ;
			$fields_query .= "$tbl_name = '$value', " ;
		}
		if ( $fields_query )
		{
			$fields_query = substr_replace( $fields_query, "", -2 ) ;
			$query = "UPDATE p_anno_resp SET $fields_query WHERE respID = $respid" ;
			database_mysql_query( $dbh, $query ) ;

			if ( $dbh[ 'ok' ] )
				return true ;
		}
		return false ;
	}

	FUNCTION Util_Announcements_put_Rating( &$dbh,
					$md5_vhash,
					$respid,
					$rating,
					$excluded )
	{
		if ( !$md5_vhash || !is_numeric( $respid ) || !$respid || !is_numeric( $rating ) )
			return false ;
		global $now ;

		LIST( $md5_vhash, $respid, $rating ) = database_mysql_quote( $dbh, $md5_vhash, $respid, $rating ) ;

		$query = "INSERT IGNORE INTO p_anno_rlog VALUES( '$md5_vhash', $now )" ;
		database_mysql_query( $dbh, $query ) ;

		if ( $dbh[ 'ok' ] )
		{
			$result = database_mysql_nresults( $dbh ) ;
			if ( $result && !$excluded )
			{
				$rating_query = ( $rating ) ? "t_up = t_up + 1" : "t_down = t_down + 1" ;
				$query = "UPDATE p_anno_resp SET $rating_query WHERE respID = $respid" ;
				database_mysql_query( $dbh, $query ) ;
			}

			$expired = $now - 60*60*24*180 ; // 6 months
			$query = "DELETE FROM p_anno_rlog WHERE created < $expired" ;
			database_mysql_query( $dbh, $query ) ;

			return true ;
		}
		return false ;
	}

	FUNCTION Util_Announcements_put_Clicked( &$dbh,
					$respid )
	{
		if ( !is_numeric( $respid ) || !$respid )
			return false ;

		LIST( $respid ) = database_mysql_quote( $dbh, $respid ) ;

		$query = "UPDATE p_anno_resp SET t_clicks = t_clicks +1 WHERE respID = $respid" ;
		database_mysql_query( $dbh, $query ) ;

		if ( $dbh[ 'ok' ] )
		{
			return true ;
		}
		return false ;
	}

	FUNCTION Util_Announcements_remove_Announcement( &$dbh,
					$respid )
	{
		if ( !is_numeric( $respid ) || !$respid )
			return false ;

		LIST( $respid ) = database_mysql_quote( $dbh, $respid ) ;

		$query = "DELETE FROM p_anno_resp WHERE respID = $respid" ;
		database_mysql_query( $dbh, $query ) ;

		if ( $dbh[ 'ok' ] )
		{
			return true ;
		}
		return false ;
	}
?>