<?php
	/***************************************/
	//
	//
	// PHP Live! Support
	//
	// https://www.phplivesupport.com
	//
	/***************************************/
	// STANDARD header for Setup
	if ( !is_file( "../../web/config.php" ) ){ HEADER("location: install.php") ; exit ; }
	include_once( "../../web/config.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Format.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Error.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/".Util_Format_Sanatize($CONF["SQLTYPE"], "ln") ) ;

	include_once( "$CONF[DOCUMENT_ROOT]/API/Depts/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/addons/announcements/API/Util_Announcements.php" ) ;

	$error = "" ; $theme = $CONF["THEME"] ;
	$win_style = ( isset( $VALS["STYLE"] ) && $VALS["STYLE"] ) ? $VALS["STYLE"] : "modern" ;

	$action = Util_Format_Sanatize( Util_Format_GetVar( "action" ), "ln" ) ;
	$respid = Util_Format_Sanatize( Util_Format_GetVar( "respid" ), "n" ) ; $orig_respid = $respid ;
	$deptid = Util_Format_Sanatize( Util_Format_GetVar( "deptid" ), "n" ) ;
	$priority = Util_Format_Sanatize( Util_Format_GetVar( "priority" ), "n" ) ;
	$title = $message = "" ;

	$departments = Depts_get_AllDepts( $dbh ) ;
	$dept_hash = Array() ;
	$dept_hash[0] = "All Departments" ;
	for ( $c = 0; $c < count( $departments ); ++$c )
	{
		$department = $departments[$c] ;
		$dept_hash[$department["deptID"]] = $department["name"] ;
	}

	if ( $action == "update" )
	{
		$title = Util_Format_Sanatize( Util_Format_GetVar( "title" ), "b64" ) ;
		$message = Util_Format_Sanatize( Util_Format_GetVar( "message" ), "b64" ) ;

		if ( $title && $message )
		{
			$start_time = 0 ;
			$end_time = 0 ;

			$respid = Util_Announcements_put_Response( $dbh, $respid, $deptid, 1, $priority, $start_time, $end_time, $title, $message ) ;
			if ( !$respid )
			{
				$respid = 0 ;
				$error = "Error: ".Util_Format_StripQuotes( $dbh["error"] ) ;
			}
			else
			{
				database_mysql_close( $dbh ) ;
				HEADER( "location: iframe.php?action=success&respid=$orig_respid" ) ; exit ;
			}
		}
		else
		{
			$error = "blank" ;
		}
	}

	$responseinfo = Util_Announcements_get_AnnouncementByID( $dbh, $respid ) ;
	if ( $respid && isset( $responseinfo["respID"] ) )
	{
		$deptid = $responseinfo["deptID"] ;
		$title = $responseinfo["title"] ;
		$message = $responseinfo["message"] ;
	}
	else if ( $respid )
		$error = "Invalid ID.  Could not locate data." ;

	if ( !$respid && !$deptid && ( count( $departments ) == 1 ) ) { $deptid = $departments[0]["deptID"] ; }
?>
<?php include_once( "../../inc_doctype.php" ) ?>
<head>
<title> PHP Live! Support </title>

<meta name="description" content="PHP Live! Support <?php echo $VERSION ?>">
<meta name="keywords" content="powered by: PHP Live!  www.phplivesupport.com">
<meta name="robots" content="all,index,follow">
<meta http-equiv="content-type" content="text/html; CHARSET=utf-8">
<?php include_once( "../../inc_meta_dev.php" ) ; ?>

<link rel="Stylesheet" href="../../themes/<?php echo $theme ?>/style.css?<?php echo filemtime( "../../themes/$theme/style.css" ) ?>" />
<?php if ( $win_style != "classic" ): ?><style>html, body { font-size: 14px; line-height: 1.4; }</style><?php endif ; ?>
<link rel="stylesheet" href="./js/quill/quill.snow.css" />
<style>
iframe { width: 100%; }
#editor-container { font-size: 14px; line-height: 1.4; }
</style>
<script data-cfasync="false" type="text/javascript" src="../../js/global.js?<?php echo filemtime ( "../../js/global.js" ) ; ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../../js/framework.js?<?php echo $VERSION ?>"></script>
<script data-cfasync="false" type="text/javascript" src="./js/quill/quill.min.js"></script>
<script data-cfasync="false" type="text/javascript" src="./js/announcements.js?<?php echo filemtime ( "./js/announcements.js" ) ; ?>"></script>

<script data-cfasync="false" type="text/javascript">
<!--
	"use strict" ;

	var respid = <?php echo $respid ?> ;

	$(document).ready(function()
	{
		<?php if ( $action == "success" ): ?>

			if ( <?php echo $orig_respid ?> )
			{
				parent.$('#span_dept_name_'+respid).html( '<?php echo isset( $dept_hash[$deptid] ) ? $dept_hash[$deptid] : "Invalid" ;  ?>' ) ;
				parent.$('#span_title_'+respid).html( '<?php echo rawurldecode( base64_decode( $title ) ) ?>' ) ;
				parent.$('#div_announcement_'+respid+'_content').html( '<?php echo rawurldecode( base64_decode( $message ) ) ?>'.announcements_images() ) ;

				$('#editor-container').html('') ;
				$('#title-container').val('') ;

				parent.do_alert( 1, "Success" ) ;

				setTimeout( function() {
					parent.$('#tr_'+respid).fadeTo("fast", .1).fadeTo("fast", 1).fadeTo("fast", .1).fadeTo("fast", 1).fadeTo("fast", .1).fadeTo("fast", 1) ;
					parent.do_edit( respid ) ;
					respid = 0 ;
				},  100 ) ;
			}
			else
			{
				parent.location.href = "list.php?"+unixtime() ;
			}
		
		<?php elseif ( $error ): ?>

			do_alert( 0, "<?php echo $error ?>" ) ;

		<?php endif ; ?>

		var quill = new Quill('#editor-container', {
			modules: {
				toolbar: '#toolbar-container'
			},
			theme: 'snow'
		});

	});

	function do_update()
	{
		var editor_div = document.querySelector('#editor-container') ;
		var message_html = editor_div.children[0].innerHTML ;

		$('#respid').val( respid ) ;
		$('#title').val( phplive_base64.encode( encodeURIComponent( $('#title-container').val().trim().tags().replace( /▒~@▒/g, "" ).replace(/"/g, "&quot;").replace(/'/g, "&#39;") ) ) ) ;
		$('#message').val( phplive_base64.encode( encodeURIComponent( message_html.replace( /▒~@▒/g, "" ).replace(/'/g, "&#39;") ) ) ) ;

		$('#form_announcement').submit() ;
	}
//-->
</script>
</head>
<body style="overflow: hidden;">

<div id="request_body" style="height: 100%; overflow: auto; padding-top: 25px;">
	<form method="POST" action="iframe.php" enctype="multipart/form-data" id="form_announcement">
	<input type="hidden" name="action" value="update">
	<input type="hidden" name="respid" id="respid" value="<?php echo $respid ?>">
	<div style="display: none;"><textarea name="title" id="title" cols="80" rows="10"></textarea></div>
	<div style="display: none;"><textarea name="message" id="message" cols="80" rows="10"></textarea></div>
	<div style="<?php echo ( count( $departments ) == 1 ) ? "display: none;" : "" ; ?> margin-bottom: 15px;">
		<b>Assign to Department:</b>
		<div style="margin-top: 2px;">
			<select name="deptid" id="deptid" style="font-size: 16px; width: 95%;" class="info_dept">
			<option value=0>All Departments</option>
			<?php
				for ( $c = 0; $c < count( $departments ); ++$c )
				{
					$department = $departments[$c] ;
					$temp_deptid = $department["deptID"] ;
					$enabled = ( isset( $deptvars_all[$temp_deptid]["gdpr_msg"] ) && $deptvars_all[$temp_deptid]["gdpr_msg"] ) ? "(enabled)" : "" ;
					$selected = ( $deptid == $department["deptID"] ) ? "selected" : "" ;
					print "<option value=\"$department[deptID]\" $selected>$department[name] $enabled</option>" ;
				}
			?>
			</select>
		</div>
	</div>

	<div>
		<b>Announcement Title</b>
		<div style="margin-top: 2px;"><input type="text" class="input_text" style="width: 95%;" maxlength="80" id="title-container" name="title-container" value="<?php echo rawurldecode( base64_decode( $title ) ) ?>" onKeyPress="return noquotestags(event)" autocomplete="off"></div>
	</div>

	<div style="margin-top: 15px;">
		<hr>
		<div style="padding-top: 10px;">
			<div><b>Note:</b> URLs will be converted to links.  HTML will be omitted but pasting emojis &#128578; are ok.  Image embed is not available at this time.</div>
		</div>
		<hr style="margin-top: 10px;">
		<div id="standalone-container">

			<div id="toolbar-container" style="border: 0px;">
				<span class="ql-formats">
					<select class="ql-size">
						<option value="10px">Small</option>
						<option selected>Normal</option>
						<option value="18px">Large</option>
						<option value="32px">Huge</option>
					</select>
				</span>
				<span class="ql-formats">
					<button class="ql-bold"></button>
					<button class="ql-italic"></button>
					<button class="ql-underline"></button>
					<button class="ql-strike"></button>
				</span>
				<span class="ql-formats">
					<button class="ql-list" value="ordered"></button>
					<button class="ql-list" value="bullet"></button>
				</span>
				<span class="ql-formats">
					<select class="ql-color"></select>
					<select class="ql-background"></select>
				</span>
				<span class="ql-formats">
					<select class="ql-align"></select>
				</span>
				<span class="ql-formats">
					<button class="ql-video"></button>
				</span>
			</div>

			<b>Announcement Message</b>
			<div id="editor-container" style="margin-top: 5px; padding: 0px; height: 260px; border: 0px; box-shadow: 0px 0px 2px rgba(0, 0, 0, 0.6);" class="chat_body"><?php echo rawurldecode( base64_decode( $message ) ) ?></div>
		</div>

	</div>
	<div style="margin-top: 15px;"><button type="button" onClick="do_update()" style="padding: 10px;" id="btn_submit">Submit</button> &nbsp; &nbsp; <?php echo ( $respid ) ? "<a href=\"JavaScript:void(0)\" onClick=\"parent.do_edit(respid)\">cancel</a>" : "" ; ?></div>
	</form>

</div>

<?php
	if ( isset( $dbh ) && $dbh['con'] ) { database_mysql_close( $dbh ) ; }
?>
</body>
</html>