<?php
	/***************************************/
	//
	//
	// PHP Live! Support
	//
	// https://www.phplivesupport.com
	//
	/***************************************/
	// STANDARD header for Setup
	if ( !is_file( "../../web/config.php" ) ){ HEADER("location: ../../setup/install.php") ; exit ; }
	include_once( "../../web/config.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Format.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Error.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/".Util_Format_Sanatize($CONF["SQLTYPE"], "ln") ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_IP.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Security.php" ) ;
	if ( !$admininfo = Util_Security_AuthSetup( $dbh ) ){ ErrorHandler( 608, "Invalid setup session or session has expired.", $PHPLIVE_FULLURL, 0, Array() ) ; exit ; }
	// STANDARD header end
	/****************************************/

	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Functions.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Depts/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/addons/announcements/API/Util_Announcements.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/addons/API/Util_Addons.php" ) ;
	if ( is_file( "$CONF[CONF_ROOT]/addons.php" ) ) { include_once( "$CONF[CONF_ROOT]/addons.php" ) ; }

	$announcements_addon = ( isset( $VALS_ADDONS ) && isset( $VALS_ADDONS["announcements"] ) && $VALS_ADDONS["announcements"] ) ? unserialize( base64_decode( $VALS_ADDONS["announcements"] ) ) : Array() ;
	$error = $title = $message = "" ;

	$action = Util_Format_Sanatize( Util_Format_GetVar( "action" ), "ln" ) ;
	$respid = Util_Format_Sanatize( Util_Format_GetVar( "respid" ), "n" ) ;
	$deptid = Util_Format_Sanatize( Util_Format_GetVar( "deptid" ), "n" ) ;
	$priority = Util_Format_Sanatize( Util_Format_GetVar( "priority" ), "n" ) ;
	$jump = Util_Format_Sanatize( Util_Format_GetVar( "jump" ), "ln" ) ; if ( !$jump ) { $jump = "list" ; }
	$page = Util_Format_Sanatize( Util_Format_GetVar( "page" ), "n" ) ;

	$departments = Depts_get_AllDepts( $dbh ) ;
	$dept_hash = Array() ;
	$dept_hash[0] = "All Departments" ;
	for ( $c = 0; $c < count( $departments ); ++$c )
	{
		$department = $departments[$c] ;
		$dept_hash[$department["deptID"]] = $department["name"] ;
	}

	if ( $action == "update_settings" )
	{
		$tab_title = Util_Format_Sanatize( Util_Format_GetVar( "tab_title" ), "notags" ) ;
		$deptids_active = Util_Format_Sanatize( Util_Format_GetVar( "deptids_active" ), "a" ) ;
		$deptids_auto = Util_Format_Sanatize( Util_Format_GetVar( "deptids_auto" ), "a" ) ;
		$links_top = Util_Format_Sanatize( Util_Format_GetVar( "links_top" ), "notags" )."," ;
		$links_top = Util_Format_StripQuotes( urldecode( rawurlencode( preg_replace( "/(http:\/\/)|(https:\/\/)|<|>|`|[\$@\?!#=\^]/", "", Util_Format_Sanatize( $links_top, "ln" ) ) ) ) ) ;

		if ( !isset( $announcements_addon["title"] ) ) { $announcements_addon = Array() ; }

		$links_top_string = "" ;
		$links_top = preg_replace( "/,{2,}/", ",", $links_top ) ;
		$links_top_array = explode( ",", $links_top ) ;
		for ( $c = 0; $c < count( $links_top_array ); ++$c )
		{
			$element = trim( $links_top_array[$c] ) ;
			if ( $element )
				$links_top_string .= "($element)|" ;
		}
		if ( $links_top_string ) { $links_top_string = substr_replace( $links_top_string, "", -1 ) ; }

		$announcements_addon["tab_title"] = base64_encode( rawurlencode( $tab_title ) ) ;
		$announcements_addon["links_top"] = base64_encode( rawurlencode( $links_top_string ) ) ;
		$announcements_addon["status"] = $deptids_active ;
		$announcements_addon["auto_display"] = $deptids_auto ;

		Util_Addons_WriteToFile( "announcements", base64_encode( serialize( $announcements_addon ) ) ) ;

		database_mysql_close( $dbh ) ;
		HEADER( "location: list.php?action=success&jump=settings" ) ; exit ;
	}
	else if ( $action == "delete" )
	{
		Util_Announcements_remove_Announcement( $dbh, $respid ) ;
	}
	else if ( $action == "display_order" )
	{
		$respids = Util_Format_Sanatize( Util_Format_GetVar( "respids" ), "a" ) ;

		$priority_hash = Array() ;
		for ( $c = 0; $c < count( $respids ); ++$c )
		{
			$respid = $respids[$c] ;
			$priority_hash[$respid] = $c ;
		}

		$responses = Util_Announcements_get_Announcements( $dbh, "", -1, "display ASC, t_up DESC, created DESC", 50 ) ;
		for ( $c = 0; $c < count( $responses ); ++$c )
		{
			$responseinfo = $responses[$c] ;
			$this_respid = $responseinfo["respID"] ;
			$this_priority = $responseinfo["display"] ;
			if ( isset( $priority_hash[$this_respid] ) && ( $priority_hash[$this_respid] != $this_priority ) )
			{
				Util_Announcements_update_AnnouncementValues( $dbh, $this_respid, Array( "display" => $priority_hash[$this_respid] ) ) ;
			}
		}

		$json_data = "json_data = { \"status\": 1 };" ;

		if ( isset( $dbh ) && isset( $dbh['con'] ) ) { database_mysql_close( $dbh ) ; }
		HEADER('Content-Type: text/plain; charset=utf-8') ;
		print $json_data ; exit ;
	}
	else if ( $action == "status" )
	{
		$status = Util_Format_Sanatize( Util_Format_GetVar( "status" ), "n" ) ;

		Util_Announcements_update_AnnouncementValues( $dbh, $respid, Array( "status" => $status ) ) ;

		$json_data = "json_data = { \"status\": 1 };" ;

		if ( isset( $dbh ) && isset( $dbh['con'] ) ) { database_mysql_close( $dbh ) ; }
		HEADER('Content-Type: text/plain; charset=utf-8') ;
		print $json_data ; exit ;
	}

	$status_hash = Array() ;
	if ( isset( $announcements_addon["status"] ) && is_array( $announcements_addon["status"] ) )
	{
		for ( $c = 0; $c < count( $announcements_addon["status"] ); ++$c )
		{
			$data = $announcements_addon["status"][$c] ;
			$status_hash[$data] = 1 ;
		}
	}
	$auto_hash = Array() ;
	if ( isset( $announcements_addon["auto_display"] ) && is_array( $announcements_addon["auto_display"] ) )
	{
		for ( $c = 0; $c < count( $announcements_addon["auto_display"] ); ++$c )
		{
			$data = $announcements_addon["auto_display"][$c] ;
			$auto_hash[$data] = 1 ;
		}
	}

	$dept_groups = Depts_get_AllDeptGroups( $dbh ) ;
	$responses = Util_Announcements_get_Announcements( $dbh, "", -1, "display ASC, t_up DESC, created DESC", 50 ) ;
?>
<?php include_once( "../../inc_doctype.php" ) ?>
<head>
<title> PHP Live! Support </title>

<meta name="description" content="PHP Live! Support <?php echo $VERSION ?>">
<meta name="keywords" content="powered by: PHP Live!  www.phplivesupport.com">
<meta name="robots" content="all,index,follow">
<meta http-equiv="content-type" content="text/html; CHARSET=utf-8">
<?php include_once( "../../inc_meta_dev.php" ) ; ?>

<link rel="Stylesheet" href="../../css/setup.css?<?php echo filemtime( "../../css/setup.css" ) ?>">
<style>
.announcement_message { font-size: 14px; line-height: 1.4; }
ul {
	padding-left: 25px;
}
</style>
<script data-cfasync="false" type="text/javascript" src="../../js/global.js?<?php echo filemtime ( "../../js/global.js" ) ; ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../../js/framework.js?<?php echo $VERSION ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../../js/jquery_md5.js?<?php echo $VERSION ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../../js/jquery-ui.min.js?<?php echo $VERSION ?>"></script>
<script data-cfasync="false" type="text/javascript" src="./js/quill/quill.min.js"></script>
<script data-cfasync="false" type="text/javascript" src="./js/announcements.js?<?php echo filemtime ( "./js/announcements.js" ) ; ?>"></script>

<script data-cfasync="false" type="text/javascript">
<!--
	"use strict" ;

	$(document).ready(function()
	{
		$("html, body").css({'background': '#F2F3F5'}) ;
		init_menu() ;
		toggle_menu_setup( "marketing" ) ;

		$( "#div_sortable" ).sortable({
			cancel: ".nosort"
		});
		$( "#div_sortable" ).on('sortupdate', function() { do_sort() ; } ) ;

		var cursor_grab = ( browser_filter ) ? "grab" : "move" ;
		var cursor_grabbing = ( browser_filter ) ? "grabbing" : "move" ;

		$( ".li_cursor" ).css('cursor', cursor_grab) ;
		$( ".li_cursor" ).mousedown(function() {
			$(this).css('cursor', cursor_grabbing) ;
		});
		$( ".li_cursor" ).mouseup(function() {
			$(this).css('cursor', cursor_grab) ;
		});

		<?php if ( $action && !$error ): ?>do_alert( 1, "Success" ) ;
		<?php elseif ( $action && $error ): ?>do_alert( 0, "<?php echo $error ?>" ) ;<?php endif ; ?>

		show_div( "anno" ) ;
		show_subdiv( "<?php echo $jump ?>" ) ;
	});

	function show_subdiv( thediv )
	{
		var divs = Array( "list", "settings", "view" ) ;
		for ( var c = 0; c < divs.length; ++c )
		{
			$('#div_anno_'+divs[c]).hide() ;
			$('#menu_anno_'+divs[c]).removeClass('op_submenu_focus').addClass('op_submenu3') ;
		}

		$('#div_anno_'+thediv).show() ;
		$('#menu_anno_'+thediv).removeClass('op_submenu3').addClass('op_submenu_focus') ;

		$('#form_announcement').trigger('reset') ;

		var location_href = location.href.replace( /\/list.php(.*?)$/, "" ) ;
		var histid = { id: "100" } ;
		window.history.replaceState( histid, document.title, location_href+"/list.php?jump="+thediv ) ;
	}

	function check_all( theobject, theck )
	{
		var index_of = ( theck == "enable" ) ? "ck_enable_" : "ck_auto_" ;
		if ( ( typeof( theobject ) != "undefined" ) && ( theobject.checked ) )
		{
			$('#div_list_depts').find('*').each( function () {
				var div_name = this.id ;
				if ( div_name.indexOf( index_of ) == 0 )
					this.checked = true ;
			}) ;
		}
		else
		{
			$('#div_list_depts').find('*').each( function () {
				var div_name = this.id ;
				if ( div_name.indexOf( index_of ) == 0 )
					this.checked = false ;
			}) ;
		}
	}

	function check_uncheck( theselection, theobj )
	{
		if ( $('#ck_'+theselection+'_all').prop('checked') && !theobj.checked )
		{
			$('#ck_'+theselection+'_all').prop('checked', false) ;
		}
	}

	function do_sort()
	{
		var sort_order = $( "#div_sortable" ).sortable("toArray") ;
		var query_string = "" ;

		for ( var c = 0; c < sort_order.length; ++c )
		{
			var matches = sort_order[c].match( /^tr_(.*?)$/ ) ;
			if ( typeof( matches[1] ) != "undefined" )
			{
				var display = c ;
				var respid = matches[1] ;
				if ( respid )
					query_string += "respids[]="+respid+"&" ;
			}
		}

		if ( query_string )
		{
			var json_data = new Object ;
			var index = 0 ;

			$("#div_sortable").find('*').each( function(){
				var div_name = this.id ;
				if ( div_name.indexOf("tr_") != -1 )
				{
					var bg_color = $(this).css('background-color') ;

					if ( bg_color != "rgb(244, 219, 217)" )
					{
						var bg_color = ( index % 2 ) ? "#EDEDED" : "#FFFFFF" ;
						$(this).css({'background-color': bg_color}) ;
						++index ;
					}
				}
			} );

			$.ajax({
			type: "POST",
			url: "list.php",
			data: "action=display_order&"+query_string,
			success: function(data){
				eval( data ) ;

				if ( json_data.status )
					do_alert( 1, "Success" ) ;
				else
					do_alert( 0, json_data.error ) ;
			},
			error:function (xhr, ajaxOptions, thrownError){
				do_alert( 0, "Lost connection to server.  Please refresh the page and try again." ) ;
			} });
		}
	}

	function confirm_status( therespid, thestatus )
	{
		var json_data = new Object ;

		$.ajax({
		type: "POST",
		url: "list.php",
		data: "action=status&respid="+therespid+"&status="+thestatus,
		success: function(data){
			eval( data ) ;

			if ( json_data.status )
			{
				if ( thestatus )
				{
					$('#div_status_'+therespid+'_1').removeClass('info_neutral').addClass('info_good').css({'opacity': 1}) ;
					$('#div_status_'+therespid+'_0').removeClass('info_error').addClass('info_neutral').css({'opacity': 0.5}) ;
				}
				else
				{
					$('#div_status_'+therespid+'_0').removeClass('info_neutral').addClass('info_error').css({'opacity': 1}) ;
					$('#div_status_'+therespid+'_1').removeClass('info_good').addClass('info_neutral').css({'opacity': 0.5}) ;
				}
				do_alert( 1, "Success" ) ;
			}
			else
				do_alert( 0, json_data.error ) ;
		},
		error:function (xhr, ajaxOptions, thrownError){
			do_alert( 0, "Lost connection to server.  Please refresh the page and try again." ) ;
		} });
	}

	function show_div_delete( thepos, thewidth, theheight )
	{
		$('#div_notice_delete').css({'top': thepos.top, 'left': thepos.left, 'width': thewidth, 'height': theheight}).fadeIn("fast") ;

		$('#div_button_confirm_delete').show() ;
	}

	function do_update()
	{
		var title = $('#tab_title').val().trim() ;
		var ok_checked = 0 ;

		$('#div_list_depts').find('*').each( function () {
			var div_name = this.id ;
			if ( ( div_name.indexOf( "ck_enable_" ) == 0 ) && this.checked )
				ok_checked = 1 ;
		}) ;

		if ( ok_checked && !title )
		{
			do_alert( 0, "Header must be provided." ) ;
			$('#tab_title').fadeTo("fast", .1).fadeTo("fast", 1).fadeTo("fast", .1).fadeTo("fast", 1).fadeTo("fast", .1).fadeTo("fast", 1) ;
			return false ;
		}

		$('#form_announcement').submit() ;
	}
//-->
</script>
</head>
<?php include_once( "../../setup/inc_header.php" ) ?>

		<?php
			if ( !$admininfo["isadmin"] && ( count( $admininfo["access"] ) && !isset( $admininfo["access"]["market"] ) ) ):
			include_once( "$CONF[DOCUMENT_ROOT]/setup/inc_access.php" ) ; else:
		?>
		<?php include_once( "$CONF[DOCUMENT_ROOT]/setup/inc_menu_marketing.php" ) ; ?>

		<div style="margin-top: 25px;">
			<div class="op_submenu_focus" style="margin-left: 0px;" onClick="show_subdiv('list')" id="menu_anno_list">Announcements List</div>
			<div class="op_submenu3" onClick="show_subdiv('settings')" id="menu_anno_settings">Announcements Settings</div>
			<div class="op_submenu3" onClick="show_subdiv('view')" id="menu_anno_view">Live View</div>
			<div style="clear: both"></div>
		</div>

		<div style="margin-top: 45px;">
			<?php if ( !count( $departments ) ): ?>
			<div style="">
				<span class="info_error"><img src="../pics/icons/warning.png" width="12" height="12" border="0" alt=""> Add a <a href="../../setup/depts.php" style="color: #FFFFFF;">Department</a> to access this area.</span>
			</div>
			<?php else: ?>

			<div style="display: none" id="div_anno_list">
				Automatically display information to the visitor during their live chat interaction.  Announce important messages, display your business hours or showcase promotions or products.
				<div style="margin-top: 15px;" class="edit_focus" onClick="do_edit(0)"><img src="../../pics/icons/add.png" width="16" height="16" border="0" alt=""> Add Announcement</div>
				<div style="margin-top: 15px;">
					<table cellspacing=0 cellpadding=0 border=0><tr><td><img src="../../pics/icons/link.png" width="16" height="16" border="0" alt=""></td><td style="padding-left: 5px;">If the announcement message contains a URL, the total URL clicks for that announcement will be tallied.  The link icon indicates the total number of link clicks.</td></tr></table>
				</div>
				<div style="margin-top: 10px;"><b>Note:</b> Click and rating activity from <a href="../../setup/settings.php">Excluced IPs</a> are not tallied and will not affect the overall link click totals.</div>
				<div style="margin-top: 15px;" class="info_action"><img src="../../pics/icons/arrow_down.png" width="15" height="16" border="0" alt=""> Mouse grab the announcement row to move and update the announcements display priority order.</div>

				<div id="div_sortable" class="info_white" style="margin-top: 5px; height: 600px; overflow: auto;">
					<?php
						for ( $c = 0; $c < count( $responses ); ++$c )
						{
							$response = $responses[$c] ;
							$respid = $response["respID"] ;
							$created = date( "M j ($VARS_TIMEFORMAT)", $response["created"] ) ;
							$dept_name = isset( $dept_hash[$response["deptID"]] ) ? $dept_hash[$response["deptID"]] : "invalid" ;
							$title = rawurldecode( base64_decode( $response["title"] ) ) ;
							$message = rawurldecode( base64_decode( $response["message"] ) ) ;

							$status = $response["status"] ;
							$status_1 = ( $status ) ? "checked" : "" ;
							$status_0 = ( !$status ) ? "checked" : "" ;

							$status_1_class = ( $status ) ? "info_good" : "info_neutral" ;
							$status_2_class = ( !$status ) ? "info_error" : "info_neutral" ;

							$status_1_opacity = ( $status ) ? "1" : "0.5" ;
							$status_2_opacity = ( !$status ) ? "1" : "0.5" ;

							$bg_color = ( ($c+1) % 2 ) ? "FFFFFF" : "EDEDED" ; $nosort = "" ;
							$td_width = $VARS_CHAT_WIDTH_WIDGET - 45 ;

							// if ( !$response["status"] ) { $bg_color = "F4DBD9" ; $nosort = "nosort" ; }

							print "<div style=\"background: #$bg_color; border: 1px solid transparent; padding: 10px;\" id=\"tr_$respid\" class=\"tr_response li_cursor round $nosort\">
								<table cellspacing=0 cellpadding=0 border=0 width=\"100%\">
								<tr>
									<td class=\"td_dept_td nosort\" valign=\"top\">
										<div class=\"$status_1_class\" id=\"div_status_{$respid}_1\" style=\"padding: 2px; width: 65px; opacity: {$status_1_opacity}; cursor: pointer;\" onclick=\"$('#status_{$respid}_1').prop('checked', true);confirm_status($respid, 1);\"><input type=\"radio\" name=\"status_{$respid}\" id=\"status_{$respid}_1\" value=\"1\" $status_1> Active</div>
										<div class=\"$status_2_class\" id=\"div_status_{$respid}_0\" style=\"margin-top: 15px; padding: 2px; width: 65px; opacity: {$status_2_opacity}; cursor: pointer;\" onclick=\"$('#status_{$respid}_0').prop('checked', true);confirm_status($respid, 0);\"><input type=\"radio\" name=\"status_{$respid}\" id=\"status_{$respid}_0\" value=\"0\" $status_0> Inactive</div>
									</td>
									<td class=\"td_dept_td\" width=\"70\" valign=\"top\">
										<div style=\"\"><a href=\"JavaScript:void(0)\" onClick=\"do_edit($respid, $response[deptID], '$response[title]', '$response[message]')\" id=\"div_edit_btn_$respid\" class=\"edit_btn nosort\"><img src=\"../../pics/btn_edit.png\" width=\"64\" height=\"23\" border=\"0\" alt=\"\"></a></div>
										<div style=\"margin-top: 10px;\"><a href=\"JavaScript:void(0)\" onClick=\"do_delete($respid)\" class=\"nosort\"><img src=\"../../pics/btn_delete.png\" width=\"64\" height=\"23\" border=\"0\" alt=\"\"></a></div>
									</td>
									<td class=\"td_dept_td\" style=\"text-align: center;\" valign=\"top\">
										<table cellspacing=0 cellpadding=0 border=0>
										<tr>
											<td style=\"text-align: center;\">
												<img src=\"../../pics/icons/link.png\" width=\"16\" height=\"16\" border=\"0\" alt=\"link total clicks\" title=\"link total clicks\" style=\"cursor: default;\"><br>
												$response[t_clicks]
											</td>
											<td style=\"padding-left: 10px; text-align: center;\">
												<img src=\"../../pics/icons/v_up.png\" width=\"16\" height=\"16\" border=\"0\" alt=\"\" style=\"cursor: default;\"><br>
												$response[t_up]
											</td>
											<td style=\"padding-left: 10px; text-align: center;\">
												<img src=\"../../pics/icons/v_down.png\" width=\"16\" height=\"16\" border=\"0\" alt=\"\" style=\"cursor: default;\"><br>
												$response[t_down]
											</td>
										</tr>
										</table>
									</td>
									<td class=\"td_dept_td\" valign=\"top\">
										<div style=\"min-width: 170px; max-width: 280px;\">
											<div>Department</div>
											<div class=\"info_dept\" id=\"span_dept_name_$respid\" style=\"margin-top: 5px; padding: 5px;\">$dept_name</div>
										</div>
									</td>
									<td class=\"td_dept_td\" width=\"100%\" valign=\"top\">
										<div style=\"font-size: larger; font-weight: bold;\">
											<h3 id=\"span_title_$respid\">$title</h3>
										</div>
										<div style=\"margin-top: 5px;\"><button type=\"button\" class=\"nosort\" onClick=\"toggle_view($respid, $response[deptID], '$response[title]', '$response[message]')\" style=\"padding: 5px;\">view message</button></div>
										<div id=\"div_announcement_$respid\" style=\"display: none; width: {$td_width}px; cursor: default;\" class=\"info_white nosort announcement_message\">
											<table cellspacing=0 cellpadding=0 border=0>
											<tr>
												<td>
													<div>
														<div style=\"float: left; padding: 3px; cursor: pointer;\" class=\"info_error\" onClick=\"toggle_view($respid)\">close</div>
														<div style=\"clear:both;\"></div>
													</div>
												</td>
												<td style=\"padding-left: 5px;\">
													<div style=\"font-size: smaller;\"><b>Note:</b> If the message contains a URL, the URL will be automatically converted to a link.  See how it will look at the <a href=\"JavaScript:void(0)\" onClick=\"show_subdiv('view')\">live view</a>.</div>
												</td>
											</tr>
											</table>
											<div id=\"div_announcement_{$respid}_content\" style=\"margin-top: 5px; max-height: 390px; overflow: auto; padding: 25px; box-shadow: {$VARS_UI_POPUP_BOXSHADOW};\">$message</div>
										</div>
									</td>
								</tr>
								</table>
							</div>" ;
						}
						if ( !count( $responses ) )
						{
							print "<div style='padding: 10px;'>Blank results.</div>" ;
						}
					?>
				</div>
			</div>

			<div style="display: none;" id="div_anno_settings">
				<form method="POST" action="list.php" enctype="multipart/form-data" id="form_announcement">
				<input type="hidden" name="action" value="update_settings">
				<input type="hidden" name="jump" value="settings">

				<div class="info_info" style="max-height: 625px; overflow: auto;">
					<table cellspacing=0 cellpadding=0 border=0 width="100%">
					<tr>
						<td width="49%" valign="top">
							<div>
								<span class="title">Header</span> (example: Announcements, Urgent News, Helpful Information)
								<div style="magin-top: 5px;"><input type="text" class="input" id="tab_title" name="tab_title" style="width: 96%;" maxlength="40" value="<?php echo ( isset( $announcements_addon["tab_title"] ) && $announcements_addon["tab_title"] ) ? Util_Format_ConvertQuotes( urldecode( rawurldecode( base64_decode( $announcements_addon["tab_title"] ) ) ) ) : "" ; ?>" autocomplete="off"></div>
							</div>

							<div class="title" style="margin-top: 25px;">&#128276; Enable for Department</div>
							<div style="margin-top: 5px; max-height: 350px; overflow: auto;" class="info_white" id="div_list_depts">
								<table cellspacing=0 cellpadding=0 border=0 width="100%">
								<tr>
									<td width="50">
										<div class="td_dept_header" style="text-align: center;">
											Enabled<br>
											<div style="margin-top: 5px;"><input type="checkbox" onClick="check_all(this, 'enable')" id="ck_enable_all"></div>
										</div>
									</td>
									<td width="100" style="display: none;">
										<div class="td_dept_header" style="text-align: center;">
											Auto Display<br>
											<div style="margin-top: 5px;"><input type="checkbox" onClick="check_all(this, 'auto')" id="ck_auto_all"></div>
										</div>
									</td>
									<td>
										<div class="td_dept_header">
											Department Name
											<div style="margin-top: 5px; opacity: 0;"><input type="checkbox"></div>
										</div>
									</td>
								</tr>
								<?php
									for ( $c = 0; $c < count( $departments ); ++$c )
									{
										$department = $departments[$c] ;
										$this_deptid = $department["deptID"] ;

										$status_checked = ( isset( $status_hash[$this_deptid] ) ) ? "checked" : "" ;
										$auto_checked = ( 1 || isset( $auto_hash[$this_deptid] ) ) ? "checked" : "" ;

										$bg_color = ( $c % 2 ) ? "FFFFFF" : "EDEDED" ;

										print "<tr style=\"background: #$bg_color;\">
											<td class=\"td_dept_td\" style=\"text-align: center;\"><input type='checkbox' class='input' name='deptids_active[]' value=$this_deptid id=\"ck_enable_$this_deptid\" onClick=\"check_uncheck('enable', this)\" $status_checked></td>
											<td class=\"td_dept_td\" style=\"display: none; text-align: center;\"><input type='checkbox' class='input' name='deptids_auto[]' value=$this_deptid id=\"ck_auto_$this_deptid\" onClick=\"check_uncheck('auto', this)\" $auto_checked></td>
											<td class=\"td_dept_td\">$department[name]</td>
										</tr>" ;
									}
								?>
								</table>
							</div>
						</td>
						<td width="2%">&nbsp;</td>
						<td width="49%" valign="top">
							<div class="title"><img src="../../pics/icons/link.png" width="16" height="16" border="0" alt=""> Open URLs in New Tab or Current Tab</div>
							<div style="margin-top: 5px;" class="info_neutral">
								URL links contained in the announcements will open in a new browser tab.  However, if the URL contains the following matching strings, that URL will open in the current tab.
								<div style="margin-top: 5px;">Matching strings:</div>
								<ul>
									<li> Separate the values with a comma (,) without spaces</li>
									<li> Do not include <code>HTTP://</code> or <code>HTTPS://</code>.  They will be automatically omitted</li>
									<li> Full domain name can be provided.  Example: <code>mysite1.com, mysite3.com</code></li>
									<li> Quotes ("), tags (&lt;&gt;) and other special characters will be automatically omitted</li>
								</ul>
								<div style="margin-top: 5px;"><input type="text" class="input" id="links_top" name="links_top" style="width: 96%;" maxlength="155" onKeyPress="return noquotestags(event)" value="<?php echo ( isset( $announcements_addon["links_top"] ) && $announcements_addon["links_top"] ) ? preg_replace( "/\|/", ",", preg_replace( "/[\(\)]/", "", urldecode( rawurldecode( base64_decode( $announcements_addon["links_top"] ) ) ) ) ) : "" ; ?>" autocomplete="off"></div>
							</div>
						</td>
					</tr>
					</table>
				</div>

				<div style="margin-top: 25px;"><button type="button" class="btn" onClick="do_update()">Update</button></div>

				</form>
			</div>

			<div style="display: none; height: 625px; overflow: auto;" id="div_anno_view">
				<?php if ( count( $departments ) > 1 ): ?>

				<div style="">
					<select name="deptid" id="deptid" style="font-size: 16px;" class="info_dept">
						<option value="0">All Departments</option>
						<?php
							for ( $c = 0; $c < count( $departments ); ++$c )
							{
								$department = $departments[$c] ;
								if ( $department["name"] != "Archive" )
								{
									$selected = ( $deptid == $department["deptID"] ) ? "selected" : "" ;
									print "<option value=\"$department[deptID]\" $selected>$department[name]</option>" ;
								}
							}
							if ( count( $dept_groups ) )
							{
								for ( $c = 0; $c < count( $dept_groups ); ++$c )
								{
									$dept_group = $dept_groups[$c] ;
									$selected = ( $deptid == $dept_group["groupID"] ) ? "selected" : "" ;
									print "<option value=\"$dept_group[groupID]\" $selected>$dept_group[name] [Department Group]</option>" ;
								}
							}
						?>
					</select>
				</div>
				<div style="margin-top: 5px; margin-bottom: 15px;"><img src="../../pics/icons/arrow_top.png" width="15" height="16" border="0" alt=""> <span class="info_warning" style="padding: 2px;"><b>IMPORTANT</b></span> The announcements that will be displayed is based on the <a href="../../setup/code.php?deptid=<?php echo $deptid ?>">Live Chat HTML Code</a> that references the above selected department.</div>

				<?php endif ; ?>
				<div style="" class="info_box"><b style="font-size: larger;">&darr;</b> The interface preview is automatically set to <span class="info_good">Online</span> status for visual purposes.  <a href="../../setup/code_autostart.php">Automatic Start Chat</a> is also disabled for the preview.</div>
				<div style="margin-top: 15px;">
					<span class="info_menu_focus" style="padding: 6px;"><a href="JavaScript:void(0)" onClick="preview_theme_embed()">view how it looks</a></span>
				</div>

				<div style="margin-top: 35px;">
					<div class="title"><img src="../../pics/icons/info.png" width="16" height="16" border="0" alt=""> Reminder</div>
					<div style="margin-top: 5px;">If you do not see the announcements &#128276; on the chat window, double check the <a href="JavaScript:void(0)" onClick="show_subdiv('settings')">announcements are enabled for the department</a>.</div>
				</div>
			</div>

			<?php endif ; ?>
		</div>
		<?php endif ; ?>

<div id="div_notice_delete" style="display: none; position: absolute; text-align: justify;" class="info_error">
	<div style="padding: 10px;">
		<div class="edit_title">Really delete this Announcement?</div>

		<div style="display: none; margin-top: 15px;" id="div_button_confirm_delete"><button type="button" onClick="do_delete_doit()" class="btn">Delete</button> &nbsp; &nbsp; &nbsp; <a href="JavaScript:void(0)" onClick="$('#div_notice_delete').fadeOut('fast')">cancel</a></div>
	</div>
</div>
<div id="div_iframe_wrapper" style="display: none; position: absolute; top: 0px; left: 0px; width: <?php echo $VARS_CHAT_WIDTH_WIDGET ?>px; height: 100%; z-Index: 1001;">
	<div style="margin-top: 25px; text-align: center; cursor: pointer;" class="info_error round_bottom_none" onClick="do_edit(global_respid)">
		Close
	</div>
	<iframe id='iframe_widget_embed' name='iframe_widget_embed' style='width: 100%; height: 100%; border: 0px; box-shadow: <?php echo $VARS_UI_POPUP_BOXSHADOW ?>;' src='iframe.php?deptid=<?php echo ( $action == "success" ) ? "" : $deptid ; ?>&respid=<?php echo ( $action == "success" ) ? "" : $respid ; ?>' scrolling='yes' border=0 frameborder=0 class="round round_top_none"></iframe>
</div>
<div id="div_sound_interaction" style="display: none; position: absolute; top: 0px; left: 0px; width: 100%; height: 100%; background: url( ../../themes/initiate/bg_trans_white.png ) repeat; z-Index: 1000;"></div>

<span style="color: #0000FF; text-decoration: underline; line-height: 0px !important; cursor: pointer; position: fixed; bottom: 0px; right: 15px; z-index: 20000000;" id="phplive_btn_615" onclick="phplive_launch_chat_0()"></span>
<script data-cfasync="false" type="text/javascript">

var phplive_v = new Object ;
var st_embed_launch ;
var phplive_stop_chat_icon = 1 ;
var phplive_theme = "" ;
var phplive_embed_win_width = "<?php echo $VARS_CHAT_WIDTH_WIDGET ; ?>" ;
var phplive_embed_win_height = "<?php echo $VARS_CHAT_HEIGHT_WIDGET ; ?>" ;

function preview_theme_embed()
{
	phplive_v["deptid"] = $('#deptid').val() ;

	if ( $('#phplive_iframe_chat_embed_wrapper').is(":visible") )
	{
		phplive_embed_window_close( ) ;
		if ( typeof( st_embed_launch ) != "undefined" ) { clearTimeout( st_embed_launch ) ; }
		st_embed_launch = setTimeout( function(){ phplive_launch_chat_0() ; }, 1000 ) ;
	}
	else { phplive_launch_chat_0() ; }
}

(function() {
var phplive_href = encodeURIComponent( location.href ) ;
var phplive_e_615 = document.createElement("script") ;
phplive_e_615.type = "text/javascript" ;
phplive_e_615.async = true ;
phplive_e_615.src = "<?php echo $CONF["BASE_URL"] ?>/js/phplive_v2.js.php?v=0%7C615%7C0%7C&r="+phplive_href ;
document.getElementById("phplive_btn_615").appendChild( phplive_e_615 ) ;
})() ;

</script>

<?php include_once( "../../setup/inc_footer.php" ) ?>