<?php
	/***************************************/
	//
	//
	// PHP Live! Support
	//
	// https://www.phplivesupport.com
	//
	/***************************************/
	// STANDARD header for Setup
	if ( !is_file( "../../web/config.php" ) ){ HEADER("location: install.php") ; exit ; }
	include_once( "../../web/config.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Format.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Error.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/".Util_Format_Sanatize($CONF["SQLTYPE"], "ln") ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Security.php" ) ;
	if ( !$admininfo = Util_Security_AuthSetup( $dbh ) ){ ErrorHandler( 608, "Invalid setup session or session has expired.", $PHPLIVE_FULLURL, 0, Array() ) ; exit ; }
	// STANDARD header end
	/****************************************/

	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Vals.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Depts/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/addons/API/Util_Addons.php" ) ;
	if ( is_file( "$CONF[CONF_ROOT]/addons.php" ) ) { include_once( "$CONF[CONF_ROOT]/addons.php" ) ; }

	$error = "" ;
	$action = Util_Format_Sanatize( Util_Format_GetVar( "action" ), "ln" ) ;
	$mapid = Util_Format_Sanatize( Util_Format_GetVar( "mapid" ), "ln" ) ;

	$CODE_MAPPER_VERSION = "1.0" ;
	if ( is_file( "$CONF[DOCUMENT_ROOT]/addons/code_mapper/VERSION.php" ) )
		include_once( "$CONF[DOCUMENT_ROOT]/addons/code_mapper/VERSION.php" ) ;

	$code_maps = ( isset( $VALS_ADDONS ) && isset( $VALS_ADDONS["code_maps"] ) && $VALS_ADDONS["code_maps"] ) ? unserialize( base64_decode( $VALS_ADDONS["code_maps"] ) ) : Array() ;

	if ( $action == "update" )
	{
		if ( !$mapid ) { $mapid = Util_Format_RandomString( 6 ) ; }
		$deptid = Util_Format_Sanatize( Util_Format_GetVar( "deptid" ), "n" ) ;
		$map_string = Util_Format_Sanatize( Util_Format_GetVar( "map_string" ), "" ) ;

		$map_string = preg_replace( "/,{2,}/", ",", $map_string ) ;
		$map_string = rawurlencode( preg_replace( "/(http:\/\/)|(https:\/\/)|<|>|`/", "", Util_Format_StripQuotes( $map_string ) ) ) ;

		$code_maps[$mapid] = "$deptid,$map_string" ;

		Util_Addons_WriteToFile( "code_maps", base64_encode( serialize( $code_maps ) ) ) ;
		$json_data = "json_data = { \"status\": 1, \"error\": \"\" };" ;

		if ( isset( $dbh ) && isset( $dbh['con'] ) ) { database_mysql_close( $dbh ) ; }
		$json_data = Util_Format_Trim( $json_data ) ;
		$json_data = preg_replace( "/\t/", "", $json_data ) ;
		HEADER('Content-Type: text/plain; charset=utf-8') ;
		print $json_data ; exit ;
	}
	else if ( $action == "delete" )
	{
		if ( isset( $code_maps[$mapid] ) )
		{
			unset( $code_maps[$mapid] ) ;
			Util_Addons_WriteToFile( "code_maps", base64_encode( serialize( $code_maps ) ) ) ;
		}
		else
			$action = "" ;
	}

	$departments = Depts_get_AllDepts( $dbh ) ;
	$dept_groups = Depts_get_AllDeptGroups( $dbh ) ;

	$depts_hash = Array() ;
?>
<?php include_once( "../../inc_doctype.php" ) ?>
<head>
<title> PHP Live! Support </title>

<meta name="description" content="PHP Live! Support <?php echo $VERSION ?>">
<meta name="keywords" content="powered by: PHP Live!  www.phplivesupport.com">
<meta name="robots" content="all,index,follow">
<meta http-equiv="content-type" content="text/html; CHARSET=utf-8">
<?php include_once( "../../inc_meta_dev.php" ) ; ?>

<link rel="Stylesheet" href="../../css/setup.css?<?php echo filemtime( "../../css/setup.css" ) ?>">
<script data-cfasync="false" type="text/javascript" src="../../js/global.js?<?php echo filemtime ( "../../js/global.js" ) ; ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../../js/framework.js?<?php echo $VERSION ?>"></script>

<script data-cfasync="false" type="text/javascript">
<!--
	var global_mapid = "" ;

	$(document).ready(function()
	{
		$("html, body").css({'background': '#F2F3F5'}) ;

		init_menu() ;
		toggle_menu_setup( "html" ) ;
		if ( typeof( show_div ) == "function" )
			show_div( "code_mapper" ) ;

		<?php if ( $action && !$error ): ?>do_alert(1, "Update Success") ;<?php endif ; ?>

	});

	function update_code_mapper()
	{
		var json_data = new Object ;
		var unique = unixtime() ;

		var map_string = $('#map_string').val().trim().replace( / |\t/g, "" ) ;
		var deptid = $('#deptid').val() ;

		$('#map_string').val( map_string ) ;

		if ( map_string == "" )
		{
			do_alert( 0, "Matching string value must be provided." ) ;
			$('#map_string').focus() ;
			return false ;
		}
		else if ( deptid == "" )
		{
			do_alert( 0, "Department must be selected." ) ;
			$('#deptid').focus() ;
			return false ;
		}

		map_string = encodeURIComponent( map_string ) ;

		$.ajax({
		type: "POST",
		url: "./code_mapper.php",
		data: "action=update&mapid="+global_mapid+"&map_string="+map_string+"&deptid="+deptid+"&"+unique,
		success: function(data){
			eval( data ) ;

			if ( json_data.status )
			{
				location.href = "code_mapper.php?action=success" ;
			}
			else
			{
				do_alert( 0, json_data.error ) ;
			}
		},
		error:function (xhr, ajaxOptions, thrownError){
			do_alert( 0, "Connection to server was lost.  Please reload the page and try again." ) ;
		} });
	}

	function edit_map( themapid, thedeptid, themap_string )
	{
		global_mapid = themapid ;

		$('#map_string').val( decodeURIComponent( themap_string ) ) ;
		$('#deptid').val( thedeptid ) ;
		$('#a_cancel').show() ;

		$('#div_code_mapper_edit').fadeTo("fast", .1).fadeTo("fast", 1).fadeTo("fast", .1).fadeTo("fast", 1).fadeTo("fast", .1).fadeTo("fast", 1) ;
	}

	function delete_map( themapid )
	{
		var pos = $('#div_tr_'+themapid).offset() ;
		var width = $('#div_tr_'+themapid).outerWidth() ;
		var height = $('#div_tr_'+themapid).outerHeight() ;

		global_mapid = themapid ;

		$('#div_notice_delete').css({'top': pos.top, 'left': pos.left, 'width': width, 'height': height}).fadeIn("fast") ;
	}

	function do_delete_doit()
	{
		location.href = "code_mapper.php?action=delete&mapid="+global_mapid ;
	}

	function do_cancel()
	{
		global_mapid = "" ;

		$('#map_string').val( "" ) ;
		$('#deptid').val( "" ) ;
		$('#a_cancel').hide() ;
	}
//-->
</script>
<?php include_once( "../../setup/inc_header.php" ) ?>

		<?php
			if ( !$admininfo["isadmin"] && ( count( $admininfo["access"] ) && !isset( $admininfo["access"]["code"] ) ) ):
			include_once( "$CONF[DOCUMENT_ROOT]/setup/inc_access.php" ) ; else:
		?>
		<?php include_once( "$CONF[DOCUMENT_ROOT]/setup/inc_menu_code.php" ) ; ?>

		<div style="margin-top: 45px;">

			<div style="margin-top: 15px;">Map a URL pattern to a <a href="../../setup/depts.php">department</a>, overriding the existing <a href="../../setup/code.php">Live Chat HTML Code</a> on the webpage. All behaviors (<a href="../../setup/code_autostart.php">Automatic Start Chat</a>, <a href="../proaction/proaction.php">ProAction Invites</a>, <a href="../../setup/icons.php">chat icons</a>, etc) will be processed as the mapped department.</div>
			<div style="margin-top: 25px;">
				<b style="font-size: larger;">Example usage scenario:</b>
				<ul style="margin-top: 5px; padding-left: 15px;">
					<li> If a website contains two versions of the site (example: English and French), a URL pattern containing "<code>/fr/</code>" can be mapped to display the French support department.</li>
					<li> If there are multiple products, few selected product URLs can be mapped to display the Product Specialist support department.</li>
					<li> If a website has a members area, map the member URL to display the Members Only support department.</li>
					<li> If the website is referencing a department ID that does not exist, map it to an existing department.</li>
				</ul>
			</div>

			<div style="margin-top: 15px;" class="info_info" id="div_code_mapper_edit">
				<div>
					Matching strings:<br>
					<ul>
						<li> Separate the values with a comma (,) without spaces</li>
						<li> Provide the string and not the full URL. Example: <code>/members/, product.php?id=12345, services/software, /english/, sales.php</code></li>
						<li> Do not include <code>HTTP://</code> or <code>HTTPS://</code>.  They will be automatically omitted</li>
						<li> Full domain name can be provided.  Example: <code>mysite1.com, mysite3.com</code></li>
						<li> Quotes ("), tags (&lt;&gt;) and other non URL special characters will be automatically omitted</li>
					</ul>
					<input type="text" class="input" size="80" maxlength="455" name="map_string" id="map_string" onKeyPress="return noquotestags(event)" value="">
				</div>
				<div style="margin-top: 15px;">
					<div class="info_white round_bottom_none" style="display: table; margin-left: 5px; border-bottom: 0px;">Map the above matching strings to Department</div>
					<select name="deptid" id="deptid" style="font-size: 16px; padding: 14px; min-width: 525px;" class="info_dept">
					<option value="">- select department -</option>
					<option value="0">All Departments</option>
					<?php
						$depts_hash[0] = "All Departments" ;
						for ( $c = 0; $c < count( $departments ); ++$c )
						{
							$department = $departments[$c] ;

							if ( $department["name"] != "Archive" )
							{
								$depts_hash[$department["deptID"]] = $department["name"] ;
								print "<option value=\"$department[deptID]\">$department[name]</option>" ;
							}
						}
						$deptgroupinfo = Array() ;
						for ( $c = 0; $c < count( $dept_groups ); ++$c )
						{
							$dept_group = $dept_groups[$c] ;
							$depts_hash[$dept_group["groupID"]] = $dept_group["name"] . " (Department Group)" ;
							print "<option value=\"$dept_group[groupID]\">$dept_group[name] (Department Group)</option>" ;
						}
					?>
					</select>
				</div>
				<div style="margin-top: 25px;">
					<div style=""><button type="button" class="btn" onClick="update_code_mapper()">Submit</button> &nbsp; <a href="JavaScript:void(0)" onClick="do_cancel()" id="a_cancel" style="display: none;">cancel</a></div>
				</div>
			</div>

			<div style="margin-top: 25px;">
				<div style="font-size: 14px; font-weight: bold;">Current Mappings</div>
				<div style="margin-top: 15px;">
					<table cellspacing=0 cellpadding=0 border=0 width="100%">
					<tr>
						<td width="14"><div class="td_dept_header">&nbsp;</div></td>
						<td width="14"><div class="td_dept_header">&nbsp;</div></td>
						<td><div class="td_dept_header">URL Patterns</div></td>
						<td width="14"><div class="td_dept_header">&nbsp;</div></td>
						<td><div class="td_dept_header">Department</div></td>
					</tr>
					<?php
						$c = 0 ;
						foreach ( $code_maps as $mapid => $data )
						{
							if ( preg_match( "/,/", $data ) )
							{
								LIST( $deptid, $map_string ) = explode( ",", $data ) ;
								$dept_name = $depts_hash[$deptid] ;
								$map_string_decoded_array = array_filter( explode( ",", rawurldecode( $map_string ) ), 'strlen' ) ;
								$map_string_decoded_string = "<div class='info_neutral' style='float: left; margin-right: 5px; margin-bottom: 5px;'>" . implode( "</div><div class='info_neutral' style='float: left; margin-right: 5px; margin-bottom: 5px;'>", $map_string_decoded_array ) . "</div>" ;

								$td1 = "td_dept_td" ;
								$bg_color = ( ( $c + 1 ) % 2 ) ? "FFFFFF" : "EDEDED" ;

								print "
								<tr style=\"background: #$bg_color\" id=\"div_tr_$mapid\">
									<td class=\"$td1\" width=\"14\"><a href=\"JavaScript:void(0)\" onClick=\"delete_map('$mapid')\"><img src=\"../../pics/btn_delete.png\" width=\"64\" height=\"23\" border=\"0\ alt=\"\></a></td><td class=\"$td1\" width=\"14\"><a href=\"JavaScript:void(0)\" onClick=\"edit_map( '$mapid', $deptid, '$map_string' )\"><img src=\"../../pics/btn_edit.png\" width=\"64\" height=\"23\" border=\"0\" alt=\"\"></a></td>
									<td class=\"$td1\">$map_string_decoded_string<div class='clear: both'></div></td>
									<td class=\"$td1\"><img src=\"../../pics/icons/arrow_right.png\" width=\"16\" height=\"15\" border=\"0\" alt=\"\"></td>
									<td class=\"$td1\">$dept_name</td>
								</tr>
								" ; ++$c ;
							}
						}
						if ( !count( $code_maps ) )
							print "<tr><td colspan=6 class=\"td_dept_td\">Blank results.</td></tr>" ;
					?>
					</table>
				</div>
			</div>

		</div>

		<div id="div_notice_delete" style="display: none; position: absolute; text-align: justify;" class="info_error">
			<div style="padding: 10px;">
				<span class="edit_title">Really delete this mapping condition?</span> &nbsp; &nbsp; &nbsp; <button type="button" onClick="do_delete_doit()" class="btn">Delete</button> &nbsp; &nbsp; &nbsp; <a href="JavaScript:void(0)" style="color: #FFFFFF" onClick="$('#div_notice_delete').fadeOut('fast');global_mapid='';">cancel</a>
			</div>
		</div>
		<?php endif ; ?>

<?php include_once( "../../setup/inc_footer.php" ) ?>
