<?php
	/***************************************/
	//
	//
	// PHP Live! Support
	//
	// https://www.phplivesupport.com
	//
	/***************************************/
	if ( defined( 'API_Util_Emarketing' ) ) { return ; }	
	define( 'API_Util_Emarketing', true ) ;

	FUNCTION Util_Emarketing_VisExists( &$dbh,
					  $md5_vis )
	{
		if ( $md5_vis == "" )
			return false ;
	
		LIST( $md5_vis ) = database_mysql_quote( $dbh, $md5_vis ) ;
		$sdate = mktime( 0, 0, 1, date("m"), date("j"), date("Y") ) ;

		$query = "SELECT statID FROM p_emarketing WHERE thevalue <> -1 AND md5_vis = '$md5_vis' LIMIT 1" ;
		database_mysql_query( $dbh, $query ) ;

		if ( $dbh[ 'ok' ] )
		{
			$data = database_mysql_fetchrow( $dbh ) ;
			if ( isset( $data["statID"] ) )
				return true ;
		}
		return false ;
	}

	FUNCTION Util_Emarketing_VisInfo( &$dbh,
					  $md5_vis )
	{
		if ( $md5_vis == "" )
			return false ;
	
		LIST( $md5_vis ) = database_mysql_quote( $dbh, $md5_vis ) ;
		$sdate = mktime( 0, 0, 1, date("m"), date("j"), date("Y") ) ;

		$query = "SELECT * FROM p_emarketing WHERE md5_vis = '$md5_vis' LIMIT 1" ;
		database_mysql_query( $dbh, $query ) ;

		$output = Array() ;
		if ( $dbh[ 'ok' ] )
		{
			$output = database_mysql_fetchrow( $dbh ) ;
		}
		return $output ;
	}

	FUNCTION Util_Emarketing_SaveResponse( &$dbh,
					  $emarketid,
					  $emarket_val,
					  $email,
					  $md5_vis,
					  $ces )
	{
		if ( !is_numeric( $emarketid ) || !$emarketid || ( $email == "" ) || ( $md5_vis == "" ) )
			return false ;
	
		$now = time() ; if ( !$ces ) { $ces = "" ; }
		LIST( $emarketid, $emarket_val, $email, $md5_vis, $ces ) = database_mysql_quote( $dbh, $emarketid, $emarket_val, $email, $md5_vis, $ces ) ;
		$sdate = mktime( 0, 0, 1, date("m"), date("j"), date("Y") ) ;

		$query = "SELECT statID FROM p_emarketing WHERE thevalue = -1 AND md5_vis = '$md5_vis' LIMIT 1" ;
		database_mysql_query( $dbh, $query ) ;
		$responseinfo = database_mysql_fetchrow( $dbh ) ;

		if ( isset( $responseinfo["statID"] ) )
			$query = "UPDATE p_emarketing SET created = $now, thevalue = $emarket_val, email = '$email' WHERE statID = $responseinfo[statID]" ;
		else
			$query = "INSERT INTO p_emarketing VALUES (NULL, $emarketid, $now, $emarket_val, '$email', '$md5_vis', $sdate, '$ces')" ;
		database_mysql_query( $dbh, $query ) ;

		if ( $dbh[ 'ok' ] )
			return true ;
		return false ;
	}

	FUNCTION Util_Emarketing_Responses( &$dbh,
					  $emarketid,
					  $thevalue,
					  $sdate,
					  $stat_start,
					  $stat_end )
	{
		if ( !$emarketid || !is_numeric( $thevalue ) || !is_numeric( $sdate ) || !is_numeric( $stat_start ) || !is_numeric( $stat_end ) )
			return false ;
	
		LIST( $emarketid, $thevalue, $sdate, $stat_start, $stat_end ) = database_mysql_quote( $dbh, $emarketid, $thevalue, $sdate, $stat_start, $stat_end ) ;

		$value_string = ( $thevalue != 10 ) ? "thevalue = $thevalue AND" : "" ;

		$query = "SELECT statID, created, email, thevalue FROM p_emarketing WHERE $value_string emarketID = $emarketid AND created >= $stat_start AND created <= $stat_end ORDER BY created DESC" ;
		if ( $sdate )
			$query = "SELECT statID, created, email, thevalue FROM p_emarketing WHERE $value_string emarketID = $emarketid AND sdate = $sdate ORDER BY created DESC" ;
		database_mysql_query( $dbh, $query ) ;

		$output = Array() ;
		if ( $dbh[ 'ok' ] )
		{
			while( $data = database_mysql_fetchrow( $dbh ) )
			{
				$output[] = $data ;
			}
		}
		return $output ;
	}

	FUNCTION Util_Emarketing_Delete( &$dbh,
					  $emarketid )
	{
		if ( $emarketid == "" )
			return false ;
	
		LIST( $emarketid ) = database_mysql_quote( $dbh, $emarketid ) ;

		$query = "UPDATE p_dept_vars SET emarketID = 0 WHERE emarketID = '$emarketid'" ;
		database_mysql_query( $dbh, $query ) ;
		$query = "DELETE FROM p_emarketing WHERE emarketID = '$emarketid'" ;
		database_mysql_query( $dbh, $query ) ;

		if ( $dbh[ 'ok' ] )
			return true ;
		return false ;
	}

	FUNCTION Util_Emarketing_DeleteStat( &$dbh,
					  $statid )
	{
		if ( !is_numeric( $statid ) || !$statid )
			return false ;
	
		LIST( $statid ) = database_mysql_quote( $dbh, $statid ) ;

		$query = "DELETE FROM p_emarketing WHERE statID = '$statid'" ;
		database_mysql_query( $dbh, $query ) ;

		if ( $dbh[ 'ok' ] )
			return true ;
		return false ;
	}

	function Util_Emarketing_Export_Responses( $dbh, $emarketinginfo, $value, $day, $month, $year, $span )
	{
		$sdate = $stat_start = $stat_end = 0 ;
		$month_temp = $month ;

		if ( $span )
		{
			if ( $span < 0 ) { $span *= -1 ; }
			$day_span = $day - $span ;
			$stat_start = mktime( 0, 0, 0, $month_temp, $day_span, $year ) ;
			$stat_end = mktime( 23, 59, 59, $month_temp, $day, $year ) ;
		}
		else if ( !$day )
		{
			$stat_start = mktime( 0, 0, 0, $month_temp, 1, $year ) ;
			$stat_end = mktime( 23, 59, 59, ++$month_temp, 0, $year ) ;
		}
		else
			$sdate = mktime( 0, 0, 1, $month, $day, $year ) ;

		return Util_Emarketing_Responses( $dbh, $emarketinginfo["id"], $value, $sdate, $stat_start, $stat_end ) ;
	}
?>