<?php
	/***************************************/
	//
	//
	// PHP Live! Support
	//
	// https://www.phplivesupport.com
	//
	/***************************************/
	// STANDARD header for Setup
	include_once( "../../../web/config.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Format.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/".Util_Format_Sanatize($CONF["SQLTYPE"], "ln") ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Security.php" ) ;
	if ( !$setupinfo = Util_Security_AuthSetup( $dbh ) )
	{
		$json_data = "json_data = { \"status\": 0, \"error\": \"Authentication error.\" };" ;
		if ( isset( $dbh ) && isset( $dbh['con'] ) ) { database_mysql_close( $dbh ) ; }
		HEADER('Content-Type: text/plain; charset=utf-8') ;
		print $json_data ; exit ;
	}
	// STANDARD header end
	/****************************************/ $live = 1 ;

	$action = Util_Format_Sanatize( Util_Format_GetVar( "action" ), "ln" ) ;
	if ( $action === "export_transcripts" )
	{
		include_once( "$CONF[DOCUMENT_ROOT]/API/Depts/get.php" ) ;
		include_once( "$CONF[DOCUMENT_ROOT]/API/Ops/get.php" ) ;
		include_once( "$CONF[DOCUMENT_ROOT]/API/".Util_Format_Sanatize($CONF["SQLTYPE"], "ln") ) ;
		include_once( "$CONF[DOCUMENT_ROOT]/addons/export_transcripts/API/Util_Export_Transcripts.php" ) ;

		if ( is_dir( $CONF["EXPORT_DIR"] ) )
		{
			$deptid = Util_Format_Sanatize( Util_Format_GetVar( "deptid" ), "n" ) ;
			$opid = Util_Format_Sanatize( Util_Format_GetVar( "opid" ), "n" ) ;
			$tid = Util_Format_Sanatize( Util_Format_GetVar( "tid" ), "n" ) ;
			$text = Util_Format_Sanatize( Util_Format_GetVar( "text" ), "" ) ; $text = ( $text ) ? $text : "" ;
			$s_as = Util_Format_Sanatize( Util_Format_GetVar( "s_as" ), "ln" ) ;
			$month = Util_Format_Sanatize( Util_Format_GetVar( "m" ), "n" ) ;
			$year = Util_Format_Sanatize( Util_Format_GetVar( "y" ), "n" ) ;

			$query_hash = md5( $CONF["CONF_ROOT"]."{$deptid}_{$opid}_{$tid}_{$text}_{$s_as}" ) ;

			if ( is_numeric( $month ) && is_numeric( $year ) && $month && $year )
			{
				$operators = Ops_get_AllOps( $dbh ) ;
				$departments = Depts_get_AllDepts( $dbh ) ;

				$operators_hash = Array() ;
				for ( $c = 0; $c < count( $operators ); ++$c )
				{
					$operator = $operators[$c] ;
					$operators_hash[$operator["opID"]] = $operator ;
				}

				$dept_hash = Array() ;
				for ( $c = 0; $c < count( $departments ); ++$c )
				{
					$department = $departments[$c] ;
					$dept_hash[$department["deptID"]] = $department ;
				}

				$this_month = date( "n", time() ) ;
				$this_year = date( "Y", time() ) ;

				$stat_start = mktime( 0, 0, 0, $month, 1, $year ) ;
				$stat_end = mktime( 23, 59, 59, $month, date( "t", $stat_start ), $year ) ;

				$filename = "transcripts_export_{$month}_{$year}_{$query_hash}.txt" ;
				$export_file = "$CONF[EXPORT_DIR]/$filename" ;
				$export_file_http = "$CONF[UPLOAD_HTTP]/exported_files/$filename" ;

				if ( !is_file( $export_file ) || ( is_file( $export_file ) && ( $this_month == $month ) && ( $this_year == $year ) ) )
				{
					$transcript_string = "" ;

					$transcripts = Util_Export_Fetch_RefinedTranscripts( $dbh, $deptid, $opid, $tid, $s_as, $text, $stat_start, $stat_end, 1 ) ;
					for ( $c = 0; $c < count( $transcripts ); ++$c )
					{
						$transcript = $transcripts[$c] ;

						$created = date( "M j, Y ($VARS_TIMEFORMAT)", $transcript["created"] ) ;
						$dept_name = ( isset( $dept_hash[$transcript["deptID"]] ) ) ? $dept_hash[$transcript["deptID"]]["name"] : "[ not found ]" ;
						$op_name = ( isset( $operators_hash[$transcript["opID"]] ) ) ? $operators_hash[$transcript["opID"]]["name"] : "[ not found ]" ;
						$op_email = ( isset( $operators_hash[$transcript["opID"]] ) ) ? $operators_hash[$transcript["opID"]]["email"] : "[ not found ]" ;
						$vis_email = ( $transcript["vemail"] && ( $transcript["vemail"] != "null" ) ) ? "<$transcript[vemail]>" : "" ;
						$duration = $transcript["ended"] - $transcript["created"] ;
						$duration = Util_Format_Duration( $duration ) ;
						$rating = ( $transcript["rating"] ) ? "$transcript[rating] stars" : "" ;

						$custom_vars_string = "" ;
						if ( $transcript["custom"] )
						{
							$custom_vars_string = "" ;
							$customs = explode( "-cus-", $transcript["custom"] ) ;
							for ( $c2 = 0; $c2 < count( $customs ); ++$c2 )
							{
								$custom_var = $customs[$c2] ;
								if ( $custom_var && preg_match( "/-_-/", $custom_var ) )
								{
									LIST( $cus_name, $cus_val ) = explode( "-_-", rawurldecode( $custom_var ) ) ;
									if ( $cus_val )
									{
										$custom_vars_string .= "* $cus_name : $cus_val\r\n" ;
									}
								}
							}
						}
						$transcript_data = preg_replace( "/&quot;/", "\"", preg_replace( "/&#39;/", "'", $transcript["plain"] ) ) ;
						$transcript_data = preg_replace( "/&nbsp;/", " ", $transcript["plain"] ) ;

						$transcript_string .= "------------------------------

* Created			: $created

* Department			: $dept_name
* Operator			: $op_name <$op_email>
* Visitor			: $transcript[vname] $vis_email
* Duration			: $duration
* Rating			: $rating
* Chat ID			: $transcript[ces]
$custom_vars_string
$transcript_data
------------------------------








" ;
					}

					if ( !$transcript_string ) { $transcript_string = "Blank results." ; }
					if ( $live ) { file_put_contents( $export_file, $transcript_string ) ; }
					else { print $transcript_string ; exit ; }
				}
				$json_data = "json_data = { \"status\": 1, \"file_name\": \"$filename\", \"file_location\": \"$export_file_http\" };" ;
			}
			else
				$json_data = "json_data = { \"status\": 0, \"error\": \"Invalid action.  Please try again.\" };" ;
		}
		else
			$json_data = "json_data = { \"status\": 0, \"error\": \"Export directory not found.  Please refresh the page and try again.\" };" ;
	}
	else if ( $action === "delete" )
	{
		$file_name = Util_Format_Sanatize( Util_Format_GetVar( "file" ), "ln" ) ;

		if ( $file_name && is_file( "$CONF[EXPORT_DIR]/$file_name" ) )
		{
			@unlink( "$CONF[EXPORT_DIR]/$file_name" ) ;
		}
		$json_data = "json_data = { \"status\": 1 };" ;
	}
	else
		$json_data = "json_data = { \"status\": 0, \"error\": \"Invalid action. [a2]\" };" ;

	if ( isset( $dbh ) && isset( $dbh['con'] ) ) { database_mysql_close( $dbh ) ; }
	$json_data = Util_Format_Trim( $json_data ) ;
	$json_data = preg_replace( "/\t/", "", $json_data ) ;
	HEADER('Content-Type: text/plain; charset=utf-8') ;
	print $json_data ; exit ;
?>