<?php
	/***************************************/
	//
	//
	// PHP Live! Support
	//
	// https://www.phplivesupport.com
	//
	/***************************************/
	// STANDARD header for Setup
	if ( !is_file( "../../web/config.php" ) ){ HEADER("location: install.php") ; exit ; }
	include_once( "../../web/config.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Format.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Error.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/".Util_Format_Sanatize($CONF["SQLTYPE"], "ln") ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Security.php" ) ;
	if ( !$admininfo = Util_Security_AuthSetup( $dbh ) ){ ErrorHandler( 608, "Invalid setup session or session has expired.", $PHPLIVE_FULLURL, 0, Array() ) ; exit ; }
	// STANDARD header end
	/****************************************/

	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Vals.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/External/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Depts/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/addons/API/Util_Addons.php" ) ;
	if ( is_file( "$CONF[CONF_ROOT]/addons.php" ) ) { include_once( "$CONF[CONF_ROOT]/addons.php" ) ; }

	$MARQUEE_VERSION = "1.0" ;
	if ( is_file( "$CONF[DOCUMENT_ROOT]/addons/marquee/API/VERSION.php" ) )
		include_once( "$CONF[DOCUMENT_ROOT]/addons/marquee/API/VERSION.php" ) ;

	$action = Util_Format_Sanatize( Util_Format_GetVar( "action" ), "ln" ) ;
	$deptid = Util_Format_Sanatize( Util_Format_GetVar( "deptid" ), "n" ) ;
	$error = "" ;

	$departments = Depts_get_AllDepts( $dbh ) ;
	$departments_visible = Array() ;
	for ( $c = 0; $c < count( $departments ); ++$c )
	{
		$department = $departments[$c] ;
		if ( $department["visible"] ) { $departments_visible[] = $department ; }
	}
	if ( count( $departments_visible ) == 1 )
	{
		if ( !$deptid )
			$deptid = $departments_visible[0]["deptID"] ;
	}

	$dept_groups = Depts_get_AllDeptGroups( $dbh ) ;

	$marquee_array = ( isset( $VALS_ADDONS ) && isset( $VALS_ADDONS["marquees"] ) && $VALS_ADDONS["marquees"] ) ? unserialize( base64_decode( $VALS_ADDONS["marquees"] ) ) : Array() ;
	$marquee_message = "" ;
	if ( isset( $marquee_array[$deptid] ) )
		$marquee_message = $marquee_array[$deptid] ;

	if ( $action == "update" )
	{
		$marquee_message = Util_Format_ConvertQuotes( Util_Format_Sanatize( Util_Format_GetVar( "marquee_message" ), "notags" ) ) ;
		$copy_all = Util_Format_Sanatize( Util_Format_GetVar( "copy_all" ), "n" ) ;

		if ( $copy_all )
		{
			$marquee_array[0] = $marquee_message ;
			for ( $c = 0; $c < count( $departments ); ++$c )
			{
				$department = $departments[$c] ;
				$marquee_array[$department["deptID"]] = $marquee_message ;
			}
			for ( $c = 0; $c < count( $dept_groups ); ++$c )
			{
				$dept_group = $dept_groups[$c] ;
				$marquee_array[$dept_group["groupID"]] = $marquee_message ;
			}
		}
		else
		{
			$marquee_array[$deptid] = $marquee_message ;
			if ( count( $departments ) == 1 )
			{
				$this_department = $departments[0] ;
				$marquee_array[$this_department["deptID"]] = $marquee_message ;
			}
		}

		Util_Addons_WriteToFile( "marquees", base64_encode( serialize($marquee_array) ) ) ;
		$json_data = "json_data = { \"status\": 1 };" ;

		if ( isset( $dbh ) && isset( $dbh['con'] ) ) { database_mysql_close( $dbh ) ; }
		HEADER('Content-Type: text/plain; charset=utf-8') ;
		print $json_data ; exit ;
	}
	else if ( $action == "clear" )
	{
		$copy_all = Util_Format_Sanatize( Util_Format_GetVar( "copy_all" ), "n" ) ;

		if ( $copy_all )
			$marquee_array = Array() ;
		else
		{
			unset( $marquee_array[$deptid] ) ;
			if ( count( $departments ) == 1 )
			{
				$this_department = $departments[0] ;
				unset( $marquee_array[$this_department["deptID"]] ) ;
			}
		}

		Util_Addons_WriteToFile( "marquees", base64_encode( serialize($marquee_array) ) ) ;
		$json_data = "json_data = { \"status\": 1 };" ;

		if ( isset( $dbh ) && isset( $dbh['con'] ) ) { database_mysql_close( $dbh ) ; }
		HEADER('Content-Type: text/plain; charset=utf-8') ;
		print $json_data ; exit ;
	}
?>
<?php include_once( "../../inc_doctype.php" ) ?>
<head>
<title> PHP Live! Support </title>

<meta name="description" content="PHP Live! Support <?php echo $VERSION ?>">
<meta name="keywords" content="powered by: PHP Live!  www.phplivesupport.com">
<meta name="robots" content="all,index,follow">
<meta http-equiv="content-type" content="text/html; CHARSET=utf-8">
<?php include_once( "../../inc_meta_dev.php" ) ; ?>

<link rel="Stylesheet" href="../../css/setup.css?<?php echo filemtime( "../../css/setup.css" ) ?>">
<script data-cfasync="false" type="text/javascript" src="../../js/global.js?<?php echo filemtime ( "../../js/global.js" ) ; ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../../js/framework.js?<?php echo $VERSION ?>"></script>

<script data-cfasync="false" type="text/javascript">
<!--
	"use strict" ;
	var global_marquee_message = "<?php echo $marquee_message ?>" ;

	$(document).ready(function()
	{
		$("html, body").css({'background': '#F2F3F5'}) ;

		init_menu() ;
		toggle_menu_setup( "marketing" ) ;

		show_div( "marquee" ) ;

		<?php if ( $action && !$error ): ?>do_alert( 1, "Update Success" ) ;<?php endif ; ?>
	});

	function switch_dept( thedeptid )
	{
		location.href = "marquee.php?deptid="+thedeptid ;
	}

	function view_preview()
	{
		var marquee_message = $('#marquee_message').val() ;
		marquee_message = marquee_message.replace( /(<([^>]+)>)/ig,"" ) ;
		$('#marquee_message').val( marquee_message ) ;

		marquee_message = encodeURIComponent( marquee_message ) ;
		document.getElementById('iframe_widget_embed').contentWindow.preview_marquee( marquee_message ) ;
		$('#phplive_widget_embed_iframe').fadeOut("fast").fadeIn("fast") ;
	}

	function do_update()
	{
		var unique = unixtime() ;
		var json_data = new Object ;

		var marquee_message = $('#marquee_message').val().trim() ;
		var copy_all = ( $('#copy_all').is(':checked') ) ? 1 : 0 ;

		if ( ( global_marquee_message != marquee_message ) || copy_all )
		{
			marquee_message = marquee_message.replace( /(<([^>]+)>)/ig,"" ) ;
			$('#marquee_message').val( marquee_message ) ;
			var copy_all = ( $('#copy_all').is(':checked') ) ? 1 : 0 ;

			$('#btn_submit').attr("disabled", true).html('Processing...') ;

			$.ajax({
			type: "POST",
			url: "marquee.php",
			data: "action=update&deptid=<?php echo $deptid ?>&marquee_message="+encodeURIComponent( marquee_message )+"&copy_all="+copy_all+"&"+unique,
			success: function(data){
				try{
					eval( data ) ;
				} catch(e){
					reset_btn() ;
					do_alert( 0, "System sent an invalid response.  Please try again." ) ;
					return false ;
				}

				if ( json_data.status )
				{
					location.href = "marquee.php?action=success&deptid=<?php echo $deptid ?>" ;
				}
				else
				{
					reset_btn() ;
					do_alert( 0, "Error processing request.  Refresh the page and try again." ) ;
				}
			},
			statusCode: {
				500: function() {
					reset_btn() ;
					do_alert( 0, "Internal 500 error.  Check the web server error logs for more details." ) ;
				}
			},
			error:function (xhr, ajaxOptions, thrownError){
				do_alert( 0, "Connection error.  Please refresh the page and try again." ) ;
			} });
		}
		else
			do_alert( 1, "Update Success" ) ;
	}

	function do_reset()
	{
		$('#theform').trigger("reset") ;
		$('#btn_reset').hide() ;

		view_preview() ;
	}

	function input_text_listen( e )
	{
		var marquee_message = $('#marquee_message').val() ;

		if ( global_marquee_message != marquee_message )
			$('#btn_reset').show() ;
	}

	function reset_btn()
	{
		$('#btn_submit').attr("disabled", false).html('Update Change') ;
	}

	function do_clear()
	{
		var unique = unixtime() ;
		var json_data = new Object ;

		if ( confirm( "Clear the department Marquee Message?" ) )
		{
			var copy_all = ( $('#copy_all').is(':checked') ) ? 1 : 0 ;

			$.ajax({
			type: "POST",
			url: "marquee.php",
			data: "action=clear&deptid=<?php echo $deptid ?>&copy_all="+copy_all+"&"+unique,
			success: function(data){
				try{
					eval( data ) ;
				} catch(e){
					do_alert( 0, "System sent an invalid response.  Please try again." ) ;
					return false ;
				}

				if ( json_data.status )
				{
					location.href = "marquee.php?action=success&deptid=<?php echo $deptid ?>" ;
				}
				else
				{
					do_alert( 0, "Error processing request.  Refresh the page and try again." ) ;
				}
			},
			statusCode: {
				500: function() {
					do_alert( 0, "Internal 500 error.  Check the web server error logs for more details." ) ;
				}
			},
			error:function (xhr, ajaxOptions, thrownError){
				do_alert( 0, "Connection error.  Please refresh the page and try again." ) ;
			} });
		}
	}
//-->
</script>
<?php include_once( "../../setup/inc_header.php" ) ?>

		<?php include_once( "$CONF[DOCUMENT_ROOT]/setup/inc_menu_marketing.php" ) ; ?>

		<?php if ( !count( $departments ) || !count( $departments_visible ) ): ?>
		<div style="padding-top: 45px;">
			<?php if ( !count( $departments ) ): ?>
			<span class="info_error"><img src="../../pics/icons/warning.png" width="12" height="12" border="0" alt=""> Add a <a href="../../setup/depts.php" style="color: #FFFFFF;">Department</a> to access this area.</span>
			<?php else: ?>
			<span class="info_error"><img src="../../pics/icons/warning.png" width="12" height="12" border="0" alt=""> At least one <a href="../../setup/depts.php" style="color: #FFFFFF;">Department</a> must be visible to access this area.</span>
			<?php endif ; ?>
		</div>
		<?php else: ?>

		<form id="theform">
		<input type="hidden" name="action" value="update">
		<div style="margin-top: 45px;">
			<table cellspacing=0 cellpadding=2 border=0 width="100%">
			<tr>
				<td valign="top" width="<?php echo $VARS_CHAT_WIDTH_WIDGET ?>">
					<div id='phplive_widget_embed_iframe' style='width: <?php echo $VARS_CHAT_WIDTH_WIDGET ?>px; height: 550px; border-radius: 5px; box-shadow: <?php echo $VARS_UI_POPUP_BOXSHADOW ?>;'>
						<iframe id='iframe_widget_embed' name='iframe_widget_embed' style='width: 100%; height: 100%; border-radius: 5px; border: 0px;' src='../../phplive.php?preview=2&embed=1&d=<?php echo $deptid ?>' scrolling='no' border=0 frameborder=0></iframe>
					</div>
				</td>
				<td valign="top" width="100%" style="padding-left: 25px;" id="td_text_values">
					<div style="margin-bottom: 15px;">Display a scrolling marquee message on the chat window footer.</div>

					<div style="margin-bottom: 15px;" class="info_box"><table cellspacing=0 cellpadding=0 border=0><tr><td><b style="font-size: larger;">&larr;</b></td><td style="padding-left: 5px;">The interface preview is automatically set to <span class="info_good">Online</span> status for visual purposes.  <a href="../../setup/code_autostart.php">Automatic Start Chat</a> is also disabled for the preview.</td></tr></table></div>

					<?php if ( count( $departments ) > 1 ): ?>
					<select name="deptid" id="deptid" style="font-size: 16px; margin-bottom: 15px;" onChange="switch_dept( this.value )" class="info_dept">
					<option value="0">All Departments <?php echo ( isset( $marquee_array[0] ) ) ? " (enabled)" : "" ; ?> <?php echo ( count( $departments_visible ) == 1 ) ? "(only 1 department is visible)" : "" ; ?> </option>
					<?php
						if ( count( $departments ) > 1 )
						{
							for ( $c = 0; $c < count( $departments ); ++$c )
							{
								$department = $departments[$c] ;

								if ( $department["name"] != "Archive" )
								{
									$selected = ( $deptid == $department["deptID"] ) ? "selected" : "" ;
									$enabled = ( isset( $marquee_array[$department["deptID"]] ) && ( preg_replace("/\s+/", "", $marquee_array[$department["deptID"]] ) != "" ) ) ? " (enabled)" : "" ;
									print "<option value=\"$department[deptID]\" $selected>$department[name]$enabled</option>" ;
								}
							}
						}
						if ( count( $dept_groups ) )
						{
							for ( $c = 0; $c < count( $dept_groups ); ++$c )
							{
								$dept_group = $dept_groups[$c] ;
								$selected = ( $deptid == $dept_group["groupID"] ) ? "selected" : "" ;
								$enabled = ( isset( $marquee_array[$dept_group["groupID"]] ) && ( preg_replace("/\s+/", "", $marquee_array[$dept_group["groupID"]] ) != "" ) ) ? " (enabled)" : "" ;
								print "<option value=\"$dept_group[groupID]\" $selected>$dept_group[name] [Department Group]$enabled</option>" ;
							}
						}
					?>
					</select>
					<div style="margin-bottom: 15px;"><img src="../../pics/icons/arrow_top.png" width="15" height="16" border="0" alt=""> <span class="info_warning" style="padding: 2px;"><b>IMPORTANT</b></span> This marquee is for the <a href="../../setup/code.php">Live Chat HTML Code</a> that references the above selected department.</div>
					<?php endif ; ?>

					<div class="info_neutral" style="padding: 15px;">
						<img src="../../pics/icons/arrow_down.png" width="15" height="16" border="0" alt=""> Marquee Message<br>
						<div><input type="text" class="input" style="width: 90%;" maxlength="255" name="marquee_message" id="marquee_message" value="<?php echo Util_Format_ConvertQuotes( $marquee_message ) ?>" onKeydown="input_text_listen_prevent(event);" onKeyup="input_text_listen(event);" autocomplete="off"></div>
						<div style="margin-top: 15px;">
							<span class="info_menu_focus" style="padding: 6px;">&larr; <a href="JavaScript:void(0)" onClick="view_preview()">view how it will look</a></span>
						</div>
					</div>

					<div style="margin-top: 25px;">
						<?php if ( count( $departments ) > 1 ) : ?>
							<?php if ( !$deptid || ( $deptid > $VARS_GID_MIN ) ): ?>
							<div>For the "<a href="JavaScript:void(0)" onClick="$('#deptid').fadeOut('fast').fadeIn('fast').fadeOut('fast').fadeIn('fast').fadeOut('fast').fadeIn('fast')">All Departments</a>", the marquee message will be displayed only on the <b>chat request window</b>.  The marquee message will not be displayed during the chat session.</div>
							
							<div style="margin-top: 15px; margin-bottom: 15px;">If you would like the marquee message to be displayed during the chat session, check the "copy this update to all departments" or provide a message for each of the <a href="JavaScript:void(0)" onClick="$('#deptid').fadeOut('fast').fadeIn('fast').fadeOut('fast').fadeIn('fast').fadeOut('fast').fadeIn('fast')">departments</a>.</div>
							<?php endif ; ?>
						<div><input type="checkbox" id="copy_all" name="copy_all" value=1> copy this update to all departments</div>
						<?php else: ?>
						<input type="hidden" name="copy_all" id="copy_all" value=1>
						<?php endif ; ?>
						<div style="margin-top: 25px;">
							<div style="">
								<button type="button" class="btn" onClick="do_update()" id="btn_submit">Update Changes</button> &nbsp; &nbsp; <button type="button" class="btn" onClick="do_reset()" id="btn_reset" style="display: none;">Reset</button>
								<?php if ( $marquee_message ): ?>
									or &nbsp; <a href="JavaScript:void(0)" onClick="do_clear()">clear message</a>
								<?php endif ; ?>
							</div>
						</div>
					</div>

				</td>
			</tr>
			</table>

		</div>
		</form>
		<?php endif ; ?>

<?php include_once( "../../setup/inc_footer.php" ) ?>