<?php
	/***************************************/
	//
	//
	// PHP Live! Support
	//
	// https://www.phplivesupport.com
	//
	/***************************************/
	include_once( "../../../web/config.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Format.php" ) ;

	include_once( "$CONF[DOCUMENT_ROOT]/API/".Util_Format_Sanatize($CONF["SQLTYPE"], "ln") ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Chat/get_itr.php" ) ;

	$ces = Util_Format_Sanatize( Util_Format_GetVar( "ces" ), "lns" ) ;
	$action = Util_Format_Sanatize( Util_Format_GetVar( "action" ), "ln" ) ;
	$peer = Util_Format_Sanatize( Util_Format_GetVar( "peer" ), "b64" ) ;
	$token = Util_Format_Sanatize( Util_Format_GetVar( "token" ), "b64" ) ;
	$ptype = Util_Format_Sanatize( Util_Format_GetVar( "ptype" ), "n" ) ;
	$md5_vis = Util_Format_Sanatize( Util_Format_GetVar( "vis_token" ), "lns" ) ;

	$requestinfo = Chat_get_itr_RequestCesInfo( $dbh, $ces ) ;

	// 2-10 as possible status for future features
	if ( !isset( $requestinfo["peer"] ) )
		$json_data = "{ \"status\": 0, \"error\": \"Voice chat request does not exist or has expired.\" }" ;
	if ( isset( $requestinfo["peer"] ) && ( $requestinfo["ces"] != $ces ) )
		$json_data = "{ \"status\": 0, \"error\": \"Invalid request. [e1]\" }" ;
	else if ( isset( $requestinfo["peer"] ) && ( $requestinfo["md5_vis_"] != $md5_vis ) )
		$json_data = "{ \"status\": 0, \"error\": \"Invalid request. [e2]\" }" ;
	else
	{
		if ( $action == "signal" )
		{
			if ( $requestinfo["peer"] != 2 )
				$json_data = "{ \"status\": 0, \"error\": \"Voice chat request has expired. [e1]\" }" ;
			else
			{
				include_once( "$CONF[DOCUMENT_ROOT]/API/Chat/Util.php" ) ;

				$opid_requester = $requestinfo["op2op"] ;
				$ptype_init = ( $ptype ) ? "vis" : "op" ;
				// x-nod only applies to visitor
				$text = "<!--vc_init_{$ptype_init}:{$opid_requester}|{$now}|{$peer}|{$token}-->" ;

				UtilChat_AppendToChatfile( "{$ces}.txt", base64_encode( $text ) ) ;
				usleep( 100000 ) ; // 10th of second for various reasons

				$json_data = "{ \"status\": 1 }" ;
			}
		}
		else if ( $action == "connected" )
		{
			include_once( "$CONF[DOCUMENT_ROOT]/API/Chat/update.php" ) ;

			Chat_update_RequestValue( $dbh, $requestinfo["requestID"], "peer", 1 ) ;
			$json_data = "{ \"status\": 1 }" ;
		}
		else if ( $action == "cancel" )
		{
			include_once( "$CONF[DOCUMENT_ROOT]/API/Chat/update.php" ) ;

			Chat_update_RequestValue( $dbh, $requestinfo["requestID"], "peer", 1 ) ;
			$json_data = "{ \"status\": 1 }" ;
		}
		else
			$json_data = "{ \"status\": 0, \"error\": \"Invalid action.\" }" ;
	}

	if ( isset( $dbh ) && isset( $dbh['con'] ) ) { database_mysql_close( $dbh ) ; }
	$json_data = Util_Format_Trim( $json_data ) ;
	$json_data = preg_replace( "/\t/", "", $json_data ) ;
	HEADER('Content-Type: application/json') ;
	print $json_data ; exit ;
?>