<?php
	/***************************************/
	//
	//
	// PHP Live! Support
	//
	// https://www.phplivesupport.com
	//
	/***************************************/
	// STANDARD header for Setup
	if ( !is_file( "../web/config.php" ) ){ HEADER("location: ../setup/install.php") ; exit ; }
	include_once( "../web/config.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Format.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Error.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/".Util_Format_Sanatize($CONF["SQLTYPE"], "ln") ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Security.php" ) ;
	if ( !$opinfo = Util_Security_AuthOp( $dbh ) ){ ErrorHandler( 602, "Invalid operator session or session has expired.", $PHPLIVE_FULLURL, 0, Array() ) ; exit ; }
	// STANDARD header end
	/****************************************/

	include_once( "$CONF[DOCUMENT_ROOT]/API/Ops/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Depts/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Canned/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Functions_itr.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Mobile_Detect.php" ) ;

	$action = Util_Format_Sanatize( Util_Format_GetVar( "action" ), "ln" ) ;
	$canid = Util_Format_Sanatize( Util_Format_GetVar( "canid" ), "n" ) ;
	$flag = Util_Format_Sanatize( Util_Format_GetVar( "flag" ), "n" ) ;
	$win_style = ( isset( $VALS["STYLE"] ) && $VALS["STYLE"] ) ? $VALS["STYLE"] : "modern" ;

	$agent = Util_Format_GetUserAgent() ;
	LIST( $os, $browser ) = Util_Format_GetOS( $agent, true ) ;
	$error = "" ;

	if ( $action == "submit" )
	{
		include_once( "$CONF[DOCUMENT_ROOT]/API/Canned/put.php" ) ;

		$deptid = Util_Format_Sanatize( Util_Format_GetVar( "deptid" ), "n" ) ;
		$title = Util_Format_Sanatize( Util_Format_GetVar( "title" ), "ln" ) ;
		$message = Util_Format_Sanatize( Util_Format_GetVar( "message" ), "" ) ;
		$catid = -1 ;

		$caninfo = Canned_get_CanInfo( $dbh, $canid ) ;
		if ( isset( $caninfo["opID"] ) )
			$opid = $caninfo["opID"] ;
		else
			$opid = $opinfo["opID"] ;

		if ( !$canid = Canned_put_Canned( $dbh, $canid, $opinfo["opID"], $deptid, $catid, "", $title, $message ) )
			$error = "Error processing canned message." ;
	}
	else if ( $action == "delete" )
	{
		include_once( "$CONF[DOCUMENT_ROOT]/API/Canned/remove.php" ) ;

		$caninfo = Canned_get_CanInfo( $dbh, $canid ) ;
		if ( $caninfo["opID"] == $opinfo["opID"] )
			Canned_remove_Canned( $dbh, $opinfo["opID"], $canid ) ;
		$action = "submit" ; $canid = 0 ;
	}

	$departments = Depts_get_OpDepts( $dbh, $opinfo["opID"] ) ;
	$cans = Canned_get_OpCanned( $dbh, $opinfo["opID"], 0 ) ;
	$cans_total = count( $cans ) ;

	// make hash for quick refrence
	$dept_hash = Array() ;
	$dept_hash[1111111111] = "All Departments" ;
	for ( $c = 0; $c < count( $departments ); ++$c )
	{
		$department = $departments[$c] ;
		$dept_hash[$department["deptID"]] = $department["name"] ;
	}

	$theme = $opinfo["theme"] ;
	$theme = "default" ;
	if ( !is_file( "$CONF[DOCUMENT_ROOT]/themes/$theme/style.css" ) || isset( $THEMES_EXCLUDE[$theme] ) ) { $theme = "default" ; }
?>
<?php include_once( "../inc_doctype.php" ) ?>
<head>
<title> Operator </title>

<meta name="description" content="v.<?php echo $VERSION ?>">
<meta name="keywords" content="<?php echo md5( $KEY ) ?>">
<meta name="robots" content="all,index,follow">
<meta http-equiv="content-type" content="text/html; CHARSET=utf-8"> 
<?php include_once( "../inc_meta_dev.php" ) ; ?>

<link rel="Stylesheet" href="./bootstrap/bootstrap.min.css">
<style>
.list_group_item, .list_group_focus{ font-size: 14px; }
.list_group_focus{ background: #27C0E1; color: #FFFFFF; }
html, body{ background-color: #FAFAFA; }
</style>
<script data-cfasync="false" type="text/javascript" src="../mapp/js/mapp.js?<?php echo filemtime ( "../mapp/js/mapp.js" ) ; ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../js/global.js?<?php echo filemtime ( "../js/global.js" ) ; ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../js/framework.js?<?php echo $VERSION ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../js/jquery_md5.js?<?php echo $VERSION ?>"></script>

<script data-cfasync="false" type="text/javascript">
<!--
	"use strict" ;
	var global_canid = <?php echo $canid ?> ;
	var global_top ;
	var global_auto_canid = parent.auto_canid ;
	var modal_auto ; var modal_delete ;

	$(document).ready(function()
	{
		reset_mapp_div_height() ;

		if ( global_auto_canid ) { $('#auto_can_'+global_auto_canid).removeClass("btn-light").addClass('btn-success') ; }
		<?php if ( ( $action == "submit" ) && !$error ): ?>parent.do_alert( 1, "Update Success" ) ; parent.populate_cans(0) ;
		<?php elseif ( $action == "reload" ): ?>parent.do_alert( 1, "Refresh Success" ) ;
		<?php endif ; ?>

		if ( <?php echo $canid ?> )
		{
			$('#table_<?php echo $canid ?>').addClass('border-dark') ;
			do_scroll( <?php echo $canid ?> ) ;
		}
		parent.init_extra_loaded() ;
		modal_auto = new bootstrap.Modal(document.getElementById('div_confirm'), {}) ;
		modal_delete = new bootstrap.Modal(document.getElementById('div_confirm_delete'), {}) ;
		document.getElementById('div_confirm').addEventListener('hidden.bs.modal', function (event) {
			//
		});

		$('#div_confirm .modal-footer .btn-light').on('click', function(event) {
			select_auto_can_doit(0) ;
		});
		$('#div_confirm_delete .modal-footer .btn-light').on('click', function(event) {
			do_delete_pre(0) ;
		});
	});

	function do_scroll( thecanid )
	{
		if ( thecanid )
		{
			$('#canned_container').animate({
				scrollTop: $('#table_'+thecanid).offset().top - $('#canned_container').offset().top + $('#canned_container').scrollTop() - 25
			}, 200) ;
		}
	}

	function do_edit( thecanid, thetitle, thedeptid, themessage, thedelete )
	{
		$('#table_'+thecanid).addClass('border-dark') ;
		if ( ( typeof( global_canid ) != "undefined" ) && ( global_canid != thecanid ) )
		{
			$('#table_'+global_canid).removeClass('border-dark') ;
			if ( $('#table_'+global_canid+'_message').is(':visible') )
				$('#table_'+global_canid+'_message').hide() ;
		}

		global_canid = thecanid ;
		global_top = $(window).scrollTop() ;

		$( "input#canid" ).val( thecanid ) ;
		$( "input#title" ).val( thetitle.replace( /&-#39;/g, "'" ) ) ;
		$( "#deptid" ).val( thedeptid ) ;
		$( "#message" ).val( themessage.replace(/<br>/g, "\r\n").replace( /&-#39;/g, "'" ) ) ;

		if ( thedelete )
			$('#div_delete').show() ;
		else
			$('#div_delete').hide() ;

		toggle_menu_info("new", 0) ;
		$('#canned_container').animate({
			scrollTop: 0
		}, 200) ;
	}

	function select_canned( thetitle )
	{
		$('#canned_container').hide() ; // fixes scroll locking bug on Android
		parent.select_canned_pre( phplive_base64.decode( thetitle ) ) ;
	}

	function do_delete()
	{
		modal_delete.show() ;
	}

	function do_delete_pre( theflag )
	{
		if ( theflag )
			location.href = "mapp_canned.php?action=delete&canid="+global_canid ;
		else
			$('#div_confirm_delete').hide() ;
	}

	function do_cancel()
	{
		$('#div_delete').hide() ;

		toggle_menu_info('list', 0) ;
		do_scroll( global_canid ) ;
	}

	function do_submit()
	{
		var canid = $('#canid').val() ;
		var title = $('#title').val() ;
		var deptid = $('#deptid').val() ;
		var message = $('#message').val() ;

		if ( title == "" )
			parent.do_alert( 0, "Please provide a Title." ) ;
		else if ( message == "" )
			parent.do_alert( 0, "Please provide a Message." ) ;
		else
			$('#theform').submit() ;
	}

	function toggle_menu_info( themenu, theclear )
	{
		var divs = Array( "list", "new" ) ;

		for ( var c = 0; c < divs.length; ++c )
		{
			$('#div_settings_'+divs[c]).hide() ;
			$('#menu_settings_'+divs[c]).removeClass('list_group_focus') ;
		}

		if ( theclear )
		{
			if ( typeof( global_canid ) != "undefined" )
			{
				$('#table_'+global_canid).removeClass('list_group_focus') ;
				if ( $('#table_'+global_canid+'_message').is(':visible') )
					$('#table_'+global_canid+'_message').hide() ;
			}

			global_canid = 0 ;
			global_top = 0 ;

			$( "input#canid" ).val( 0 ) ;
			$( "input#title" ).val( "" ) ;
			$( "#deptid" ).val( 1111111111 ) ;
			$( "#message" ).val( "" ) ;

			$('#div_delete').hide() ;
		}

		$('#div_settings_'+themenu).show() ;
		$('#menu_settings_'+themenu).addClass('list_group_focus') ;

		if ( ( themenu == "list" ) && global_canid )
			do_scroll( global_canid ) ;
	}

	function select_auto_can( thecanid )
	{
		$('#table_'+thecanid).addClass('border-dark') ;

		if ( typeof( global_canid ) != "undefined" )
		{
			$('#table_'+global_canid).removeClass('border-dark') ;
			if ( $('#table_'+global_canid+'_message').is(':visible') )
				$('#table_'+global_canid+'_message').hide() ;
		}

		global_canid = thecanid ;

		$('#div_settings_list').find('*').each( function () {
			var div_name = this.id ;
			if ( div_name.indexOf( "auto_can_" ) == 0 )
				$(this).removeClass('btn-success').addClass("btn-light") ;
		}) ;
		$('#auto_can_'+thecanid).removeClass("btn-light").addClass('btn-success') ;

		$('#confirm_canid').val( thecanid ) ;
		if ( global_auto_canid != thecanid )
		{
			modal_auto.show() ;
			$('#div_confirm').modal() ;
			$('#confirm_value').val( 1 ) ;
			$('#confirm_title').html( "Automatically send this canned response immediately after accepting a chat?" ) ;
		}
		else
		{
			$('#confirm_value').val( 0 ) ;
			select_auto_can_doit(1) ;
		}
	}

	function select_auto_can_doit( theoption )
	{
		var thecanid = parseInt( $('#confirm_canid').val() ) ;
		var thevalue = parseInt( $('#confirm_value').val() ) ;

		modal_auto.hide() ;
		if ( theoption )
		{
			var unique = unixtime() ;
			var json_data = new Object ;

			$.ajax({
			type: "POST",
			url: "../ajax/chat_actions_op_cans.php",
			data: "action=auto_canned&canid="+thecanid+"&value="+thevalue+"&unique="+unique,
			success: function(data){
				eval( data ) ;

				if ( json_data.status )
				{
					if ( thevalue )
					{
						parent.auto_canid = global_auto_canid = thecanid ;
						$('#auto_can_'+thecanid).removeClass('btn-light').addClass('btn-success') ;
					}
					else
					{
						parent.auto_canid = global_auto_canid = 0 ;
						$('#auto_can_'+thecanid).removeClass('btn-success').addClass('btn-light') ;
					}
					parent.do_alert( 1, "Update Success" ) ;
				}
				else
					parent.do_alert( 0, "Error updating.  Please refresh the console and try again." ) ;
			},
			error:function (xhr, ajaxOptions, thrownError){
				parent.do_alert( 0, "Error updating.  Please refresh the console and try again." ) ;
			} });
		}
		else if ( global_auto_canid )
		{
			$('#auto_can_'+thecanid).removeClass('btn-success').addClass('btn-light') ;
			$('#auto_can_'+global_auto_canid).removeClass('btn-light').addClass('btn-success') ;
		}
		else
			$('#auto_can_'+thecanid).removeClass('btn-success').addClass('btn-light') ;
	}

	function do_can_jump( thecanid )
	{
		if ( thecanid )
		{
			$('#table_'+thecanid).addClass('border-dark') ;
			if ( ( typeof( global_canid ) != "undefined" ) && ( global_canid != thecanid ) )
			{
				$('#table_'+global_canid).removeClass('border-dark') ;
				if ( $('#table_'+global_canid+'_message').is(':visible') )
					$('#table_'+global_canid+'_message').hide() ;
			}

			global_canid = thecanid ;
			global_top = $(window).scrollTop() ;
			do_scroll( global_canid ) ;
		}
	}

	function toggle_view_message( thecanid )
	{
		if ( !$('#table_'+thecanid+'_message').is(':visible') )
		{
			global_canid = thecanid ;
			$("#div_settings_list").find('*').each( function(){
				var div_name = this.id ;
				if ( div_name.indexOf("table_") != -1 )
				{
					$(this).removeClass('border-dark') ;
					$('#'+div_name+'_message').hide() ;
				}
			} );

			$('#table_'+thecanid).addClass('border-dark') ;
			$('#table_'+thecanid+'_message').show() ;
		}
		else
		{
			$('#table_'+thecanid+'_message').hide() ;
			if ( global_canid != thecanid )
				$('#table_'+thecanid).removeClass('border-dark') ;
		}
	}
//-->
</script>
</head>
<body style="-webkit-text-size-adjust: 100%; font-size: 14px;">

<div id="canned_container" class="p-3 pt-4" style="height: 200px; overflow: auto;">

	<ul class="list-group list-group-horizontal">
		<li id="menu_settings_list" class="list-group-item list_group_focus" onClick="toggle_menu_info('list', 0)">List</li>
		<li id="menu_settings_new" class="list-group-item" onClick="toggle_menu_info('new', 1)">Create/Edit</li>
	</ul>

	<div class="mt-3 pb-3">
		<div id="div_settings_list">
			<?php if ( $cans_total > 4 ): ?>
				<div class="mb-3">Jump to:
					<div class="dropdown">
						<button class="btn btn-secondary dropdown-toggle w-100" type="button" id="dropdown_jumpto" data-bs-toggle="dropdown" aria-expanded="false"></button>
						<ul class="dropdown-menu dropdown-menu dropdown-menu-end w-100 shadow" aria-labelledby="dropdown_jumpto">
						<?php
							$deptid = 0 ;
							$cans_string = "" ;
							for ( $c = 0; $c < $cans_total; ++$c )
							{
								$can = $cans[$c] ;
								$title = preg_replace( "/\"/", "&quot;", preg_replace( "/'/", "&-#39;", $can["title"] ) ) ;
								$title_display = Util_Format_ConvertQuotes( $can["title"] ) ;

								if ( !$deptid || ( $deptid != $can["deptID"] ) )
								{
									$deptid = $can["deptID"] ;
									$dept_name = $dept_hash[$deptid] ;
									$cans_string .= "<li onClick='JavaScript:void(0)' class='bg-light p-2 text-secondary'>$dept_name</li>" ;
								}
								$cans_string .= '<li><button class="dropdown-item" type="button" onClick="do_can_jump('.$can["canID"].')">'.$title_display.'</button></li>' ;
							} print $cans_string ;
						?>
						</ul>
					</div>
				</div>
			<?php endif ; ?>

			<?php
				for ( $c = 0; $c < $cans_total; ++$c )
				{
					$caninfo = $cans[$c] ;
					$cats_extra = ( $caninfo["cats_extra"] && Util_Functions_itr_is_serialized( $caninfo["cats_extra"] ) ) ? unserialize( $caninfo["cats_extra"] ) : Array() ;
					$title = preg_replace( "/\"/", "&quot;", preg_replace( "/'/", "&-#39;", $caninfo["title"] ) ) ;

					// have to use base64 encode/decode method to pass into function without quotes issue
					$title_display_select = base64_encode( $caninfo["title"] ) ;

					$deptid = $caninfo["deptID"] ; $catid = $caninfo["catID"] ;
					if ( isset( $cats_extra[$opinfo["opID"]] ) && preg_match( "/,/", $cats_extra[$opinfo["opID"]] ) )
					{
						LIST( $deptid, $catid ) = explode( ",", $cats_extra[$opinfo["opID"]] ) ;
					}

					if ( isset( $dept_hash[$deptid] ) )
					{
						$message = preg_replace( "/\"/", "&quot;", preg_replace( "/((')|(&apos;)|(&#39;))/", "&-#39;", preg_replace( "/(\r\n)|(\n)|(\r)/", "<br>", $caninfo["message"] ) ) ) ;
						$message = preg_replace( "/▒~@▒/", "", $message ) ;
						$message_display = preg_replace( "/\"/", "&quot;", preg_replace( "/(\r\n)|(\n)|(\r)/", "<br>", Util_Format_ConvertTags( $caninfo["message"] ) ) ) ;
						if ( $os != 3 ) { $message_display = wordwrap( $message_display, 43, "<br>", true ) ; }
						$delete_option = ( $caninfo["opID"] == $opinfo["opID"] ) ? 1 : 0 ;

						$edit_image = ( $caninfo["opID"] == $opinfo["opID"] ) ? "<button type=\"button\" class=\"btn btn-sm btn-light\" onClick=\"do_edit($caninfo[canID], '$title', '$deptid', '$message', $delete_option)\">edit</button>" : "<img src=\"../themes/default/lock.png\" width=\"16\" height=\"16\" border=0 title=\"created by Setup Admin\" alt=\"created by Setup Admin\" onClick=\"parent.do_alert(0, 'created by Setup Admin')\">" ;

						print "
							<div class=\"card p-2 bg-light mb-5\" id='table_$caninfo[canID]' name=\"tr_dept_{$deptid}_{$catid}_\">
								<div class=\"alert alert-dark p-1\" onClick=\"toggle_view_message($caninfo[canID])\">".
									$caninfo["title"]."<div class=\"\" style=\"display: none;\" id=\"table_$caninfo[canID]_message\">$message_display</div>".
								"</div>
								<div>
									<table cellspacing=0 cellpadding=0 border=0 width=\"100%\">
									<tr>
										<td width=\"100%\">
											<button type=\"button\" class=\"btn btn-sm btn-dark\" onClick=\"select_canned('$title_display_select')\">select</button> &nbsp; &nbsp;
											<button type=\"button\" class=\"btn btn-sm btn-light\" onClick=\"toggle_view_message($caninfo[canID])\">view</button> &nbsp; $edit_image
										</td>
										<td width=\"70\" nowrap><button type=\"button\" class=\"btn btn-sm btn-light\" onClick=\"select_auto_can($caninfo[canID])\" id=\"auto_can_$caninfo[canID]\">auto</button></td>
									</tr>
									</table>
								</div>
							</div>
						" ;
					}
				}
				if ( $cans_total )
					print "<div>&nbsp;</div>" ;
				else
					print "<div>Blank Results.</div>" ;
			?>
		</div>

		<div id="div_settings_new" style="display: none;">
			<div>Canned responses created here will be available just for your account.</div>

			<form method="POST" action="mapp_canned.php?<?php echo time() ?>" id="theform">
			<input type="hidden" name="action" value="submit">
			<input type="hidden" name="canid" id="canid" value="0">
			<div class="mt-3">
				<div class="input-group input-group-sm mb-3">
					<span class="input-group-text" id="inputGroup-sizing-sm">Title</span>
					<input type="text" class="form-control" placeholder="Greeting, Just a moment" aria-describedby="inputGroup-sizing-sm" name="title" id="title" autocomplete="off">
				</div>
				<div class="input-group input-group-sm mb-3">
					<label class="input-group-text" for="inputGroupSelect01">Department</label>
					<select class="form-select" id="inputGroupSelect01" name="deptid" id="deptid">
						<option value="1111111111">All Departments</option>
						<?php
							for ( $c = 0; $c < count( $departments ); ++$c )
							{
								$department = $departments[$c] ;

								print "<option value=\"$department[deptID]\">$department[name]</option>" ;
							}
						?>
					</select>
				</div>
				<div class="input-group input-group-sm">
					<span class="input-group-text">Message</span>
					<textarea class="form-control" aria-label="Message" name="message" id="message" wrap="virtual" rows="4"></textarea>
				</div>
				<div class="mt-3"><button type="button" onClick="do_submit()" class="btn btn-dark">Submit</button> &nbsp; &nbsp; &nbsp; <span style="text-decoration: underline; cursor: pointer;" onClick="do_cancel()">cancel</span></div>
				</form>
			</div>
			<div id="div_delete" style="display: none;" class="mt-5"><button type="button" class="btn btn-danger" onClick="do_delete()">Delete Canned Response</button></div>

		</div>
	</div>

</div>

<div id="div_confirm" class="modal fade" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true" style="z-Index: 2000;">
	<div class="modal-dialog modal-dialog-centered">
		<div class="modal-content">
			<div class="modal-body" id="confirm_title"></div>
			<div class="modal-footer">
				<form><input type="hidden" id="confirm_canid" name="confirm_canid" value=""><input type="hidden" id="confirm_value" name="confirm_value" value=""></form>
				<button type="button" class="btn btn-light" data-bs-dismiss="modal">Cancel</button> &nbsp; &nbsp; 
				<button type="button" class="btn btn-primary" onClick="select_auto_can_doit(1)">Yes</button>
			</div>
		</div>
	</div>
</div>

<div id="div_confirm_delete" class="modal fade" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true" style="z-Index: 2000;">
	<div class="modal-dialog modal-dialog-centered">
		<div class="modal-content">
			<div class="modal-body">Really delete this canned response?</div>
			<div class="modal-footer">
				<button type="button" class="btn btn-light" data-bs-dismiss="modal">Cancel</button> &nbsp; &nbsp; 
				<button type="button" class="btn btn-primary" onClick="do_delete_pre(1)">Yes</button>
			</div>
		</div>
	</div>
</div>
<script data-cfasync="false" type="text/javascript" src="./bootstrap/bootstrap.bundle.js"></script>
</body>
</html>
<?php
	if ( isset( $dbh ) && $dbh['con'] )
		database_mysql_close( $dbh ) ;
?>