<?php
	/***************************************/
	//
	//
	// PHP Live! Support
	//
	// https://www.phplivesupport.com
	//
	/***************************************/
	// STANDARD header for Setup
	if ( !is_file( "../web/config.php" ) ){ HEADER("location: ../setup/install.php") ; exit ; }
	include_once( "../web/config.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Format.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Error.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/".Util_Format_Sanatize($CONF["SQLTYPE"], "ln") ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Security.php" ) ;
	if ( !$opinfo = Util_Security_AuthOp( $dbh ) ){ ErrorHandler( 602, "Invalid operator session or session has expired.", $PHPLIVE_FULLURL, 0, Array() ) ; exit ; }
	// STANDARD header end
	/****************************************/

	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Functions.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Ops/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Depts/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Chat/get_ext.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Mobile_Detect.php" ) ;

	$action = Util_Format_Sanatize( Util_Format_GetVar( "action" ), "ln" ) ;
	$page = Util_Format_Sanatize( Util_Format_GetVar( "page" ), "n" ) ;
	$index = Util_Format_Sanatize( Util_Format_GetVar( "index" ), "n" ) ;
	$tid = Util_Format_Sanatize( Util_Format_GetVar( "tid" ), "n" ) ;

	$agent = Util_Format_GetUserAgent() ;
	LIST( $os, $browser ) = Util_Format_GetOS( $agent, true ) ;
	$error = "" ;
	$win_style = ( isset( $VALS["STYLE"] ) && $VALS["STYLE"] ) ? $VALS["STYLE"] : "modern" ;

	$operators = Ops_get_AllOps( $dbh ) ;
	$departments = Depts_get_OpDepts( $dbh, $opinfo["opID"] ) ;

	// make hash for quick refrence
	$operators_hash = Array() ;
	for ( $c = 0; $c < count( $operators ); ++$c )
	{
		$operator = $operators[$c] ;
		$operators_hash[$operator["opID"]] = $operator["name"] ;
	}

	$dept_hash = Array() ; $dept_customs = Array() ;
	for ( $c = 0; $c < count( $departments ); ++$c )
	{
		$department = $departments[$c] ;
		$dept_hash[$department["deptID"]] = $department["name"] ;
		if ( $department["custom"] )
		{
			$custom = unserialize( $department["custom"] ) ;
			$dept_customs = array_merge( $dept_customs, $custom ) ;
		}
	}

	$custom_search_options = "" ; $custom_search_field_hash = Array() ;
	for ( $c = 0; $c < count( $dept_customs ); ++$c )
	{
		$custom = $dept_customs[$c] ;
		if ( $custom && !isset( $custom_search_field_hash[$custom] ) )
		{ $custom_search_field_hash[$custom] = 1 ; $custom_search_options .= "<option value='cus_$c'>$custom</option>" ; }
		++$c ;
	}

	$text = Util_Format_Sanatize( Util_Format_GetVar( "text" ), "" ) ; $text = ( $text ) ? $text : "" ; $text_query = urlencode( $text ) ;
	$s_as = Util_Format_Sanatize( Util_Format_GetVar( "s_as" ), "ln" ) ;
	$year = Util_Format_Sanatize( Util_Format_GetVar( "y" ), "n" ) ;
	$stat_start = mktime( 0, 0, 1, 1, 1, $year ) ;
	$stat_end = mktime( 23, 59, 59, 12, date( "t", mktime( 23, 59, 59, 12, 1, $year ) ), $year ) ;
	$transcripts = Chat_ext_get_OpDeptTrans( $dbh, $opinfo["opID"], $s_as, $text, 0, $year, $stat_start, $stat_end, $tid, $page, 50 ) ;
	$total_index = count($transcripts) - 1 ;

	$tags = ( isset( $VALS['TAGS'] ) && $VALS['TAGS'] ) ? unserialize( $VALS['TAGS'] ) : Array() ;
	$theme = $opinfo["theme"] ;
	$theme = "default" ;
	if ( !is_file( "$CONF[DOCUMENT_ROOT]/themes/$theme/style.css" ) || isset( $THEMES_EXCLUDE[$theme] ) ) { $theme = "default" ; }
?>
<?php include_once( "../inc_doctype.php" ) ?>
<head>
<title> Operator </title>

<meta name="description" content="v.<?php echo $VERSION ?>">
<meta name="keywords" content="<?php echo md5( $KEY ) ?>">
<meta name="robots" content="all,index,follow">
<meta http-equiv="content-type" content="text/html; CHARSET=utf-8"> 
<?php include_once( "../inc_meta_dev.php" ) ; ?>

<link rel="Stylesheet" href="./bootstrap/bootstrap.min.css">
<style>
.list_group_focus{ background-color: #0070EB; color: #FFFFFF; }
html, body{ background-color: #FAFAFA; }
</style>
<script data-cfasync="false" type="text/javascript" src="../mapp/js/mapp.js?<?php echo filemtime ( "../mapp/js/mapp.js" ) ; ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../js/global.js?<?php echo filemtime ( "../js/global.js" ) ; ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../js/framework.js?<?php echo $VERSION ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../js/jquery_md5.js?<?php echo $VERSION ?>"></script>

<script data-cfasync="false" type="text/javascript">
<!--
	var global_ces ;

	$(document).ready(function()
	{
		reset_mapp_div_height() ;
		init_external_url() ;

		<?php if ( $action == "reload" ): ?>parent.do_alert( 1, "Refresh Success" ) ;<?php endif ; ?>

		parent.init_extra_loaded() ;
	});

	function open_transcript( theces )
	{
		var div_width = $('#canned_container').width() ;
		var div_height = $('#canned_container').height() - 50 ;
		var url = "../ops/op_trans_view.php?ces="+theces+"&id=<?php echo $opinfo["opID"] ?>&auth=operator&back=1&mapp=1&"+unixtime() ;

		if ( global_ces != theces )
		{
			$('#table_'+theces).addClass('border-dark') ;
			if ( typeof( global_ces ) != "undefined" )
				$('#table_'+global_ces).removeClass('border-dark') ;
			global_ces = theces ;
		}

		$('#div_cans').hide() ;
		$('#iframe_transcript').css({'width': '100%', 'height': div_height}).attr( 'src', url ).on("load", function() {
			$('#div_cans_iframe').show() ;
			setTimeout( function(){
				$('#div_cans_iframe').show() ;
				document.getElementById('iframe_transcript').contentWindow.init_chat_body_height(div_width-10, div_height-20) ;
			}, 200 ) ;
		});
	}

	function close_transcript( theces )
	{
		$('#div_cans_iframe').hide() ;
		$('#div_cans').show() ;

		var div_pos = $('#table_'+theces).position() ;
		var scroll_to = div_pos.top - 50 ;

		$('#canned_container').scroll() ;
		$('#canned_container').animate({
			scrollTop: scroll_to
		}, 200) ;
	}

	function input_text_listen_search( e )
	{
		var key = -1 ;
		var shift ;

		key = e.keyCode ;
		shift = e.shiftKey ;

		if ( !shift && ( ( key == 13 ) || ( key == 10 ) ) )
			$('#btn_page_search').click() ;
	}
//-->
</script>
</head>
<body style="-webkit-text-size-adjust: 100%; font-size: 14px;">

<div id="canned_container" class="" style="height: 200px; overflow: auto;">
	<div id="div_cans" class="p-3 pt-4">
		<div style="">
		<?php if ( $text ): ?>
			<?php echo $transcripts[$total_index] ?> matching transcripts found.
		<?php else: ?>
			Most recent 50 transcripts.
		<?php endif ; ?>
		</div>

		<div class="mt-3">
			<?php
				for ( $c = 0; $c < count( $transcripts )-1; ++$c )
				{
					$transcript = $transcripts[$c] ;

					// filter out random bugs of no operator data
					if ( $transcript["opID"] )
					{
						// intercept nulled operator accounts that have been deleted
						if ( !isset( $operators_hash[$transcript["op2op"]] ) ) { $operators_hash[$transcript["op2op"]] = "&nbsp;" ; }
						if ( !isset( $operators_hash[$transcript["opID"]] ) ) { $operators_hash[$transcript["opID"]] = "&nbsp;" ; }

						$operator = ( $transcript["op2op"] ) ? $operators_hash[$transcript["op2op"]] : $operators_hash[$transcript["opID"]] ;
						$created = date( "M j, Y ($VARS_TIMEFORMAT)", $transcript["created"] ) ;
						$duration = $transcript["ended"] - $transcript["created"] ;
						$duration = Util_Format_Duration( $duration ) ;
						$question = $transcript["question"] ;
						$vname = ( $transcript["op2op"] ) ? $operators_hash[$transcript["opID"]] : $transcript["vname"] ;
						$vemail = ( $transcript["vemail"] && ( $transcript["vemail"] != "null" ) ) ? $transcript["vemail"] : "" ;
						$rating = ( $transcript["rating"] ) ? "<div class=\"\">".Util_Functions_Stars( "..", $transcript["rating"] )."</div>" : "" ;
						$initiated = ( $transcript["initiated"] ) ?  "<img src=\"../themes/$theme/info_initiate.gif\" width=\"10\" height=\"10\" border=\"0\" alt=\"\" title=\"Operator Initiated Chat Invite\" alt=\"Operator Initiated Chat Invite\"> " : "" ;
						$comment = ( $transcript["noteID"] ) ?  "<img src=\"../pics/icons/flag_blue.png\" width=\"14\" height=\"14\" border=\"0\" alt=\"\" title=\"includes visitor comment\" alt=\"includes visitor comment\"> " : "" ;
						$hasnote = ( $transcript["hasnote"] ) ?  "<img src=\"../pics/icons/pin_note.png\" width=\"14\" height=\"14\" border=\"0\" alt=\"\" title=\"includes notes\" alt=\"includes notes\"> " : "" ;
						$tag_string = "" ;
						if ( isset( $tags[$transcript["tag"]] ) && preg_match( "/,/", $tags[$transcript["tag"]] ) )
						{
							LIST( $sthistatus, $thiscolor, $thistag ) = explode( ",", $tags[$transcript["tag"]] ) ;
							$tag_string = "<span class=\"p-0 rounded\" style=\"background: #$thiscolor; border: 1px solid #C2C2C2; color: #474747; text-shadow: none;\">".rawurldecode( preg_replace( "/(.*?),/", "", $tags[$transcript["tag"]] ) )."</span> " ;
						}

						if ( $os != 3 ) { $question = wordwrap( $transcript["question"], 37, "<br>", true ) ; }

						if ( $transcript["op2op"] )
							$question = " <img src=\"../themes/initiate/agent.png\" width=\"16\" height=\"16\" border=\"0\" title=\"Operator to Operator Chat\" alt=\"Operator to Operator Chat\"> " ;
						else if ( $transcript["md5_vis"] == "grc" )
							$question = " <img src=\"../themes/initiate/group.png\" width=\"16\" height=\"16\" border=\"0\" title=\"Group Chat\" alt=\"Group Chat\" style=\"cursor: help;\"> " ;

						print "
							<div class=\"card p-2 bg-white mb-5\" id='table_$transcript[ces]'>
								<div class=\"alert alert-dark p-1\">
									<div>$question</div>
									<div class=\"mt-2 btn-group-sm\">
										<table cellspacing=0 cellpading=0 border=0>
										<tr>
											<td><button type=\"button\" onClick=\"open_transcript('$transcript[ces]')\" class=\"btn btn-dark\">view</button></td>
											<td style=\"padding-right: 5px; opacity: 0.5;\">Chat ID: $transcript[ces]</td>
											<td>$comment $hasnote</td>
											<td>$rating</td>
										</tr>
										</table>
									</div>
									<div style=\"margin-top: 5px;\">$tag_string</div>
								</div>
								<div class=\"pb-2\">
									<div class=\"\">$created ($duration)</div>
									<div>
										$initiated<b>$vname</b>
										<div><a href=\"mailto:$transcript[vemail]\" target=\"_blank\">$vemail</a></div>
									</div>
								</div>
							</div>
						" ;
					}
				}
				if ( $c != 0 )
					print "<div>&nbsp;</div>" ;
				else
					print "<div>Blank Results.</div>" ;
			?>
		</div>

	</div>
	<div id="div_cans_iframe" class="row overflow-hidden" style="display: none;">
		<div class="p-0 m-0">
			<div class="alert bg-danger text-white p-2 m-0 text-center" onClick="close_transcript(global_ces)">Close Transcript</div>
			<div><iframe class="" id="iframe_transcript" name="iframe_transcript" src="about:blank" allowfullscreen="0"></iframe></div>
		</div>
	</div>
</div>
<script data-cfasync="false" type="text/javascript" src="./bootstrap/bootstrap.bundle.js"></script>
</body>
</html>
<?php
	if ( isset( $dbh ) && $dbh['con'] )
		database_mysql_close( $dbh ) ;
?>