<?php
	/***************************************/
	//
	//
	// PHP Live! Support
	//
	// https://www.phplivesupport.com
	//
	/***************************************/
	// STANDARD header for Setup
	if ( !is_file( "../web/config.php" ) ){ HEADER("location: install.php") ; exit ; }
	include_once( "../web/config.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Format.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Error.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/".Util_Format_Sanatize($CONF["SQLTYPE"], "ln") ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Security.php" ) ;
	if ( !$admininfo = Util_Security_AuthSetup( $dbh ) ){ ErrorHandler( 608, "Invalid setup session or session has expired.", $PHPLIVE_FULLURL, 0, Array() ) ; exit ; }
	// STANDARD header end
	/****************************************/

	include_once( "$CONF[DOCUMENT_ROOT]/API/Ops/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Functions_itr.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/mapp/API/Util_MAPP.php" ) ;

	$action = Util_Format_Sanatize( Util_Format_GetVar( "action" ), "ln" ) ;
	$opid = Util_Format_Sanatize( Util_Format_GetVar( "opid" ), "n" ) ;
	$error = "" ;

	$openssl_enabled = ( function_exists( "openssl_encrypt" ) && function_exists( "openssl_decrypt" ) ) ? 1 : 0 ;
	$mapps_array = ( isset( $VALS["MAPPS"] ) && $VALS["MAPPS"] ) ? unserialize( $VALS["MAPPS"] ) : Array() ;

	$operators = Ops_get_AllOps( $dbh ) ;
	$opinfo = Ops_get_OpInfoByID( $dbh, $opid ) ;

	$salt_requests = isset( $opinfo["opID"] ) ? md5( $CONF['SALT'].$opinfo["opID"]."requests" ) : "" ;
	$webhook_requests_decrypted = ( $salt_requests && isset( $mapps_array[$salt_requests] ) ) ? Util_Functions_itr_Decrypt_OpenSSL( $mapps_array[$salt_requests], $salt_requests ) : "" ;

	if ( $action == "update" )
	{
		include_once( "$CONF[DOCUMENT_ROOT]/API/Ops/update.php" ) ;
		include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Vals.php" ) ;
		$webhook_requests = Util_Format_Sanatize( Util_Format_GetVar( "webhook_requests" ), "url" ) ;

		if ( isset( $opinfo["opID"] ) )
		{
			$webhook_requests_encrypted = Util_Functions_itr_Encrypt_OpenSSL( $webhook_requests, $salt_requests ) ;
			$mapps_array[$salt_requests] = $webhook_requests_encrypted ;

			if ( $webhook_requests && preg_match( "/^http/i", $webhook_requests ) && Util_Vals_WriteToFile( "MAPPS", serialize( $mapps_array ) ) )
			{
				Util_MAPP_Publish( $opinfo["opID"], "system", "Click the \"Open Console\" button to go online from this mobile device.", "Open Console" ) ;
				Ops_update_OpValue( $dbh, $opinfo["opID"], "mapper", 1 ) ;
				if ( isset( $dbh ) && isset( $dbh['con'] ) ) { database_mysql_close( $dbh ) ; }
				HEADER( "location: settings.php?action=verified&opid=$opid" ) ; exit ;
			}
			else { $error = "Could not write to vals file." ; }
		}
		else
			$error = "Invalid operator ID." ;
	}
	else if ( $action == "clear" )
	{
		include_once( "$CONF[DOCUMENT_ROOT]/API/Ops/update.php" ) ;
		include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Vals.php" ) ;
		if ( isset( $mapps_array[$salt_requests] ) )
		{
			unset( $mapps_array[$salt_requests] ) ;
			Util_Vals_WriteToFile( "MAPPS", serialize( $mapps_array ) ) ;
			Ops_update_OpValue( $dbh, $opinfo["opID"], "mapper", 0 ) ;
		}
		if ( isset( $dbh ) && isset( $dbh['con'] ) ) { database_mysql_close( $dbh ) ; }
		HEADER( "location: settings.php?action=success&opid=$opid" ) ; exit ;
	}
	else if ( $action == "send_verification" )
	{
		$webhook_url = Util_Format_Sanatize( Util_Format_GetVar( "webhook_url" ), "url" ) ;
		$verification_code = Util_Format_RandomString( 4, '', true ) ;

		foreach ( $mapps_array AS $this_salt_requests => $this_webhook_requests_encrypted )
		{
			$this_webhook_requests_decrypted = Util_Functions_itr_Decrypt_OpenSSL( $this_webhook_requests_encrypted, $this_salt_requests ) ;
			if ( ( $this_salt_requests != $salt_requests ) && ( strtolower( $this_webhook_requests_decrypted ) == strtolower( $webhook_url ) ) )
				$error = "This Webhook URL is already linked to an operator.  Webhook URL must be unique to each operator." ;
		}

		/***************************************/
		// need to mimic the VALS var for processing
		$mapps_array = Array() ;
		$mapps_array[$salt_requests] = Util_Functions_itr_Encrypt_OpenSSL( $webhook_url, $salt_requests ) ;
		$VALS["MAPPS"] = serialize( $mapps_array ) ;
		/***************************************/

		if ( !isset( $opinfo["opID"] ) )
			$json_data = "json_data = { \"status\": 0, \"error\": \"Invalid operator ID.\" };" ;
		else if ( $error )
			$json_data = "json_data = { \"status\": 0, \"error\": \"$error\" };" ; 
		else if ( Util_MAPP_Publish( $opinfo["opID"], "system", "Verification Code: $verification_code" ) )
			$json_data = "json_data = { \"status\": 1, \"code\": \"$verification_code\" };" ;
		else if ( isset( $CONF["ERROR"] ) )
			$json_data = "json_data = { \"status\": 0, \"error\": \"Webhook URL sent an invalid response or the Webhook URL is invalid.  Error: $CONF[ERROR]\" };" ;
		else
			$json_data = "json_data = { \"status\": 0, \"error\": \"Invalid request.  Please try again.\" };" ;

		if ( isset( $dbh ) && isset( $dbh['con'] ) ) { database_mysql_close( $dbh ) ; }
		HEADER('Content-Type: text/plain; charset=utf-8') ;
		print $json_data ; exit ;
	}
	else if ( $action == "update_fields" )
	{
		include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Vals.php" ) ;
		$fields = Util_Format_Sanatize( Util_Format_GetVar( "fields" ), "a" ) ;

		$fields_array = Array() ;
		for ( $c = 0; $c < count( $fields ); ++$c )
		{
			$fields_array[$fields[$c]] = 1 ;
		}

		$mapps_fields_array[$opid] = $fields_array ;
		if ( Util_Vals_WriteToFile( "MAPPS_FIELDS", serialize( $mapps_fields_array ) ) )
			$json_data = "json_data = { \"status\": 1 };" ;
		else
			$json_data = "json_data = { \"status\": 0, \"error\": \"Could not write to vals file.\" };" ;

		if ( isset( $dbh ) && isset( $dbh['con'] ) ) { database_mysql_close( $dbh ) ; }
		HEADER('Content-Type: text/plain; charset=utf-8') ;
		print $json_data ; exit ;
	}
	$mapps_fields_array = isset( $mapps_fields_array[$opid] ) ? $mapps_fields_array[$opid] : Array() ;
?>
<?php include_once( "../inc_doctype.php" ) ?>
<head>
<title> PHP Live! Support </title>

<meta name="description" content="PHP Live! Support <?php echo $VERSION ?>">
<meta name="keywords" content="powered by: PHP Live!  www.phplivesupport.com">
<meta name="robots" content="all,index,follow">
<meta http-equiv="content-type" content="text/html; CHARSET=utf-8">
<?php include_once( "../inc_meta_dev.php" ) ; ?>

<link rel="Stylesheet" href="../css/setup.css?<?php echo filemtime( "../css/setup.css" ) ?>">
<script data-cfasync="false" type="text/javascript" src="../js/global.js?<?php echo filemtime ( "../js/global.js" ) ; ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../js/framework.js?<?php echo $VERSION ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../js/jquery_md5.js?<?php echo $VERSION ?>"></script>

<script data-cfasync="false" type="text/javascript">
<!--
	var global_mobile_push ;

	$(document).ready(function()
	{
		$("html, body").css({'background': '#F2F3F5'}) ;
		init_menu() ;
		toggle_menu_setup( "settings" ) ;

		var url = location.href ;
		url = url.replace( /\/mapp\/settings(.*)$/, "" ) ;
		url = url.replace( /\/$/, "" ) ;

		<?php if ( $action && $error ): ?>do_alert( 0, "<?php echo $error ?>" ) ;
		<?php endif ; ?>

		if ( <?php echo ( isset( $opinfo["opID"] ) ) ? 1 : 0 ; ?> )
		{
			$('#div_webhook').show() ;
			$('#div_desktop_to_mobile').show() ;

			if ( <?php echo ( $webhook_requests_decrypted ) ? 1 : 0 ; ?> )
				$('#div_verified').show() ;
			else
				$('#div_prep').show() ;
		}
	});

	function do_update()
	{
		$('#theform').submit() ;
	}

	var verification_code = 0 ;
	function webhook_verify( theinput )
	{
		var thevalue = $('#webhook_'+theinput ).val().trim() ;

		$('#div_alert').fadeOut("slow") ;

		if ( thevalue )
		{
			var json_data = new Object ;

			$('#webhook_requests').attr("readonly", true) ;
			$('#btn_submit').attr("disabled", true) ;
			$('#btn_submit').html('Processing...') ;

			$.ajax({
			type: "POST",
			url: "settings.php",
			data: "action=send_verification&opid=<?php echo $opid ?>&webhook_url="+thevalue,
			success: function(data){
				try {
					eval(data) ;
				} catch(err) {
					do_alert( 0, err ) ;
					return false ;
				}

				if ( json_data.status )
				{
					verification_code = parseInt( json_data.code ) ;
					$('#div_prep').hide() ;
					$('#div_verify').show() ;
				}
				else
				{
					$('#webhook_requests').attr("readonly", false) ;
					$('#btn_submit').attr("disabled", false) ;
					$('#btn_submit').html('Send Verification Code and Continue') ;
					do_alert_div( "..", 0, json_data.error ) ;
				}

			},
			error:function (xhr, ajaxOptions, thrownError){
				do_alert( 0, "Connection error.  Please refresh the page and try again." ) ;
			} });
		}
		else
			do_alert( 0, "Please provide the Webhook URL." ) ;
	}

	function do_verify()
	{
		var code = parseInt( $('#code').val().trim() ) ;

		if ( code == verification_code )
			do_update() ;
		else
			do_alert( 0, "Verification code is invalid." ) ;
	}

	function edit_form()
	{
		$('#webhook_requests').attr("readonly", false) ;
		$('#btn_submit').attr("disabled", false).html('Send Verification Code and Continue') ;

		$('#div_verified').hide() ;
		$('#div_verify').hide() ;
		$('#div_prep').show() ;
	}

	function do_cancel( thestep )
	{
		$('#webhook_requests').attr("readonly", true).val('<?php echo $webhook_requests_decrypted ?>') ;

		$('#div_verify').hide() ;
		if ( '<?php echo $webhook_requests_decrypted ?>' )
		{
			$('#div_prep').hide() ;
			$('#div_verified').show() ;
		}
		else
		{
			$('#webhook_requests').attr("readonly", false) ;
			$('#btn_submit').attr("disabled", false).html('Send Verification Code and Continue') ;
			$('#div_verified').hide() ;
			$('#div_prep').show() ;
		}
	}

	function do_clear()
	{
		if ( confirm( "Clear the Webhook value?  The operator will not be able to login from the Mobile App." ) )
			location.href = "settings.php?action=clear&opid=<?php echo $opid ?>&"+unixtime() ;
	}

	function switch_op()
	{
		var opid = $('#select_ops').val() ;

		$('#id_image_loading').show() ;

		$('#div_webhook_wrapper').fadeTo( "fast" , 0, function() {
			location.href = "settings.php?opid="+opid ;
		});
	}

	function set_mapp_push()
	{
		var json_data = new Object ;
		var third_party = false ;

		var query_string = "" ;
		$('#theform').find('*').each( function () {
			var div_name = this.id ;
			if ( div_name.indexOf( "mapp_" ) == 0 )
			{
				if ( this.checked )
				{
					div_name = div_name.replace( /mapp_/i, "" ) ;
					query_string += "fields[]="+div_name+"&" ;
					if ( div_name != "push" )
						third_party = true ;
				}
			}
		}) ;

		if ( third_party && !$('#third_party_agreement').prop( 'checked' ) )
		{
			do_alert( 0, "You must understand the visitor's information will be sent to a third-party." ) ;
			$('#div_third_party').fadeTo("fast", .1).fadeTo("fast", 1).fadeTo("fast", .1).fadeTo("fast", 1).fadeTo("fast", .1).fadeTo("fast", 1) ;
			return false ;
		}

		$('#btn_submit_mapp').attr("disabled", true) ;

		$.ajax({
		type: "POST",
		url: "settings.php",
		data: "action=update_fields&opid=<?php echo $opid ?>&"+query_string,
		success: function(data){
			try {
				eval(data) ;
			} catch(err) {
				do_alert( 0, err ) ;
				$('#btn_submit_mapp').attr("disabled", false) ;
				return false ;
			}

			if ( json_data.status )
			{
				setTimeout( function(){ $('#btn_submit_mapp').attr("disabled", false) ; }, 3000 ) ;
				do_alert( 1, "Update Success" ) ;
			}
			else
			{
				$('#btn_submit_mapp').attr("disabled", false) ;
			}

		},
		error:function (xhr, ajaxOptions, thrownError){
			do_alert( 0, "Connection error.  Please refresh the page and try again." ) ;
		} });
	}
//-->
</script>
</head>
<?php include_once( "../setup/inc_header.php" ) ?>

			<div class="op_submenu_wrapper">
				<div class="op_submenu" style="margin-left: 0px;" onClick="location.href='../setup/settings.php?jump=eips'" id="menu_eips">Excluded IPs</div>
				<div class="op_submenu" onClick="location.href='../setup/settings.php?jump=sips'" id="menu_sips">Blocked IPs</div>
				<div class="op_submenu" onClick="location.href='../setup/settings.php?jump=upload'" id="menu_upload">File Upload</div>
				<?php if ( is_file( "$CONF[DOCUMENT_ROOT]/addons/ldap/ldap.php" ) ): ?><div class="op_submenu" onClick="location.href='../addons/ldap/ldap.php'" id="menu_ldap">LDAP</div><?php endif ; ?>
				<div class="op_submenu" onClick="location.href='../addons/smtp/smtp.php'" id="menu_smtp">SMTP</div>
				<?php if ( is_file( "$CONF[DOCUMENT_ROOT]/addons/voice_chat/voice_chat.php" ) ): ?><div class="op_submenu" onClick="location.href='<?php echo $CONF["BASE_URL"] ?>/addons/voice_chat/voice_chat_admin.php'" id="menu_voice_chat">Voice Chat</div><?php endif ; ?>
				<div class="op_submenu_focus" id="menu_mapp"><img src="../pics/icons/mobile.png" width="12" height="12" border="0" alt=""> Mobile App</div>
				<div class="op_submenu" onClick="location.href='../setup/settings_profile.php'" id="menu_profile"><img src="../pics/icons/key.png" width="12" height="12" border="0" alt=""> Password</div>
				<div class="op_submenu" onClick="location.href='../setup/settings.php?jump=props'" id="menu_props">Misc.</div>
				<div class="op_submenu" onClick="location.href='../setup/system.php'" id="menu_system">System</div>
				<div style="clear: both"></div>
			</div>

			<div style="margin-top: 45px;">
				<?php if ( count( $operators ) > 0 ): ?>
				<div style="">
					<select id="select_ops" style="font-size: 16px;" onChange="switch_op()" class="info_dept"><option value="0">- select operator -</option>
					<?php
						for ( $c = 0; $c < count( $operators ); ++$c )
						{
							$operator = $operators[$c] ;
							if ( $operator["login"] != "phplivebot" )
							{
								$selected = "" ;
								if ( $opid == $operator["opID"] )
								{
									$selected = "selected" ;
									$op_name = $operator["name"] ;
								}
								$salt_requests = md5( $CONF['SALT'].$operator["opID"]."requests" ) ;
								$enabled = isset( $mapps_array[$salt_requests] ) ? "(enabled)" : "" ;
								print "<option value=\"$operator[opID]\" $selected>$operator[name] $enabled</option>" ;
							}
						}
					?>
					</select> &nbsp; <img src="../pics/loading_ci.gif" width="16" height="16" border="0" alt="" class="round" id="id_image_loading" style="display: none;">
				</div>
				<div style="margin-top: 15px;" id="div_webhook_wrapper">
					<?php if ( !$openssl_enabled ): ?>
					<div class="info_error"><a href="https://www.php.net/manual/en/book.openssl.php" target="_blank">PHP openssl</a> is not enabled.  Openssl is required for mobile app.</div>
					<?php else: ?>

					<div style="margin-bottom: 15px;" class="info_neutral">
						<div>For operators to be able to login and chat from their mobile device, the mobile app access must be configured for each operator.  The following how-to videos will provide the steps to integrate your system with Slack&trade; for mobile app access.</div>
						<div style="margin-top: 5px; " class="title">How-to Videos: </div>
						<table cellspacing=0 cellpadding=0 border=0>
						<tr>
							<td>
								<div class="info_misc">
									<a href="https://www.phplivesupport.com/r.php?r=slack_vid" target="_blank"><img src="../pics/icons/social/youtube_play.png" width="16" height="16" border="0" alt=""> How-to Create a Slack&trade; Webhook URL</a>
								</div>
							</td>
							<td style="padding-left: 15px;">
								<div class="info_misc">
									<a href="https://www.phplivesupport.com/r.php?r=slack_vid2" target="_blank"><img src="../pics/icons/social/youtube_play.png" width="16" height="16" border="0" alt=""> How-to Create additional Slack&trade; Webhook URLs</a>
								</div>
							</td>
						</tr>
						</table>
					</div>

					<form method="POST" action="settings.php" enctype="multipart/form-data" id="theform">
					<input type="hidden" name="action" value="update">
					<input type="hidden" name="opid" value="<?php echo $opid ?>">
					<div style="display: none;" id="div_webhook">
						<table cellspacing=0 cellpadding=0 border=0>
						<tr>
							<td><div class="tab_form_title">Webhook URL</div></td>
							<td style="padding-left: 10px;"><input type="text" class="input" name="webhook_requests" id="webhook_requests" size="115" maxlength="160" onKeyPress="return noquotestags(event)" value="<?php echo ( $webhook_requests_decrypted ) ? $webhook_requests_decrypted : "" ; ?>" <?php echo ( $webhook_requests_decrypted ) ? "readonly" : "" ; ?> autocomplete="off"></td>
						</tr>
						</table>
					</div>
					<div style="margin-top: 15px; width: 95%;">
						<table cellspacing=0 cellpadding=0 border=0>
						<tr>
							<td><div class="tab_form_title" style="background: #F2F3F5; border: 0px;">&nbsp;</div></td>
							<td style="padding-left: 10px; padding-top: 10px;">
								<div id="div_verified" style="display: none;" class="info_info">
									<span class="edit_title">Webhook URL verified!</span>
									<div style="margin-top: 5px;" class="info_good title">Settings saved and is active.</div>
									<div style="margin-top: 15px;">

										<div>To login from your mobile device, click the "Open Console" button from the Slack&trade; app.  The "Open Console" button is available at the Slack&trade; app channel that is associated with the above Webhook URL.</div>
										<div style="margin-top: 5px;" id="div_verified_edit">[ <a href="JavaScript:void(0)" onClick="edit_form()">edit webhook value</a> ] &nbsp; [ <a href="JavaScript:void(0)" onClick="do_clear()">clear webhook value and disable Mobile App access for this operator</a> ]</div>
									</div>

									<div class="info_white" style="margin-top: 15px;">
										<b style="font-size: larger;">Alert Message Options</b>
										<div class="border_top">As a default, the new chat request message sent to the webhook URL will include the visitor's question.  Additional information can be sent but keep in mind the information will be sent to a third-party.</div>
										<hr>
										<div style="margin-top: 5px;">
											<table cellspacing=0 cellpadding=4 border=0 width="100%">
											<tr>
												<td width="20"><input type="checkbox" id="mapp_push" value="1" <?php echo isset( $mapps_fields_array["push"] ) ? "checked" : "" ; ?>></td>
												<td><label for="mapp_push">
													Always send new chat request alert message to the webhook URL if the operator is online, even if they are logged in from a desktop computer.  This will be a one time alert if the operator is not logged in from the Mobile App.
													<div style="margin-top: 5px; background: #E5E5E5;" class="info_white">The default behavior is only send a new chat request alert message if the operator is logged in from the Mobile App <b>AND</b> the Mobile App is minimized to the background.</div>
												</label></td>
											</tr>
											<tr>
												<td width="20"><input type="checkbox" id="mapp_name" value="1" <?php echo isset( $mapps_fields_array["name"] ) ? "checked" : "" ; ?>></td>
												<td><label for="mapp_name">Include the <b>Name</b> in the message.</label></td>
											</tr>
											<tr>
												<td width="20"><input type="checkbox" id="mapp_email" value="1" <?php echo isset( $mapps_fields_array["email"] ) ? "checked" : "" ; ?>></td>
												<td><label for="mapp_email">Include the <b>Email</b> in the message.</label></td>
											</tr>
											<tr>
												<td width="20"><input type="checkbox" id="mapp_url" value="1" <?php echo isset( $mapps_fields_array["url"] ) ? "checked" : "" ; ?>></td>
												<td><label for="mapp_url">Include the <b>Clicked from URL</b> in the message.</label></td>
											</tr>
											<tr>
												<td width="20"><input type="checkbox" id="mapp_cust" value="1" <?php echo isset( $mapps_fields_array["cust"] ) ? "checked" : "" ; ?>></td>
												<td><label for="mapp_cust">Include all the <a href="../setup/interface_custom.php"><b>Custom Fields</b></a> in the message.</label></td>
											</tr>
											<tr>
												<td></td>
												<td style="padding-top: 15px;">
													<div class="info_box" id="div_third_party"><input type="checkbox" id="third_party_agreement" value="1"> You understand the above checked information will be sent to a third-party company (Slack&trade;).</div>
													<div style="margin-top: 15px;"><button type="button" class="btn" onClick="set_mapp_push()" id="btn_submit_mapp">Update</button></div>
												</td>
											</tr>
											</table>
										</div>
									</div>
								</div>
								<div id="div_prep" style="display: none;">
									<div style="margin-bottom: 15px;"><img src="../pics/icons/warning.png" width="12" height="12" border="0" alt=""> Before saving the Webhook URL, it will need to be verified.  The system will attempt to send the Verification Code to the Webhook URL, which will need to be provided on the next step.</div>

									<div id="div_alert" style="display: none; margin-bottom: 15px;"></div>
									<div><button type="button" onClick="webhook_verify('requests')" class="btn" id="btn_submit">Send Verification Code and Continue</button> &nbsp; <span id="text_cancel" style="<?php echo ( $webhook_requests_decrypted ) ? "" : "display: none;" ; ?>"><a href="JavaScript:void(0)" onClick="do_cancel(0)">cancel</a></div>
								</div>
								<div id="div_verify" style="display: none;" class="info_info">
									<span class="edit_title">Verification Code Sent!</span>
									<div style="margin-top: 5px;" class="info_error">Settings have not been saved yet.</div>
									<div style="margin-top: 15px;">The verification code has been sent to the Webhook URL.  Provide the verification code to complete the verification process.</div>

									<div style="margin-top: 25px;">
										<table cellspacing=0 cellpadding=0 border=0>
										<tr>
											<td><div class="tab_form_title">Verification Code</div></td>
											<td style="padding-left: 10px;"><input type="text" name="code" id="code" size="6" maxlength="50" onKeyPress="return logins(event)" value="" autocomplete="off" class="input"></td>
											<td style="padding-left: 10px;"><button type="button" onClick="do_verify()" class="btn" id="btn_verify">Verify</button> &nbsp; <a href="JavaScript:void(0)" onClick="do_cancel(1)">cancel</a></td>
										</tr>
										</table>
									</div>
								</div>
							</td>
						</tr>
						</table>
					</div>
					</form>

					<?php endif ; ?>
				</div>
				<?php else: ?>
				<span class="info_error"><img src="../pics/icons/warning.png" width="12" height="12" border="0" alt=""> Add an <a href="../setup/ops.php" style="color: #FFFFFF;">Operator</a> to access this area.</span>
				<?php endif ; ?>
			</div>

<?php include_once( "../setup/inc_footer.php" ) ?>