<?php
	/***************************************/
	//
	//
	// PHP Live! Support
	//
	// https://www.phplivesupport.com
	//
	/***************************************/
	// STANDARD header for Setup
	if ( !is_file( "../web/config.php" ) ){ HEADER("location: install.php") ; exit ; }
	include_once( "../web/config.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Format.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Error.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/".Util_Format_Sanatize($CONF["SQLTYPE"], "ln") ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Security.php" ) ;
	if ( !$admininfo = Util_Security_AuthSetup( $dbh ) ){ ErrorHandler( 608, "Invalid setup session or session has expired.", $PHPLIVE_FULLURL, 0, Array() ) ; exit ; }
	// STANDARD header end
	/****************************************/

	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Vals.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Ops/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Ops/get_itr.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Depts/get.php" ) ;
	if ( is_file( "$CONF[CONF_ROOT]/addons.php" ) ) { include_once( "$CONF[CONF_ROOT]/addons.php" ) ; }

	$action = Util_Format_Sanatize( Util_Format_GetVar( "action" ), "ln" ) ;
	$jump = ( Util_Format_Sanatize( Util_Format_GetVar( "jump" ), "ln" ) ) ? Util_Format_Sanatize( Util_Format_GetVar( "jump" ), "ln" ) : "main" ;
	$deptid = Util_Format_Sanatize( Util_Format_GetVar( "deptid" ), "n" ) ;
	$proto = Util_Format_Sanatize( Util_Format_GetVar( "proto" ), "n" ) ;
	$position = Util_Format_Sanatize( Util_Format_GetVar( "position" ), "n" ) ;
	$error = "" ; $display = 0 ;

	if ( !isset( $VALS["OB_CLEAN"] ) ) { $VALS["OB_CLEAN"] = "on" ; }

	$code_maps = ( isset( $VALS_ADDONS ) && isset( $VALS_ADDONS["code_maps"] ) && $VALS_ADDONS["code_maps"] ) ? unserialize( base64_decode( $VALS_ADDONS["code_maps"] ) ) : Array() ;
	/***************************************/
	/* a check to make sure code.php is not in condition to limit confusion */
	$code_mapper_coexists = 0 ;
	foreach ( $code_maps as $mapid => $data )
	{
		if ( preg_match( "/,/", $data ) )
		{
			LIST( $thisdeptid, $map_string ) = explode( ",", $data ) ;
			$map_string_array = explode( "%2C", $map_string ) ;
			for( $c = 0; $c < count( $map_string_array ); ++$c )
			{
				$map_string_match = $map_string_array[$c] ;
				if ( $map_string_match && preg_match( "/$map_string_match/", "code.php" ) )
				{
					$code_mapper_coexists = 1 ;
					break 2 ;
				}
			}
		}
	}
	/***************************************/

	$departments = Depts_get_AllDepts( $dbh ) ;
	$ops_assigned = 0 ;
	for ( $c = 0; $c < count( $departments ); ++$c )
	{
		$department = $departments[$c] ;
		$ops = Depts_get_DeptOps( $dbh, $department["deptID"] ) ;
		if ( count( $ops ) )
			$ops_assigned = 1 ;
	}
	$deptinfo = Array() ;
	if ( $deptid )
		$deptinfo = Depts_get_DeptInfo( $dbh, $deptid ) ;

	$total_ops = Ops_get_TotalOps( $dbh ) ;
	$total_ops_online = Ops_get_itr_AnyOpsOnline( $dbh, $deptid ) ;

	$dept_query = $deptid ;
	if ( $action == "update_proto" )
	{
		include_once( "$CONF[DOCUMENT_ROOT]/API/Vars/update.php" ) ;

		$vars = Util_Format_Get_Vars( $dbh ) ;
		if ( ( $proto != $vars["code"] ) || !is_numeric( $vars["code"] ) )
		{
			include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Vals.php" ) ;

			$error = "" ;
			if ( !$proto )
			{
				$error = ( Util_Vals_WriteToConfFile( "BASE_URL", preg_replace( "/^(http:\/\/)|(https:\/\/)/i", "//", $CONF["BASE_URL"] ) ) ) ? "" : "Could not write to config file." ;
			}
			else if ( $proto == 1 )
				$error = ( Util_Vals_WriteToConfFile( "BASE_URL", preg_replace( "/^(https:\/\/)|(http:\/\/)|(\/\/)/i", "http://", $CONF["BASE_URL"] ) ) ) ? "" : "Could not write to config file." ;
			else if ( $proto == 2 )
			{
				$error = ( Util_Vals_WriteToConfFile( "BASE_URL", preg_replace( "/^(https:\/\/)|(http:\/\/)|(\/\/)/i", "https://", $CONF["BASE_URL"] ) ) ) ? "" : "Could not write to config file." ;
			}
			if ( !$error ) { Vars_update_Var( $dbh, "code", $proto ) ; }
		}
		Vars_update_Var( $dbh, "position", $position ) ;
	}
	else if ( $action == "add_extra_departments" )
	{
		$deptids = Util_Format_Sanatize( Util_Format_GetVar( "deptids" ), "a" ) ;

		$dept_query = "" ;
		for ( $c = 0; $c < count( $deptids ); ++$c )
			$dept_query .= $deptids[$c]."010" ;
	}
	else if ( $action == "proto_error" )
	{
		$error = "Could not detect HTTPS (SSL) support on this server." ;
	}
	else if ( $action == "update_ob_clean" )
	{
		include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Vals.php" ) ;

		$value = Util_Format_Sanatize( Util_Format_GetVar( "value" ), "ln" ) ;

		if ( $value && Util_Vals_WriteToFile( "OB_CLEAN", Util_Format_Trim( $value ) ) )
			$VALS["OB_CLEAN"] = $value ;
		else
			$error = "Could not write to vals file [OB: $value]." ;
	}

	/*************/
	/* Live Chat HTML Code */
	$position_css = "" ;
	$vars = Util_Format_Get_Vars( $dbh ) ;
	if ( isset( $vars["code"] ) )
	{
		$proto = $vars["code"] ;
		if ( !is_numeric( $proto ) ) { $proto = 0 ; }
		switch ( $vars["position"] )
		{
			case 2:
				$position_css = " position: fixed; bottom: 0px; right: $VARS_CHAT_PADDING_WIDGET"."px; z-index: 20000000;" ;
				break ;
			case 3:
				$position_css = " position: fixed; bottom: 0px; left: $VARS_CHAT_PADDING_WIDGET"."px; z-index: 20000000;" ;
				break ;
			case 4:
				$position_css = " position: fixed; top: 0px; right: $VARS_CHAT_PADDING_WIDGET"."px; z-index: 20000000;" ;
				break ;
			case 5:
				$position_css = " position: fixed; top: 0px; left: $VARS_CHAT_PADDING_WIDGET"."px; z-index: 20000000;" ;
				break ;
			case 6:
				$position_css = " position: fixed; top: 50%; left: 0px; z-index: 20000000;" ;
				break ;
			case 7:
				$position_css = " position: fixed; top: 50%; right: 0px; z-index: 20000000;" ;
				break ;
			default:
				$position_css = "" ;
		}

		// automatic fix for toggle
		if ( !$proto && preg_match( "/^http:/", $CONF["BASE_URL"] ) )
		{
			include_once( "$CONF[DOCUMENT_ROOT]/API/Vars/update.php" ) ;
			$error = ( Util_Vals_WriteToConfFile( "BASE_URL", preg_replace( "/^(http:)/i", "", $CONF["BASE_URL"] ) ) ) ? "" : "Could not write to config file." ;
		}
	}

	$base_url = $CONF["BASE_URL"] ;
	$source_url = "$base_url/js/phplive_v2.js.php?v={$deptid}%7C{$now}%7C{$proto}%7C" ;
	$code = "&lt;!-- BEGIN PHP Live! Live Chat HTML Code [v3] --&gt;-nl-&lt;span style=\"color: #0000FF; text-decoration: underline; line-height: 0px !important; cursor: pointer;$position_css\" id=\"phplive_btn_$now\"&gt;&lt;/span&gt;-nl-&lt;script data-cfasync=\"false\" type=\"text/javascript\"&gt;-nl--nl-(function() {-nl-var phplive_e_$now = document.createElement(\"script\") ;-nl-phplive_e_$now.type = \"text/javascript\" ;-nl-phplive_e_$now.async = true ;-nl-phplive_e_$now.src = \"$source_url%%text_string%%&\" ;-nl-document.getElementById(\"phplive_btn_$now\").appendChild( phplive_e_$now ) ;-nl-if ( [].filter ) { document.getElementById(\"phplive_btn_$now\").addEventListener( \"click\", function(){ phplive_launch_chat_$deptid() } ) ; } else { document.getElementById(\"phplive_btn_$now\").attachEvent( \"onclick\", function(){ phplive_launch_chat_$deptid() } ) ; }-nl-})() ;-nl-//phplive_auto-nl-&lt;/script&gt;-nl-&lt;!-- END PHP Live! Live Chat HTML Code [v3] --&gt;" ;

	$thecode = preg_replace( "/%%base_url%%/", $base_url, $code ) ;
	$code_html = preg_replace( "/&lt;/", "<", $thecode ) ;
	$code_html = preg_replace( "/&gt;/", ">", $code_html ) ;
	$code_html = preg_replace( "/-nl-/", "\r\n", $code_html ) ;
	/* Live Chat HTML Code */
	/*************/
	
	$online = ( isset( $VALS['ONLINE'] ) && $VALS['ONLINE'] ) ? unserialize( $VALS['ONLINE'] ) : Array( ) ;
	$offline = ( isset( $VALS['OFFLINE'] ) && $VALS['OFFLINE'] ) ? unserialize( $VALS['OFFLINE'] ) : Array() ;
	$offline_option = "icon" ;
	if ( isset( $offline[$deptid] ) )
	{
		if ( !preg_match( "/^(icon|hide)$/", $offline[$deptid] ) ) { $offline_option = "redirect" ; }
		else{ $offline_option = $offline[$deptid] ; }
	}
	else
	{
		if ( isset( $offline[0] ) )
		{
			if ( !preg_match( "/^(icon|hide)$/", $offline[0] ) ) { $offline_option = "redirect" ; }
			else{ $offline_option = $offline[0] ; }
		}
	}
	$dept_groups = Depts_get_AllDeptGroups( $dbh ) ;
?>
<?php include_once( "../inc_doctype.php" ) ?>
<head>
<title> PHP Live! Support </title>

<meta name="description" content="PHP Live! Support <?php echo $VERSION ?>">
<meta name="keywords" content="powered by: PHP Live!  www.phplivesupport.com">
<meta name="robots" content="all,index,follow">
<meta http-equiv="content-type" content="text/html; CHARSET=utf-8"> 
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<?php include_once( "../inc_meta_dev.php" ) ; ?>

<link rel="Stylesheet" href="../css/setup.css?<?php echo filemtime( "../css/setup.css" ) ?>">
<script data-cfasync="false" type="text/javascript" src="../js/global.js?<?php echo filemtime ( "../js/global.js" ) ; ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../js/framework.js?<?php echo $VERSION ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../js/jquery_md5.js?<?php echo $VERSION ?>"></script>

<script data-cfasync="false" type="text/javascript">
<!--
	var global_ob_clean = "<?php echo $VALS["OB_CLEAN"] ?>" ;
	var global_proto = "<?php echo $proto ?>" ;
	var global_position = <?php echo isset( $vars["position"] ) ? $vars["position"] : 1 ?> ;
	var phplive_html_code_global_div ; // to not show the chat icon for plain text embed close

	var st_proto_verify ;
	var thecode = '<?php echo $thecode ?>' ;
	thecode = thecode.replace( /-nl-/g, "\r\n" ) ;
	thecode = thecode.replace( /&lt;/g, "<" ) ;
	thecode = thecode.replace( /&gt;/g, ">" ) ;
	var phplive_browser = navigator.appVersion ; var phplive_mime_types = "" ;
	var phplive_display_width = "" ; var phplive_display_height = "" ; var phplive_display_color = "" ; var phplive_timezone = new Date().getTimezoneOffset() ;
	if ( navigator.mimeTypes.length > 0 ) { for (var x=0; x < navigator.mimeTypes.length; x++) { phplive_mime_types += navigator.mimeTypes[x].description ; } }
	var phplive_browser_gl = ( typeof( document.createElement("canvas").getContext ) != "undefined" ) ? document.createElement("canvas").getContext("webgl") : new Object ; var phplive_browser_gl_string = "" ; for ( var phplive_browser_gl in phplive_browser_gl ) { phplive_browser_gl_string += phplive_browser_gl+phplive_browser_gl[phplive_browser_gl] ; }
	var phplive_browser_token = phplive_md5( phplive_display_width+phplive_display_height+phplive_display_color+phplive_timezone+phplive_browser+phplive_mime_types+phplive_browser_gl_string ) ;

	$(document).ready(function()
	{
		$("html, body").css({'background': '#F2F3F5'}) ;
		check_protocol() ;
		init_menu() ;
		toggle_menu_setup( "html" ) ;

		populate_code( "standard" ) ;
		if ( typeof( show_div ) == "function" )
			show_div( "code_main" ) ;

		<?php if ( ( ( $action == "switch" ) || ( $action == "update_proto" ) ) && !$error ): ?>
			$('#div_new_code').delay(200).fadeIn("slow") ; do_alert(1, "New Live Chat HTML Code Generated", 3) ;
		<?php elseif ( ( $action == "update_proto" ) && $error ): ?>
			do_alert(0, "<?php echo $error ?>") ;
		<?php elseif ( ( $action == "proto_error" ) && $error ): ?>
			do_alert( 0, "<?php echo $error ?>" ) ;
		<?php elseif ( $action && !$error ): ?>
			do_alert( 1, "Update Success" ) ;
		<?php endif ; ?>
	});

	function switch_dept( theobject )
	{
		location.href = "code.php?deptid="+theobject.value+"&action=switch&proto=<?php echo $proto ?>&"+unixtime() ;
	}

	function populate_code( thetextarea )
	{
		var thiscode = thecode.replace( /\/\/phplive_auto/, "" ) ;
		if ( thetextarea == "standard" )
		{
			var code = thiscode.replace( /%%text_string%%/g, "" ) ;
			$('#textarea_code_'+thetextarea).val( code ) ;
		}
		else if ( thetextarea == "text" )
		{
			var text = encodeURI( $('#code_text').val() ) ;
			var code = thiscode.replace( /%%text_string%%/g, text ) ;
			code = code.replace( / line-height: (.*?);/, "" ) ;

			if ( text == "" )
				do_alert( 0, "Please provide the text." ) ;
			else
			{
				$('#code_text_code').show() ;

				<?php if ( !$total_ops_online && ( $offline_option == "hide" ) ): ?>
				$('#html_code_text_output').html("<span onClick=\"$('#div_text_link_offline').fadeOut('fast').fadeIn('fast').fadeOut('fast').fadeIn('fast').fadeOut('fast').fadeIn('fast')\" style=\"cursor: pointer;\">"+$('#code_text').val()+"</span>") ;
				<?php else: ?>
				$('#html_code_text_output').html("<span onClick=\"phplive_launch_chat_<?php echo $deptid ?>(0)\" style=\"cursor: pointer;\">"+$('#code_text').val()+"</span>") ;
				<?php endif ; ?>

				$('#textarea_code_'+thetextarea).val( code ) ;
				$('#html_code_text_output_tip').show() ;
				do_alert(1, "New Live Chat HTML Code Generated", 3) ;
			}
		}
		$('#div_textarea_text_wrapper').show() ;
	}

	function input_text_listen_text( e )
	{
		var key = -1 ;
		var shift ;

		key = e.keyCode ;
		shift = e.shiftKey ;

		if ( !shift && ( ( key == 13 ) || ( key == 10 ) ) )
			$('#btn_generate').click() ;
	}

	function toggle_code( theproto )
	{
		var unique = unixtime() ;
		var proto = $('input[name=proto]:checked', '#form_proto').val() ;
		var position = $('#position').val() ;

		if ( ( global_proto != proto ) || ( global_position != position ) )
		{
			var url = "<?php echo $CONF["BASE_URL"] ?>" ;
			var url_https = ( proto == 2 ) ? url.replace( /^(http:\/\/)|(\/\/)/i, "https://" ) : url ;

			$('#proto_verify').show() ;
			$('#iframe_proto_verify').attr('src', url_https+"/blank.php").ready(function() {
				toggle_code_doit() ;
			});
			if ( typeof( st_proto_verify ) != "undefined" ) { clearTimeout( st_proto_verify ) ; }
			st_proto_verify = setTimeout( function(){ location.href = "./code.php?action=proto_error" }, 10000 ) ;
		}
	}

	function toggle_code_doit()
	{
		var unique = unixtime() ;
		var proto = $('input[name=proto]:checked', '#form_proto').val() ;
		var position = $('#position').val() ;

		var url = "<?php echo $CONF["BASE_URL"] ?>" ;
		var url_https = ( proto == 2 ) ? url.replace( /^((http:\/\/)|(\/\/))/i, "https://" ) : url ;

		location.href = url_https+"/setup/code.php?action=update_proto&deptid=<?php echo $deptid ?>&proto="+proto+"&position="+position+"&"+unique ;
	}

	function show_html_code()
	{
		$('#btn_show').hide() ;
		$('#div_html_code').show() ;
	}

	function check_protocol()
	{
		var url = window.location.href ;
		var url_https = ( url.match( /^https:/i ) ) ? 1 : 0 ;

		// check for situations where the server always redirects http to https
		if ( url_https && ( <?php echo $proto ?> == 1 ) )
		{
			$('#div_always_https').show() ;
			$('#proto_radio_https').prop("checked", true) ;

			setTimeout( function(){ toggle_code() ; }, 3000 ) ;
		} return true ;
	}

	function do_redirect()
	{
		location.href = "code_invite.php?token="+phplive_browser_token ;
	}

	function toggle_html_code( thediv )
	{
		phplive_html_code_global_div = thediv ;
		var divs = Array( "standard", "text", "noj", "direct" ) ;

		for ( var c = 0; c < divs.length; ++c )
		{
			$('#menu_html_code_'+divs[c]).removeClass('op_submenu_focus').addClass('op_submenu3') ;
			$('#div_code_'+divs[c]).hide() ;
		}

		if ( thediv == "standard" )
		{
			$('#phplive_btn_<?php echo $now ?>').show() ;
			$('#phplive_btn_<?php echo $now ?>_clone').show() ;
		}
		else
		{
			$('#phplive_btn_<?php echo $now ?>').hide() ;
			$('#phplive_btn_<?php echo $now ?>_clone').hide() ;
		}

		$('#menu_html_code_'+thediv).removeClass('op_submenu3').addClass('op_submenu_focus') ;
		$('#div_code_'+thediv).show() ;
	}

	function toggle_ob()
	{
		if ( $('#settings_ob').is(':visible') )
			$('#settings_ob').hide() ;
		else
		{
			$('#settings_ob').show() ;
			$("html, body").animate( { scrollTop: $(document).height() }, "slow" ) ;
		}
	}

	function confirm_ob_clean( theob_clean )
	{
		if ( global_ob_clean != theob_clean )
		{
			location.href = "code.php?action=update_ob_clean&value="+theob_clean+"&deptid=<?php echo $deptid ?>&proto=<?php echo $proto ?>&position=<?php echo isset( $vars["position"] ) ? $vars["position"] : 1 ; ?>&"+unixtime() ;
		}
	}
//-->
</script>
</head>
<?php include_once( "./inc_header.php" ) ?>

		<?php
			if ( !$admininfo["isadmin"] && ( count( $admininfo["access"] ) && !isset( $admininfo["access"]["code"] ) ) ):
			include_once( "$CONF[DOCUMENT_ROOT]/setup/inc_access.php" ) ; else:
		?>
		<?php if ( !count( $departments ) ): ?>
		<div><span class="info_error"><img src="../pics/icons/warning.png" width="12" height="12" border="0" alt=""> Add a <a href="depts.php" style="color: #FFFFFF;">Department</a> to access this area.</span></div>
		<?php elseif ( !$total_ops ): ?>
		<div><span class="info_error"><img src="../pics/icons/warning.png" width="12" height="12" border="0" alt=""> Add an <a href="ops.php" style="color: #FFFFFF;">Operator</a> to access this area.</span></div>
		<?php elseif ( !$ops_assigned ): ?>
		<div><span class="info_error"><img src="../pics/icons/warning.png" width="12" height="12" border="0" alt=""> <a href="ops.php?jump=assign" style="color: #FFFFFF;">Assign an operator to a department</a> to access this area.</span></div>
		<?php
			else:
			$display = 1 ; $select_depts = 1 ;
			if ( count( $departments ) == 1 )
			{
				$department = $departments[0] ;
				if ( $department["visible"] )
					$select_depts = 0 ;
			}
		?>
		<?php endif ; ?>

		<?php
			if ( $display ):
			include_once( "$CONF[DOCUMENT_ROOT]/setup/inc_menu_code.php" ) ;
		?>

		<div style="">
			<?php if ( $select_depts ): ?>
			<form method="POST" action="" id="form_theform">
			<div class="info_white round_bottom_none" style="display: table; margin-left: 5px; border-bottom: 0px;">Department</div>
			<div style="margin-bottom: 25px;">
				<table cellspacing=0 cellpadding=0 border=0>
				<tr>
					<td><select name="deptid" id="deptid" style="font-size: 16px; padding: 14px; min-width: 525px;" OnChange="switch_dept( this )" class="info_dept">
						<option value="0">All Departments</option>
						<?php
							if ( $select_depts )
							{
								for ( $c = 0; $c < count( $departments ); ++$c )
								{
									$department = $departments[$c] ;

									if ( $department["name"] != "Archive" )
									{
										$selected = ( $deptid == $department["deptID"] ) ? "selected" : "" ;
										print "<option value=\"$department[deptID]\" $selected>$department[name]</option>" ;
									}
								}
								$deptgroupinfo = Array() ;
								for ( $c = 0; $c < count( $dept_groups ); ++$c )
								{
									$dept_group = $dept_groups[$c] ;
									$selected = ( $deptid == $dept_group["groupID"] ) ? "selected" : "" ;
									if ( $selected ) { $deptgroupinfo["deptID"] = $deptid ; $deptgroupinfo["name"] = $dept_group["name"] ; }
									print "<option value=\"$dept_group[groupID]\" $selected>$dept_group[name] (Department Group)</option>" ;
								}
							}
						?>
						</select>
						<?php if ( count( $departments ) && !$deptid ): ?>
						&nbsp; <span style="font-size: 18px; font-weight: bold; padding: 2px;" class="info_blue">&larr;</span> (optional) Select a department to generate a <b>Department Specific Live Chat HTML Code</b>.
						<?php endif ; ?>
					</td>
					<?php if ( $deptid && ( isset( $deptinfo["deptID"] ) || isset( $deptgroupinfo["deptID"] ) ) ): ?>
					<td style="padding-left: 15px;">
						<div style="line-height: 190%;"><span class="info_misc" style="padding: 2px;">This is a Department Specific Live Chat HTML Code</span>  Visitors will be automatically routed to this department when the chat icon is clicked.</div></div>
					</td>
					<?php endif ; ?>
				</tr>
				</table>
			</div>
			</form>
			<?php endif ; ?>
			<div style="width: 525px;">
				<form id="proto_pos">
				<div class="info_white round_bottom_none" style="display: table; margin-left: 5px; border-bottom: 0px;">Chat Icon Position</div>
				<select name="position" id="position" onChange="toggle_code()" style="width: 100%; font-size: 16px;">
					<option value="1" <?php echo ( $vars["position"] == 1 ) ? "selected" : "" ; ?>>Display the chat icon where the HTML code is placed on the page.</option>
					<option value="2" <?php echo ( $vars["position"] == 2 ) ? "selected" : "" ; ?>>Bottom Right (floating icon)</option>
					<option value="3" <?php echo ( $vars["position"] == 3 ) ? "selected" : "" ; ?>>Bottom Left (floating icon)</option>
					<option value="4" <?php echo ( $vars["position"] == 4 ) ? "selected" : "" ; ?>>Top Right (floating icon)</option>
					<option value="5" <?php echo ( $vars["position"] == 5 ) ? "selected" : "" ; ?>>Top Left (floating icon)</option>
					<option value="6" <?php echo ( $vars["position"] == 6 ) ? "selected" : "" ; ?>>Center Left (floating icon)</option>
					<option value="7" <?php echo ( $vars["position"] == 7 ) ? "selected" : "" ; ?>>Center Right (floating icon)</option>
				</select>
				</form>
			</div>

			<div style="width: 525px;">
				<form id="form_proto">
				<div class="info_white round_bottom_none" style="display: table; margin-top: 25px; margin-left: 5px; border-bottom: 0px;">Toggle or Always HTTPS</div>
				<div class="info_white">
					<div style="display: none; margin-top: 5px;" class="info_error" id="div_always_https">System has detected an Always HTTPS environment.</div>
					<div style="margin-top: 5px;"><input type="radio" name="proto" value="0" <?php echo ( !isset( $vars["code"] ) || !$vars["code"] ) ? "checked" : "" ?> onClick="toggle_code()"> Toggle <b><i>HTTP and HTTPS</i></b> based on the webpage URL</div>
					<div style="margin-top: 5px;"><input type="radio" id="proto_radio_https" name="proto" value="2" <?php echo ( $vars["code"] == 2 ) ? "checked" : "" ?> onClick="toggle_code()"> Always <b><i>HTTPS</i></b> <img src="../pics/icons/lock.png" width="16" height="16" border="0" alt=""> secure chats (SSL enabled servers)</div>
				</div>
				</form>
			</div>
		</div>
		<div style="margin-top: 25px;">

			<div style="display: none; margin-bottom: 15px; padding: 15px; text-align: center;" class="info_good" id="div_new_code">
				<div class="edit_title">New Live Chat HTML Code Generated.</div>
				<div style="margin-top: 5px;">To use these new settings, copy the new Live Chat HTML Code (displayed below) and paste or replace the code on your webpages.</div>
			</div>

			<?php if ( $code_mapper_coexists ): ?>
			<div style="margin-top: 25px; margin-bottom: 25px;"><span class="info_error"><b>Note</b></span> If the chat icon and the chat request window is not displaying the selected department, the <a href="../addons/code_mapper/code_mapper.php">Code Mapper addon</a> contains <code>code.php</code> as a mapped condition.</div>
			<?php endif ; ?>

			<div>
				<div style="margin-left: 0px; margin-top: 5px; padding: 15px; font-weight: normal; cursor: pointer;" class="op_submenu_focus" onClick="toggle_html_code('standard')" id="menu_html_code_standard">Standard Live Chat HTML Code (recommended)</div>
				<div style="margin-top: 5px; padding: 15px; font-weight: normal; cursor: pointer;" class="op_submenu3" onClick="toggle_html_code('noj')" id="menu_html_code_noj">No JavaScript, just an image with a link.</div>
				<div style="margin-top: 5px; padding: 15px; font-weight: normal; cursor: pointer;" class="op_submenu3" onClick="toggle_html_code('direct')" id="menu_html_code_direct">URL Link</div>
				<div style="margin-top: 5px; padding: 15px; font-weight: normal; cursor: pointer;" class="op_submenu3" onClick="toggle_html_code('text')" id="menu_html_code_text">Plain Text Link</div>
				<div style="clear: both;"></div>
			</div>
			<div style="padding: 25px; box-shadow: 0px 0px 5px rgba(0, 0, 0, 0.2);" class="info_dept round_top_none">
				<div style="font-size: 32px; font-weight: bold; text-shadow: 1px 1px #C8DAD6;">Copy and paste the below HTML Code to your webpages.</div>
				<div style="margin-bottom: 5px;">
					For best results, it is recommended to paste the below Live Chat HTML Code onto all of your webpages, anywhere after the &lt;body&gt; tag and before the closing &lt;/body&gt; tag.  For multiple chat icons on the same page, please reference the <a href="http://www.phplivesupport.com/r.php?r=multi" target="new" style=""><img src="../pics/icons/view.png" width="16" height="16" border="0" alt=""> documentation</a>.
				</div>
				<div id="div_code_standard">
					<div><textarea wrap="virtual" id="textarea_code_standard" style="font-size: 12px; padding: 25px; width: 96%; height: 260px; resize: none; outline: none; box-shadow: rgba(17, 17, 26, 0.1) 0px 8px 24px, rgba(17, 17, 26, 0.1) 0px 16px 56px, rgba(17, 17, 26, 0.1) 0px 24px 80px;" onMouseDown="setTimeout(function(){ $('#textarea_code_standard').select(); }, 200);" readonly></textarea></div>

					<?php if ( isset( $deptinfo["deptID"] ) && !$deptinfo["visible"] ): ?>
					<div class="info_error" style="margin-top: 15px;"><img src="../pics/icons/warning.png" width="12" height="12" border="0" alt=""> This department is <a href="depts.php?ftab=vis" style="">not visible for selection</a> but visitors can still reach this department with the above Live Chat HTML Code.</div>
					<?php endif ; ?>

					<div style="margin-top: 10px;">The above Live Chat HTML Code will produce the following chat icon.</div>

					<?php if ( !$total_ops_online && ( $offline_option == "hide" ) ): ?>
					<div class="info_error" style="margin-top: 5px;">Reminder: Offline chat icon is not displayed based on the current <a href="icons.php?deptid=<?php echo $deptid ?>&jump=settings" style="">offline setting</a>.</div>
					<?php endif; ?>
					<div style="margin-top: 5px;" id="output_code"><?php echo preg_replace( "/%%text_string%%/", "", $code_html ) ?></div>
				</div>

				<div id="div_code_text" style="display: none;">
					<div id="div_textarea_text_wrapper" style="display: none;"><textarea wrap="virtual" id="textarea_code_text" style="font-size: 12px; padding: 25px; width: 96%; height: 260px; resize: none; outline: none; box-shadow: rgba(17, 17, 26, 0.1) 0px 8px 24px, rgba(17, 17, 26, 0.1) 0px 16px 56px, rgba(17, 17, 26, 0.1) 0px 24px 80px;" onMouseDown="setTimeout(function(){ $('#textarea_code_text').select(); }, 200);" readonly></textarea></div>

					<div style="margin-top: 10px;">
						<div class="info_box" style="display: none; margin-bottom: 15px; width: 70%;" id="html_code_text_output_tip">
							<img src="../pics/icons/info.png" width="16" height="16" border="0" alt=""> To achieve design consistency with your website, modify the &lt;span&gt; style portion of the above code.
						</div>
						<div><input type="text" class="input" size="25" maxlength="155" id="code_text" onKeydown="input_text_listen_text(event);" value="Click for Live Chat"> <input type="button" value="Generate" onClick="populate_code('text')" id="btn_generate" class="btn"></div>
						<div style="margin-top: 10px;">
							Example: <i>"Click for Live Chat"</i>
							<div id="code_text_code" style="display: none; margin-top: 10px;">The above code will produce the following text link.</div>
							<div id="html_code_text_output" style="margin-top: 5px; color: #0000FF; text-decoration: underline;"></div>
							<?php if ( !$total_ops_online && ( $offline_option == "hide" ) ): ?>
							<div class="info_error" style="margin-top: 15px;" id="div_text_link_offline">Reminder: When chat is offline, the text link will not be displayed based on the current <a href="icons.php?deptid=<?php echo $deptid ?>&jump=settings">offline setting</a>.</div>
							<?php endif ; ?>
						</div>
						<div style="margin-top: 25px;" class="info_action">
							<table cellspacing=0 cellpadding=0 border=0>
							<tr>
								<td nowrap><img src="../pics/icons/info.png" width="16" height="16" border="0" alt=""> <span class="title">Alternative Method</span></td>
								<td style="padding-left: 5px;">Instead of just a plain text, display a styled text link using <a href="icons.php?deptid=<?php echo $deptid ?>&jump2=text" style="color: #757575;">Chat Icon With Text</a>.  The "Chat Icon With Text" alternative method does not require updating the Live Chat HTML Code on your webpages.</td>
							</tr>
							</table>
						</div>
					</div>
				</div>

				<div id="div_code_noj" style="display: none;">
					<textarea wrap="virtual" id="textarea_code_plain" style="font-size: 12px; padding: 25px; width: 96%; height: 85px; resize: none; outline: none; box-shadow: rgba(17, 17, 26, 0.1) 0px 8px 24px, rgba(17, 17, 26, 0.1) 0px 16px 56px, rgba(17, 17, 26, 0.1) 0px 24px 80px;" onMouseDown="setTimeout(function(){ $('#textarea_code_plain').select(); }, 200);" readonly>&lt;!-- BEGIN PHP Live! Live Chat HTML Code --&gt;
<a href="<?php echo $base_url ?>/phplive.php?d=<?php echo $dept_query ?>&onpage=livechatimagelink&title=Live+Chat+Image+Link" target="_blank"><img src="<?php echo $base_url ?>/ajax/image.php?d=<?php echo $dept_query ?>" border=0 alt="Live Chat" title="Live Chat"></a>
&lt;!-- END PHP Live! Live Chat HTML Code --&gt;</textarea>

					<div style="margin-top: 10px;">
						<img src="../pics/icons/warning.png" width="12" height="12" border="0" alt=""> Automatic chat invite, operator chat invite and real-time visitor footprint monitor/tracking will not be available for this code option due to the lack of JavaScript.
					</div>
					<div style="margin-top: 15px;">The above Live Chat HTML Code will produce the following chat icon.</div>
					<div style="margin-top: 5px;"><a href="<?php echo $base_url ?>/phplive.php?d=<?php echo $dept_query ?>&onpage=livechatimagelink&title=Live+Chat+Image+Link" target="_blank"><img src="<?php echo $base_url ?>/ajax/image.php?d=<?php echo $dept_query ?>" border=0 alt="Live Chat" title="Live Chat"></a></div>
				</div>

				<div id="div_code_direct" style="display: none;">
					<div style=""><textarea wrap="virtual" id="textarea_code_direct" style="font-size: 12px; padding: 25px; width: 96%; height: 55px; resize: none; outline: none; box-shadow: rgba(17, 17, 26, 0.1) 0px 8px 24px, rgba(17, 17, 26, 0.1) 0px 16px 56px, rgba(17, 17, 26, 0.1) 0px 24px 80px;" onMouseDown="setTimeout(function(){ $('#textarea_code_direct').select(); }, 200);" readonly><?php echo $base_url ?>/phplive.php?d=<?php echo $dept_query ?>&onpage=livechatimagelink&title=Live+Chat+Direct+Link</textarea></div>

					<div style="margin-top: 10px;">URL link to request a chat.</div>
				</div>
			</div>

			<div style="margin-top: 15px;" class="info_neutral"><b>Related Feature:</b> The setting to open the chat as an <b>embed</b> or <b>popup</b> window can be set at the <a href="icons.php?jump=settings">Chat Icons settings area</a>.</div>

			<div style="margin-top: 5px;" class="info_neutral">
				<table cellspacing=0 cellpadding=0 border=0 width="100%">
				<tr>
					<td valign="top" width="16"><img src="../pics/icons/info.png" width="16" height="16" border="0" alt=""></td>
					<td style="padding-left: 5px;" valign="top">
						<b>Note:</b> If you do not see the chat icon on this page, try updating the "Image Output OB Clean" setting.
						<div style="margin-top: 5px;">For most server enviornments, this setting can be on or off, it won't affect anything.  But for some server enviornments, it must be set to "Off" to display the chat icon.</div>
						<div style="margin-top: 5px;"><button type="button" style="padding: 5px;" onClick="toggle_ob()">Image Output OB Clean Setting</button></div>

						<div style="display: none; margin-top: 15px;" id="settings_ob">
							<hr>
							<div style="padding-top: 15px; font-size: 14px; font-weight: bold;">Image Output "OB Clean"</div>

							<div style="margin-top: 15px;">(default is On) If the chat icon is not displaying, it may be because of a server setting.  In these situations, simply switch the <b>OB Clean</b> to <b>Off</b> to correct the issue.</div>
							<div style="margin-top: 15px;">
								<div class="info_good" style="float: left; width: 60px; cursor: pointer;" onclick="$('#ob_clean_on').prop('checked', true);confirm_ob_clean('on');"><input type="radio" name="ob_clean" id="ob_clean_on" value="on" <?php echo ( $VALS["OB_CLEAN"] != "off" ) ? "checked" : "" ?>> On</div>
								<div class="info_error" style="float: left; margin-left: 10px; width: 60px; cursor: pointer;" onclick="$('#ob_clean_off').prop('checked', true);confirm_ob_clean('off');"><input type="radio" name="ob_clean" id="ob_clean_off" value="off" <?php echo ( $VALS["OB_CLEAN"] == "off" ) ? "checked" : "" ?>> Off</div>
								<div style="clear: both;"></div>
							</div>
						</div>
					</td>
				</tr>
				</table>
			</div>

		</div>

		<?php endif ; ?>

		<?php endif ; ?>

		<div style="display: none;"><iframe id='iframe_proto_verify' src='about:blank' scrolling='no' border=0 frameborder=0></iframe></div>
<?php include_once( "./inc_footer.php" ) ?>