<?php
	/***************************************/
	//
	//
	// PHP Live! Support
	//
	// https://www.phplivesupport.com
	//
	/***************************************/
	// STANDARD header for Setup
	if ( !is_file( "../web/config.php" ) ){ HEADER("location: install.php") ; exit ; }
	include_once( "../web/config.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Format.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Error.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/".Util_Format_Sanatize($CONF["SQLTYPE"], "ln") ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Security.php" ) ;
	if ( !$admininfo = Util_Security_AuthSetup( $dbh ) ){ ErrorHandler( 608, "Invalid setup session or session has expired.", $PHPLIVE_FULLURL, 0, Array() ) ; exit ; }
	// STANDARD header end
	/****************************************/

	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Vals.php" ) ;
	if ( is_file( "$CONF[DOCUMENT_ROOT]/API/Util_Extra_Pre.php" ) ) { include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Upload_.php" ) ; }
	else { include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Upload.php" ) ; }
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Upload_File.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Ops/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Ops/get_itr.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Depts/get.php" ) ;

	$action = Util_Format_Sanatize( Util_Format_GetVar( "action" ), "ln" ) ;
	$token = Util_Format_Sanatize( Util_Format_GetVar( "token" ), "ln" ) ;
	$jump = ( Util_Format_GetVar( "jump" ) ) ? Util_Format_Sanatize( Util_Format_GetVar( "jump" ), "ln" ) : "image" ;
	$deptid = Util_Format_Sanatize( Util_Format_GetVar( "deptid" ), "n" ) ;
	$error = "" ; $display = 0 ;

	$departments = Depts_get_AllDepts( $dbh ) ;
	$ops_assigned = 0 ;
	for ( $c = 0; $c < count( $departments ); ++$c )
	{
		$department = $departments[$c] ;
		$ops = Depts_get_DeptOps( $dbh, $department["deptID"] ) ;
		if ( count( $ops ) )
			$ops_assigned = 1 ;
	}
	$deptinfo = Array() ;
	if ( $deptid )
		$deptinfo = Depts_get_DeptInfo( $dbh, $deptid ) ;

	$total_ops = Ops_get_TotalOps( $dbh ) ;
	$total_ops_online = Ops_get_itr_AnyOpsOnline( $dbh, $deptid ) ;

	if ( ( $action === "clear" ) && ( isset( $CONF['icon_initiate'] ) && $CONF['icon_initiate'] ) )
	{
		$error = ( Util_Vals_WriteToConfFile( "icon_initiate", "" ) ) ? "" : "Could not write to config file." ;
	}
	else if ( $action === "update_image" )
	{
		LIST( $error, $filename ) = Util_Upload_File( "icon_initiate", 0 ) ;
		if ( !$error )
		{
			if ( isset( $dbh ) && isset( $dbh['con'] ) ) { database_mysql_close( $dbh ) ; }
			HEADER( "location: code_invite.php?action=success" ) ; exit ;
		}
	}
	else if ( $action == "update_criteria" )
	{
		$onoff = Util_Format_Sanatize( Util_Format_GetVar( "onoff" ), "n" ) ;
		$duration = Util_Format_Sanatize( Util_Format_GetVar( "duration" ), "n" ) ;
		$andor = Util_Format_Sanatize( Util_Format_GetVar( "andor" ), "n" ) ;
		$footprints = Util_Format_Sanatize( Util_Format_GetVar( "footprints" ), "n" ) ;
		$reset = Util_Format_Sanatize( Util_Format_GetVar( "reset" ), "n" ) ;
		$pos = Util_Format_Sanatize( Util_Format_GetVar( "pos" ), "n" ) ;
		$exin = Util_Format_Sanatize( Util_Format_GetVar( "exin" ), "ln" ) ;
		$exclude = preg_replace( "/[;*\/:\[\]\"\']/", "", stripslashes( Util_Format_Sanatize( Util_Format_GetVar( "exclude" ), "ln" ) ) ) ;

		if ( !$onoff )
		{
			$initiate = Array() ;
			$initiate["pos"] = $pos ;
			$initiate_serialize = serialize( $initiate ) ;
			$admininfo["initiate"] = $initiate_serialize ;
			$error = ( Util_Vals_WriteToFile( "auto_initiate", htmlentities( $initiate_serialize ) ) ) ? "" : "Could not write to vals file." ;
		}
		else
		{
			$exclude_array = explode( ",", $exclude ) ;
			$exclude_string = "" ;
			for ( $c = 0; $c < count( $exclude_array ); ++$c )
			{
				$temp = preg_replace( "/ +/", "", $exclude_array[$c] ) ;
				if ( $temp )
					$exclude_string .= "$temp," ;
			}
			if ( $exclude_string ) { $exclude_string = substr_replace( $exclude_string, "", -1 ) ; }

			$initiate = Array() ;
			$initiate["duration"] = ( is_numeric( $duration ) ) ? $duration : 5 ;
			$initiate["andor"] = $andor ;
			$initiate["footprints"] = $footprints ;
			$initiate["reset"] = $reset ;
			$initiate["exclude"] = $exclude_string ;
			$initiate["pos"] = $pos ;
			$initiate["exin"] = $exin ;

			$initiate_serialize = serialize( $initiate ) ;
			$admininfo["initiate"] = $initiate_serialize ;

			if ( $andor )
			{
				$error = ( Util_Vals_WriteToFile( "auto_initiate", htmlentities( $initiate_serialize ) ) ) ? "" : "Could not write to vals file." ;
				if ( !$error )
				{
					database_mysql_close( $dbh ) ;
					HEADER( "location: code_invite.php?action=success&jump=criteria" ) ; exit ;
				}
			}
		}
	}
	else if ( $action == "reset" )
	{
		$query = "UPDATE p_ips SET i_footprints = 0 WHERE i_footprints <> 0" ;
		database_mysql_query( $dbh, $query ) ;
		$jump = "clear" ;
	}

	$ips = isset( $VALS['TRAFFIC_EXCLUDE_IPS'] ) ? explode( "-", $VALS['TRAFFIC_EXCLUDE_IPS'] ) : Array() ; $ips_exclude = 0 ;
	for ( $c = 0; $c < count( $ips ); ++$c )
	{
		if ( $ips[$c] ) { ++$ips_exclude ; }
	}
	$initiate = ( isset( $VALS["auto_initiate"] ) && $VALS["auto_initiate"] ) ? unserialize( html_entity_decode( $VALS["auto_initiate"] ) ) : Array() ;
	$automatic_invite_pos = ( isset( $initiate["pos"] ) ) ? $initiate["pos"] : 1 ;
	if ( !is_numeric( $automatic_invite_pos ) || ( $automatic_invite_pos == 1 ) || ( $automatic_invite_pos > 4 ) ) { $automatic_invite_show = "left,3em" ; $automatic_invite_start = "top: 40%; left: -800px;" ; }
	else if ( $automatic_invite_pos == 2 ) { $automatic_invite_show = "right,3em" ; $automatic_invite_start = "top: 40%; right: -800px;" ; }
	else if ( $automatic_invite_pos == 3 ) { $automatic_invite_show = "bottom,3em" ; $automatic_invite_start = "bottom: -800px; left: 3em;" ; }
	else { $automatic_invite_show = "bottom,3em" ; $automatic_invite_start = "bottom: -800px; right: 3em;" ; }
	$initiate_chat_image = Util_Upload_GetInitiate( 0 ) ;
?>
<?php include_once( "../inc_doctype.php" ) ?>
<head>
<title> PHP Live! Support </title>

<meta name="description" content="PHP Live! Support <?php echo $VERSION ?>">
<meta name="keywords" content="powered by: PHP Live!  www.phplivesupport.com">
<meta name="robots" content="all,index,follow">
<meta http-equiv="content-type" content="text/html; CHARSET=utf-8"> 
<?php include_once( "../inc_meta_dev.php" ) ; ?>

<link rel="Stylesheet" href="../css/setup.css?<?php echo filemtime( "../css/setup.css" ) ?>">
<script data-cfasync="false" type="text/javascript" src="../js/global.js?<?php echo filemtime ( "../js/global.js" ) ; ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../js/framework.js?<?php echo $VERSION ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../js/jquery_md5.js?<?php echo $VERSION ?>"></script>

<script data-cfasync="false" type="text/javascript">
<!--
	var phplive_browser = navigator.appVersion ; var phplive_mime_types = "" ;
	var phplive_display_width = "" ; var phplive_display_height = "" ; var phplive_display_color = "" ; var phplive_timezone = new Date().getTimezoneOffset() ;
	if ( navigator.mimeTypes.length > 0 ) { for (var x=0; x < navigator.mimeTypes.length; x++) { phplive_mime_types += navigator.mimeTypes[x].description ; } }
	var phplive_browser_gl = ( typeof( document.createElement("canvas").getContext ) != "undefined" ) ? document.createElement("canvas").getContext("webgl") : new Object ; var phplive_browser_gl_string = "" ; for ( var phplive_browser_gl in phplive_browser_gl ) { phplive_browser_gl_string += phplive_browser_gl+phplive_browser_gl[phplive_browser_gl] ; }
	var phplive_browser_token = phplive_md5( phplive_display_width+phplive_display_height+phplive_display_color+phplive_timezone+phplive_browser+phplive_mime_types+phplive_browser_gl_string ) ;

	$(document).ready(function()
	{
		$("html, body").css({'background': '#F2F3F5'}) ;
		init_menu() ;
		toggle_menu_setup( "marketing" ) ;
		if ( typeof( show_div ) == "function" )
			show_div( "code_invite" ) ;

		show_subdiv( "<?php echo $jump ?>" ) ;

		<?php if ( $action == "demo" ): ?>do_alert( 1, "Launching Invite" ) ; phplive_automatic_chat_invite_window_build() ;
		<?php elseif ( ( $action == "reset" ) && !$error ): ?>do_alert( 1, "Clear Success" ) ;
		<?php elseif ( $action && !$error ): ?>do_alert( 1, "Update Success" ) ;
		<?php elseif ( $action && $error ): ?>do_alert_div( "..", 0, "<?php echo $error ?>" ) ;
		<?php endif ; ?>
	});

	function show_subdiv( thediv )
	{
		var divs = Array( "image", "criteria", "demo", "clear" ) ;
		for ( var c = 0; c < divs.length; ++c )
		{
			$('#div_sub_'+divs[c]).hide() ;
			$('#menu_sub_'+divs[c]).removeClass('op_submenu_focus').addClass('op_submenu3') ;
		}

		$('#div_sub_'+thediv).show() ;
		$('#menu_sub_'+thediv).removeClass('op_submenu3').addClass('op_submenu_focus') ;

		if ( thediv == "criteria" )
		{
			if ( <?php echo isset( $initiate["exin"] ) ? 1 : 0 ; ?> )
			{
				$('#onoff_on').prop('checked', true) ;
				toggle_onoff( 1 ) ;
			}
			else
			{
				$('#onoff_off').prop('checked', true) ;
				toggle_onoff( 0 ) ;
			}
		}
	}

	function toggle_onoff( theflag )
	{
		if ( theflag )
		{
			$('#div_on').show() ;
		}
		else
		{
			$('#div_on').hide() ;
		}
	}

	function confirm_clear()
	{
		if ( confirm( "Really reset the chat invite image?" ) )
		{
			location.href = "code_invite.php?action=clear&<?php echo $now ?>" ;
		}
	}

	function confirm_reset_data()
	{
		if ( confirm( "Really clear the stored data for all previous visitors?" ) )
		{
			location.href = "code_invite.php?action=reset&<?php echo $now ?>" ;
		}
	}

	var phplive_automatic_chat_invite_processed = 0 ;
	var phplive_globals = new Object ;
	phplive_globals["icon_initiate"] = "<?php echo $initiate_chat_image ?>" ;
	phplive_globals["icon_initiate_bg"] = "<?php echo $CONF["BASE_URL"] ?>/themes/initiate/bg_trans.png" ;
	phplive_globals["icon_initiate_close"] = "<?php echo $CONF["BASE_URL"] ?>/themes/initiate/close_box.png" ;
	phplive_globals["invite_pos"] = <?php echo $automatic_invite_pos ?> ;
	phplive_globals["invite_start"] = "<?php echo $automatic_invite_start ?>" ;
	phplive_globals["invite_show"] = "<?php echo $automatic_invite_show ?>" ;
	function phplive_automatic_chat_invite_window_build()
	{
		var invite_show = phplive_globals["invite_show"].split( ',' ) ;
		var invite_pos = {} ; invite_pos[invite_show[0]] = invite_show[1] ;

		if ( !phplive_automatic_chat_invite_processed )
		{
			var phplive_automatic_chat_invite_div = "<div id='phplive_automatic_chat_invite_wrapper' style='display: none; position: fixed !important; background: url( ../themes/initiate/bg_trans.png ) repeat; "+phplive_globals["invite_start"]+" border-radius: 5px; z-Index: 1000005 !important;'>"+
				"<div style='text-align: right !important; padding: 3px; padding-top: 8px; padding-right: 15px;'><span onClick='phplive_automatic_chat_invite_window_close()' style='cursor: pointer;'><img src='"+phplive_globals["icon_initiate_close"]+"' border='0' style='width: 20px !important; height: 20px !important; border-radius: 2px;'></span></div>"+
				"<div style='padding: 12px; padding-top: 0px; border-radius: 5px;'><span onClick='phplive_automatic_chat_invite_accept()' style='cursor: pointer;'><img src='"+phplive_globals["icon_initiate"]+"' border=0 style='max-width: 100% !important; max-height: 100% !important; border-radius: 5px;'></span></div>"+
			"</div>" ;
			$( "body" ).append( phplive_automatic_chat_invite_div ).promise( ).done(function( ) {
				phplive_automatic_chat_invite_processed = 1 ;
				if ( phplive_globals["invite_pos"] > 4 )
				{
					// needs delay for center to process correctly
					setTimeout( function(){ $('#phplive_automatic_chat_invite_wrapper').center( ).fadeIn( 'fast' ) ; }, 400 ) ;
				}
				else
				{
					$('#phplive_automatic_chat_invite_wrapper').show( ).animate(invite_pos, 1500, function( ) {
						//
					}) ;
				}
			}) ;
		}
	}

	function phplive_automatic_chat_invite_window_close()
	{
		$('#phplive_automatic_chat_invite_wrapper').fadeOut( 'fast' ) ;
	}

	function phplive_automatic_chat_invite_accept()
	{
		$('#phplive_automatic_chat_invite_wrapper').fadeOut( 'fast' ) ;
	}
//-->
</script>
</head>
<?php include_once( "./inc_header.php" ) ?>

		<?php
			if ( !$admininfo["isadmin"] && ( count( $admininfo["access"] ) && !isset( $admininfo["access"]["market"] ) ) ):
			include_once( "$CONF[DOCUMENT_ROOT]/setup/inc_access.php" ) ; else:
		?>
		<?php if ( !count( $departments ) ): ?>
		<span class="info_error"><img src="../pics/icons/warning.png" width="12" height="12" border="0" alt=""> Add a <a href="depts.php" style="color: #FFFFFF;">Department</a> to access this area.</span>
		<?php elseif ( !$total_ops ): ?>
		<span class="info_error"><img src="../pics/icons/warning.png" width="12" height="12" border="0" alt=""> Add an <a href="ops.php" style="color: #FFFFFF;">Operator</a> to access this area.</span>
		<?php elseif ( !$ops_assigned ): ?>
		<span class="info_error"><img src="../pics/icons/warning.png" width="12" height="12" border="0" alt=""> <a href="ops.php?jump=assign" style="color: #FFFFFF;">Assign an operator to a department</a> to access this area.</span>
		<?php
			else:
			$display = 1 ;
		?>
		<?php endif ; ?>

		<?php
			if ( $display ):
			include_once( "$CONF[DOCUMENT_ROOT]/setup/inc_menu_marketing.php" ) ;
		?>

		<div style="margin-top: 25px;">
			<div>
				<div id="menu_sub_image" class="op_submenu3" style="margin-left: 0px;" onClick="show_subdiv('image')">Chat Invite Image</div>
				<div id="menu_sub_criteria" class="op_submenu3" onClick="show_subdiv('criteria')">Invite Criteria</div>
				<div id="menu_sub_demo" class="op_submenu3" onClick="show_subdiv('demo')">View Invite</div>
				<div id="menu_sub_clear" class="op_submenu3" onClick="show_subdiv('clear')">Clear Data</div>
				<div style="clear: both"></div>
			</div>

			<div style="margin-top: 45px;">
				<div style=" margin-bottom: 35px;">On webpages that have the <a href="./code.php">Standard Live Chat HTML Code</a>, automatically display a chat invite to the visitor when <a href="JavaScript:void(0)" onClick="show_subdiv('criteria')">certain criterias</a> are met <span class="info_good">AND when an operator is Online</span>.</div>

				<div id="div_sub_image" style="display: none;">
					<form method="POST" action="code_invite.php" enctype="multipart/form-data">
					<input type="hidden" name="action" value="update_image">
					<input type="hidden" name="token" value="<?php echo $token ?>">
					<input type="hidden" name="jump" value="image">
					<input type="hidden" name="MAX_FILE_SIZE" value="200000">

					<table cellspacing=0 cellpadding=0 border=0>
					<tr>
						<td valign="top" width="270">
							<div style="box-shadow: <?php echo $VARS_UI_POPUP_BOXSHADOW ?>;" class="info_neutral round">
								<div class="edit_title info_clear">Chat Invite Image</div>
								<div style="margin-top: 5px; background: url( ../themes/initiate/bg_trans.png ) repeat;" class="round">
									<div style="text-align: right; padding: 3px; padding-top: 8px; padding-right: 15px;"><img src="../themes/initiate/close_box.png" width="20" height="20" border="0" alt=""></div>
									<div style="padding: 12px; padding-top: 0px;"><span style=""><img src="<?php echo $initiate_chat_image ?>" border="0" alt="" class="round"></span></div>
								</div>
							</div>
						</td>
						<td valign="top" style="padding-left: 30px;">
							<div class="op_submenu_focus" style="margin-left: 0px;">Update Chat Invite Image</div>
							<div style="clear: both"></div>
							<ul style="padding-left: 0px; margin-top: 15px;">
								<li> Max image file size: 300 KB</li>
								<li style="margin-top: 15px; line-height: 160%;"> <span class="info_warning" style="padding: 2px;"><b>IMPORTANT</b></span> The image will be displayed in its original size (not scaled).  The recommended image size is 250px width and 160px height</li>
							</ul>

							<div id="div_alert" style="display: none; margin-top: 15px;"></div>
							<div style="margin-top: 25px;">
								<div><input type="file" name="icon_initiate" size="30"></div>
								<div style="margin-top: 25px;">
									<input type="submit" value="Upload Image" class="btn">
									<?php if ( isset( $CONF['icon_initiate'] ) && $CONF['icon_initiate'] ): ?> &nbsp; &nbsp; <img src="../pics/icons/reset.png" width="16" height="16" border="0" alt=""> <a href="JavaScript:void(0)" onClick="confirm_clear()">reset the chat invite image to the original</a><?php endif ; ?>
								</div>
							</div>
						</td>
					</tr>
					</table>
					</form>
				</div>
				<div id="div_sub_criteria" style="display: none;">
					<div style="">
						<form method="POST" action="code_invite.php" enctype="multipart/form-data">
						<input type="hidden" name="action" value="update_criteria">
						<input type="hidden" name="token" value="<?php echo $token ?>">
						<input type="hidden" name="jump" value="criteria">
						<input type="hidden" name="MAX_FILE_SIZE" value="200000">
						<div>
							<table cellspacing=0 cellpadding=0 border=0>
							<tr>
								<td><div class="tab_form_title">Active</div></td>
								<td style="padding-left: 10px;">
									<div>
										<div class="info_good" style="float: left; width: 60px; cursor: pointer;" onClick="$('#onoff_on').prop('checked', true);toggle_onoff(1);"><input type="radio" name="onoff" id="onoff_on" value="1" onClick="toggle_onoff(1)" <?php echo isset( $initiate["exin"] ) ? "checked" : "" ; ?>> Active</div>
										<div class="info_error" style="float: left; margin-left: 10px; width: 60px; cursor: pointer;"  onClick="$('#onoff_off').prop('checked', true);toggle_onoff(0);"><input type="radio" name="onoff" id="onoff_off" value="0" onClick="toggle_onoff(0)" <?php echo !isset( $initiate["exin"] ) ? "checked" : "" ; ?>> Off</div>
										<div style="clear: both;"></div>
									</div>
								</td>
							</tr>
							</table>
						</div>
						<div style="margin-top: 25px;">
							<table cellspacing=0 cellpadding=0 border=0>
							<tr>
								<td><div class="tab_form_title">Invite Display Position</div></td>
								<td style="padding-left: 10px;">
									<select name="pos" id="pos" style="">
										<option value="1" <?php echo ( !isset( $initiate["pos"] ) || ( $initiate["pos"] == 1 ) ) ? "selected" : "" ; ?> >Center Left</option>
										<option value="2" <?php echo ( isset( $initiate["pos"] ) && ( $initiate["pos"] == 2 ) ) ? "selected" : "" ; ?> >Center Right</option>
										<option value="3" <?php echo ( isset( $initiate["pos"] ) && ( $initiate["pos"] == 3 ) ) ? "selected" : "" ; ?> >Bottom Left</option>
										<option value="4" <?php echo ( isset( $initiate["pos"] ) && ( $initiate["pos"] == 4 ) ) ? "selected" : "" ; ?> >Bottom Right</option>
									</select>
								</td>
							</tr>
							</table>
						</div>
						<div id="div_on" style="display: none;">
							<div style="margin-top: 25px;">
								<table cellspacing=0 cellpadding=0 border=0 width="100%">
								<tr>
									<td nowrap><div class="tab_form_title">Criteria</div></td>
									<td width="100%" style="padding-left: 10px;">
										On the same page for <select name="duration">
										<?php
											$options = Array(
												5 => "5 seconds",
												15 => "15 seconds",
												30 => "30 seconds",
												60 => "1 minute",
												90 => "1 min 30 sec",
												120 => "2 minutes",
												150 => "2 min 30 sec",
												180 => "3 minutes",
												300 => "5 minutes"
											) ;
											foreach ( $options as $numeric => $value )
											{
												$selected = "" ;
												if ( isset( $initiate["duration"] ) && ( $initiate["duration"] == $numeric ) )
													$selected = "selected" ;

												print "<option value='$numeric' $selected>$value</option>" ;
											}
										?></select>
										<select name="andor"><option value="2" <?php echo ( isset( $initiate["andor"] ) && ( $initiate["andor"] == 2 ) ) ? "selected" : "" ?> >and</option><option value="1" <?php echo ( isset( $initiate["andor"] ) && ( $initiate["andor"] == 1 ) ) ? "selected" : "" ?> >or</option></select>
										<select name="footprints">
										<?php
											for( $c = 1; $c <= 25; ++$c )
											{
												$selected = "" ;
												if ( isset( $initiate["footprints"] ) && ( $initiate["footprints"] == $c ) )
													$selected = "selected" ;

												print "<option value=\"$c\" $selected>$c</option>" ;
											}
										?></select> page views.
										<div style="margin-top: 5px;">After the critera has been met, the chat invite will continue to display from page to page until the visitor takes action (clicks or declines the invite).</div>
									</td>
								</tr>
								</table>
							</div>
							<div style="margin-top: 25px;">
								<table cellspacing=0 cellpadding=0 border=0>
								<tr>
									<td valign="top"><div class="tab_form_title">Criteria Reset</div></td>
									<td valign="top" style="padding-left: 10px;">
										<div style="">After the visitor takes action (clicks or declines the invite), reset the criteria and process the criteria again after   
											<select name="reset">
											<option value=".08" <?php echo ( isset( $initiate["reset"] ) && ( $initiate["reset"] == .08 ) ) ? "selected" : "" ; ?>>5 minutes</option>
											<option value=".25" <?php echo ( isset( $initiate["reset"] ) && ( $initiate["reset"] == .15 ) ) ? "selected" : "" ; ?>>15 minutes</option>
											<option value=".50" <?php echo ( isset( $initiate["reset"] ) && ( $initiate["reset"] == .30 ) ) ? "selected" : "" ; ?>>30 minutes</option>
											<option value=".75" <?php echo ( isset( $initiate["reset"] ) && ( $initiate["reset"] == .75 ) ) ? "selected" : "" ; ?>>45 minutes</option>
											<?php
												for( $c = 1; $c <= 48; ++$c )
												{
													$selected = "" ;
													if ( ( isset( $initiate["reset"] ) && ( $initiate["reset"] == $c ) ) || ( !isset( $initiate["reset"] ) && ( $c == 1 ) ) )
														$selected = "selected" ;
													print "<option value=\"$c\" $selected>$c hours</option>" ;
												}
											?></select>.
											<div style=""><img src="../pics/icons/info.png" width="16" height="16" border="0" alt=""> If the invite was already processed on a page, any reset will happen when the visitor navigates to another page.</div>
										</div>
									</td>
								</tr>
								</table>
							</div>
							<div style="margin-top: 25px;">
								<table cellspacing=0 cellpadding=0 border=0>
								<tr>
									<td valign="top"><div class="tab_form_title">Exclude or Include<div style="font-weight: normal;">(optional)</div></div></td>
									<td valign="top" style="padding-left: 10px;">
										<div style="">
											<select name="exin" id="exin" style="width: 100%;">
												<option value="exclude" <?php echo ( isset( $initiate["exin"] ) && ( $initiate["exin"] == "exclude" ) ) ? "selected" : "" ; ?> >EXCLUDE automatic chat invite for webpage URLs that contain:</option>
												<option value="include" <?php echo ( isset( $initiate["exin"] ) && ( $initiate["exin"] == "include" ) ) ? "selected" : "" ; ?>>INCLUDE automatic chat invite for only the webpage URLs that contain:</option>
											</select>
										</div>

										<div style="margin-top: 5px;">
											<ul>
												<li> Separate the values with a comma (,) without spaces</li>
												<li> Provide the page itself and not the full URL. Example: <code>purchase.php, checkout.html, trial.asp</code></li>
												<li> Full domain name can be provided.  Example: <code>mysite1.com, mysite3.com</code></li>
												<li> Quotes ("), forward slash (/), back slash (\) and other special characters will be automatically omitted</li>
											</ul>

											<div style="margin-top: 5px;"><input type="text" class="input" size="65" name="exclude" id="exclude" onKeydown="input_text_listen_prevent(event);" onKeyPress="return noquotes(event)" value="<?php echo ( isset( $initiate["exclude"] ) && $initiate["exclude"] ) ? $initiate["exclude"] : "" ; ?>"></div>

											<div style="<?php echo ( $ips_exclude ) ? "" : "display: none;" ; ?> margin-top: 25px;"><img src="../pics/icons/info.png" width="16" height="16" border="0" alt=""> Automatic chat invite will not be displayed for <a href="settings.php">Excluded IPs</a>.</div>
										</div>
									</td>
								</tr>
								</table>
							</div>
						</div>

						<div style="margin-top: 25px;">
							<table cellspacing=0 cellpadding=0 border=0>
							<tr>
								<td><div class="tab_form_title" style="background: #F2F3F5; border: 0px; text-align: left; font-weight: normal;">&nbsp;</div></td>
								<td style="padding-left: 10px;">
									<input type="submit" value="Save Settings" class="btn">
								</td>
							</tr>
							</table>
						</div>
						</form>

					</div>
				</div>
				<div id="div_sub_demo" style="display: none;" class="info_neutral">
					<div>For this area, clicking the invite preview will simply close the chat invite.  For your website visitors, clicking the invite will open the chat request window.</div>
					<div style="margin-top: 15px;"><button type="button" class="btn" onClick="location.href='code_invite.php?action=demo&jump=demo'">Launch Invite</button></div>
				</div>
				<div id="div_sub_clear" style="display: none;" class="info_neutral">
					<div>Clear the stored Automatic Chat Invite data for all previous visitors and process the <a href="JavaScript:void(0)" onClick="show_subdiv('criteria')">Automatic Chat Invite criteria</a> again, starting at zero page views.  The chat reports will not be affected nor cleared.  This action simply resets the page view counter for all previous visitors.</div>
					<div style="margin-top: 25px;"><button type="button" class="btn" onClick="confirm_reset_data()">Clear Data</button></div>
				</div>

			</div>
		</div>
		<?php endif ; ?>

		<?php endif ; ?>

<?php include_once( "./inc_footer.php" ) ?>