<?php
	/***************************************/
	//
	//
	// PHP Live! Support
	//
	// https://www.phplivesupport.com
	//
	/***************************************/
	// STANDARD header for Setup
	if ( !is_file( "../web/config.php" ) ){ HEADER("location: install.php") ; exit ; }
	include_once( "../web/config.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Format.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Error.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/".Util_Format_Sanatize($CONF["SQLTYPE"], "ln") ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Security.php" ) ;
	if ( !$admininfo = Util_Security_AuthSetup( $dbh ) ){ ErrorHandler( 608, "Invalid setup session or session has expired.", $PHPLIVE_FULLURL, 0, Array() ) ; exit ; }
	// STANDARD header end
	/****************************************/

	include_once( "$CONF[DOCUMENT_ROOT]/API/Depts/get.php" ) ;

	$action = Util_Format_Sanatize( Util_Format_GetVar( "action" ), "ln" ) ;
	$error = "" ;

	$departments = Depts_get_AllDepts( $dbh, "display ASC, name ASC" ) ;

	$can_cats_admin = ( isset( $VALS["can_cats"] ) && $VALS["can_cats"] ) ? $VALS["can_cats"] : "" ;

	// make hash for quick refrence
	$can_cats_prefill = "{ \"1111111111\":[], " ;
	$dept_hash = Array() ;
	$dept_hash[1111111111] = "All Departments" ;
	for ( $c = 0; $c < count( $departments ); ++$c )
	{
		$department = $departments[$c] ;
		$dept_hash[$department["deptID"]] = $department["name"] ;

		$can_cats_prefill .= " \"$department[deptID]\":[], " ;
	} $can_cats_prefill = preg_replace( "/, $/", "", $can_cats_prefill ) ;
	$can_cats_prefill .= " }" ;
?>
<?php include_once( "../inc_doctype.php" ) ?>
<head>
<title> PHP Live! Support </title>

<meta name="description" content="PHP Live! Support <?php echo $VERSION ?>">
<meta name="keywords" content="powered by: PHP Live!  www.phplivesupport.com">
<meta name="robots" content="all,index,follow">
<meta http-equiv="content-type" content="text/html; CHARSET=utf-8"> 
<?php include_once( "../inc_meta_dev.php" ) ; ?>

<link rel="Stylesheet" href="../css/setup.css?<?php echo filemtime( "../css/setup.css" ) ?>">
<link rel="Stylesheet" href="../js/jquery-ui.min.css?<?php echo $VERSION ?>">
<script data-cfasync="false" type="text/javascript" src="../js/global.js?<?php echo filemtime ( "../js/global.js" ) ; ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../js/framework.js?<?php echo $VERSION ?>"></script>

<script data-cfasync="false" type="text/javascript">
<!--
	var global_deptid = 0 ; var global_deptid_cat ; var global_catid ;
	var global_auto_canid = parent.auto_canid ;
	var cans = [] ;
	var cats_backup = {} ; var cats = new Object ;
	if ( typeof( JSON ) != "undefined" )
	{
		try{
			cats_backup = ( <?php echo ( $can_cats_admin ) ? 1 : 0 ; ?>  ) ? JSON.parse( decodeURIComponent( "<?php echo ( $can_cats_admin ) ? rawurlencode( base64_decode(  $can_cats_admin ) ) : "" ; ?>" ) ) : JSON.parse( '<?php echo $can_cats_prefill ?>' ) ;
		} catch(e){ }
		cats = jQuery.extend( true, {}, cats_backup ) ;
	}

	$(document).ready(function()
	{
		$("html, body").css({'background': '#F2F3F5'}) ;
		init_menu() ;
		toggle_menu_setup( "depts" ) ;

		<?php if ( $action && !$error ): ?>do_alert( 1, "Update Success" ) ;
		<?php elseif ( $action && $error ): ?>do_alert( 0, "<?php echo $error ?>" ) ;
		<?php endif ; ?>

		if ( typeof( JSON ) != "undefined" ) { $('#div_cans_categories_ok').show() ; }
		else { $('#div_cans_categories_error').show() ; }

		print_categories() ;
	});

	function toggle_categories( theflag )
	{
		$('#div_alert_confirm').hide() ;
		$('#div_save').show() ;

		if ( theflag )
		{
			delete( cats ) ; cats = jQuery.extend( true, {}, cats_backup ) ;
			print_categories() ;

			$('#btn_reset').hide() ;
		}
	}

	function print_categories()
	{
		for ( var thisdeptid in cats )
		{
			var cats_array = cats[thisdeptid] ;
			$('#div_dept_'+thisdeptid).empty() ;

			for ( var c = 0; c < cats_array.length; ++c )
			{
				$('#div_dept_'+thisdeptid).append( print_row( thisdeptid, c, cats_array[c] ) ) ;
			}
		}
	}

	function add_cat( thedeptid, thecatid, theevent )
	{
		var click_y = theevent.pageY - $(window).scrollTop() ;

		global_deptid_cat = thedeptid ;
		global_catid = thecatid ;

		$('#div_add_cat_wrapper').fadeIn("fast") ;
		$('#cat_name').focus() ;
		$('#div_add_cat').css({'top': click_y}) ;
	}

	function prep_add_cat()
	{
		var thisdeptid = global_deptid_cat ;

		var name = $('#cat_name').val().replace( /<(.*?)>/g, "" ).nquotes() ;
		$('#cat_name').val(name) ;

		if ( name == "" )
		{
			do_alert( 0, "Please provide a Category Name." ) ;
		}
		else
		{
			if ( typeof( cats[thisdeptid] ) == "undefined" )
			{
				cats[thisdeptid] = new Array() ;
			}

			if ( typeof( global_catid ) != "undefined" )
			{
				$('#span_cat_name_'+thisdeptid+"_"+global_catid).html( name ) ;
				cats[thisdeptid][global_catid] = name ;
			}
			else
			{
				cats[thisdeptid].push( name ) ;
				var array_index = cats[thisdeptid].length - 1 ;
				$('#div_dept_'+thisdeptid).append( print_row( thisdeptid, array_index, name ) ) ;
			}

			$('#cat_name').val('') ;
			$('#div_add_cat_wrapper').fadeOut("fast") ;

			$('#btn_reset').show() ;
		}
	}

	function print_row( thedeptid, thecatid, thename )
	{
		return "<div style=\"margin-top: 15px; padding-left: 45px;\"><img src=\"../themes/initiate/category.png\" width=\"16\" height=\"16\" border=0 alt=\"category\" title=\"category\"> &nbsp; <img src=\"../pics/icons/edit.png\" width=\"16\" height=\"16\" border=0 alt=\"edit\" title=\"edit\" onClick=\"prep_edit_cat(event, "+thedeptid+", "+thecatid+" )\" style=\"cursor: pointer;\"> &nbsp; <img src=\"../pics/icons/delete.png\" width=\"16\" height=\"16\" border=0 alt=\"delete\" title=\"delete\" onClick=\"prep_delete_cat("+thedeptid+", "+thecatid+" )\" style=\"cursor: pointer;\"> &nbsp; <span id=\"span_cat_name_"+thedeptid+"_"+thecatid+"\">"+thename+"</span></div>" ;
	}

	function prep_edit_cat( theevent, thedeptid, thecatid )
	{
		global_catid = thecatid ;
		$('#cat_name').val(cats[thedeptid][global_catid]) ;

		add_cat( thedeptid, global_catid, theevent ) ;
	}

	function prep_delete_cat( thedeptid, thecatid )
	{
		if ( typeof( cats[thedeptid] ) != "undefined" )
			cats[thedeptid].splice( thecatid, 1 ) ;

		var cats_string = "" ;
		for ( var c = 0; c < cats[thedeptid].length; ++c )
		{
			var name = cats[thedeptid][c] ;

			cats_string += print_row( thedeptid, c, name ) ;
		}
		$('#div_dept_'+thedeptid).hide().html(cats_string).fadeIn("slow") ;
	}

	function do_listen_cat( e )
	{
		var key = e.keyCode ;
		var shift = e.shiftKey 

		if ( !shift && ( ( key == 13 ) || ( key == 10 ) ) )
		{
			prep_add_cat() ;
		}
	}

	var total_cat_cans = new Object ;
	function init_total_cat_cans()
	{
		for ( var c = 0; c < cans.length; ++c )
		{
			var caninfo = cans[c] ;
			var template = decodeURIComponent( caninfo["template"] ) ;
			var title = decodeURIComponent( caninfo["title"] ) ;
			var message = decodeURIComponent( caninfo["message"] ) ;

			var matches = template.match( /tr_dept_(.*?)_(.*?)_/i ) ;
			var tempdeptid = ( ( typeof( matches[1] ) != "undefined" ) && ( matches[1] != "" ) ) ? parseInt( matches[1] ) : "" ;
			var thiscatid = ( ( typeof( matches[2] ) != "undefined" ) && ( matches[2] != "" ) ) ? parseInt( matches[2] ) : "" ;

			var thedeptid = ( parseInt( thiscatid ) != -1 ) ? tempdeptid+"_"+thiscatid+"_" : tempdeptid ;

			var tr_id = "tr_dept_"+thedeptid+"_" ; tr_id = tr_id.replace( /__/, "_" ) ;

			if ( typeof( total_cat_cans[tr_id] ) == "undefined" )
				total_cat_cans[tr_id] = 0 ;
			++total_cat_cans[tr_id] ;

			if ( parseInt( thiscatid ) != -1 )
			{
				tr_id = tr_id.replace( /^tr_dept_(.*?)_(.*?)_$/, "tr_dept_"+tempdeptid+"_" ) ;
				if ( typeof( total_cat_cans[tr_id] ) == "undefined" )
					total_cat_cans[tr_id] = 0 ;
				++total_cat_cans[tr_id] ;
			}
		}
	}

	function do_save( theflag )
	{
		if ( !obj_length( cats_backup ) && !obj_length( cats.length ) )
			do_alert( 0, "There are no changes." ) ;
		else if ( JSON.stringify( cats_backup ) == JSON.stringify( cats ) )
			do_alert( 0, "There are no changes." ) ;
		else if ( <?php echo ( $can_cats_admin == "" ) ? 1 : 0 ; ?> && !theflag )
		{
			$('#div_save').hide() ;
			$('#div_alert_confirm').show() ;
		}
		else
		{
			var unique = unixtime() ;
			var json_data = new Object ;

			var cats_string = encodeURIComponent( JSON.stringify( cats ) ) ;

			$.ajax({
			type: "POST",
			url: "../ajax/setup_actions_.php",
			data: "action=can_cats&value="+cats_string+"&"+unique,
			success: function(data){
				eval( data ) ;

				if ( json_data.status )
					location.href = "dept_canned_cats.php?action=success" ;
				else
					do_alert( 0, json_data.error ) ;
			},
			error:function (xhr, ajaxOptions, thrownError){
				do_alert( 0, "Lost connection to server.  Please refresh the page and try again." ) ;
			} });
		}
	}
//-->
</script>
</head>
<?php include_once( "./inc_header.php" ) ?>

		<?php
			if ( !$admininfo["isadmin"] && ( count( $admininfo["access"] ) && !isset( $admininfo["access"]["depts"] ) ) ):
			include_once( "$CONF[DOCUMENT_ROOT]/setup/inc_access.php" ) ; else:
		?>
		<div class="op_submenu_wrapper">
			<div class="op_submenu" style="margin-left: 0px;" onClick="location.href='depts.php'">Chat Departments</div>
			<div class="op_submenu" onClick="location.href='dept_display.php'">Department Select Display Order</div>
			<div class="op_submenu" onClick="location.href='dept_groups.php'">Department Groups</div>
			<div class="op_submenu_focus">Shared Canned Response Categories</div>
			<div style="clear: both"></div>
		</div>

		<?php if ( !count( $departments ) ): ?>
		<div style="margin-top: 45px;">
			<span class="info_error"><img src="../pics/icons/warning.png" width="12" height="12" border="0" alt=""> Add a <a href="depts.php" style="color: #FFFFFF;">Department</a> to access this area.</span>
		</div>
		<?php else: ?>

		<div style="margin-top: 45px;">
			<div>Canned response categories created here will be available to <a href="ops.php?jump=assign">all operators assigned to the department</a>.  These canned categories will be available when adding/editing a canned response at the <a href="depts.php?ftab=cans">Department Shared Canned Responses</a> area.</div>

			<div style="margin-top: 15px;" class="info_box">If canned response categories are created here for any of the departments listed below, the operators will not be able to create/edit their own canned response categories because these categories will be used. If there are no categories in this area, the system will automatically allow the operators to create/edit their own canned response categories.</div>
			<div style="margin-top: 25px;">
				<div id="div_cans_categories_ok" style="display: none;">
					<?php
						for ( $c = 0; $c < count( $departments ); ++$c )
						{
							$department = $departments[$c] ;

							print "<div style=\"margin-bottom: 15px;\" class=\"info_neutral\">
									<div style=\"font-size: larger;\"><b>$department[name]</b></div>
									<div style=\"margin-top: 5px;\"><button type=\"button\" onClick=\"add_cat($department[deptID], undeefined, event)\" style=\"cursor: pointer;\">+ add canned response category</button></div>
									<div id=\"div_dept_$department[deptID]\"></div>
								</div>" ;
						}
						print "<div style=\"margin-bottom: 15px;\" class=\"info_neutral\" id=\"div_global_cat\">
							<div>All Departments</div>
							<div style=\"margin-top: 5px;\"><button type=\"button\" onClick=\"add_cat(1111111111, undeefined, event)\" style=\"cursor: pointer;\">+ add canned response category</button></div>
							<div id=\"div_dept_1111111111\"></div>
						</div>" ;
					?>

					<div style="margin-top: 25px;">
						<div class="info_warning">
							<table cellspacing=0 cellpadding=0 border=0>
							<tr>
								<td><img src="../pics/icons/warning.gif" width="16" height="16" border="0" alt="" class="info_white"></td>
								<td style="padding-left: 5px;">If an <a href="ops.php">operator</a> is Online, they must logout and login again for the changes to take affect on their operator console.</td>
							</tr>
							</table>
						</div>
						<div style="display: none; margin-top: 15px;" class="info_error" id="div_alert_confirm">
							You are about to disable the ability for operators to create their own canned response categories.  If they have already created their own categories, these categories will replace their categories.
							<div style="margin-top: 15px;">
								<div class="title">Are you sure?</div>
								<div style="margin-top: 15px;"><button type="button" onClick="do_save(1)" class="btn">Yes. Save.</button> &nbsp; &nbsp; &nbsp; <span style="text-decoration: underline; cursor: pointer;" onClick="toggle_categories(0)">cancel</span></div>
							</div>
						</div>
						<div style="margin-top: 15px;" id="div_save"><button type="button" onClick="do_save(0)" class="btn">Save Changes</button> &nbsp; <button type="button" class="btn" id="btn_reset" onClick="toggle_categories(1)" style="display: none;">Reset</button></div>
					</div>
				</div>
				<div id="div_cans_categories_error" style="display: none;">
					<div class="info_error">Canned response categories not available on this web browser.  For best online and chat experience, please use a modern web browser (example: Google Chrome, Firefox).</div>
				</div>
			</div>
		</div>
		<?php endif ; ?>
		<?php endif ; ?>

<div id="div_add_cat_wrapper" style="display: none; position: fixed; top: 0px; left: 0px; height: 100%; padding: 25px; background: url( ../themes/initiate/bg_trans_dark.png ) repeat; overflow: hidden; z-index: 20; box-shadow: <?php echo $VARS_UI_POPUP_BOXSHADOW ?>;">
	<div id="div_add_cat" class="info_info" style="position: relative; margin: 0 auto; top: 230px; padding: 25px; box-shadow: 5px 5px 15px rgba(0, 0, 0, 0.2);">
		<span style="font-size: 14px; font-weight: bold;">Category Name:</span> <input type="text" size="25" maxlength="45" id="cat_name" class="input" onKeyUp="return do_listen_cat(event)" autocomplete="off"> &nbsp; <button type="button" onClick="prep_add_cat()" class="btn">Submit</button> &nbsp; &nbsp; <a href="JavaScript:void(0)" onClick="global_catid=0;$('#div_add_cat_wrapper').fadeOut('fast');$('#cat_name').val('');">cancel</a>
	</div>
</div>

<?php include_once( "./inc_footer.php" ) ?>