<?php
	/***************************************/
	//
	//
	// PHP Live! Support
	//
	// https://www.phplivesupport.com
	//
	/***************************************/
	// STANDARD header for Setup
	if ( !is_file( "../web/config.php" ) ){ HEADER("location: install.php") ; exit ; }
	include_once( "../web/config.php" ) ;

	if ( !isset( $CONF['SQLTYPE'] ) ) { $CONF['SQLTYPE'] = "SQL.php" ; }
	else if ( $CONF['SQLTYPE'] == "mysql" ) { $CONF['SQLTYPE'] = "SQL.php" ; }

	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Format.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Error.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/".Util_Format_Sanatize($CONF["SQLTYPE"], "ln") ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Security.php" ) ;
	if ( !$admininfo = Util_Security_AuthSetup( $dbh ) ){ ErrorHandler( 608, "Invalid setup session or session has expired.", $PHPLIVE_FULLURL, 0, Array() ) ; exit ; }
	// STANDARD header end
	/****************************************/
	/* AUTO PATCH */
	if ( !is_file( "$CONF[CONF_ROOT]/patches/$patch_v" ) )
	{
		$query = isset( $_SERVER["QUERY_STRING"] ) ? Util_Format_Sanatize( $_SERVER["QUERY_STRING"], "query" ) : "" ;
		if ( isset( $dbh ) && isset( $dbh['con'] ) ) { database_mysql_close( $dbh ) ; }
		HEADER( "location: ../patch.php?from=setup&".$query."&" ) ; exit ;
	}

	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Vals.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Functions.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Depts/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Ops/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Ops/update_itr.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Chat/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Chat/get_ext.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Chat/remove.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Reports/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Footprints/get_ext.php" ) ;
	if ( is_file( "$CONF[DOCUMENT_ROOT]/API/Util_Extra_Pre.php" ) ) { include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Upload_.php" ) ; }
	else { include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Upload.php" ) ; }

	$action = Util_Format_Sanatize( Util_Format_GetVar( "action" ), "ln" ) ;
	$init = Util_Format_Sanatize( Util_Format_GetVar( "init" ), "n" ) ;
	if ( $admininfo["status"] == -1 ) { $init = 0 ; }
	$error = "" ;
	$theme = "default" ;

	Ops_update_itr_IdleOps( $dbh ) ;
	// double check safe measure
	$vars = Util_Format_Get_Vars( $dbh ) ;
	if ( !isset( $vars["code"] ) )
	{
		include_once( "$CONF[DOCUMENT_ROOT]/API/Vars/update.php" ) ;
		Vars_update_Var( $dbh, "code", 0 ) ;
	}

	$departments = Depts_get_AllDepts( $dbh ) ;
	$operators = Ops_get_AllOps( $dbh, 1 ) ;
	$t_transcripts = Chat_ext_get_TotalTranscript( $dbh ) ;
	$query = "SELECT SUM(rateit) AS rateit, SUM(ratings) AS ratings FROM p_rstats_depts" ;
	database_mysql_query( $dbh, $query ) ;
	$data = database_mysql_fetchrow( $dbh ) ;
	$t_rating = ( isset( $data["rateit"] ) && $data["rateit"] ) ? round( $data["ratings"]/$data["rateit"] ) : 0 ;
	$t_rating = Util_Functions_Stars( "..", $t_rating ) ;
	$t_requests = Chat_ext_get_AllRequests( $dbh, 0 ) ;
	$is_assigned = Ops_get_TotalOpsAssigned( $dbh ) ;
	$global_default_logo = Util_Upload_GetLogo( "logo", 0 ) ;
	$timezone_array = explode( "/", $CONF["TIMEZONE"] ) ; 
	$timezone = end( $timezone_array ) ;

	$message = Util_Format_Sanatize( Util_Format_GetVar( "message" ), "ln" ) ;

	$pr = Util_Format_Sanatize( Util_Format_GetVar( "pr" ), "n" ) ;
	if ( $pr ) { database_mysql_close( $dbh ) ; HEADER( "location: settings_profile.php?pr=$pr&init=$init" ) ; exit ; }

	$total_operators = 0 ;
	$operators_hash = Array() ;
	for ( $c = 0; $c < count( $operators ); ++$c )
	{
		$operator = $operators[$c] ;
		if ( $operator["login"] != "phplivebot" )
		{
			$operators_hash[$operator["opID"]] = $operator["name"] ;
			++$total_operators ;
		}
	}
	for ( $c = 0; $c < count( $departments ); ++$c )
	{
		$department = $departments[$c] ;
		Chat_remove_ExpiredTranscript( $dbh, $department["deptID"], $department["texpire"] ) ;
	}

	$ips = isset( $VALS['CHAT_SPAM_IPS'] ) ? explode( "-", $VALS['CHAT_SPAM_IPS'] ) : Array() ; $ips_spam = 0 ;
	for ( $c = 0; $c < count( $ips ); ++$c )
	{
		if ( $ips[$c] ) { ++$ips_spam ; }
	}

	$created = date( "M j, Y", $admininfo["created"] ) ;
	$diff = time() - $admininfo["created"] ; $days_running = round( $diff/(60*60*24) ) ;

	$m = date( "m", $now ) ;
	$d = date( "j", $now ) ;
	$y = date( "Y", $now ) ;
	$stat_end = mktime( 0, 0, 1, $m, $d, $y ) ;
	$stat_end_day = date( "j", $stat_end ) ;

	$now_start = $now - (60*60*24*14) ;
	$m = date( "m", $now_start ) ;
	$d = date( "j", $now_start ) ;
	$y = date( "Y", $now_start ) ;
	$stat_start = mktime( 0, 0, 1, $m, $d, $y ) ;
	$stat_start_day = date( "j", $stat_start ) ;

	$requests_timespan = Chat_get_ext_RequestsRangeHash( $dbh, $stat_start, $stat_end, $operators, 0 ) ;
	$wstats = Reports_get_Stat( $dbh, "p_wstats", 0, $stat_start, $stat_end ) ;
	$wstats_max = 0 ;
	foreach ( $wstats as $sdate => $data )
	{
		if ( ( $data["wl"] + $data["wlo"] ) > $wstats_max )
			$wstats_max = $data["wl"] + $data["wlo"] ;
	}

	$month_stats = Array() ;
	$month_total_requests = $month_total_taken = $month_total_declined = $month_total_message = $month_total_initiated = 0 ;
	$month_max_chat = 0 ;
	foreach ( $requests_timespan as $sdate => $deptop )
	{
		// todo: filter for invalid dates (should be fixed with timezone reset)
		if ( isset( $deptop["depts"] ) )
		{
			foreach ( $deptop["depts"] as $key => $value )
			{
				if ( !isset( $month_stats[$sdate] ) )
				{
					$month_stats[$sdate] = Array() ;
					$month_stats[$sdate]["requests"] = $month_stats[$sdate]["taken"] = $month_stats[$sdate]["declined"] = $month_stats[$sdate]["message"] = $month_stats[$sdate]["initiated"] = 0 ;
				}

				$month_stats[$sdate]["requests"] += $value["requests"] ;
				$month_stats[$sdate]["taken"] += $value["taken"] ;
				$month_stats[$sdate]["declined"] += $value["declined"] ;
				$month_stats[$sdate]["message"] += $value["message"] ;
				$month_stats[$sdate]["initiated"] += $value["initiated"] ;

				if ( $sdate )
				{
					$month_total_requests += $value["requests"] ;
					$month_total_taken += $value["taken"] ;
					$month_total_declined += $value["declined"] ;
					$month_total_initiated += $value["initiated"] ;
					$month_total_message += $value["message"] ;
				}

				$rating = ( $value["rateit"] ) ? round( $value["ratings"]/$value["rateit"] ) : 0 ;
			}
		}
		if ( isset( $deptop["ops"] ) )
		{
			foreach ( $deptop["ops"] as $key => $value )
			{
				$rating = ( $value["rateit"] ) ? round( $value["ratings"]/$value["rateit"] ) : 0 ;
			}
		}

		if ( isset( $month_stats[$sdate]["requests"] ) && ( $month_stats[$sdate]["requests"] > $month_max_chat ) && $sdate )
			$month_max_chat = $month_stats[$sdate]["requests"] ;
	}

	$dir_files_custom = is_dir( $CONF["DOCUMENT_ROOT"]."/custom_code/" ) ? glob( $CONF["DOCUMENT_ROOT"]."/custom_code/*", GLOB_NOSORT ) : Array() ;
	if ( !isset( $CONF['API_KEY'] ) ) { $CONF['API_KEY'] = Util_Format_RandomString( 10 ) ; Util_Vals_WriteToConfFile( "API_KEY", $CONF['API_KEY'] ) ; }
?>
<?php include_once( "../inc_doctype.php" ) ?>
<head>
<title> PHP Live! Support </title>

<meta name="description" content="PHP Live! Support <?php echo $VERSION ?>">
<meta name="keywords" content="powered by: PHP Live!  www.phplivesupport.com">
<meta name="robots" content="all,index,follow">
<meta http-equiv="content-type" content="text/html; CHARSET=utf-8">
<?php include_once( "../inc_meta_dev.php" ) ; ?>

<link rel="Stylesheet" href="../css/setup.css?<?php echo filemtime( "../css/setup.css" ) ?>">
<style>
.rotate_gear {
	animation: rotation 2s infinite linear;
}
@keyframes rotation {
  from {
    transform: rotate(0deg);
  }
  to {
    transform: rotate(359deg);
  }
}
</style>
<script data-cfasync="false" type="text/javascript" src="../js/global.js?<?php echo filemtime ( "../js/global.js" ) ; ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../js/framework.js?<?php echo $VERSION ?>"></script>

<script data-cfasync="false" type="text/javascript">
<!--
	var st_rd ;
	var global_c_chat ;

	$(document).ready(function()
	{
		$("html, body").css({'background': '#F2F3F5'}) ;

		init_menu() ;
		toggle_menu_setup( "home" ) ;

		$('#div_greeting').show() ;

		<?php if ( $action === "success" ): ?>do_alert( 1, "<?php echo ( $message ) ? $message : 'Success' ; ?>" ) ;<?php endif ; ?>

		<?php if ( $init ): ?>
		$('#div_body_wrapper').hide() ;
		$('body').css({'overflow':'hidden'}) ;
		$('#div_init').fadeIn("slow") ;
		<?php endif ; ?>

	});

	function remote_disconnect( theopid, thelogin )
	{
		if ( typeof( st_rd ) != "undefined" ) { do_alert( 0, "Another disconnect in progress." ) ; return false ; }

		if ( confirm( "Remote disconnect operator console ("+thelogin+")?" ) )
		{
			var json_data = new Object ;

			$('#op_login').html( thelogin ) ;
			$('#remote_disconnect_notice').center().show() ;

			$.ajax({
				type: "POST",
				url: "../ajax/setup_actions.php",
				data: "action=remote_disconnect&opid="+theopid+"&"+unixtime(),
				success: function(data){
					eval( data ) ;

					if ( json_data.status )
						check_op_status( theopid ) ;
					else
					{
						$('#remote_disconnect_notice').hide() ;
						do_alert( 0, "Could not remote disconnect console.  Please try again." ) ;
					}
				}
			});
		}
	}

	function check_op_status( theopid )
	{
		var unique = unixtime() ;
		var json_data = new Object ;

		if ( typeof( st_rd ) != "undefined" ) { clearTimeout( st_rd ) ; }

		$.ajax({
		type: "POST",
		url: "../wapis/status_op.php",
		data: "opid="+theopid+"&jkey=<?php echo md5( $CONF['API_KEY'] ) ?>&"+unique,
		success: function(data){
			eval( data ) ;

			if ( !parseInt( json_data.status ) )
				location.href = 'index.php?action=success&'+unique ;
			else
				st_rd = setTimeout( function(){ check_op_status( theopid ) ; }, 2000 ) ;
		},
		error:function (xhr, ajaxOptions, thrownError){
			do_alert( 0, "Lost connection to server.  Please refresh the page and try again." ) ;
		} });
	}

	function show_div( thediv )
	{
		var divs = Array( "operator", "setup" ) ;

		for ( var c = 0; c < divs.length; ++c )
		{
			$('#login_'+divs[c]).hide() ;
			$('#menu_url_'+divs[c]).removeClass('op_submenu_focus').addClass('op_submenu') ;
		}

		$('#login_'+thediv).show() ;
		$('#menu_url_'+thediv).removeClass('op_submenu').addClass('op_submenu_focus') ;
	}

	function select_date_chat( theunix, thedayexpand, thetotal, thec, theincro )
	{
		$('#tr_requests').find('*').each( function(){
			var div_name = this.id ;
			if ( div_name.indexOf("bar_v_requests_") != -1 )
				$(this).css({'border': '1px solid #4FD25B'}) ;
		} );

		if ( typeof( thetotal ) == "undefined" ) { var thetotal = 0 ; }

		if ( global_c_chat == thec )
		{
			global_c_chat = undeefined ;
			$('#stat_day_expand_chat').html( "" ) ;
		}
		else
		{
			global_c_chat = thec ;
			$('#stat_day_expand_chat').html( "<span class=\"info_action\" style=\"font-weight: bold;\">"+thedayexpand+"</span> &nbsp; Chat Requests: <b>"+thetotal+"</b>" ) ;
			if ( typeof( thec ) != "undefined" ) { $('#bar_v_requests_'+thec).css({'border': '1px solid #235D28'}) ; }
		}
	}

	function update_timezone()
	{
		var unique = unixtime() ;
		var json_data = new Object ;

		var timezone = $('#timezone').val() ;
		var format = $('#timeformat_12').prop('checked') ? 12 : 24 ;

		if ( timezone )
		{
			if ( confirm( "Update time zone to "+timezone+"?" ) )
			{
				$.ajax({
				type: "POST",
				url: "../ajax/setup_actions_.php",
				data: "action=update_timezone&timezone="+timezone+"&format="+format+"&"+unique,
				success: function(data){
					eval( data ) ;

					if ( json_data.status )
					{
						location.href = "index.php?action=success&message=Time+Zone+Updated" ;
					}
					else
					{
						do_alert( 0, json_data.error ) ;
					}
				},
				error:function (xhr, ajaxOptions, thrownError){
					do_alert( 0, "Lost connection to server.  Please refresh the page and try again." ) ;
				} });
			}
		}
		else
			do_alert( 0, "Timezone must be selected." ) ;
	}
//-->
</script>
</head>

<?php include_once( "./inc_header.php" ) ; ?>

		<div style="" id="div_body_wrapper">	
			<table cellspacing=0 cellpadding=0 border=0 width="100%">
			<tr>
				<td valign="top">

					<div class="home_box" style="width: 280px; margin-left: 0px; padding: 10px; background: #495261; color: #FFFFFF;">
						<div style="" class="round">
							<div style="padding-bottom: 10px;"><a href="interface.php?jump=logo"><img src="<?php echo $global_default_logo ?>" style="max-width: 99%; max-height: 150px; padding: 0px; border: 1px solid #FFFFFF;" border=0 class="info_white"></a></div>
							<div style="padding-top: 10px;">
								<table cellspacing=0 cellpadding=0 border=0>
								<tr style="<?php echo ( !$admininfo["isadmin"] && ( count( $admininfo["access"] ) && !isset( $admininfo["access"]["trans"] ) ) ) ? "display: none;" : "" ; ?>">
									<td style="padding-bottom: 10px;">Total Transcripts</td>
									<td style="padding-left: 5px; padding-bottom: 10px;"><span class="info_neutral" onClick="location.href='transcripts.php'" style="cursor: pointer;"><b><?php echo $t_transcripts ?></b></span></td>
								</tr>
								<tr style="<?php echo ( !$admininfo["isadmin"] && ( count( $admininfo["access"] ) && !isset( $admininfo["access"]["reports"] ) ) ) ? "display: none;" : "" ; ?>">
									<td style="padding-top: 10px; padding-bottom: 10px;">Overall Rating</td>
									<td style="padding-left: 5px; padding-top: 10px; padding-bottom: 10px;"><a href="transcripts.php"><?php echo $t_rating ?></a></td>
								</tr>
								<tr style="<?php echo ( !$admininfo["isadmin"] && ( count( $admininfo["access"] ) && !isset( $admininfo["access"]["interface"] ) ) ) ? "display: none;" : "" ; ?>">
									<td style="padding-top: 10px;">Time Zone</td>
									<td style="padding-left: 5px; padding-top: 10px;"><a href="interface.php?jump=time" style="color: #FFFFFF;"><?php echo $timezone ?></a></td>
								</tr>
								</table>
							</div>
						</div>
						<div style="margin-top: 15px; background: url( ../pics/dotted_line.png ) repeat-x; height: 10px;"></div>

						<div style="<?php echo ( !$admininfo["isadmin"] && ( count( $admininfo["access"] ) && !isset( $admininfo["access"]["depts"] ) ) ) ? "display: none;" : "" ; ?> padding-top: 10px; padding-bottom: 5px;"><img src="../pics/icons/menu/menu_depts.png" width="16" height="16" border="0" alt="" class="info_white" style="padding: 1px;"> <a href="depts.php" style="color: #FFFFFF;">Chat Departments (<?php echo count( $departments ) ?>)</a></div>

						<div style="margin-top: 15px; background: url( ../pics/dotted_line.png ) repeat-x; height: 10px;"></div>

						<div style="<?php echo ( !$admininfo["isadmin"] && ( count( $admininfo["access"] ) && !isset( $admininfo["access"]["ops"] ) ) ) ? "display: none;" : "" ; ?>">
							<div style="padding-top: 10px;" class="title"><img src="../pics/icons/menu/menu_ops.png" width="16" height="16" border="0" alt="" class="info_white" style="padding: 1px;"> <a href="ops.php" style="color: #FFFFFF;">Chat Operators (<?php echo $total_operators ?>)</a></div>
							<div style="padding-top: 10px;max-height: 200px; overflow: auto;">
								<?php
									for ( $c = 0; $c < count( $operators ); ++$c )
									{
										$operator = $operators[$c] ;
										$login = $operator["login"] ;
										if ( $operator["login"] != "phplivebot" )
										{
											$name = Util_Format_CreateSnap( $operator["name"], 36 ) ;
											$name_display = "<span alt='login: $login' title='login: $login'>$name</span>" ;
											$mapp_online_icon = ( $operator["mapp"] ) ? " <img src=\"../pics/icons/mobile.png\" width=\"10\" height=\"10\" border=\"0\" alt=\"logged in on mobile\" title=\"logged in on mobile\" style=\"cursor: help;\">" : "" ;
											$status_img = ( $operator["status"] ) ? "<img src=\"../pics/icons/bulb.png\" width=\"16\" height=\"16\" border=\"0\" alt=\"online\" title=\"online\">$mapp_online_icon" : "<img src=\"../pics/icons/bulb_off.png\" width=\"16\" height=\"16\" border=\"0\" alt=\"offline\" title=\"offline\">" ;

											print "<div style=\"margin-bottom: 5px;\">$status_img $name_display</div>" ;
										}
									}
								?>
							</div>
						</div>

					</div>
					<?php
						if ( count( $dir_files_custom ) && ( !isset( $CONF_EXTEND ) || ( $CONF_EXTEND == "geo" ) ) )
						{
							$custom_codes_string = '<div style="margin-top: 15px;">This system has the following Custom Codes files:<ul style="margin-top: 5px;">' ;
							for ( $c = 0; $c < count( $dir_files_custom ); ++$c )
							{
								preg_match( "/custom_code\/(.*?)$/", $dir_files_custom[$c], $maches ) ;
								$custom_codes_string .= "<li> custom_code/$maches[1]</li>" ;
							}
							$custom_codes_string .= "</ul></div>" ;
							print $custom_codes_string ;
						}
					?>
					<div style="<?php echo ( !$admininfo["isadmin"] && ( count( $admininfo["access"] ) && !isset( $admininfo["access"]["settings"] ) ) ) ? "display: none;" : "" ; ?> margin-top: 25px; opacity: 0.5;">
						<div style="padding-top: 10px;">
							PHP Live! Live Chat Software
							<div style="margin-top: 5px;"><a href="system.php">v.<?php echo $VERSION ?></a></div>
						</div>

						<div style="margin-top: 15px;">
							For information, how-to and answers to common issues, please visit the <a href="https://www.phplivesupport.com/r.php?r=support" target="_blank">PHP Live! Knowledge Base</a>.
						</div>
					</div>

				</td>
				<td valign="top" width="100%">
					<table cellspacing=0 cellpadding=0 border=0 width="100%">
					<tr>
						<td valign="top" style="padding-left: 10px;">

							<div id="home_box_start" class="home_box" style="<?php echo ( !$admininfo["isadmin"] && ( count( $admininfo["access"] ) && ( !isset( $admininfo["access"]["depts"] ) && !isset( $admininfo["access"]["ops"] ) && !isset( $admininfo["access"]["code"] ) ) ) ) ? "display: none;" : "" ; ?> width: 340px; padding-top: 0px;">
								<div class="edit_title round_top" style="margin-right: 0px; margin-bottom: 0px; padding: 15px; padding-left: 16px; font-size: larger; border-bottom: 0px; text-shadow: none; background: #495261; box-shadow: <?php echo $VARS_UI_POPUP_BOXSHADOW ?>;">
									<table cellspacing=0 cellpadding=0 border=0>
									<tr>
										<td style="padding-left: 2px;"><img src="../themes/initiate/profile_admin_gear.png" width="32" height="32" border="0" alt="" class="info_white" style="padding: 2px; box-shadow: rgba(0, 0, 0, 0.25) 0px 14px 28px, rgba(0, 0, 0, 0.22) 0px 10px 10px;"></td>
										<td style="padding-left: 10px; font-size: 24px; font-weight: normal; color: #FFFFFF; letter-spacing: .1rem">Basic Things To Do</td>
									</tr>
									</table>
								</div>
								<div style="background: url( ../pics/bg_setup.png?615 ) no-repeat #FFFFFF; background-position: bottom right; padding: 15px; box-shadow: rgba(0, 0, 0, 0.16) 0px 1px 4px;" class="round_bottom">
									<table cellspacing=0 cellpadding=6 border=0>
									<tr style="<?php echo ( !$admininfo["isadmin"] && ( count( $admininfo["access"] ) && !isset( $admininfo["access"]["depts"] ) ) ) ? "display: none;" : "" ; ?>">
										<td><img src="../pics/icons/numbers/1.gif" width="22" height="22" border="0" alt=""></td>
										<td><h3 style="font-weight: normal;"><a href="depts.php">Add Chat Department</a></h3></td>
									</tr>
									<tr style="<?php echo ( !$admininfo["isadmin"] && ( count( $admininfo["access"] ) && !isset( $admininfo["access"]["ops"] ) ) ) ? "display: none;" : "" ; ?>">
										<td style="padding-top: 15px;"><img src="../pics/icons/numbers/2.gif" width="22" height="22" border="0" alt=""></td>
										<td style="padding-top: 15px;"><h3 style="font-weight: normal;"><a href="ops.php">Add Chat Operator</a></h3></td>
									</tr>
									<tr style="<?php echo ( !$admininfo["isadmin"] && ( count( $admininfo["access"] ) && !isset( $admininfo["access"]["ops"] ) ) ) ? "display: none;" : "" ; ?>">
										<td style="padding-top: 15px;"><img src="../pics/icons/numbers/3.gif" width="22" height="22" border="0" alt=""></td>
										<td style="padding-top: 15px;"><h3 style="font-weight: normal;"><a href="ops.php?jump=assign">Assign Operator to Department</a></h3></td>
									</tr>
									<tr style="<?php echo ( !$admininfo["isadmin"] && ( count( $admininfo["access"] ) && !isset( $admininfo["access"]["code"] ) ) ) ? "display: none;" : "" ; ?>">
										<td style="padding-top: 15px;"><img src="../pics/icons/numbers/4.gif" width="22" height="22" border="0" alt=""></td>
										<td style="padding-top: 15px;"><h3 style="font-weight: normal;"><a href="code.php">Copy/Paste Live Chat Code</a></h3></td>
									</tr>
									<tr style="<?php echo ( !$admininfo["isadmin"] && ( count( $admininfo["access"] ) && !isset( $admininfo["access"]["ops"] ) ) ) ? "display: none;" : "" ; ?>">
										<td style="padding-top: 15px;"><img src="../pics/icons/numbers/5.gif" width="22" height="22" border="0" alt=""></td>
										<td style="padding-top: 15px;"><h3 style="font-weight: normal;"><a href="go_online.php"><img src="../pics/icons/bulb_big.png" width="20" height="20" border="0" alt=""> Go online!</a></h3></td>
									</tr>
									</table>
								</div>
							</div>

						</td>
						<td valign="top">

							<div class="home_box" style="padding-top: 0px;">
								<div style="<?php echo ( !$admininfo["isadmin"] && ( count( $admininfo["access"] ) && !isset( $admininfo["access"]["market"] ) ) ) ? "display: none;" : "" ; ?>padding: 10px; width: 100%;" class="info_neutral">
									<div style="font-size: larger;">&#128276; <a href="../addons/announcements/list.php">Set Up Your Announcements</a></div>
									<div style="margin-top: 10px;">
										Announce important messages, display your business hours or showcase promotions or products.  <a href="../addons/announcements/list.php">Set up your announcements</a> to automatically display information to the visitor during their live chat interaction.
									</div>
								</div>
								<?php if ( !$admininfo["isadmin"] && ( count( $admininfo["access"] ) && !isset( $admininfo["access"]["reports"] ) ) ): ?>
								<?php else: ?>
								<div style="margin-top: 15px; background: url( ../pics/dotted_line.png ) repeat-x; height: 10px;"></div>
								<div style="padding-top: 15px;">Recent 7 Days Chat Window Activity [ <a href="reports_chat_win.php">view stats</a> ]</div>
								<div style="margin-top: 15px;">
									<table cellspacing=0 cellpadding=0 border=0 style="height: 100px;" width="100%">
									<tr>
										<?php
											$tooltips = Array() ; $stat_day_totals = Array() ; $incro = 1 ;
											while ( $incro <= 14 )
											{
												$m = date( "m", $stat_start ) ;
												$d = date( "j", $stat_start ) ;
												$y = date( "Y", $stat_start ) ;
												$stat_day = mktime( 0, 0, 1, $m, $d+$incro, $y ) ;

												$stat_day_expand = date( "l, M j, Y", $stat_day ) ;
												$c = date( "j", $stat_day ) ;

												$h1 = "0px" ; $meter = "meter_green1.gif" ;
												$tooltip = "$stat_day_expand" ;
												$tooltips[$stat_day] = "$tooltip (Total: 0)" ;

												$meter_shadow = " box-shadow: 5px 5px 15px rgba(0, 0, 0, 0.2); " ;
												if ( isset( $wstats[$stat_day] ) )
												{
													$stat_day_totals[$c] = $wstats[$stat_day]["wl"] + $wstats[$stat_day]["wlo"] ;
													if ( $wstats_max )
														$h1 = round( ( $stat_day_totals[$c]/$wstats_max ) * 100 ) . "px" ;
													$tooltips[$stat_day] = "$tooltip (Total: ".$stat_day_totals[$c].")" ;
												}
												else
													$stat_day_totals[$c] = 0 ;

												if ( $incro > 7 )
												{
													print "
														<td valign=\"bottom\" style=\"width: 15px; height: 100px;\"><div title=\"".$tooltips[$stat_day]."\" alt=\"".$tooltips[$stat_day]."\" style=\"height: $h1; background: url( ../pics/meters/$meter ) repeat-y; border: 1px solid #02C39A; border-top-left-radius: 5px 5px; border-top-right-radius: 5px 5px; cursor: default; $meter_shadow\"\">&nbsp;</div></td>
														<td><img src=\"../pics/space.gif\" width=\"2\" height=1 border=0></td>
													" ;
												}
												++$incro ;
											}
										?>
									</tr>
									<tr>
										<?php
											$incro = 1 ;
											while ( $incro <= 14 )
											{
												$m = date( "m", $stat_start ) ;
												$d = date( "j", $stat_start ) ;
												$y = date( "Y", $stat_start ) ;
												$stat_day = mktime( 0, 0, 1, $m, $d+$incro, $y ) ;

												$stat_day_expand = date( "l, M j, Y", $stat_day ) ;
												$c = date( "j", $stat_day ) ;

												if ( $incro > 7 )
												{
													print "
														<td style=\"text-align: center;\"><div class=\"page_report\" style=\"width: 25px; margin: 0px; font-size: 10px; font-weight: bold; cursor: default;\" title=\"$tooltips[$stat_day]\">$c</div></td>
														<td><img src=\"../pics/space.gif\" width=\"2\" height=1 border=0></td>
													" ;
												}
												++$incro ;
											}
										?>
									</tr>
									<tr>
										<?php
											$incro = 1 ;
											while ( $incro <= 14 )
											{
												$m = date( "m", $stat_start ) ;
												$d = date( "j", $stat_start ) ;
												$y = date( "Y", $stat_start ) ;
												$stat_day = mktime( 0, 0, 1, $m, $d+$incro, $y ) ;

												$stat_day_expand = date( "l, M j, Y", $stat_day ) ;
												$c = date( "j", $stat_day ) ;
												$total = $stat_day_totals[$c] ;

												if ( $incro > 7 )
												{
													print "
														<td style=\"text-align: center;\"><div class=\"info_clear\" style=\"margin: 0px; font-size: 12px;\">$total</div></td>
														<td><img src=\"../pics/space.gif\" width=\"2\" height=1 border=0></td>
													" ;
												}
												++$incro ;
											}
										?>
									</tr>
									</table>
								</div>
								<?php endif ; ?>
							</div>

						</td>
					</tr>
					<tr>
						<td valign="top" colspan=2 style="<?php echo ( !$admininfo["isadmin"] && ( count( $admininfo["access"] ) && !isset( $admininfo["access"]["reports"] ) ) ) ? "display: none;" : "" ; ?> padding-top: 45px;">

							<div class="home_box" style="border-top: 1px dashed #F2F3F5;">
								<div style="padding-top: 15px; font-size: larger;"><big>Recent 14 Days Chat Stat [ <a href="reports_chat.php">view reports</a> ] &nbsp; <span id="stat_day_expand_chat"></span></big></div>
								<div style="margin-top: 25px;">
									<table cellspacing=0 cellpadding=0 border=0 style="height: 100px;" width="100%">
									<tr id="tr_requests">
										<?php
											$tooltips = Array() ; $stat_day_totals = Array() ; $incro = 1 ;
											while ( $incro <= 14 )
											{
												$m = date( "m", $stat_start ) ;
												$d = date( "j", $stat_start ) ;
												$y = date( "Y", $stat_start ) ;
												$stat_day = mktime( 0, 0, 1, $m, $d+$incro, $y ) ;

												$stat_day_expand = date( "l, M j, Y", $stat_day ) ;
												$c = date( "j", $stat_day ) ;

												$h1 = "0px" ; $meter = "meter_v_green.gif" ;
												$tooltip = "$stat_day_expand" ;
												$tooltips[$stat_day] = "$tooltip (Total: 0)" ;

												$meter_shadow = " box-shadow: 5px 5px 15px rgba(0, 0, 0, 0.2); " ;
												if ( isset( $month_stats[$stat_day] ) )
												{
													$stat_day_totals[$c] = $month_stats[$stat_day]["requests"] ;
													if ( $month_max_chat )
														$h1 = round( ( $month_stats[$stat_day]["requests"]/$month_max_chat ) * 100 ) . "px" ;
													$tooltips[$stat_day] = "$tooltip (Total: ".$stat_day_totals[$c].")" ;
												}
												else
													$stat_day_totals[$c] = 0 ;

												print "
													<td valign=\"bottom\" style=\"width: 25px; height: 100px;\"><div id=\"bar_v_requests_$c\" title=\"".$tooltips[$stat_day]."\" alt=\"".$tooltips[$stat_day]."\" style=\"height: $h1; background: url( ../pics/meters/$meter ) repeat-y; border: 1px solid #4FD25B; border-top-left-radius: 5px 5px; border-top-right-radius: 5px 5px; cursor: pointer; $meter_shadow\" OnClick=\"select_date_chat( $stat_day, '$stat_day_expand', '".$stat_day_totals[$c]."', $c, $incro );\">&nbsp;</div></td>
													<td><img src=\"../pics/space.gif\" width=\"2\" height=1 border=0></td>
												" ;
												++$incro ;
											}
										?>
									</tr>
									<tr>
										<?php
											$incro = 1 ;
											while ( $incro <= 14 )
											{
												$m = date( "m", $stat_start ) ;
												$d = date( "j", $stat_start ) ;
												$y = date( "Y", $stat_start ) ;
												$stat_day = mktime( 0, 0, 1, $m, $d+$incro, $y ) ;

												$stat_day_expand = date( "l, M j, Y", $stat_day ) ;
												$c = date( "j", $stat_day ) ;
												print "
													<td style=\"text-align: center;\"><div id=\"requests_bg_day_$incro\" class=\"page_report\" style=\"width: 25px; margin: 0px; font-size: 10px; font-weight: bold;\" title=\"$tooltips[$stat_day]\" id=\"$tooltips[$stat_day]\" OnClick=\"select_date_chat( $stat_day, '$stat_day_expand', '".$stat_day_totals[$c]."', $c, $incro );\">$c</div></td>
													<td><img src=\"../pics/space.gif\" width=\"2\" height=1 border=0></td>
												" ;
												++$incro ;
											}
										?>
									</tr>
									<tr>
										<?php
											$incro = 1 ;
											while ( $incro <= 14 )
											{
												$m = date( "m", $stat_start ) ;
												$d = date( "j", $stat_start ) ;
												$y = date( "Y", $stat_start ) ;
												$stat_day = mktime( 0, 0, 1, $m, $d+$incro, $y ) ;

												$stat_day_expand = date( "l, M j, Y", $stat_day ) ;
												$c = date( "j", $stat_day ) ;
												$total = $stat_day_totals[$c] ;

												print "
													<td style=\"text-align: center;\"><div id=\"requests_bg_total_$c\" class=\"info_clear\" style=\"margin: 0px; font-size: 14px; font-weight: bold;\">$total</div></td>
													<td><img src=\"../pics/space.gif\" width=\"2\" height=1 border=0></td>
												" ;
												++$incro ;
											}
										?>
									</tr>
									</table>
								</div>

								<?php if ( $ips_spam ): ?>
								<div class="info_warning" style="margin-top: 25px;"><table cellspacing=0 cellpadding=0 border=0><tr><td><img src="../pics/icons/bullet_red.png" width="12" height="12" border="0" alt=""></td><td style="padding-left: 5px;"> There are <b><a href="settings.php?jump=sips"><?php echo $ips_spam ?> blocked IPs</a></b> from chat access.  Blocked IPs will always see an offline chat icon.</td></tr></table></div>
								<?php endif ; ?>

							</div>

						</td>
					</tr>
					</table>
				</td>
			</tr>
			</table>
		</div>

		<div id="remote_disconnect_notice" style="display: none; position: absolute; top: 0px; left: 0px; width: 100%; height: 100%; background: url( ../pics/bg_trans_white.png ) repeat; overflow: hidden; z-index: 20;">
			<div style="padding-top: 300px; text-align: center;"><span class="info_error" style="">Disconnecting console [ <span id="op_login"></span> ].  Just a moment... <img src="../pics/loading_fb.gif" width="16" height="11" border="0" alt=""></span></div>
		</div>

<?php
	if ( $init ):
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Hash.php" ) ;
	$timezones = Util_Hash_Timezones() ;
?>
<div id="div_init" style="display: none; position: absolute; top: 0px; left: 0px; width: 100%; height: 100%; padding-top: 80px; z-index: 50; background: url(../themes/initiate/bg_trans_darker.png) repeat;">
	<div class="info_info" style="width: 600px; height: 350px; margin: 0 auto; padding: 10px; text-shadow: 1px 1px #FFFFFF;">

		<div class="td_dept_td noshadow">
			<div class="edit_title">Update Time Zone</div>
			<div style="margin-top: 5px; text-align: justify;">
				Before continuing, update the time zone of your live chat system.
				<div style="margin-top: 5px;" class="info_box">
					<table cellspacing=0 cellpadding=0 border=0>
					<tr>
						<td><img src="../pics/icons/alert.png" width="16" height="16" border="0" alt=""></td>
						<td style="padding-left: 5px;">Please double check the time zone selection.  Updating the time zone again will reset the chat stats report (total accepted, total declined, total chats missed, etc), starting from zero for all the departments and for all the operators.</td>
					</tr>
					</table>
				</div>
			</div>
		</div>
		
		<div>
			<table cellspacing=0 cellpadding=0 border=0>
			<tr> 
				<td class="td_dept_td noshadow" width="120">Time Zone</td> 
				<td class="td_dept_td noshadow">
					<select id="timezone">
					<option value=""></option>
					<?php
						for ( $c = 0; $c < count( $timezones ); ++$c )
						{
							print "<option value=\"$timezones[$c]\">$timezones[$c]</option>" ;
						}
					?>
					</select>
				</td> 
			</tr>
			<tr>
				<td class="td_dept_td noshadow">Time Format</td>
				<td class="td_dept_td noshadow">
					<div style="">
						<span class="info_neutral" style="margin-left: 5px; cursor: pointer;" onclick="$('#timeformat_12').prop('checked', true);"><input type="radio" id="timeformat_12" name="timeformat_12" value="24" <?php echo ( !$VARS_24H ) ? "checked" : "" ; ?>> 12h</span>
						<span class="info_neutral" style="margin-left: 5px; cursor: pointer;" onclick="$('#timeformat_24').prop('checked', true);"><input type="radio" id="timeformat_24" name="timeformat_12" value="24" <?php echo ( $VARS_24H ) ? "checked" : "" ; ?>> 24h</span>
					</div>
				</td>
			</tr>
			<tr>
				<td class="td_dept_td noshadow">&nbsp;</td>
				<td class="td_dept_td noshadow">
					<input type="hidden" class="input" size="35" id="password" value="1">
					<button type="button" onClick="update_timezone()" class="btn">Update Time Zone</button>
				</td>
			</tr>
			</table>
		</div>

	</div>
</div>
<?php endif ; ?>

<?php include_once( "./inc_footer.php" ) ; ?>