<?php
	/***************************************/
	//
	//
	// PHP Live! Support
	//
	// https://www.phplivesupport.com
	//
	/***************************************/
	// STANDARD header for Setup
	if ( !is_file( "../web/config.php" ) ){ HEADER("location: install.php") ; exit ; }
	include_once( "../web/config.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Format.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Error.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/".Util_Format_Sanatize($CONF["SQLTYPE"], "ln") ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Security.php" ) ;
	if ( !$admininfo = Util_Security_AuthSetup( $dbh ) ){ ErrorHandler( 608, "Invalid setup session or session has expired.", $PHPLIVE_FULLURL, 0, Array() ) ; exit ; }
	// STANDARD header end
	/****************************************/

	$error = "" ;

	include_once( "$CONF[DOCUMENT_ROOT]/API/Depts/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Ops/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Chat/get_ext.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Chat/remove_itr.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Marketing/get.php" ) ;

	$deptid = Util_Format_Sanatize( Util_Format_GetVar( "deptid" ), "n" ) ;

	$departments = Depts_get_AllDepts( $dbh ) ;
	$operators = Ops_get_AllOps( $dbh ) ;
	$markets = Marketing_get_AllMarketing( $dbh ) ;

	// make hash for quick refrence
	$operators_hash = Array() ;
	for ( $c = 0; $c < count( $operators ); ++$c )
	{
		$operator = $operators[$c] ;
		$operators_hash[$operator["opID"]] = $operator["name"] ;
	}

	$dept_hash = Array() ;
	for ( $c = 0; $c < count( $departments ); ++$c )
	{
		$department = $departments[$c] ;
		$dept_hash[$department["deptID"]] = $department ;
	}

	$markets_hash = Array() ;
	for ( $c = 0; $c < count( $markets ); ++$c )
	{
		$market = $markets[$c] ;
		$marketid = $market["marketID"] ;
		$markets_hash[$marketid] = Array() ;
		$markets_hash[$marketid]["name"] = $market["name"] ;
		$markets_hash[$marketid]["color"] = $market["color"] ;
	}
	Chat_remove_itr_OldRequests( $dbh ) ;

	$active_requests = Chat_ext_get_AllRequests( $dbh, $deptid ) ;
?>
<?php include_once( "../inc_doctype.php" ) ?>
<head>
<title> PHP Live! Support </title>

<meta name="description" content="PHP Live! Support <?php echo $VERSION ?>">
<meta name="keywords" content="powered by: PHP Live!  www.phplivesupport.com">
<meta name="robots" content="all,index,follow">
<meta http-equiv="content-type" content="text/html; CHARSET=utf-8">
<?php include_once( "../inc_meta_dev.php" ) ; ?>

<link rel="Stylesheet" href="../css/setup.css?<?php echo filemtime( "../css/setup.css" ) ?>">
<script data-cfasync="false" type="text/javascript" src="../js/global.js?<?php echo filemtime ( "../js/global.js" ) ; ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../js/framework.js?<?php echo $VERSION ?>"></script>

<script data-cfasync="false" type="text/javascript">
<!--
	"use strict" ;
	var refresh_counter = <?php echo $VARS_REFRESH_ACTIVE_CHATS ?> ;

	$(document).ready(function()
	{
		$("html, body").css({'background': '#F2F3F5'}) ;
		init_menu() ;
		toggle_menu_setup( "rchats" ) ;

		var si_refresh = setInterval(function(){
			if ( refresh_counter <= 0 )
				location.href = "reports_chat_active.php?deptid=<?php echo $deptid ?>&"+unixtime() ;
			else
			{
				$('#refresh_counter').html( pad( refresh_counter, 1 ) ) ;
				--refresh_counter ;
			}
		}, 1000) ;
	});

	function open_chat( theces )
	{
		var url = "../ops/op_trans_view.php?ces="+theces+"&id=<?php echo $admininfo["adminID"] ?>&auth=setup&realtime=1&"+unixtime() ;

		External_lib_PopupCenter( url, theces, <?php echo $VARS_CHAT_WIDTH+100 ?>, <?php echo $VARS_CHAT_HEIGHT+155 ?>, "scrollbars=yes,menubar=no,resizable=1,location=no,width=<?php echo $VARS_CHAT_WIDTH+100 ?>,height=<?php echo $VARS_CHAT_HEIGHT+155 ?>,status=0" ) ;
	}

	function switch_dept( theobject )
	{
		location.href = "reports_chat_active.php?deptid="+theobject.value+"&"+unixtime() ;
	}

//-->
</script>
</head>
<?php include_once( "./inc_header.php" ) ?>

		<?php
			if ( !$admininfo["isadmin"] && ( count( $admininfo["access"] ) && !isset( $admininfo["access"]["reports"] ) ) ):
			include_once( "$CONF[DOCUMENT_ROOT]/setup/inc_access.php" ) ; else:
		?>
		<div class="op_submenu_wrapper">
			<div class="op_submenu" style="margin-left: 0px;" onClick="location.href='reports_chat.php'">Chat Reports</div>
			<div class="op_submenu_focus">Active Chats (<?php echo count( $active_requests ) ?>)</div>
			<div class="op_submenu" onClick="location.href='reports_chat_missed.php'">Missed Chats</div>
			<div class="op_submenu" onClick="location.href='reports_chat_msg.php'">Offline Messages</div>
			<div class="op_submenu" onClick="location.href='reports_traffic.php'">Website Traffic</div>
			<div class="op_submenu" onClick="location.href='reports_chat_win.php'">Chat Window Activity</div>
			<div style="clear: both"></div>
		</div>

		<?php if ( count( $departments ) ): ?>
		<div style="margin-top: 45px;">
			<div>View active chat sessions in real-time.  This page will automatically refresh in <span id="refresh_counter" class="info_neutral"><?php echo $VARS_REFRESH_ACTIVE_CHATS ?></span> seconds.</div>
			<div style="margin-top: 35px;">
				<form method="POST" action="reports_chat_active.php" id="form_theform">
				<select name="deptid" id="deptid" style="font-size: 16px;" onChange="switch_dept( this )" class="info_dept">
				<option value="0">All Departments</option>
				<?php
					$ops_assigned = 0 ;
					for ( $c = 0; $c < count( $departments ); ++$c )
					{
						$department = $departments[$c] ;
						$ops = Depts_get_DeptOps( $dbh, $department["deptID"] ) ;
						if ( count( $ops ) )
							$ops_assigned = 1 ;

						if ( $department["name"] != "Archive" )
						{
							$selected = ( $deptid == $department["deptID"] ) ? "selected" : "" ;
							print "<option value=\"$department[deptID]\" $selected>$department[name]</option>" ;
						}
					}
				?>
				</select>
				</form>
			</div>
		</div>
		<?php endif ; ?>

		<div style="margin-top: 35px;">For situations the website visitor closes the web browser or navigates away from the website without properly cancelling or closing the chat request, it may take up to <?php echo ( round( $VARS_EXPIRED_REQS/60 ) ) ?> minutes for the request to be considered a missed chat.  The duration allows some time for the visitor to return to chat if the internet disconnected or other unforeseen reasons.</div>

		<table cellspacing=0 cellpadding=0 border=0 width="100%" style="margin-top: 15px;">
		<tr>
			<td width="40"><div class="td_dept_header">&nbsp;</div></td>
			<td width="140"><div class="td_dept_header">Operator</div></td>
			<td width="80"><div class="td_dept_header">Visitor</div></td>
			<td width="140"><div class="td_dept_header">Department</div></td>
			<td width="140"><div class="td_dept_header">Created</div></td>
			<td width="90"><div class="td_dept_header">Duration</div></td>
			<td><div class="td_dept_header">Question</div></td>
		</tr>
		<?php
			$output = "" ;
			for ( $c = 0; $c < count( $active_requests ); ++$c )
			{
				$chat = $active_requests[$c] ;

				$operator = isset( $operators_hash[$chat["opID"]] ) ? $operators_hash[$chat["opID"]] : "&nbsp;" ;
				$email = ( $chat["vemail"] && ( $chat["vemail"] != "null" ) ) ? "<div style=\"margin-top: 5px;\">$chat[vemail]</div>" : "" ;
				$visitor = Util_Format_Sanatize( $chat["vname"], "v" ) . $email ;
				if ( $chat["md5_vis_"] == "grc" )
					$visitor = "<table cellspacing=0 cellpadding=0 border=0><tr><td><img src='../themes/initiate/group.png' width='16' height='16' border='0' title='Group Chat' alt='Group Chat' class='info_neutral'></td><td style=\"padding-left: 5px;\">$visitor</td></tr></table>" ;
				else if ( $chat["md5_vis_"] == "op2op" )
					$visitor = "<table cellspacing=0 cellpadding=0 border=0><tr><td><img src='../themes/initiate/agent.png' width='16' height='16' border='0' title='Operator to Operator Chat' alt='Operator to Operator Chat' class='info_neutral'></td><td style=\"padding-left: 5px;\">$visitor</td></tr></table>" ;

				$department = isset( $dept_hash[$chat["deptID"]] ) ? $dept_hash[$chat["deptID"]] : Array() ;
				$dept_name = ( isset( $department["name"] ) ) ? $department["name"] : "Invalid" ;
				$created = date( "M j ($VARS_TIMEFORMAT)", $chat["created"] ) ;
				$duration = $now - $chat["created"] ; $duration = Util_Format_Duration( $duration ) ;
				$ip = $chat["ip"] ;
				$market = ( $chat["marketID"] && isset( $markets_hash[$chat["marketID"]] ) ) ? "<div style=\"margin-top: 15px;\">Campaign: <span class=\"info_clear\" style=\"padding: 2px; background: #".$markets_hash[$chat["marketID"]]["color"]."; cursor: pointer;\" onClick=\"location.href='marketing_click.php'\">".$markets_hash[$chat["marketID"]]["name"]."</span></div>" : "" ;
				$question = preg_replace( "/(\r\n)|(\n)|(\r)/", "<br>", $chat["question"] ) ;

				$rstring_string = "" ;
				if ( $chat["rstring"] )
				{
					$rstring_array = explode( ",", $chat["rstring"] ) ;
					if ( count( $rstring_array ) && ( $chat["opID"] != 1111111111 ) ) { $rstring_string = "<div style='text-align: left;' class='info_neutral'> Request has already been routed to:" ; }
					if ( $rstring_string )
					{
						for ( $c2 = 0; $c2 < count( $rstring_array ); ++$c2 )
						{
							$this_opid = trim( $rstring_array[$c2] ) ;
							if ( $this_opid )
							{
								$op_name = isset( $operators_hash[$this_opid] ) ? $operators_hash[$this_opid] : "invalid" ;
								$rstring_string .= " <div style='margin-top: 5px; padding-left: 15px;'>&bull; $op_name</div> " ;
							}
						}
						$rstring_string .= "</div>" ;
					}
				}

				$icon_link = ( $chat["status"] ) ? "<a href=\"JavaScript:void(0)\" onClick=\"open_chat('$chat[ces]')\" id=\"img_$chat[ces]\"><img src=\"../pics/icons/chats.png\" title=\"view chat session\" alt=\"view chat session\"> view chat</a>" : "" ;

				$routing_string = "" ;
				if ( $chat["initiated"] && !$chat["status"] )
					$routing_string = "<div class=\"info_warning\" style=\"margin-bottom: 5px;\"><img src=\"../pics/icons/info_initiate.gif\" width=\"10\" height=\"10\" border=\"0\" alt=\"\" title=\"Operator Initiated Chat Invite\" alt=\"Operator Initiated Chat Invite\" class=\"info_misc\"> Waiting for Visitor Action</div>" ;
				else if ( !$chat["status"] )
				{
					$rtime = $department["rtime"] ;
					$routing_string = "<div class=\"info_misc\" style=\"margin-bottom: 5px;\" title=\"Chat request is routing to operators.\" alt=\"Chat request is routing to operators.\">Routing to Operators</div><div>$rstring_string</div>" ;
					if ( $chat["created"] < ( $now - (60*60*10) ) )
					{
						$routing_string = "<div class=\"info_warning\" style=\"margin-bottom: 5px;\" title=\"Visitor has abandoned the chat request (closed the browser). Request will timeout in 25-30 minutes.\" alt=\"Visitor has abandoned the chat request (closed the browser). Request will timeout in 25-30 minutes.\">Abandoned Request</div>" ;
					}
				}

				$bg_color = ( ($c+1) % 2 ) ? "FFFFFF" : "EDEDED" ;
				$td1 = "td_dept_td" ;

				$output .= "<tr id=\"tr_$chat[ces]\" style=\"background: #$bg_color;\">
					<td class=\"$td1\" style=\"padding: 15px;\" nowrap>
						<div class=\"info_neutral\" style=\"padding: 1px; opacity: 0.5; filter: alpha(opacity=50);\" alt=\"chat ID\" title=\"chat ID\">Chat ID<br>$chat[ces]</div>
						<div style=\"margin-top: 8px;\">$icon_link$routing_string</div>
					</td>
					<td class=\"$td1\" style=\"padding: 15px;\"><b><div id=\"chat_$chat[ces]\">$operator</div></b></td>
					<td class=\"$td1\" style=\"padding: 15px;\" nowrap>$visitor</td>
					<td class=\"$td1\" style=\"padding: 15px;\">$dept_name</td>
					<td class=\"$td1\" nowrap>$created</td>
					<td class=\"$td1\" style=\"padding: 15px;\" nowrap>$duration</td>
					<td class=\"$td1\" style=\"padding: 15px;\">
						$question
						$market
					</td>
				</tr>" ;
			}
			if ( $c == 0 )
				$output = "<tr><td colspan=8 class=\"td_dept_td\">Blank results.</td></tr>" ;
			
			print $output ; 
		?>
		</table>
		<?php endif ; ?>

<?php include_once( "./inc_footer.php" ) ?>