<?php
	/***************************************/
	//
	//
	// PHP Live! Support
	//
	// https://www.phplivesupport.com
	//
	/***************************************/
	// STANDARD header for Setup
	if ( !is_file( "../web/config.php" ) ){ HEADER("location: install.php") ; exit ; }
	include_once( "../web/config.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Format.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Error.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/".Util_Format_Sanatize($CONF["SQLTYPE"], "ln") ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Security.php" ) ;
	if ( !$admininfo = Util_Security_AuthSetup( $dbh ) ){ ErrorHandler( 608, "Invalid setup session or session has expired.", $PHPLIVE_FULLURL, 0, Array() ) ; exit ; }
	// STANDARD header end
	/****************************************/

	$error = "" ;

	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Functions.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Depts/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Ops/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Chat/get_ext.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Marketing/get.php" ) ;

	$action = Util_Format_Sanatize( Util_Format_GetVar( "action" ), "ln" ) ;
	$deptid = Util_Format_Sanatize( Util_Format_GetVar( "deptid" ), "n" ) ;
	$page = Util_Format_Sanatize( Util_Format_GetVar( "page" ), "n" ) ;
	$index = Util_Format_Sanatize( Util_Format_GetVar( "index" ), "n" ) ;
	$jump = Util_Format_Sanatize( Util_Format_GetVar( "jump" ), "ln" ) ; if ( !$jump ) { $jump = "view" ; }
	$m = Util_Format_Sanatize( Util_Format_GetVar( "m" ), "n" ) ;
	$d = Util_Format_Sanatize( Util_Format_GetVar( "d" ), "n" ) ;
	$y = Util_Format_Sanatize( Util_Format_GetVar( "y" ), "n" ) ;
	$created_timestamp = Util_Format_TableFirstCreated( $dbh, "p_req_log" ) ;
	$auto_connect_array = ( isset( $VALS["auto_connect"] ) && $VALS["auto_connect"] ) ? unserialize( $VALS["auto_connect"] ) : Array() ;

	$y_start = date( "Y", $created_timestamp ) ;
	$cal_year = date( "Y", time() ) ;
	$c_start = ( isset( $y_start ) ) ? $y_start : 2010 ;

	$year = $y ; // used for the page generation function Util_Functions_Page

	if ( $m || $y )
	{
		if ( $m && $y )
		{
			if ( $d )
			{
				$stat_start = mktime( 0, 0, 1, $m, $d, $y ) ;
				$stat_end = mktime( 23, 59, 59, $m, $d, $y ) ;
			}
			else
			{
				$stat_start = mktime( 0, 0, 1, $m, 1, $y ) ;
				$stat_end = mktime( 23, 59, 59, $m, date('t', $stat_start), $y ) ;
			}
		}
		else if ( !$m && $y )
		{
			$stat_start = mktime( 0, 0, 1, 1, 1, $y ) ;
			$stat_end = mktime( 23, 59, 59, 12, date('t', $stat_start), $y ) ;
		}
		else
			goto default_stat ;
	}
	else
	{
		default_stat:
		$stat_start = mktime( 0, 0, 1, date( "m", $created_timestamp ), 1, date( "Y", $created_timestamp ) ) ;
		$stat_end = mktime( 23, 59, 59, date( "m", $now ), date( "t", $now ), date( "Y", $now ) ) ;
	}

	$departments = Depts_get_AllDepts( $dbh ) ;
	$operators = Ops_get_AllOps( $dbh ) ;
	$markets = Marketing_get_AllMarketing( $dbh ) ;

	// make hash for quick refrence
	$operators_hash = Array() ;
	for ( $c = 0; $c < count( $operators ); ++$c )
	{
		$operator = $operators[$c] ;
		$operators_hash[$operator["opID"]] = $operator["name"] ;
	}

	// make hash for quick refrence
	$dept_hash = Array() ;
	for ( $c = 0; $c < count( $departments ); ++$c )
	{
		$department = $departments[$c] ;
		$dept_hash[$department["deptID"]] = $department["name"] ;
	}

	$markets_hash = Array() ;
	for ( $c = 0; $c < count( $markets ); ++$c )
	{
		$market = $markets[$c] ;
		$marketid = $market["marketID"] ;
		$markets_hash[$marketid] = Array() ;
		$markets_hash[$marketid]["name"] = $market["name"] ;
		$markets_hash[$marketid]["color"] = $market["color"] ;
	}

	if ( $action == "update_onoff" )
	{
		include_once( "$CONF[DOCUMENT_ROOT]/API/Depts/update.php" ) ;

		$deptid = Util_Format_Sanatize( Util_Format_GetVar( "deptid" ), "n" ) ;
		$onoff = Util_Format_Sanatize( Util_Format_GetVar( "onoff" ), "n" ) ;
		$message = preg_replace( "/<script(.*?)<\/script>/i", "", Util_Format_Sanatize( Util_Format_GetVar( "message" ), "" ) ) ;
		$copy_all = Util_Format_Sanatize( Util_Format_GetVar( "copy_all" ), "n" ) ;

		if ( $deptid && $message )
		{
			$message = Util_Format_StripQuotes( $message ) ;
			$message = "{$onoff}-_-{$message}" ;
			if ( $copy_all )
			{
				for ( $c = 0; $c < count( $departments ); ++$c )
				{
					$deptinfo = $departments[$c] ;
					Depts_update_DeptValues( $dbh, $deptinfo["deptID"], Array( "msg_missed"=>$message ) ) ;
				}
			}
			else
				Depts_update_DeptValues( $dbh, $deptid, Array( "msg_missed"=>$message ) ) ;
		}
		$departments = Depts_get_AllDepts( $dbh ) ;
		$jump = "onoff" ;
	}

	$deptinfo = Array() ;
	if ( $deptid ) { $deptinfo = Depts_get_DeptInfo( $dbh, $deptid ) ; }

	$placeholder = "Your chat information was automatically email to the proper department. A member of our staff will reply as soon as possible." ;
	$onoff = 0 ; $message = "" ;
	if ( isset( $deptinfo["msg_missed"] ) && preg_match( "/-_-/", $deptinfo["msg_missed"] ) )
	{
		$temp = $deptinfo["msg_missed"] ;
		LIST( $onoff, $message ) = explode( "-_-", $temp ) ;
	}

	/*
	status = 0, status_msg = 0, archive = 0, initiated = 0 (dropped chats)
	status = 0, status_msg = 1, archive = 0 (route complete, no message)
	status = 0, status_msg = 2, archive = 0 (route complete, left a message)
	status = 0, status_msg = 3, archive = 0 (cancelled request, no message)
	status = 0, status_msg = 4, archive = 0 (cancelled request, left a message)
	status = 0, status_msg = 0, archive = 0, initiated = 1 (initiated declined)
	*/

	// SELECT count(*) AS total FROM p_req_log WHERE status = 0 AND status_msg = 0 $dept_string AND archive = 0 AND created >= $stat_start AND created <= $stat_end AND initiated = 0
	$total_dropped = Chat_ext_get_Chats_MissedStatus( $dbh, $deptid, 10, $stat_start, $stat_end ) ;
	$total_route_complete_no_msg = Chat_ext_get_Chats_MissedStatus( $dbh, $deptid, 1, $stat_start, $stat_end ) ;
	$total_route_complete_left_msg = Chat_ext_get_Chats_MissedStatus( $dbh, $deptid, 2, $stat_start, $stat_end ) ;
	$abandon_no_msg = Chat_ext_get_Chats_MissedStatus( $dbh, $deptid, 3, $stat_start, $stat_end ) ;
	$abandon_left_msg = Chat_ext_get_Chats_MissedStatus( $dbh, $deptid, 4, $stat_start, $stat_end ) ;

	// SELECT count(*) AS total FROM p_req_log WHERE status = 0 AND initiated = 1 AND ended = 0 $dept_string AND archive = 0 AND created >= $stat_start AND created <= $stat_end
	$op_initiate_declined = Chat_ext_get_Chats_MissedStatus( $dbh, $deptid, 11, $stat_start, $stat_end ) ; // there is no status above 10, it is for "op initiate" declined

	$chats_missed = Chat_ext_get_Chats_Missed( $dbh, $deptid, $stat_start, $stat_end, $page, 15 ) ;
	$total_missed = Chat_ext_get_Total_Chats_Missed( $dbh, $deptid, $stat_start, $stat_end ) ;
	$pages = Util_Functions_Page( $page, $index, 15, $total_missed, "reports_chat_missed.php", "m=$m&deptid=$deptid" ) ;

	$t_requests = Chat_ext_get_AllRequests( $dbh, 0 ) ;
?>
<?php include_once( "../inc_doctype.php" ) ?>
<head>
<title> PHP Live! Support </title>

<meta name="description" content="PHP Live! Support <?php echo $VERSION ?>">
<meta name="keywords" content="powered by: PHP Live!  www.phplivesupport.com">
<meta name="robots" content="all,index,follow">
<meta http-equiv="content-type" content="text/html; CHARSET=utf-8">
<?php include_once( "../inc_meta_dev.php" ) ; ?>

<link rel="Stylesheet" href="../css/setup.css?<?php echo filemtime( "../css/setup.css" ) ?>">
<script data-cfasync="false" type="text/javascript" src="../js/global.js?<?php echo filemtime ( "../js/global.js" ) ; ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../js/framework.js?<?php echo $VERSION ?>"></script>

<script data-cfasync="false" type="text/javascript">
<!--
	"use strict" ;
	var global_div = "<?php echo $jump ?>" ;

	$(document).ready(function()
	{
		$("html, body").css({'background': '#F2F3F5'}) ;
		init_menu() ;
		toggle_menu_setup( "rchats" ) ;

		show_div( "<?php echo $jump ?>" ) ;

		<?php if ( $action && !$error ): ?>do_alert( 1, "Success" ) ;<?php endif ; ?>

		<?php if ( $m && !$y ): ?>select_day() ;
		<?php endif ; ?>

		select_days_options( <?php echo $m ?>, <?php echo $d ?>, <?php echo $y ?> ) ;
	});

	function close_message()
	{
		$('#div_message').fadeOut("fast") ;
	}

	function switch_dept( theobject )
	{
		location.href = "reports_chat_missed.php?deptid="+theobject.value+"&jump="+global_div+"&"+unixtime() ;
	}

	function select_day()
	{
		var month = $('#day_month').val() ;
		var day = ( $('#day_day').val() ) ? $('#day_day').val() : 0 ;
		var year = $('#day_year').val() ;

		if ( parseInt( month ) && !parseInt( year ) )
		{
			do_alert( 0, "Please select the year." ) ;
			$('#day_year').fadeTo("fast", .1).fadeTo("fast", 1).fadeTo("fast", .1).fadeTo("fast", 1).fadeTo("fast", .1).fadeTo("fast", 1) ;
			return false ;
		}
		
		location.href = "reports_chat_missed.php?deptid=<?php echo $deptid ?>&m="+month+"&d="+day+"&y="+year+"&"+unixtime() ;
	}

	function show_div( thediv )
	{
		var divs = Array( "view", "onoff" ) ;
		for ( var c = 0; c < divs.length; ++c )
		{
			$('#div_missed_'+divs[c]).hide() ;
			$('#menu_missed_'+divs[c]).removeClass('op_submenu_focus').addClass('op_submenu3') ;
		}

		global_div = thediv ;

		$('#div_missed_'+thediv).show() ;
		$('#menu_missed_'+thediv).removeClass('op_submenu3').addClass('op_submenu_focus') ;

		toggle_onoff( <?php echo $onoff ?> ) ;
	}

	function toggle_onoff( thevalue )
	{
		if ( thevalue )
			$('#div_onoff').show() ;
		else
			$('#div_onoff').hide() ;
	}

	function do_reset()
	{
		$('#btn_reset').hide() ;
		$('#form_theform_onoff').trigger("reset") ;
	}

	function do_submit()
	{
		if ( !$('#message').val().trim() )
		{
			do_alert( 0, "Please provide a message." ) ;
		}
		else
			$('#form_theform_onoff').submit() ;
	}
//-->
</script>
</head>
<?php include_once( "./inc_header.php" ) ?>

		<?php
			if ( !$admininfo["isadmin"] && ( count( $admininfo["access"] ) && !isset( $admininfo["access"]["reports"] ) ) ):
			include_once( "$CONF[DOCUMENT_ROOT]/setup/inc_access.php" ) ; else:
		?>
		<div class="op_submenu_wrapper">
			<div class="op_submenu" style="margin-left: 0px;" onClick="location.href='reports_chat.php'">Chat Reports</div>
			<div class="op_submenu" onClick="location.href='reports_chat_active.php'">Active Chats (<?php echo count( $t_requests ) ?>)</div>
			<div class="op_submenu_focus">Missed Chats</div>
			<div class="op_submenu" onClick="location.href='reports_chat_msg.php'">Offline Messages</div>
			<div class="op_submenu" onClick="location.href='reports_traffic.php'">Website Traffic</div>
			<div class="op_submenu" onClick="location.href='reports_chat_win.php'">Chat Window Activity</div>
			<div style="clear: both"></div>
		</div>

		<div style="margin-top: 25px;">
			<div class="op_submenu3" style="margin-left: 0px;" id="menu_missed_view" onClick="show_div('view')">View Missed Chats</div>
			<div class="op_submenu3" id="menu_missed_onoff" onClick="show_div('onoff')">Automatic Email Missed Chats</div>
			<div style="clear: both"></div>
		</div>

		<div style="margin-top: 45px;">
			<?php if ( !count( $departments ) ): ?>
			<div class="info_error"><img src="../pics/icons/warning.png" width="12" height="12" border="0" alt=""> You must add a <a href="depts.php" style="color: #FFFFFF;">Department</a> to access this area.</div>

			<?php else: ?>
			<div id="div_missed_view" style="display: none;">
				<form method="POST" action="reports_chat_missed.php" id="form_theform">
				<table cellspacing=0 cellpadding=0 border=0 width="100%">
				<tr>
					<td>
						<?php if ( count( $departments ) ): ?>
						<select name="deptid" id="deptid" style="font-size: 16px;" onChange="switch_dept( this )" class="info_dept">
						<option value="0">All Departments</option>
						<?php
							for ( $c = 0; $c < count( $departments ); ++$c )
							{
								$department = $departments[$c] ;

								if ( $department["name"] != "Archive" )
								{
									$selected = ( $deptid == $department["deptID"] ) ? "selected" : "" ;
									print "<option value=\"$department[deptID]\" $selected>$department[name]</option>" ;
								}
							}
						?>
						</select>
						<?php else: ?>&nbsp;<?php endif ; ?>
					</td>
					<td align="right">
						<table cellspacing=0 cellpadding=0 border=0>
						<tr>
							<td style="padding-left: 15px;">
							<select id="day_month" onChange="select_days_options($('#day_month').val(), $('#day_day').val(), $('#day_year').val())">
								<option value=0></option>
								<?php
									for( $c = 1; $c <= 12; ++$c )
									{
										$selected = ( $c == $m ) ? "selected" : "" ;
										print "<option value=$c $selected>".date("F", mktime( 0, 0, 1, $c, 1, 2010 ))."</option>" ;
									}
								?>
							</select> &nbsp;
							<select id="day_day"></select> &nbsp;
							<select id="day_year" onChange="select_days_options($('#day_month').val(), $('#day_day').val(), $('#day_year').val())">
								<option value=0></option>
								<?php
									for( $c = $c_start; $c <= $cal_year; ++$c )
									{
										$selected = ( $c == $y ) ? "selected" : "" ;
										print "<option value=$c $selected>$c</option>" ;
									}
								?>
							</select> &nbsp; <button type="button" onClick="select_day();" id="btn_submit_cal" class="btn">submit</button>
						</td>
						</tr>
						</table>
					</td>
				</tr>
				</table>

				<div style="padding-top: 35px;">
					<div class="edit_title">Missed Chats Icon Descriptions</div>
					<div style="margin-top: 5px;">
						<table cellspacing=0 cellpadding=0 border=0>
						<tr>
							<td><img src="../pics/icons/bullet_red.png" width="16" height="16" border="0" alt=""></td>
							<td style="padding-left: 5px;">
								<div class="info_white">
									The chat request was abandoned (dropped) by the visitor or the internet disconnected during the routing process.  The request did not complete the routing cycle.
									<div style="margin-top: 5px;" class="info_box">
										<b>NOTE:</b> All new chat requests will have a "dropped" status <img src="../pics/icons/bullet_red.png" width="12" height="12" border="0" alt=""> until the chat request has been accepted or has completed the routing cycle.  This is because the visitor might abandon the chat request or potential internet issue may happen at anytime.  The dropped status will change when the chat request has been accepted or when the request has completed the routing cycle <img src="../pics/icons/bullet_blue.png" width="12" height="12" border="0" alt="">.  If neither an accept or routing complete happens, the request will remain at dropped status.
									</div>
								</div>
							</td>
						</tr>
						</table>
					</div>
					<div style="margin-top: 5px;"><img src="../pics/icons/bullet_orange.png" width="16" height="16" border="0" alt=""> The chat request was cancelled by the visitor during the routing cycle.  The request routed to the leave a message.</div>
					<div style="margin-top: 5px;"><img src="../pics/icons/bullet_blue.png" width="16" height="16" border="0" alt=""> The chat request completed the routing cycle to all department online operators but the request was declined.  The request routed to the leave a message.</div>
					<div style="margin-top: 5px;"><img src="../pics/icons/bullet_purple.png" width="16" height="16" border="0" alt=""> Operator Initiated Chat Invite -  The operator initiated a chat invite to the visitor but the invite was declined by the visitor or the visitor did not take action.</div>
					<div style="margin-top: 5px;"><img src="../pics/icons/email.png" width="16" height="16" border="0" alt=""> The visitor <a href="reports_chat_msg.php">left a message</a>.</div>

					<div style="margin-top: 15px;" class="info_neutral">The <img src="../pics/icons/bullet_purple.png" width="16" height="16" border="0" alt=""> "Operator Initiated Chat Invite" stat is not counted towards the total missed.</div>

					<div style="margin-top: 15px;" class="info_neutral">
						<table cellspacing=2 cellpadding=2 border=0 width="100%">
						<tr>
							<td align="center"><div class="info_neutral">Chat Dropped<br><img src="../pics/icons/bullet_red.png" width="16" height="16" border="0" alt=""></div></td>
							<td align="center"><div class="info_neutral">Visitor Cancelled<br><img src="../pics/icons/bullet_orange.png" width="16" height="16" border="0" alt=""></div></td>
							<td align="center"><div class="info_neutral">Route Completed<br><img src="../pics/icons/bullet_blue.png" width="16" height="16" border="0" alt=""></div></td>
							<td align="center"><div class="info_neutral">Operator Initiated<br><img src="../pics/icons/bullet_purple.png" width="16" height="16" border="0" alt=""></div></td>
							<td align="center"><div class="info_error"><b>Total Missed</b><br><img src="../pics/space.gif" width="16" height="16" border="0" alt=""></div></td>
							<td align="center"><div class="info_neutral"><a href="reports_chat_msg.php">Left a Message</a><br><img src="../pics/icons/email.png" width="16" height="16" border="0" alt=""></div></td>
							<td style="padding-left: 5px;"><img src="../pics/icons/reset.png" width="14" height="14" border="0" alt=""> <a href="reports_chat.php?ftab=reset">Reset Stats</a></td>
						</tr>
						<tr>
							<td align="center"><?php echo $total_dropped ?></td>
							<td align="center"><?php echo $abandon_no_msg + $abandon_left_msg ?></td>
							<td align="center"><?php echo $total_route_complete_no_msg + $total_route_complete_left_msg ?></td>
							<td align="center"><?php echo $op_initiate_declined ?></td>
							<td align="center"><?php echo $total_missed ?></td>
							<td align="center"><?php echo $total_route_complete_left_msg + $abandon_left_msg ?></td>
						</tr>
						</table>
					</div>
				</div>
				</form>

				<table cellspacing=0 cellpadding=0 border=0 width="100%" style="margin-top: 25px;" id="messages">
				<tr><td colspan="10"><div class="page_top_wrapper"><?php echo $pages ?></div></td></tr>
				<tr>
					<td width="50" nowrap><div class="td_dept_header">&nbsp;</div></td>
					<td width="140"><div class="td_dept_header">Created</div></td>
					<td width="80" nowrap><div class="td_dept_header">Department</div></td>
					<td width="160" nowrap><div class="td_dept_header">Visitor Name</div></td>
					<td><div class="td_dept_header">Question</div></td>
				</tr>
				<?php
					for ( $c = 0; $c < count( $chats_missed ); ++$c )
					{
						$chatinfo = $chats_missed[$c] ;

						$visitor = ( $chatinfo["vname"] != "null" ) ? $chatinfo["vname"] : "&nbsp;" ;
						$email = ( $chatinfo["vemail"] != "null" ) ? "<a href=\"mailto:$chatinfo[vemail]\">$chatinfo[vemail]</a>" : "&nbsp;" ;
						$oname = ( $chatinfo["initiated"] && isset( $operators_hash[$chatinfo["opID"]] ) ) ? "<div style='margin-bottom: 15px;' class='info_login'><img src='../pics/icons/user_chat_big.png' width='16' height='16' border='0' alt='' class='info_white' style='padding: 1px;'> Operator <a href='ops.php?opid=$chatinfo[opID]'>".$operators_hash[$chatinfo["opID"]]."</a> sent a chat invite to the visitor.</div> " : "" ;
						$department = isset( $dept_hash[$chatinfo["deptID"]] ) ? $dept_hash[$chatinfo["deptID"]] : "&nbsp;" ;
						$created_date = date( "M j, Y", $chatinfo["created"] ) ;
						$created_time = date( "$VARS_TIMEFORMAT", $chatinfo["created"] ) ;
						$ip = $chatinfo["ip"] ;
						$md5_vis = $chatinfo["md5_vis"] ;
						$market = ( $chatinfo["marketID"] && isset( $markets_hash[$chatinfo["marketID"]] ) ) ? "<div style=\"margin-top: 10px;\">Campaign: <span class=\"info_clear\" style=\"padding: 2px; background: #".$markets_hash[$chatinfo["marketID"]]["color"]."; cursor: pointer;\" onClick=\"location.href='marketing_click.php'\">".$markets_hash[$chatinfo["marketID"]]["name"]."</span></div>" : "" ;
						$title = preg_replace( "/\"/", "&quot;", $chatinfo["title"] ) ;
						$onpage = preg_replace( "/hphp/i", "http", preg_replace( "/\"/", "&quot;", $chatinfo["onpage"] ) ) ;
						$question = ( $chatinfo["question"] != "null" ) ? preg_replace( "/(\r\n)|(\n)|(\r)/", "<br>", $chatinfo["question"] ) : "&nbsp;" ;

						$bullet = "bullet_red.png" ; $bullet_title = "chat was dropped" ;
						if ( ( $chatinfo["status_msg"] == 1 ) || ( $chatinfo["status_msg"] == 2 ) )
						{ $bullet = "bullet_blue.png" ; $bullet_title = "route completed" ; }
						else if ( ( $chatinfo["status_msg"] == 3 ) || ( $chatinfo["status_msg"] == 4 ) )
						{ $bullet = "bullet_orange.png" ; $bullet_title = "chat request cancelled" ; }
						else if ( $chatinfo["initiated"] )
						{ $bullet = "bullet_purple.png" ; $bullet_title = "operator initiated chat invite" ; }

						$left_message = ( ( $chatinfo["status_msg"] == 2 ) || ( $chatinfo["status_msg"] == 4 ) ) ? "<div><img src=\"../pics/icons/email.png\" width=\"16\" height=\"16\" border=\"0\" alt=\"left a message\" title=\"left a message\"></div>" : "" ;

						$bg_color = ( ($c+1) % 2 ) ? "FFFFFF" : "EDEDED" ;
						$td1 = "td_dept_td" ;

						$custom_vars_string = "" ;
						if ( $chatinfo["custom"] )
						{
							$customs = explode( "-cus-", $chatinfo["custom"] ) ;
							for ( $c2 = 0; $c2 < count( $customs ); ++$c2 )
							{
								$custom_var = $customs[$c2] ;
								if ( $custom_var && preg_match( "/-_-/", $custom_var ) )
								{
									LIST( $cus_name, $cus_val ) = explode( "-_-", rawurldecode( $custom_var ) ) ;
									if ( $cus_val )
									{
										if ( preg_match( "/^((http)|(www))/", $cus_val ) )
										{
											if ( preg_match( "/^(www)/", $cus_val ) ) { $cus_val = "https://$cus_val" ; }
											$cus_val_snap = Util_Format_CreateSnap( $cus_val, 40 ) ;
											$custom_vars_string .= "<div style=\"padding: 2px;\"><b>$cus_name:</b> <a href=\"$cus_val\" target=_blank>$cus_val_snap</a></div>" ;
										}
										else
										{
											$custom_vars_string .= "<div style=\"padding: 2px;\"><b>$cus_name:</b> $cus_val</div>" ;
										}
									}
								}
							}
							$custom_vars_string = ( $custom_vars_string ) ? "<div style=\"margin-top: 5px;\" class=\"info_neutral\"><img src=\"../pics/icons/ops.png\" width=\"16\" height=\"16\" border=\"0\" alt=\"\"> Custom Fields<div style=\"margin-top: 5px; max-height: 65px; overflow: auto;\">$custom_vars_string</div></div>" : "" ;
						}
						print "
							<tr id=\"tr_$chatinfo[ces]\" style=\"background: #$bg_color;\">
								<td class=\"$td1\" style='text-align: center;' nowrap>
									<div><div class=\"info_neutral\" style=\"text-align: left; padding: 1px; opacity: 0.5; filter: alpha(opacity=50);\" alt=\"chat ID\" title=\"chat ID\">Chat ID<br>$chatinfo[ces]</div></div>
									<div style=\"margin-top: 8px;\"><img src=\"../pics/icons/$bullet\" width=\"16\" height=\"16\" border=\"0\" alt=\"$bullet_title\" title=\"$bullet_title\">$left_message</div>
								</td>
								<td class=\"$td1\" nowrap>
									$created_date
									<div style=\"font-size: 10px; margin-top: 3px;\">($created_time)</div>
								</td>
								<td class=\"$td1\">$department</td>
								<td class=\"$td1\">
									$visitor
									<div style=\"margin-top: 3px;\">$email</div>
								</td>
								<td class=\"$td1\">
									<div id=\"div_$chatinfo[ces]\">
										<div style=\"text-shadow: none; word-break: break-word; word-wrap: break-word;\">$oname$question</div>
										$custom_vars_string
										<div style=\"margin-top: 5px;\">
											Visitor ID: $md5_vis<br>
											IP: $ip<br>
											On Page: <a href=\"$onpage\" target=\"_blank\">$title</a>
											$market
										</div>
									</div>
								</td>
						</tr>" ;
					}
					if ( $c == 0 )
						print "<tr><td colspan=5 class=\"td_dept_td\">Blank results.</td></tr>" ;
				?>
				<tr><td colspan="10"><div class="page_bottom_wrapper"><?php echo $pages ?></div></td></tr>
				</table>
				<?php endif ; ?>
			</div>
			<div id="div_missed_onoff" style="display: none;">
				<form method="POST" action="reports_chat_missed.php" id="form_theform_onoff">
				<input type="hidden" name="action" value="update_onoff">
				<input type="hidden" name="deptid" value="<?php echo $deptid ?>">
				<table cellspacing=0 cellpadding=0 border=0 width="100%">
				<tr>
					<td>
						<?php if ( count( $departments ) ): ?>
						<select name="deptid2" id="deptid2" style="font-size: 16px;" onChange="switch_dept( this )" class="info_dept">
						<option value="0">All Departments</option>
						<?php
							for ( $c = 0; $c < count( $departments ); ++$c )
							{
								$department = $departments[$c] ;

								if ( $department["name"] != "Archive" )
								{
									$selected = ( $deptid == $department["deptID"] ) ? "selected" : "" ;
									$enabled = ( isset( $department["msg_missed"] ) && preg_match( "/^1-_-/", $department["msg_missed"] ) ) ? "(enabled)" : "" ;
									print "<option value=\"$department[deptID]\" $selected>$department[name] $enabled</option>" ;
								}
							}
						?>
						</select>
						<?php else: ?>&nbsp;<?php endif ; ?>
					</td><td align="right" style="opacity: 0;"><button type="button" onClick="select_day();" id="btn_submit_cal2" class="btn">submit</button></td>
				</tr>
				</table>

				<div style="padding-top: 35px;">
					<?php
						$deptvars = Depts_get_DeptVars( $dbh, $deptid ) ;
						$auto_connect_enabled = "" ;
						if ( isset( $auto_connect_array[$deptid] ) && isset( $auto_connect_array[$deptid]["auto_connect"] ) )
						{
							if ( ( $auto_connect_array[$deptid]["auto_connect"] == "bot" ) && isset( $auto_connect_array[$deptid]["bot_form"] ) && $auto_connect_array[$deptid]["bot_form"] ) { }
							else { $auto_connect_enabled = 'To enable this feature, <a href="code_autostart.php?deptid='.$deptid.'">you must disable "Automatic Connect" for this department</a>.' ; }
						}
						
						if ( !$auto_connect_enabled )
						{
							if ( isset( $deptvars["prechat_form"] ) && !$deptvars["prechat_form"] ) { $auto_connect_enabled = 'To enable this feature, <a href="interface_custom.php?deptid=<?php echo $deptid ?>">you must set the Pre-Chat Form to be <b>displayed</b> for this department</a>.' ; }
							else if ( isset( $deptinfo["remail"] ) && !$deptinfo["remail"] ) { $auto_connect_enabled = 'To enable this feature, <a href="interface_custom.php?deptid='.$deptid.'">you must set the Email field to be <b>required</b> on the pre-chat form for this department</a>.' ; }
						}

						if ( !$deptid ):
					?>
					<img src="../pics/icons/arrow_top.png" width="15" height="16" border="0" alt=""> Select a department above to update the "Automatic Email Missed Chats" settings.

					<?php elseif ( $auto_connect_enabled ): ?>
					<div class="info_warning">
						<?php echo ( isset( $deptinfo["msg_missed"] ) && preg_match( "/^1-_-/", $deptinfo["msg_missed"] ) ) ? "Feature is enabled but <span class='info_error'><b>is not working</b></span> because ".preg_replace( "/To enable this feature, /", "", $auto_connect_enabled ) : $auto_connect_enabled ; ?>
					</div>

					<?php else: ?>
					<div style="" class="info_info">
						<div>(default is "Off") If the department operators are online but were not able to accept the chat request, the chat request is automatically routed to the "leave a message" form.  The visitor can proceed to fill out the offline form and send an email to the department.  This is the default behavior.  However, if "On", <a href="JavaScript:void(0)" onClick="show_div('view')">missed chats</a> will be automatically emailed to the <a href="depts.php?ftab=email">department email address</a>.  The email message will contain the visitor's name, visitor's email, the question and all the <a href="interface_custom.php">custom form fields</a>.</div>
						<div style="margin-top: 15px;">For situations the website visitor closes the web browser or navigates away from the website without properly cancelling or closing the chat request, it may take up to <?php echo ( round( $VARS_EXPIRED_REQS/60 ) ) ?> minutes for the request to be considered a missed chat.  The duration allows some time for the visitor to return to chat if the internet disconnected or other unforeseen reasons.</div>
						<div class="title" style="margin-top: 15px;">Automatic Email Missed Chats</div>
						<div style="margin-top: 5px;">
							<div class="info_good" style="float: left; padding: 3px; cursor: pointer;" onClick="$('#onoff_1').prop('checked', true);toggle_onoff(1);"><input type="radio" name="onoff" id="onoff_1" value="1" onClick="toggle_onoff(1)" <?php echo ( $onoff ) ? "checked" : "" ; ?> > On &nbsp;</div>
							<div class="info_error" style="float: left; margin-left: 10px; padding: 3px; cursor: pointer;"  onClick="$('#onoff_0').prop('checked', true);toggle_onoff(0);"><input type="radio" name="onoff" id="onoff_0" value="0" onClick="toggle_onoff(0)" <?php echo ( $onoff ) ? "" : "checked" ; ?> > Off &nbsp;</div>
							<div style="clear: both;"></div>
						</div>

						<div id="div_onoff" style="display: none; margin-top: 25px;">
							<div style="text-align: justify;">
								<table cellspacing=0 cellpadding=0 border=0>
								<tr>
									<td><img src="../pics/icons/arrow_down.png" width="15" height="16" border="0" alt=""></td>
									<td style="padding-left: 5px;">Display the following message to the visitor to inform them their information was automatically sent to the department.  The <a href="interface_offline.php?jump=offline">Offline Texts and the email form</a> will not be displayed.  Instead, the below custom message will be displayed.</td>
								</tr>
								</table>
							</div>
							<div style="margin-top: 5px;" class="info_neutral">
								<span class="title">Custom Message</span>
								<div style="margin-top: 5px;">example: <i><?php echo $placeholder ?></i></div>
								<div style=""><input type="text" class="input" style="width: 95%" id="message" name="message" maxlength="200" value="<?php echo ( !$message ) ? $placeholder : preg_replace( "/\"/", "&quot;", $message ) ; ?>" onKeyDown="$('#btn_reset').show()" onKeyPress="return noquotestags(event)" autocomplete="off"></div>
							</div>
						</div>

						<?php if ( count( $departments ) > 1 ) : ?>
						<div style="margin-top: 15px;"><input type="checkbox" id="copy_all" name="copy_all" value=1> copy this update to all departments</div>
						<?php endif ; ?>

						<div style="margin-top: 15px;"><input type="button" class="btn" onClick="do_submit()" value="Update"> &nbsp; <input type="button" style="display: none;" id="btn_reset" onClick="do_reset()" class="btn" value="Reset"> &nbsp; &nbsp; <a href="reports_chat_missed.php?jump=onoff">cancel</a></div>
						<?php endif ; ?>

					</div>

				</div>
			</div>
			<?php endif ; ?>

		</div>

<?php include_once( "./inc_footer.php" ) ?>