<?php
	/***************************************/
	//
	//
	// PHP Live! Support
	//
	// https://www.phplivesupport.com
	//
	/***************************************/
	// STANDARD header for Setup
	if ( !is_file( "../web/config.php" ) ){ HEADER("location: install.php") ; exit ; }
	include_once( "../web/config.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Format.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Error.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/".Util_Format_Sanatize($CONF["SQLTYPE"], "ln") ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Security.php" ) ;
	if ( !$admininfo = Util_Security_AuthSetup( $dbh ) ){ ErrorHandler( 608, "Invalid setup session or session has expired.", $PHPLIVE_FULLURL, 0, Array() ) ; exit ; }
	// STANDARD header end
	/****************************************/

	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Functions.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Depts/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Reports/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Reports/remove.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Chat/get_ext.php" ) ;

	$error = "" ;

	$deptid = Util_Format_Sanatize( Util_Format_GetVar( "deptid" ), "n" ) ;
	$m = Util_Format_Sanatize( Util_Format_GetVar( "m" ), "n" ) ;
	$d = Util_Format_Sanatize( Util_Format_GetVar( "d" ), "n" ) ;
	$y = Util_Format_Sanatize( Util_Format_GetVar( "y" ), "n" ) ;

	$m_orig = $m ; $y_orig = $y ;

	if ( !$m ) { $m = date( "m", $now ) ; }
	if ( !$d ) { $d = date( "j", $now ) ; }
	if ( !$y ) { $y = date( "Y", $now ) ; }

	$today = mktime( 0, 0, 1, $m, $d, $y ) ;
	$stat_start = mktime( 0, 0, 1, $m, 1, $y ) ;
	$stat_end = mktime( 23, 59, 59, $m, date('t', $stat_start), $y ) ;
	$stat_end_day = date( "j", $stat_end ) ;

	Reports_remove_Reports( $dbh, $VARS_ACTIVITY_LOG_EXPIRE ) ;

	$y_start = date( "Y", Util_Format_TableFirstCreated( $dbh, "p_wstats" ) ) ;
	$month_stats = Reports_get_Stat( $dbh, "p_wstats", $deptid, $stat_start, $stat_end ) ;

	// max from all fields for graph visual purpose for proper ratio on all graphs
	$month_max = 0 ;
	foreach ( $month_stats as $sdate => $data )
	{
		if ( ( $data["wl"] + $data["wlo"] ) > $month_max )
			$month_max = $data["wl"] + $data["wlo"] ;
		if ( $data["wc"] > $month_max )
			$month_max = $data["wc"] ;
		if ( $data["wo"] > $month_max )
			$month_max = $data["wo"] ;
	}

	$departments = Depts_get_AllDepts( $dbh ) ;
	$dept_groups = Depts_get_AllDeptGroups( $dbh ) ;
	$t_requests = Chat_ext_get_AllRequests( $dbh, 0 ) ;
?>
<?php include_once( "../inc_doctype.php" ) ?>
<head>
<title> PHP Live! Support </title>

<meta name="description" content="PHP Live! Support <?php echo $VERSION ?>">
<meta name="keywords" content="powered by: PHP Live!  www.phplivesupport.com">
<meta name="robots" content="all,index,follow">
<meta http-equiv="content-type" content="text/html; CHARSET=utf-8">
<?php include_once( "../inc_meta_dev.php" ) ; ?>

<link rel="Stylesheet" href="../css/setup.css?<?php echo filemtime( "../css/setup.css" ) ?>">
<script data-cfasync="false" type="text/javascript" src="../js/global.js?<?php echo filemtime ( "../js/global.js" ) ; ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../js/framework.js?<?php echo $VERSION ?>"></script>

<script data-cfasync="false" type="text/javascript">
<!--
	"use strict" ;
	var global_deptid = <?php echo $deptid ?> ; // needed for calendar that is shared with op online activity

	$(document).ready(function()
	{
		$("html, body").css({'background': '#F2F3F5'}) ;
		init_menu() ;
		toggle_menu_setup( "rchats" ) ;
	});

	function switch_dept( theobject )
	{
		global_deptid = theobject.value ;
	}

	function do_savem( thevalue )
	{
		if ( global_savem != thevalue )
		{
			var json_data = new Object ;

			$.ajax({
				type: "POST",
				url: "../ajax/setup_actions.php",
				data: "action=update_savem&deptid=<?php echo $deptid ?>&savem="+thevalue+"&"+unixtime(),
				success: function(data){
					global_savem = thevalue ;
					do_alert( 1, "Update Success" ) ;
				}
			});
		}
	}

//-->
</script>
</head>
<?php include_once( "./inc_header.php" ) ?>

		<?php
			if ( !$admininfo["isadmin"] && ( count( $admininfo["access"] ) && !isset( $admininfo["access"]["reports"] ) ) ):
			include_once( "$CONF[DOCUMENT_ROOT]/setup/inc_access.php" ) ; else:
		?>
		<div class="op_submenu_wrapper">
			<div class="op_submenu" style="margin-left: 0px;" onClick="location.href='reports_chat.php'">Chat Reports</div>
			<div class="op_submenu" onClick="location.href='reports_chat_active.php'">Active Chats (<?php echo count( $t_requests ) ?>)</div>
			<div class="op_submenu" onClick="location.href='reports_chat_missed.php'">Missed Chats</div>
			<div class="op_submenu" onClick="location.href='reports_chat_msg.php'">Offline Messages</div>
			<div class="op_submenu" onClick="location.href='reports_traffic.php'">Website Traffic</div>
			<div class="op_submenu_focus">Chat Window Activity</div>
			<div style="clear: both"></div>
		</div>

		<div style="margin-top: 45px; margin-bottom: 20px;">This page will provide an overview of the chat system window activity such as how many times the chat request window was loaded.  <b>Note:</b> <a href="settings.php">Excluded IPs</a> will not be tallied.</div>

		<div style="margin-top: 25px;">
			<?php if ( count( $departments ) > 1 ): ?>
				<div style="margin-bottom: 5px;">
					<select name="deptid" id="deptid" style="font-size: 16px;" onChange="switch_dept( this )" class="info_dept">
					<option value="0">Grand Totals</option>
					<option value="-1" <?php echo ( $deptid == -1 ) ? "selected" : "" ; ?> >Department ID: 0 (also All Departments)</option>
					<?php
						for ( $c = 0; $c < count( $departments ); ++$c )
						{
							$department = $departments[$c] ;

							if ( $department["name"] != "Archive" )
							{
								$selected = ( $deptid == $department["deptID"] ) ? "selected" : "" ;
								print "<option value=\"$department[deptID]\" $selected>$department[name]</option>" ;
							}
						}
						$deptgroupinfo = Array() ;
						for ( $c = 0; $c < count( $dept_groups ); ++$c )
						{
							$dept_group = $dept_groups[$c] ;
							$selected = ( $deptid == $dept_group["groupID"] ) ? "selected" : "" ;
							if ( $selected ) { $deptgroupinfo["deptID"] = $deptid ; $deptgroupinfo["name"] = $dept_group["name"] ; }
							print "<option value=\"$dept_group[groupID]\" $selected>$dept_group[name] (Department Group)</option>" ;
						}
					?>
					</select>
				</div>
			<?php endif ; ?>
			<div><?php include_once( "./inc_select_cal.php" ) ; ?></div>
		</div>

		<div style="margin-top: 25px;">
			<table cellspacing=0 cellpadding=0 border=0 style="height: 100px; width: 100%;">
			<tr>
				<?php
					$tooltips = Array() ; $stat_day_totals = Array() ;
					$total_wl = $total_wlo = 0 ;
					for ( $c = 1; $c <= $stat_end_day; ++$c )
					{
						$stat_day = mktime( 0, 0, 1, $m, $c, $y ) ;
						$stat_day_expand = date( "l, M j, Y", $stat_day ) ;

						$h1 = "0px" ; $meter = "meter_green1.gif" ;
						$tooltip = "$stat_day_expand" ;
						$tooltips[$stat_day] = "$tooltip (Total: 0)" ;

						$meter_shadow = " box-shadow: 5px 5px 15px rgba(0, 0, 0, 0.2); " ;
						if ( isset( $month_stats[$stat_day] ) )
						{
							$total_wl += $month_stats[$stat_day]["wl"] ;
							$total_wlo += $month_stats[$stat_day]["wlo"] ;
							$stat_day_totals[$c] = $month_stats[$stat_day]["wl"] + $month_stats[$stat_day]["wlo"] ;
							if ( $month_max )
								$h1 = round( ( $stat_day_totals[$c]/$month_max ) * 100 ) . "px" ;
							$tooltips[$stat_day] = "$tooltip (Total: ".$stat_day_totals[$c].")" ;
						}
						else if ( ( $c == $stat_end_day ) && !$month_max )
						{
							$stat_day_totals[$c] = 0 ;
							$h1 = "0px" ;
							$meter = "meter_v_clear.gif" ;
							$meter_shadow = "" ;
						}
						else
							$stat_day_totals[$c] = 0 ;

						print "
							<td valign=\"bottom\" width=\"2%\" style=\"height: 100px;\"><div id=\"bar_v_overall_$c\" title=\"".$tooltips[$stat_day]."\" alt=\"".$tooltips[$stat_day]."\" style=\"height: $h1; background: url( ../pics/meters/$meter ) repeat-y; border: 1px solid #02C39A; border-top-left-radius: 5px 5px; border-top-right-radius: 5px 5px; $meter_shadow\"></div></td>
							<td><img src=\"../pics/space.gif\" width=\"5\" height=1 border=0></td>
						" ;
					}
				?>
			</tr>
			<tr>
				<?php
					for ( $c = 1; $c <= $stat_end_day; ++$c )
					{
						$stat_day = mktime( 0, 0, 1, $m, $c, $y ) ;
						$stat_day_expand = date( "l, M j, Y", $stat_day ) ;
						print "
							<td style=\"text-align: center;\"><div class=\"page_report\" style=\"min-width: 12px; margin: 0px; font-size: 10px; font-weight: bold; cursor: default;\" title=\"$tooltips[$stat_day]\">$c</div></td>
							<td><img src=\"../pics/space.gif\" width=\"5\" height=1 border=0></td>
						" ;
					}
				?>
			</tr>
			<tr>
				<?php
					$grand_total = 0 ;
					for ( $c = 1; $c <= $stat_end_day; ++$c )
					{
						$stat_day = mktime( 0, 0, 1, $m, $c, $y ) ;
						$stat_day_expand = date( "l, M j, Y", $stat_day ) ;
						$total = $stat_day_totals[$c] ;
						$grand_total += $total ;
						print "
							<td style=\"text-align: center;\"><div id=\"requests_bg_total_$c\" class=\"\" style=\"margin: 0px; font-size: 10px;\">$total</div></td>
							<td><img src=\"../pics/space.gif\" width=\"5\" height=1 border=0></td>
						" ;
					}
				?>
			</tr>
			</table>
			<div class="info_neutral">
				<span class=""><b>Chat Window Loaded</b> <span class="info_black" style="padding: 4px;"><?php echo $total_wl ?> <img src="../pics/icons/online_green.png?1" width="12" height="12" border="0" alt="chat was online" title="chat was online"> + <?php echo $total_wlo ?> <img src="../pics/icons/online_grey.png" width="12" height="12" border="0" alt="chat was offline" title="chat was offline"> = <?php echo $grand_total ?></span></span>
				<div style="margin-top: 5px;">When the visitor clicks the chat icon, the chat request window will load the pre-chat form or the leave a message form based on the live chat online/offline status.  Whether the live chat is online or offline, when the chat window loads, the <b>Chat Window Loaded</b> is incremented by 1.  For example, if the visitor clicks the live chat icon and the chat window loads, the <b>Chat Window Loaded</b> is incremented.  If the visitor closes the chat window and then clicks the chat icon to open the chat window again, the <b>Chat Window Loaded</b> is incremented, again.  The <img src="../pics/icons/online_green.png?1" width="12" height="12" border="0" alt="chat was online" title="chat was online"> icon indicates the chat window loaded online (the chat request form).  The <img src="../pics/icons/online_grey.png" width="12" height="12" border="0" alt="chat was offline" title="chat was offline"> icon indicates the chat window loaded offline (the leave a message form).</div>
				<div style="margin-top: 5px; padding-top: 15px; padding-top: 0px;">
					<div class="info_white" style="padding: 10px;">
						<div style="font-size: larger;">&#128276; <a href="../addons/announcements/list.php">Set Up Your Announcements</a></div>
						<div style="margin-top: 5px;">
							Announce important messages, display business hours or showcase promotions. <a href="../addons/announcements/list.php">Set up your announcements</a> to automatically display information to the visitor during their live chat interaction.
						</div>
					</div>
				</div>
			</div>
		</div>

		<div style="margin-top: 25px;">
			<table cellspacing=0 cellpadding=0 border=0 style="height: 100px; width: 100%;">
			<tr>
				<?php
					$tooltips = Array() ; $stat_day_totals = Array() ;
					for ( $c = 1; $c <= $stat_end_day; ++$c )
					{
						$stat_day = mktime( 0, 0, 1, $m, $c, $y ) ;
						$stat_day_expand = date( "l, M j, Y", $stat_day ) ;

						$h1 = "0px" ; $meter = "meter_green2.gif" ;
						$tooltip = "$stat_day_expand" ;
						$tooltips[$stat_day] = "$tooltip (Total: 0)" ;

						$meter_shadow = " box-shadow: 5px 5px 15px rgba(0, 0, 0, 0.2); " ;
						if ( isset( $month_stats[$stat_day] ) )
						{
							$stat_day_totals[$c] = $month_stats[$stat_day]["wc"] ;
							if ( $month_max )
								$h1 = round( ( $month_stats[$stat_day]["wc"]/$month_max ) * 100 ) . "px" ;
							$tooltips[$stat_day] = "$tooltip (Total: ".$stat_day_totals[$c].")" ;
						}
						else if ( ( $c == $stat_end_day ) && !$month_max )
						{
							$stat_day_totals[$c] = 0 ;
							$h1 = "0px" ;
							$meter = "meter_v_clear.gif" ;
							$meter_shadow = "" ;
						}
						else
							$stat_day_totals[$c] = 0 ;

						print "
							<td valign=\"bottom\" width=\"2%\" style=\"height: 100px;\"><div id=\"bar_v_overall_$c\" title=\"".$tooltips[$stat_day]."\" alt=\"".$tooltips[$stat_day]."\" style=\"height: $h1; background: url( ../pics/meters/$meter ) repeat-y; border: 1px solid #00A896; border-top-left-radius: 5px 5px; border-top-right-radius: 5px 5px; $meter_shadow\"></div></td>
							<td><img src=\"../pics/space.gif\" width=\"5\" height=1 border=0></td>
						" ;
					}
				?>
			</tr>
			<tr>
				<?php
					for ( $c = 1; $c <= $stat_end_day; ++$c )
					{
						$stat_day = mktime( 0, 0, 1, $m, $c, $y ) ;
						$stat_day_expand = date( "l, M j, Y", $stat_day ) ;
						print "
							<td style=\"text-align: center;\"><div class=\"page_report\" style=\"min-width: 12px; margin: 0px; font-size: 10px; font-weight: bold; cursor: default;\" title=\"$tooltips[$stat_day]\">$c</div></td>
							<td><img src=\"../pics/space.gif\" width=\"5\" height=1 border=0></td>
						" ;
					}
				?>
			</tr>
			<tr>
				<?php
					$grand_total = 0 ;
					for ( $c = 1; $c <= $stat_end_day; ++$c )
					{
						$stat_day = mktime( 0, 0, 1, $m, $c, $y ) ;
						$stat_day_expand = date( "l, M j, Y", $stat_day ) ;
						$total = $stat_day_totals[$c] ;
						$grand_total += $total ;
						print "
							<td style=\"text-align: center;\"><div id=\"requests_bg_total_$c\" class=\"\" style=\"margin: 0px; font-size: 10px;\">$total</div></td>
							<td><img src=\"../pics/space.gif\" width=\"5\" height=1 border=0></td>
						" ;
					}
				?>
			</tr>
			</table>
			<div class="info_neutral">
				<span class=""><b>Chat Session Loaded</b> <span class="info_black" style="padding: 4px;"><?php echo $grand_total ?></span></span>
				<div style="margin-top: 5px;">When the visitor requests chat, the "agent will be with you shortly" page loads (the chat routing process).  The <b>Chat Session Loaded</b> is incremented by 1 each time the chat routing process window loads or when an active chat session window loads.  For example, when the visitor requests chat and the chat routing process window loads, the <b>Chat Session Loaded</b> is incremented.  While the visitor is waiting to be connected (the chat routing process), the chat is accepted, the <b>Chat Session Loaded</b> WILL NOT increment for this situation becaused the chat window did not actually load again.  However, during a chat session, if the visitor navigates to another page, causing the chat to automatically load again on the new page, the <b>Chat Session Loaded</b> will be incremented because the chat session window actually loaded again.</div>
			</div>
		</div>

		<div style="margin-top: 25px;">
			<table cellspacing=0 cellpadding=0 border=0 style="height: 100px; width: 100%;">
			<tr>
				<?php
					$tooltips = Array() ; $stat_day_totals = Array() ;
					for ( $c = 1; $c <= $stat_end_day; ++$c )
					{
						$stat_day = mktime( 0, 0, 1, $m, $c, $y ) ;
						$stat_day_expand = date( "l, M j, Y", $stat_day ) ;

						$h1 = "0px" ; $meter = "meter_green3.gif" ;
						$tooltip = "$stat_day_expand" ;
						$tooltips[$stat_day] = "$tooltip (Total: 0)" ;

						$meter_shadow = " box-shadow: 5px 5px 15px rgba(0, 0, 0, 0.2); " ;
						if ( isset( $month_stats[$stat_day] ) )
						{
							$stat_day_totals[$c] = $month_stats[$stat_day]["wo"] ;
							if ( $month_max )
								$h1 = round( ( $month_stats[$stat_day]["wo"]/$month_max ) * 100 ) . "px" ;
							$tooltips[$stat_day] = "$tooltip (Total: ".$stat_day_totals[$c].")" ;
						}
						else if ( ( $c == $stat_end_day ) && !$month_max )
						{
							$stat_day_totals[$c] = 0 ;
							$h1 = "0px" ;
							$meter = "meter_v_clear.gif" ;
							$meter_shadow = "" ;
						}
						else
							$stat_day_totals[$c] = 0 ;

						print "
							<td valign=\"bottom\" width=\"2%\" style=\"height: 100px;\"><div id=\"bar_v_overall_$c\" title=\"".$tooltips[$stat_day]."\" alt=\"".$tooltips[$stat_day]."\" style=\"height: $h1; background: url( ../pics/meters/$meter ) repeat-y; border: 1px solid #028090; border-top-left-radius: 5px 5px; border-top-right-radius: 5px 5px; $meter_shadow\"></div></td>
							<td><img src=\"../pics/space.gif\" width=\"5\" height=1 border=0></td>
						" ;
					}
				?>
			</tr>
			<tr>
				<?php
					for ( $c = 1; $c <= $stat_end_day; ++$c )
					{
						$stat_day = mktime( 0, 0, 1, $m, $c, $y ) ;
						$stat_day_expand = date( "l, M j, Y", $stat_day ) ;
						print "
							<td style=\"text-align: center;\"><div class=\"page_report\" style=\"min-width: 12px; margin: 0px; font-size: 10px; font-weight: bold; cursor: default;\" title=\"$tooltips[$stat_day]\">$c</div></td>
							<td><img src=\"../pics/space.gif\" width=\"5\" height=1 border=0></td>
						" ;
					}
				?>
			</tr>
			<tr>
				<?php
					$grand_total = 0 ;
					for ( $c = 1; $c <= $stat_end_day; ++$c )
					{
						$stat_day = mktime( 0, 0, 1, $m, $c, $y ) ;
						$stat_day_expand = date( "l, M j, Y", $stat_day ) ;
						$total = $stat_day_totals[$c] ;
						$grand_total += $total ;
						print "
							<td style=\"text-align: center;\"><div id=\"requests_bg_total_$c\" class=\"\" style=\"margin: 0px; font-size: 10px;\">$total</div></td>
							<td><img src=\"../pics/space.gif\" width=\"5\" height=1 border=0></td>
						" ;
					}
				?>
			</tr>
			</table>
			<div class="info_neutral">
				<span class=""><b>Redirect</b> <span class="info_black" style="padding: 4px;"><?php echo $grand_total ?></span></span>
				<div style="margin-top: 5px;">When a chat request was routed to the leave a message form, the <b>Redirect</b> is incremented by 1.  For example, while the visitor is waiting to be connecting to an operator (the chat routing process), they cancel the request by clicking the "end chat".  The chat request will be routed to the leave a message form.  For this situation, the <b>Redirect</b> is incremented because the offline form was loaded.  If the chat request was declined by all operators, causing the chat request to be routed to the leave a message form, the <b>Redirect</b> is incremented for this situation also.  If the visitor closes the web browser during the chat routing process, <b>Redirect</b> will not be incremented because the visitor was not redirected to the offline form.</div>
			</div>
		</div>
		<div style="margin-top: 125px; text-align: right; font-size: 10px;">* <?php echo $VARS_ACTIVITY_LOG_EXPIRE ?> years of activity data is stored</div>

		<?php endif ; ?>

<?php include_once( "./inc_footer.php" ) ?>