<?php
	/***************************************/
	//
	//
	// PHP Live! Support
	//
	// https://www.phplivesupport.com
	//
	/***************************************/
	// STANDARD header for Setup
	if ( !is_file( "../web/config.php" ) ){ HEADER("location: install.php") ; exit ; }
	include_once( "../web/config.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Format.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Error.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/".Util_Format_Sanatize($CONF["SQLTYPE"], "ln") ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Security.php" ) ;
	if ( !$admininfo = Util_Security_AuthSetup( $dbh ) ){ ErrorHandler( 608, "Invalid setup session or session has expired.", $PHPLIVE_FULLURL, 0, Array() ) ; exit ; }
	// STANDARD header end
	/****************************************/

	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Functions.php" ) ;

	$action = Util_Format_Sanatize( Util_Format_GetVar( "action" ), "ln" ) ;
	$snapshot_file = "$CONF[DOCUMENT_ROOT]/examples/snapshot.txt" ;

	if ( $action == "opcache_clear" )
	{
		// opcache_invalidate( $script_stats["full_path"], true ) does not work on some cached files
		// entire reset works but perhaps future feature... disabled for now because it clears entire cache

		opcache_reset() ;
		database_mysql_close( $dbh ) ;
		HEADER( "location: settings_snapshot.php?action=success" ) ; exit ;
	}

	$md5s_prep = Array() ;
	$md5s = Array() ;

	$opcache_vars = ( $opcache && function_exists( "opcache_get_status" ) ) ? opcache_get_status() : Array() ;
	$opcache_scripts = Array() ;
	$opcache_memory_usage = 0 ; $opcache_total_hits = 0 ;
	if ( isset( $opcache_vars["scripts"] ) )
	{
		$document_root_hash = Util_Format_Sanatize( $CONF["DOCUMENT_ROOT"], "lnss" ) ;
		foreach ( $opcache_vars["scripts"] as $script_path_full => $script_stats )
		{
			$document_root = str_replace( '\\\\', '\\', $CONF["DOCUMENT_ROOT"] ) ;
			$script_path = str_replace( "$document_root", "", $script_path_full ) ;
			$script_path = str_replace( '\\', '/', $script_path) ;
			$script_path = preg_replace( "/^\//", "", $script_path ) ;
			$opcache_scripts[$script_path] = $script_stats ;

			$script_path_hash = Util_Format_Sanatize( $script_path_full, "lnss" ) ;

			// work with just alphanumeric due to different OS having different directory indicators (\\ vs \ vs /)
			if ( preg_match( "/$document_root_hash/i", $script_path_hash ) )
			{
				$opcache_memory_usage += $script_stats["memory_consumption"] ;
				$opcache_total_hits += $script_stats["hits"] ;
			}
		}
	}

	$file_path = "" ;
	$output = fetch_dir_files( "../" ) ;
	foreach ( $output as $index => $file )
	{
		$file_contents = trim( file_get_contents( $file ) ) ;
		$file_contents = str_replace( Array( "\r\n", "\r", "\n" ), "", $file_contents) ;
		$file_md5 = md5( $file_contents ) ;

		$file = preg_replace( "/\\\/", "/", $file ) ;

		if ( !$file_path && preg_match( "/^(.*?)phplive\.php/", $file, $matches ) )
		{
			if ( isset( $matches[1] ) )
				$file_path = $matches[1] ;
		}

		$md5s_prep[$file] = $file_md5 ;
	}

	if ( $file_path )
	{
		$file_path = preg_replace( "/\//", "\/", $file_path ) ;
		foreach ( $md5s_prep as $file => $md5 )
		{
			$file = preg_replace( "/$file_path/", "", $file ) ;
			$md5s[$file] = $md5 ;
		}
	}

	$snapshot_string = file_get_contents( $snapshot_file ) ;

	$error = "" ;
	try {
		$snapshot_array = unserialize( $snapshot_string ) ;
	} catch ( PDOException $e ) {
		$error = "ERROR: Invalid snapshot string." ;
	}

	// -1 = file md5 mismatch, -2 = file does not exist
	$files = Array() ;
	$files_total = 0 ;
	if ( !$error )
	{
		foreach ( $snapshot_array as $file => $md5 )
		{
			if ( isset( $md5s[$file] ) )
			{
				if ( $md5s[$file] == $md5 )
					$files[$file] = 1 ;
				else
					$files[$file] = -1 ;
				++$files_total ;
			}
			else
				$files[$file] = -2 ;
		}
	} asort( $files ) ;

	function fetch_dir_files( $dir, &$results = array() )
	{
		$files = scandir( $dir ) ;

		foreach( $files as $key => $value )
		{
			$path = realpath( $dir.DIRECTORY_SEPARATOR.$value ) ;
			if ( !is_dir( $path ) )
			{
				if ( preg_match( "/\.php$/i", $path ) || preg_match( "/\.js$/i", $path ) || preg_match( "/\.css$/i", $path ) )
				{
					$results[] = $path ;
				}
			}
			else if ( $value != "." && $value != ".." )
			{
				if ( !preg_match( "/(\/pics|\\\pics)$/i", $path ) && !preg_match( "/README/i", $path ) && !preg_match( "/custom_code/i", $path ) && !preg_match( "/(\/web|\\web)$/i", $path ) && !preg_match( "/(\/data|\\data)$/i", $path ) && !preg_match( "/(\/vendor|\\vendor)$/i", $path ) && !preg_match( "/(swift|ratche)/i", $path ) && !preg_match( "/(\/phplive|\\\phplive)$/i", $path ) && !preg_match( "/(\/sms|\\\sms)$/i", $path ) && !preg_match( "/(\/messenger|\\\messenger)$/i", $path ) )
				{
					fetch_dir_files( $path, $results ) ;
				}
			}
		}

		return $results ;
	}
?>
<?php include_once( "../inc_doctype.php" ) ?>
<head>
<title> PHP Live! Support </title>

<meta name="description" content="PHP Live! Support <?php echo $VERSION ?>">
<meta name="keywords" content="powered by: PHP Live!  www.phplivesupport.com">
<meta name="robots" content="all,index,follow">
<meta http-equiv="content-type" content="text/html; CHARSET=utf-8">
<?php include_once( "../inc_meta_dev.php" ) ; ?>

<link rel="Stylesheet" href="../css/setup.css?<?php echo filemtime( "../css/setup.css" ) ?>">
<script data-cfasync="false" type="text/javascript" src="../js/global.js?<?php echo filemtime ( "../js/global.js" ) ; ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../js/framework.js?<?php echo $VERSION ?>"></script>

<script data-cfasync="false" type="text/javascript">
<!--
	$(document).ready(function()
	{
		$("html, body").css({'background': '#F2F3F5'}) ;
		init_menu() ;
		toggle_menu_setup( "settings" ) ;
	});

	function opcache_clear()
	{
		var unique = unixtime() ;
		location.href = "settings_snapshot.php?action=opcache_clear&"+unique ;
	}
//-->
</script>
</head>
<?php include_once( "./inc_header.php" ) ?>

		<div class="op_submenu_wrapper">
			<div class="op_submenu" style="margin-left: 0px;" onClick="location.href='settings.php?jump=eips'" id="menu_eips">Excluded IPs</div>
			<div class="op_submenu" onClick="location.href='settings.php?jump=sips'" id="menu_sips">Blocked IPs</div>
			<div class="op_submenu" onClick="location.href='settings.php?jump=upload'" id="menu_upload">File Upload</div>
			<?php if ( is_file( "$CONF[DOCUMENT_ROOT]/addons/ldap/ldap.php" ) ): ?><div class="op_submenu" onClick="location.href='../addons/ldap/ldap.php'" id="menu_ldap">LDAP</div><?php endif ; ?>
			<div class="op_submenu" onClick="location.href='../addons/smtp/smtp.php'" id="menu_smtp">SMTP</div>
			<?php if ( is_file( "$CONF[DOCUMENT_ROOT]/addons/voice_chat/voice_chat.php" ) ): ?><div class="op_submenu" onClick="location.href='<?php echo $CONF["BASE_URL"] ?>/addons/voice_chat/voice_chat_admin.php'" id="menu_voice_chat">Voice Chat</div><?php endif ; ?>
			<div class="op_submenu" onClick="location.href='../mapp/settings.php'" id="menu_mapp"><img src="../pics/icons/mobile.png" width="12" height="12" border="0" alt=""> Mobile App</div>
			<div class="op_submenu" onClick="location.href='settings_profile.php'" id="menu_profile"><img src="../pics/icons/key.png" width="12" height="12" border="0" alt=""> Password</div>
			<div class="op_submenu" onClick="location.href='settings.php?jump=props'" id="menu_props">Misc.</div>
			<div class="op_submenu_focus" id="menu_system">System</div>
			<div style="clear: both"></div>
		</div>

		<div style="margin-top: 45px;">
			<div style="margin-bottom: 35px;"><span class="info_neutral"><img src="../pics/icons/arrow_left.png" width="16" height="15" border="0" alt=""> <a href="system.php">back</a></span></div>
			<div id="div_alert"></div>
			<div>
				<table cellspacing=0 cellpadding=0 border=0 width="100%">
				<tr>
					<td><div class="td_dept_header">File Name</div></td>
					<td><div class="td_dept_header">MD5 Hash</div></td>
					<td width="50"><div class="td_dept_header">Status</div></td>
					<td width="100%"><div class="td_dept_header">
						<a href="https://www.php.net/manual/en/book.opcache.php" target="_blank">OpCache</a> <?php echo ( $opcache ) ? '<img src="../pics/icons/bolt_yes.png" width="16" height="16" border="0" alt="OpCache enabled" title="OpCache enabled">' : '<img src="../pics/icons/bolt_no.png" width="16" height="16" border="0"  alt="OpCache not enabled" title="OpCache not enabled">' ; ?>
						<?php if ( $opcache && !isset( $CONF_EXTEND ) ): ?>
						<div style="margin-top: 5px; font-weight: normal" class="info_neutral">
							<a href="https://www.php.net/manual/en/opcache.configuration.php#ini.opcache.validate-timestamps" target="_blank">validate_timestamps</a>: <?php echo ( $opcache_config["directives"]["opcache.validate_timestamps"] ) ? 1 : 0 ; ?> (<a href="https://www.php.net/manual/en/opcache.configuration.php#ini.opcache.revalidate-freq" target="_blank">revalidate_freq</a>: <?php echo $opcache_config["directives"]["opcache.revalidate_freq"] ?> sec)
							<div style="margin-top: 5px;">PHP Live! memory usage: <?php echo Util_Functions_Bytes( $opcache_memory_usage ) ?>
								&bull; cache hits: <?php echo number_format( $opcache_total_hits ) ?>
								<button type="button" style="display: none; font-size: 10px;" onClick="opcache_clear()">clear cache</button>
							</div>
						</div>
						<?php endif ; ?>
					</div></td>
				</tr>
				<?php
					$index = 1 ;
					if ( !isset( $CONF_EXTEND ) )
					{
						// add system files
						$files["web/config.php"] = is_file( "$CONF[CONF_ROOT]/config.php" ) ? 2 : 0 ;
						$files["web/vals.php"] = is_file( "$CONF[CONF_ROOT]/vals.php" ) ? 2 : 0 ;
						$files["web/VERSION.php"] = is_file( "$CONF[CONF_ROOT]/VERSION.php" ) ? 2 : 0 ;
						if ( is_file( "$CONF[CONF_ROOT]/addons.php" ) ) { $files["web/addons.php"] = 2 ; }
					}
					foreach ( $files as $file_name => $status )
					{
						$md5 = ( isset( $md5s[$file_name] ) && $md5s[$file_name] ) ? $md5s[$file_name] : "" ;
						$bg_color = ( $index % 2 ) ? "FFFFFF" : "EDEDED" ; ++$index ;
						$status_string = "" ;

						if ( $status == 1 )
							$status_string = "<span class=\"info_good\" style=\"padding: 2px;\">Ok</span>" ;
						else if ( $status == 2 )
							$status_string = "<span class=\"info_good\" style=\"padding: 2px;\" alt=\"Dynamic System File\" title=\"Dynamic System File\">Ok</span>" ;
						else if ( $status == -1 )
							$status_string = "<span class=\"info_error\" style=\"padding: 2px;\">Modified</span>" ;
						else if ( !isset( $md5s[$file_name] ) || !$status )
							$status_string = "<span class=\"info_error\" style=\"padding: 2px;\"><img src=\"../pics/icons/warning.png\" width=\"16\" height=\"16\" border=\"0\" alt=\"\"> Not Found</span>" ;
						else
							$status_string = "<span class=\"info_error\" style=\"padding: 2px;\">Invalid</span>" ;

						$op_cache_stats = ( $opcache ) ? "<img src=\"../pics/icons/bolt_no.png\" width=\"16\" height=\"16\" border=\"0\" alt=\"not yet cache\" title=\"not yet cache\">" : "<span style=\"opacity: 0.5; filter: alpha(opacity=50);\">OpCache not enabled</span>" ;
						if ( $opcache && !count( $opcache_vars ) ) { $op_cache_stats = "<img src=\"../pics/icons/bolt_noq.png\" width=\"16\" height=\"16\" border=\"0\" alt=\"cache stat not available\" title=\"cache stat not available\">" ; }
						if ( isset( $opcache_scripts[$file_name] ) )
						{
							$hits = number_format( $opcache_scripts[$file_name]["hits"] ) ;
							$cached_created = ( $opcache_scripts[$file_name]["last_used_timestamp"] ) ? $opcache_scripts[$file_name]["last_used_timestamp"] : $now ;
							$created = date( "n/d/Y ($VARS_TIMEFORMAT)", $cached_created ) ;
							$script_memory = $opcache_scripts[$file_name]["memory_consumption"] ;
							$memory = Util_Functions_Bytes( $script_memory ) ;
							if ( isset( $CONF_EXTEND ) )
								$op_cache_stats = "<span class=\"info_good\" style=\"padding: 2px;\">Cached <img src=\"../pics/icons/bolt_yes.png\" width=\"16\" height=\"16\" border=\"0\" alt=\"cached\" title=\"cached\"></span>" ;
							else
								$op_cache_stats = "<span class=\"info_good\" style=\"padding: 2px;\">Cached <img src=\"../pics/icons/bolt_yes.png\" width=\"16\" height=\"16\" border=\"0\" alt=\"cached\" title=\"cached\"></span> <span class=\"info_neutral\" style=\"padding: 2px;\">hits: $hits</span> <span class=\"info_neutral\" style=\"padding: 2px;\">memory: $memory</span>" ;
						}
						else if ( preg_match( "/.js$/i", $file_name ) )
						{
							$op_cache_stats = "<img src=\"../pics/icons/js.png\" width=\"16\" height=\"16\" border=\"0\" alt=\"JavaScript file\" title=\"JavaScript file\">" ;
						}
						else if ( preg_match( "/.css$/i", $file_name ) )
						{
							$op_cache_stats = "<img src=\"../pics/icons/css.png\" width=\"16\" height=\"16\" border=\"0\" alt=\"CSS file\" title=\"CSS file\">" ;
						}

						print "<tr style=\"background: #$bg_color\">
							<td style=\"padding: 5px;\">$file_name</td>
							<td style=\"padding: 5px;\">$md5</td>
							<td nowrap><div class=\"td_dept_td\">$status_string</div></td>
							<td><div class=\"td_dept_td\">$op_cache_stats</div></td>
						</tr>" ;
					}
				?>
				<tr style="background: #E2E3E5; color: #4C4C4C; border: 0px;">
					<td colspan=4>
						<div class="info_blank" style="padding: 12px;">Total Files Checked: <?php echo $files_total ?></div>
					</td>
				</tr>
				</table>
			</div>
		</div>

<?php include_once( "./inc_footer.php" ) ?>