<?php
	/***************************************/
	//
	//
	// PHP Live! Support
	//
	// https://www.phplivesupport.com
	//
	/***************************************/
	if ( defined( 'Util_Export_Transcripts' ) ) { return ; }	
	define( 'Util_Export_Transcripts', true ) ;

	FUNCTION Util_Export_Transcripts_TotalTranscripts( &$dbh,
					  $stat_start,
					  $stat_end )
	{
		if ( !is_numeric( $stat_start ) || !is_numeric( $stat_end ) )
			return 0 ;
	
		LIST( $stat_start, $stat_end ) = database_mysql_quote( $dbh, $stat_start, $stat_end ) ;
		$sdate = mktime( 0, 0, 1, date("m"), date("j"), date("Y") ) ;

		$query = "SELECT count(*) AS total FROM p_transcripts WHERE created >= $stat_start AND created < $stat_end" ;
		database_mysql_query( $dbh, $query ) ;

		if ( $dbh[ 'ok' ] )
		{
			$data = database_mysql_fetchrow( $dbh ) ;
			return $data["total"] ;
		}
		return 0 ;
	}

	FUNCTION Util_Export_Fetch_RefinedTranscripts( &$dbh,
								$deptid,
								$opid,
								$tid,
								$s_as,
								$text,
								$stat_start,
								$stat_end,
								$flag )
	{
		LIST( $deptid, $opid, $tid, $text, $stat_start, $stat_end ) = database_mysql_quote( $dbh, $deptid, $opid, $tid, $text, $stat_start, $stat_end ) ;

		$search_string = " AND created >= $stat_start AND created <= $stat_end " ;
		if ( $s_as == "ces" ) { $search_string .= " AND ( ces = '$text' ) " ; }
		else if ( $s_as == "vid" ) { $search_string .= " AND ( md5_vis = '$text' ) " ; }
		else if ( preg_match( "/^cus_/i", $s_as ) ) { $search_string .= " AND ( custom LIKE '%$text%' ) " ; }
		else if ( $s_as && $text ) { $search_string .= " AND ( plain LIKE '%$text%' ) " ; }

		if ( $tid ) { $search_string .= " AND ( tag = $tid ) " ; }
		if ( $deptid && $opid )
		{
			if ( $flag )
				$query = "SELECT * FROM p_transcripts WHERE deptID = $deptid AND opID = $opid $search_string ORDER BY created DESC" ;
			else
				$query = "SELECT count(*) AS total FROM p_transcripts WHERE deptID = $deptid AND opID = $opid $search_string" ;
		}
		else if ( $deptid )
		{
			if ( $flag )
				$query = "SELECT * FROM p_transcripts WHERE deptID = $deptid $search_string ORDER BY created DESC" ;
			else
				$query = "SELECT count(*) AS total FROM p_transcripts WHERE deptID = $deptid $search_string" ;
		}
		else if ( $opid )
		{
			if ( $flag )
				$query = "SELECT * FROM p_transcripts WHERE opID = $opid $search_string ORDER BY created DESC" ;
			else
				$query = "SELECT count(*) AS total FROM p_transcripts WHERE opID = $opid $search_string" ;
		}
		else
		{
			if ( $flag )
				$query = "SELECT * FROM p_transcripts WHERE created > 0 $search_string ORDER BY created DESC" ;
			else
				$query = "SELECT count(*) AS total FROM p_transcripts WHERE created > 0 $search_string" ;
		}
		database_mysql_query( $dbh, $query ) ;

		if ( $flag )
		{
			$output = Array() ;
			if ( $dbh[ 'ok' ] )
			{
				while ( $data = database_mysql_fetchrow( $dbh ) )
					$output[] = $data ;
			}
		}
		else
		{
			$data = database_mysql_fetchrow( $dbh ) ;
			$output = isset( $data["total"] ) ? $data["total"] : 0 ;
		}

		return $output ;
	}
?>