<?php
	/***************************************/
	//
	//
	// PHP Live! Support
	//
	// https://www.phplivesupport.com
	//
	/***************************************/
	// STANDARD header for Setup
	include_once( "../../web/config.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Format.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Error.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/".Util_Format_Sanatize($CONF["SQLTYPE"], "ln") ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Security.php" ) ;
	if ( !$admininfo = Util_Security_AuthSetup( $dbh ) ){ ErrorHandler( 608, "Invalid setup session or session has expired.", $PHPLIVE_FULLURL, 0, Array() ) ; exit ; }
	// STANDARD header end
	/****************************************/

	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Functions.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Ops/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Depts/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Chat/get_ext.php" ) ;

	$EXPORTT_VERSION = "1.0" ;
	if ( is_file( "$CONF[DOCUMENT_ROOT]/addons/export_transcripts/API/VERSION.php" ) )
		include_once( "$CONF[DOCUMENT_ROOT]/addons/export_transcripts/API/VERSION.php" ) ;

	$error = "" ;
	$action = Util_Format_Sanatize( Util_Format_GetVar( "action" ), "ln" ) ;
	$deptid = Util_Format_Sanatize( Util_Format_GetVar( "deptid" ), "n" ) ;
	$opid = Util_Format_Sanatize( Util_Format_GetVar( "opid" ), "n" ) ;
	$index = Util_Format_Sanatize( Util_Format_GetVar( "index" ), "n" ) ;
	$tid = Util_Format_Sanatize( Util_Format_GetVar( "tid" ), "n" ) ;

	$departments = Depts_get_AllDepts( $dbh ) ;
	$operators = Ops_get_AllOps( $dbh ) ;

	// make hash for quick refrence
	$operators_hash = Array() ;
	for ( $c = 0; $c < count( $operators ); ++$c )
	{
		$operator = $operators[$c] ;
		$operators_hash[$operator["opID"]] = $operator["name"] ;
	}

	$dept_hash = Array() ; $dept_customs = Array() ;
	for ( $c = 0; $c < count( $departments ); ++$c )
	{
		$department = $departments[$c] ;
		$dept_hash[$department["deptID"]] = $department["name"] ;
		if ( $department["custom"] )
		{
			$custom = unserialize( $department["custom"] ) ;
			$dept_customs = array_merge( $dept_customs, $custom ) ;
		}
	}

	$custom_search_options = "" ;
	$custom_search_field_hash = Array() ; // used for page function Util_Functions_Page

	for ( $c = 0; $c < count( $dept_customs ); ++$c )
	{
		$custom = $dept_customs[$c] ;
		if ( $custom && !isset( $custom_search_field_hash[$custom] ) && !preg_match( "/,/", $custom ) )
		{
			$custom_search_field_hash[$custom] = 1 ;
			$custom_search_options .= "<option value='cus_$c'>$custom</option>" ;
		}
		++$c ;
	}

	$query = "SELECT created FROM p_admins WHERE adminID = 1 LIMIT 1" ;
	database_mysql_query( $dbh, $query ) ;
	$super_admin = database_mysql_fetchrow( $dbh ) ;
	if ( isset( $super_admin["created"] ) ) { $y_start = date( "Y", $super_admin["created"] ) ; }
	else { $y_start = 2011 ; }

	$text = Util_Format_Sanatize( Util_Format_GetVar( "text" ), "" ) ; $text = ( $text ) ? $text : "" ; $text_query = urlencode( $text ) ;
	$s_as = Util_Format_Sanatize( Util_Format_GetVar( "s_as" ), "ln" ) ;
	$year = Util_Format_Sanatize( Util_Format_GetVar( "y" ), "n" ) ;

	$tags = ( isset( $VALS['TAGS'] ) && $VALS['TAGS'] ) ? unserialize( $VALS['TAGS'] ) : Array() ;
	$tags_hash = Array() ;
	foreach( $tags as $index => $value )
	{
		if ( ( $index != "c" ) && preg_match( "/,/", $value ) )
		{
			LIST( $status, $color, $tag ) = explode( ",", $value ) ;
			$tag = rawurldecode( $tag ) ;
			$tags_hash[$index] = $tag ;
		}
	} $export_transcripts = 1 ;

	// make sure new file exists before calling new function
	if ( is_file( "$CONF[DOCUMENT_ROOT]/API/Util_Files.php" ) )
	{
		include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Files.php" ) ;
		Util_Files_CleanExportDir() ;
	}
?>
<?php include_once( "$CONF[DOCUMENT_ROOT]/inc_doctype.php" ) ?>
<head>
<title> PHP Live! Support </title>

<meta name="description" content="PHP Live! Support <?php echo $VERSION ?>">
<meta name="keywords" content="powered by: PHP Live!  www.phplivesupport.com">
<meta name="robots" content="all,index,follow">
<meta http-equiv="content-type" content="text/html; CHARSET=utf-8">
<?php include_once( "$CONF[DOCUMENT_ROOT]/inc_meta_dev.php" ) ; ?>

<link rel="Stylesheet" href="../../css/setup.css?<?php echo filemtime( "../../css/setup.css" ) ?>">
<script data-cfasync="false" type="text/javascript" src="../../js/global.js?<?php echo filemtime ( "../../js/global.js" ) ; ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../../js/framework.js?<?php echo $VERSION ?>"></script>
<script data-cfasync="false" type="text/javascript" src="./js/export_transcripts.js?<?php echo filemtime ( "./js/export_transcripts.js" ) ; ?>"></script>

<script data-cfasync="false" type="text/javascript">
<!--
	$(document).ready(function()
	{
		$("html, body").css({'background': '#F2F3F5'}) ;

		init_menu() ;
		toggle_menu_setup( "trans" ) ;
	});

	function input_text_listen_search( e )
	{
		var key = -1 ;
		var shift ;

		key = e.keyCode ;
		shift = e.shiftKey ;

		if ( !shift && ( ( key == 13 ) || ( key == 10 ) ) )
			e.preventDefault() ;
	}
//-->
</script>
</head>
<?php include_once( "$CONF[DOCUMENT_ROOT]/setup/inc_header.php" ) ?>

		<div class="op_submenu_wrapper">
			<div class="op_submenu_focus" style="margin-left: 0px;" onClick="location.href='../../setup/transcripts.php'" id="menu_trans_list">Transcripts</div>
			<div class="op_submenu" onClick="location.href='../../setup/transcripts_tags.php'" id="menu_trans_tags">Tags</div>
			<div style="clear: both"></div>
		</div>

		<div style="margin-top: 25px;">
			<div class="op_submenu3" style="margin-left: 0px;" onClick="location.href='../../setup/transcripts.php'">View Transcripts</div>
			<div class="op_submenu_focus">Export Transcripts</div>
			<div class="op_submenu3" onClick="location.href='../../setup/transcripts_settings.php'">Automatic Delete Transcripts</div>
			<div style="clear: both"></div>
		</div>

		<div id="transcripts_list" style="margin-top: 45px;">

			<div style="">
				<?php
					$trans_script = "/addons/export_transcripts/export_transcripts.php" ;
				?>
				<div class="info_neutral" id="div_trans_search">
					<form method="POST" action="" id="form_trans_search" style="">
					<div style="">
						<table cellspacing=0 cellpadding=0 border=0>
						<tr>
							<td colspan=6 style="padding-bottom: 15px;">
								<table cellspacing=0 cellpadding=0 border=0>
								<tr>
									<td style="padding-right: 15px;">
										Department<br>
										<select name="deptid" id="deptid" style="font-size: 16px;">
										<option value="0"></option>
										<?php
											for ( $c = 0; $c < count( $departments ); ++$c )
											{
												$department = $departments[$c] ;
												$selected = ( $deptid == $department["deptID"] ) ? "selected" : "" ;
												print "<option value=\"$department[deptID]\" $selected>$department[name]</option>" ;
											}
										?>
										</select>
									</td>
									<td style="padding-right: 15px;">
										Operator<br>
										<select name="opid" id="opid" style="font-size: 16px;">
										<option value="0"></option>
										<?php
											for ( $c = 0; $c < count( $operators ); ++$c )
											{
												$operator = $operators[$c] ;
												$selected = ( $opid == $operator["opID"] ) ? "selected" : "" ;
												print "<option value=\"$operator[opID]\" $selected>$operator[name]</option>" ;
											}
										?>
										</select>
									</td>
								</tr>
								</table>
							</td>
						</tr>
						<tr>
							<?php if ( count( $tags ) ): ?>
							<td style="padding-right: 15px;">
								Tag<br>
								<select id="tid" style="font-size: 16px;"><option value="0"></option>
								<?php
									foreach( $tags as $index => $value )
									{
										if ( ( $index != "c" ) && preg_match( "/,/", $value ) )
										{
											LIST( $status, $color, $tag ) = explode( ",", $value ) ;
											$tag = rawurldecode( $tag ) ;

											if ( $status )
											{
												$selected = ( $index == $tid ) ? "selected" : "" ;
												print "<option value=\"$index\" $selected>$tag</option>" ;
											}
										}
									}
								?>
								</select>
							</td>
							<?php else: ?>
							<td><input type="hidden" id="tid" name="tid" value=0></td>
							<?php endif; ?>
							<td style="padding-right: 15px;">
								Year<br>
								<?php
									$y = date( "Y", time() ) ;
									$year_string = "<select name='year' id='year' style='font-size: 16px;'>" ;
									$year_string .= ( isset( $page ) ) ? "<option value='0'></option>" : "" ;
									for ( $c = $y; $c >= $y_start; --$c ) { $selected = "" ; if ( $year == $c ) { $selected = "selected" ; } $year_string .= "<option value=$c $selected>$c</option>" ; } $year_string .= "</select>" ;
									print $year_string ;
								?>
							</td>
							<td style="padding-right: 15px;">
								Search Text<br>
								<input type="text" class="input_text_search input" size="15" maxlength="55" style="" id="input_search" value="<?php echo $text ?>" onKeydown="input_text_listen_search(event);" autocomplete="off">
							</td>
							<td style="padding-right: 15px;">
								Search Field<br>
								<select name="s_as" id="s_as" style="">
									<option value=""></option>
									<option value="text">text</option>
									<option value="ces">Chat ID</option>
									<option value="vid">Visitor ID</option> <?php echo $custom_search_options ?>
								</select>
							</td>
							<td>
								&nbsp;<br>
								<div>
									<input type="button" id="btn_page_search" style="" class="btn" value="search" onClick="do_search('<?php echo $CONF["BASE_URL"].$trans_script ?>')">
								</div>
								<script data-cfasync="false" type="text/javascript">
									$('#s_as').val('<?php echo ( $s_as ) ? $s_as : "" ; ?>') ;
								</script>
							</td>
						</tr>
						</table>
					</div>
					</form>
				</div>
			</div>

			<div id="div_export_content" style="padding-top: 25px;">

				<?php if ( class_exists( "PharData" ) ): ?>
				<div style="">
					<?php
						if ( !is_dir( $CONF["EXPORT_DIR"] ) )
						{
							mkdir( $CONF["EXPORT_DIR"], 0777 ) ;
							if ( is_dir( $CONF["EXPORT_DIR"] ) && is_writeable( $CONF["EXPORT_DIR"] ) )
							{
								$index_file = "$CONF[DOCUMENT_ROOT]/files/index.php" ;
								@copy( $index_file, "$CONF[EXPORT_DIR]/index.php" ) ;
							}
						}
						if ( $year )
						{
							include_once( "$CONF[DOCUMENT_ROOT]/addons/export_transcripts/API/Util_Export_Transcripts.php" ) ;
							for ( $c = 1; $c <= 12; ++$c )
							{
								$month_expanded = date( "F", mktime( 0, 0, 1, $c, 1, 2010 ) ) ;
								$stat_start = mktime( 0, 0, 0, $c, 1, $year ) ;
								$stat_end = mktime( 0, 0, 0, $c, date( "t", $stat_start ), $year ) ;

								$total = Util_Export_Fetch_RefinedTranscripts( $dbh, $deptid, $opid, $tid, $s_as, $text, $stat_start, $stat_end, 0 ) ;
								$disabled = ( !$total ) ? "disabled" : "" ;

								print "<div style='float: left; margin-right: 5px; margin-bottom: 15px; text-align: center;' class='info_neutral'><button type='button' style='padding: 5px;' $disabled onClick='export_transcripts(\"step1\", $c, \"$month_expanded\", $year)'>$month_expanded $year</button><div style='margin-top: 5px;'>$total transcripts</div></div>" ;
							}
						}
					?>
					<div style="clear: both;"></div>
				</div>
				<?php else: ?>
				<div class="info_error" style=""><b>Error</b><br><br>Missing PHP <a href="http://php.net/manual/en/class.phardata.php" target="_blank" style="color: #FFFFFF;"><code>PharData</code></a> class.  Enable the PHP PharData class to utilize the export transcripts feature.</div>
				<?php endif ; ?>
			</div>

		</div>

		<div id="div_export_wrapper" style="display: none; position: absolute; top: 0px; left: 0px; width: 10px; height: 10px; background: url( ../../pics/bg_trans_white.png ) repeat; overflow: hidden; z-Index: 1001;"></div>
		<div id="div_export_body" class="info_misc" style="display: none; position: absolute; text-align: center; padding: 25px; width: 310px; z-Index: 1002;">
			<div style="text-align: right;"><span style="cursor: pointer;" onClick="export_transcripts('', 0, '', 0)" class="info_error">close</span></div>
			<div style="margin-top: 35px; font-weight: bold;">Export <span id="div_export_timeline" class="info_box"></span> chat transcripts?</div>

			<div id="div_btn_export" style="margin-top: 35px;"></div>
			<div id="div_export_delete" style="display:none; margin-top: 15px;">The exported file located on the server will be automatically deleted.  However, it can be deleted immediately.  <a href="JavaScript:void(0)" onClick="delete_file()" style="color: #FFFFFF;">Delete the file now.</a></div>
		</div>

<?php include_once( "$CONF[DOCUMENT_ROOT]/setup/inc_footer.php" ) ?>
