<?php
	/***************************************/
	//
	//
	// PHP Live! Support
	//
	// https://www.phplivesupport.com
	//
	/***************************************/
	// STANDARD header for Setup
	if ( !is_file( "../../web/config.php" ) ){ HEADER("location: install.php") ; exit ; }
	include_once( "../../web/config.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Format.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Error.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/".Util_Format_Sanatize($CONF["SQLTYPE"], "ln") ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Security.php" ) ;
	if ( !$admininfo = Util_Security_AuthSetup( $dbh ) ){ ErrorHandler( 608, "Invalid setup session or session has expired.", $PHPLIVE_FULLURL, 0, Array() ) ; exit ; }
	// STANDARD header end
	/****************************************/

	include_once( "$CONF[DOCUMENT_ROOT]/addons/API/Util_Addons.php" ) ;
	if ( is_file( "$CONF[CONF_ROOT]/addons.php" ) ) { include_once( "$CONF[CONF_ROOT]/addons.php" ) ; }

	$action = Util_Format_Sanatize( Util_Format_GetVar( "action" ), "ln" ) ;
	$ldap_array = ( isset( $VALS_ADDONS ) && isset( $VALS_ADDONS["LDAP"] ) && $VALS_ADDONS["LDAP"] ) ? unserialize( base64_decode( $VALS_ADDONS["LDAP"] ) ) : Array() ;

	$error = "" ;

	if ( $action == "update_ldap" )
	{
		include_once( "$CONF[DOCUMENT_ROOT]/addons/ldap/API/Util_LDAP.php" ) ;

		$server = Util_Format_Sanatize( Util_Format_GetVar( "server" ), "" ) ;
		$basedn = Util_Format_Sanatize( Util_Format_GetVar( "basedn" ), "" ) ;
		$login = Util_Format_Sanatize( Util_Format_GetVar( "login" ), "" ) ;
		$password = rawurldecode( Util_Format_Sanatize( Util_Format_GetVar( "password" ), "" ) ) ;
		$uid = Util_Format_Sanatize( Util_Format_GetVar( "uid" ), "" ) ;
		$name = $email = "" ;

		$ldap_array = Array() ;
		$ldap_array["server"] = $server ;
		$ldap_array["basedn"] = $basedn ;
		$ldap_array["login"] = $login ;
		$ldap_array["password"] = $password ;

		$error = Util_LDAP_connect() ;
		if ( $error ) { $error = Util_Format_ConvertQuotes( $error ) ; }
		else
		{
			$userinfo = Util_LDAP_search( $uid, "" ) ;
			if ( is_array( $userinfo ) && isset( $userinfo['cn'] ) )
			{
				$name = $userinfo['cn'][0] ;
				$email = $userinfo['mail'][0] ;
			}
			else { $error = $userinfo ; }
		}
		Util_LDAP_close() ;

		if ( $error )
			$json_data = "json_data = { \"status\": 0, \"error\": \"$error\" };" ;
		else
		{
			if ( Util_Addons_WriteToFile( "LDAP", base64_encode( serialize($ldap_array) ) ) )
				$json_data = "json_data = { \"status\": 1, \"name\": \"$name\", \"email\": \"$email\" };" ;
			else
				$json_data = "json_data = { \"status\": 0, \"error\": \"Error writing to LDAP addon file.\" };" ;
		}

		if ( isset( $dbh ) && isset( $dbh['con'] ) ) { database_mysql_close( $dbh ) ; }
		$json_data = Util_Format_Trim( $json_data ) ;
		$json_data = preg_replace( "/\t/", "", $json_data ) ;
		HEADER('Content-Type: text/plain; charset=utf-8') ;
		print $json_data ; exit ;
	}
	else if ( $action == "delete_ldap" )
	{
		$ldap_array = Array() ;
		Util_Addons_WriteToFile( "LDAP", base64_encode( serialize($ldap_array) ) ) ;
		if ( isset( $dbh ) && isset( $dbh['con'] ) ) { database_mysql_close( $dbh ) ; }
		HEADER( "location: ldap.php?action=success" ) ; exit ;
	}
?>
<?php include_once( "../../inc_doctype.php" ) ?>
<head>
<title> PHP Live! Support </title>

<meta name="description" content="PHP Live! Support <?php echo $VERSION ?>">
<meta name="keywords" content="powered by: PHP Live!  www.phplivesupport.com">
<meta name="robots" content="all,index,follow">
<meta http-equiv="content-type" content="text/html; CHARSET=utf-8">
<?php include_once( "../../inc_meta_dev.php" ) ; ?>

<link rel="Stylesheet" href="../../css/setup.css?<?php echo filemtime( "../../css/setup.css" ) ?>">
<script data-cfasync="false" type="text/javascript" src="../../js/global.js?<?php echo filemtime ( "../../js/global.js" ) ; ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../../js/framework.js?<?php echo $VERSION ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../../js/jquery_md5.js?<?php echo $VERSION ?>"></script>

<script data-cfasync="false" type="text/javascript">
<!--
	$(document).ready(function()
	{
		$("html, body").css({'background': '#F2F3F5'}) ;
		init_menu() ;
		toggle_menu_setup( "settings" ) ;

		<?php if ( $action && !$error ): ?>do_alert( 1, "Success" ) ;<?php endif ; ?>

		<?php if ( isset( $ldap_array["server"] ) ): ?>
			input_disable() ;
		<?php endif ; ?>
	});

	function do_update()
	{
		var json_data = new Object ;
		var server = $('#server').val().trim() ;
		var basedn = $('#basedn').val().trim() ;
		var login = $('#login').val().trim() ;
		var password = $('#password').val().trim() ;
		var uid = $('#uid').val().trim() ;

		$('#div_alert').hide() ;

		if ( !server || !basedn || !login || !password || !uid )
		{
			do_alert( 0, "All values must be provided." ) ;
			return false ;
		}
		else if ( !server.match( /^((ldap)|(ldaps)):/i ) )
		{
			do_alert( 0, "LDAP server must begin with ldap:" ) ;
			return false ;
		}
		else
		{
			$('#btn_submit').attr('disabled', true) ;

			$.ajax({
			type: "POST",
			url: "./ldap.php",
			data: "action=update_ldap&server="+server+"&basedn="+basedn+"&login="+login+"&password="+encodeURI( encodeURIComponent(password) )+"&uid="+uid,
			success: function(data){
				$('#btn_submit').attr('disabled', false) ;
				eval( data ) ;

				if ( json_data.status )
				{
					location.href = "ldap.php?action=success" ;
				}
				else
				{
					do_alert_div( "../../", 0, json_data.error ) ;
				}
			},
			error:function (xhr, ajaxOptions, thrownError){
				do_alert( 0, "Error connecting to server.  Please refresh the window and try again." ) ;
			} });
		}
	}

	function input_disable()
	{
		$('#div_ldap_password').hide() ;
		$('#div_ldap_uid').hide() ;
		$("#theform input").prop("disabled", true) ;

		$('#div_btn_submit').hide() ;
		$('#div_active').show() ;
	}

	function input_enable()
	{
		$('#div_ldap_password').show() ;
		$('#div_ldap_uid').show() ;
		$("#theform input").prop("disabled", false) ;

		$('#div_btn_submit').show() ;
		$('#div_active').hide() ;
	}

	function do_delete()
	{
		$('#div_active').hide() ;
		$('#div_delete').show() ;
	}

	function do_delete_doit()
	{
		location.href = "ldap.php?action=delete_ldap" ;
	}
//-->
</script>
</head>
<?php include_once( "../../setup/inc_header.php" ) ?>

		<?php
			if ( !$admininfo["isadmin"] && ( count( $admininfo["access"] ) && !isset( $admininfo["access"]["settings"] ) ) && !$pr ):
			include_once( "$CONF[DOCUMENT_ROOT]/setup/inc_access.php" ) ; else:
		?>
		<div class="op_submenu_wrapper">
			<div class="op_submenu" style="margin-left: 0px;" onClick="location.href='../../setup/settings.php?jump=eips'" id="menu_eips">Excluded IPs</div>
			<div class="op_submenu" onClick="location.href='../../setup/settings.php?jump=sips'" id="menu_sips">Blocked IPs</div>
			<div class="op_submenu" onClick="location.href='../../setup/settings.php?jump=upload'" id="menu_upload">File Upload</div>
			<div class="op_submenu_focus" id="menu_ldap">LDAP</div>
			<div class="op_submenu" onClick="location.href='../../addons/smtp/smtp.php'" id="menu_smtp">SMTP</div>
			<?php if ( is_file( "$CONF[DOCUMENT_ROOT]/addons/voice_chat/voice_chat.php" ) ): ?><div class="op_submenu" onClick="location.href='<?php echo $CONF["BASE_URL"] ?>/addons/voice_chat/voice_chat_admin.php'" id="menu_voice_chat">Voice Chat</div><?php endif ; ?>
			<div class="op_submenu" onClick="location.href='../../mapp/settings.php'" id="menu_mapp"><img src="../../pics/icons/mobile.png" width="12" height="12" border="0" alt=""> Mobile App</div>
			<div class="op_submenu" onClick="location.href='../../setup/settings_profile.php'" id="menu_profile"><img src="../../pics/icons/key.png" width="12" height="12" border="0" alt=""> Password</div>
			<div class="op_submenu" onClick="location.href='../../setup/settings.php?jump=props'" id="menu_props">Misc.</div>
			<div class="op_submenu" onClick="location.href='../../setup/system.php'" id="menu_system">System</div>
			<div style="clear: both"></div>
		</div>

		<?php if ( !function_exists( "ldap_connect" ) ): ?>
		<div style="margin-top: 45px;" class="info_error">Please enable the <a href="https://www.php.net/manual/en/book.ldap.php" target="_blank">PHP LDAP extension</a> to continue.</div>
		<?php else: ?>
		<div style="margin-top: 45px;">
			Provide your LDAP information to allow <a href="../../setup/ops.php">operators</a> to signin using their LDAP credentials.
			<form id="theform">
			<div style="margin-top: 15px;">
				<table cellspacing=0 cellpadding=0 border=0>
				<tr>
					<td><div class="tab_form_title">Server</div></td>
					<td style="padding-left: 10px;"><input type="text" class="input" name="server" id="server" size="65" maxlength="255" onKeyPress="return noquotestags(event)" value="<?php echo ( isset( $ldap_array["server"] ) ) ? $ldap_array["server"] : "" ; ?>" autocomplete="off"></td>
				</tr>
				</table>
			</div>
			<div style="margin-top: 15px;">
				<table cellspacing=0 cellpadding=0 border=0>
				<tr>
					<td><div class="tab_form_title">Base DN (ORG DN)</div></td>
					<td style="padding-left: 10px;"><input type="text" class="input" name="basedn" id="basedn" size="65" maxlength="255" onKeyPress="return noquotestags(event)" value="<?php echo ( isset( $ldap_array["basedn"] ) ) ? $ldap_array["basedn"] : "" ; ?>" autocomplete="off"></td>
				</tr>
				</table>
			</div>
			<div style="margin-top: 15px;">
				<table cellspacing=0 cellpadding=0 border=0>
				<tr>
					<td><div class="tab_form_title">Login (UID)</div></td>
					<td style="padding-left: 10px;"><input type="text" class="input" name="login" id="login" size="25" maxlength="255" onKeyPress="return noquotestags(event)" value="<?php echo ( isset( $ldap_array["login"] ) ) ? $ldap_array["login"] : "" ; ?>" autocomplete="off"></td>
				</tr>
				</table>
			</div>
			<div style="margin-top: 15px;" id="div_ldap_password">
				<table cellspacing=0 cellpadding=0 border=0>
				<tr>
					<td><div class="tab_form_title">Password</div></td>
					<td style="padding-left: 10px;"><input type="password" class="input" name="password" id="password" size="25" maxlength="255" value="" autocomplete="off"></td>
				</tr>
				</table>
			</div>
			<div style="margin-top: 15px;" id="div_ldap_uid">
				<table cellspacing=0 cellpadding=0 border=0>
				<tr>
					<td><div class="tab_form_title" style="background: #F2F3F5; border: 0px;">&nbsp;</div></td>
					<td style="padding-left: 10px;">
						To verify the LDAP information, search an existing user login.
						<div style="margin-top: 5px;" class="info_neutral">
							Search for user login:<br>
							<input type="text" class="input" name="uid" id="uid" size="25" maxlength="15" onKeyPress="return noquotestags(event)" value="" autocomplete="off">
						</div>
					</td>
				</tr>
				</table>
			</div>
			<div style="margin-top: 15px;">
				<table cellspacing=0 cellpadding=0 border=0>
				<tr>
					<td><div class="tab_form_title" style="background: #F2F3F5; border: 0px;">&nbsp;</div></td>
					<td style="padding-left: 10px; padding-top: 10px;">
						<div id="div_btn_submit">
							<div id="div_alert" style="display: none; margin-bottom: 25px;"></div>
							<button type="button" onClick="do_update()" class="btn" id="btn_submit">Submit</button>
							<?php if ( isset( $ldap_array["server"] ) ): ?>&nbsp; <a href="ldap.php">cancel</a><?php endif ; ?>
						</div>
						<div id="div_active" style="display: none;">
							<span class="info_good"><img src="./pics/ldap.png" width="34" height="34" border="0" alt=""> <img src="../../pics/icons/check.png" width="16" height="16" border="0" alt=""> LDAP values are saved and is active. <a href="../../setup/ops.php">Operators</a> must use their LDAP credentials to log in to the operator area.</span>
							<div style="margin-top: 25px;">
								<a href="JavaScript:void(0)" onClick="input_enable()"><img src="../../pics/btn_edit.png" width="64" height="23" border="0" alt=""></a>
								&nbsp;
								<a href="JavaScript:void(0)" onClick="do_delete()"><img src="../../pics/btn_delete.png" width="64" height="23" border="0" alt=""></a>
							</div>
						</div>
						<div id="div_delete" style="display: none;">
							<div class="info_error" style="margin-bottom: 25px;">
								Really delete the LDAP values and discontinue using LDAP to signin for operators?
								<div style="margin-top: 15px;">
									<button type="button" class="btn" onClick="do_delete_doit()">Yes, delete LDAP values.</button> &nbsp; <a href="ldap.php">cancel</a>
								</div>
							</div>
						</div>
					</td>
				</tr>
				</table>
			</div>
			</form>

		</div>
		<?php endif ; ?>

		<?php endif ; ?>

<?php include_once( "../../setup/inc_footer.php" ) ?>