function input_text_listen( e )
{
	var key = -1 ;
	var shift ;

	key = e.keyCode ;
	shift = e.shiftKey ;

	if ( !shift && ( ( key == 13 ) || ( key == 10 ) ) )
	{
		e.preventDefault ? e.preventDefault() : (e.returnValue = false) ;
		send_message() ;
	}
}

function init_message_board()
{
	// at least 2 seconds more than the chat requesting interval to fix a blank initial loading on the console
	var timeout = 1000 ;
	setTimeout( function(){
		init_display_messages() ;
	}, timeout ) ;
	init_emoji() ;
}

var display_message_processing = 0 ;
function init_display_messages()
{
	var min_messageid = get_min_messageid() ;
	var total_messages = get_total_messages() ;

	var messageids = Array() ;
	for ( var messageid in parent.messageboard )
		messageids.push( messageid ) ;
	messageids.sort( function (a, b) { return a - b; } ) ;

	display_message_processing = 1 ;
	var append_text_out = "" ;
	for ( var c = 0; c < messageids.length; ++c )
	{
		var message_object = parent.messageboard[messageids[c]] ;
		var append_text = generate_display_message( messageids[c], message_object["opid"], message_object["created"], message_object["message"] ) ;

		append_text_out += parent.init_timestamps( append_text, messageids[c], 1 ) ;
	}

	// this is the best place due to time consuming message parsing (above)
	if ( $('#img_messages_loading').is(":visible") ) { $('#img_messages_loading').hide() ; }

	$('#chat_body').append( parent.autolink_it( append_text_out.emoji() ) ) ; if ( isop && mapp ) { init_external_url() ; }

	if ( ( total_messages >= 100 ) && ( parseInt( min_messageid ) > 1 ) && !parent.messageboard_all_loaded )
	{
		display_load_previous( min_messageid ) ;
	}
	else if ( $('#chat_body').html() == "" )
	{
		//$('#chat_body').html( "<div class='info_box'></div>" ) ;
	}

	setTimeout( function(){ init_scrolling() ; }, 100 ) ;
	display_message_processing = 0 ;
}

function append_success( themessage )
{
	$('#chat_body').append( themessage ) ;
	setTimeout( function() { $('#div_delete_success').fadeOut("slow") ; }, 60000 ) ;
}

function display_load_previous( themessageid )
{
	if ( !$('#div_load_previous').length )
		$('#chat_body').prepend( "<div class='ca info_box' id='div_load_previous' style='text-align: center;'><span onClick='load_previous_messages("+themessageid+")' style='cursor: pointer;'><img src=\"../../themes/"+theme+"/chats.png\" width=\"12\" height=\"12\" border=\"0\" alt=\"\"> load more messages</span></div>" ) ;
}

function generate_display_message( themessageid, theopid, thecreated, themessage )
{
	var delete_string = ( typeof( parent.setup_admin_key ) != "undefined" ) ? "<td style=\"padding-left: 5px; cursor: pointer;\" onClick=\"delete_message("+themessageid+")\" id='td_delete_message_"+themessageid+"'><img src=\"../../themes/"+theme+"/delete.png\" width=\"14\" height=\"14\" border=\"0\" alt=\"delete message\" title=\"delete message\"></td>" : "" ;

	var mid_string = ( debug ) ? " [ MID="+themessageid+" ] " : "" ;

	var op_profile_pic = ( $('#img_profile_'+theopid).length ) ? $('#img_profile_'+theopid).attr('src') : "../../themes/"+theme+"/profile.png" ;
	var op_profile_pic_string = "<img src='"+op_profile_pic+"' width='32' height='32' style='border-radius: 50%;' alt=''> " ;

	var op_name = ( $('#span_name_'+theopid).length ) ? $('#span_name_'+theopid).html() : "&nbsp[?]&nbsp;" ;
	var matches = themessage.match( /<x-(.*?)>$/ ) ;
	if ( !theopid && matches && ( typeof( matches[1] ) != "undefined" ) ) { op_name = matches[1] ; }
	else if ( !theopid && !matches ) { op_name = "Setup Admin" ; } // pre v.4.8 with no <x-> tag

	var display_message = "<div class='co' id='div_message_"+themessageid+"' onClick='display_timestamp("+themessageid+")'>"+
		"<table cellspacing=0 cellpadding=0 border=0 width=\"100%\">"+
		"<tr>"+
			"<td width=\"100%\"><table cellspacing=0 cellpadding=0 border=0><tr><td valign=\"top\">"+op_profile_pic_string+"</td><td valign=\"top\" style=\"padding-left: 5px;\"><span class='notranslate'><b>"+op_name+"<timestamp_"+thecreated+"_co></b></span><div style=\"margin-top: 5px;\">"+mid_string+themessage+"</div></td></tr></table></td>"+
			delete_string+
		"</tr></table></div>" ;

	return display_message ;
}

function display_timestamp( themessageid )
{
	if ( $('#span_timestamp_'+themessageid).is(":visible" ) )
		$('#span_timestamp_'+themessageid).hide() ;
	else
		$('#span_timestamp_'+themessageid).show() ;
}

function delete_message( themessageid )
{
	if ( !$('#div_delete_message_'+themessageid).length )
		$('#div_message_'+themessageid).append( "<div class='info_error' id='div_delete_message_"+themessageid+"'>Really delete this message? &nbsp; <button type='button' style='padding: 3px;' onClick='delete_message_doit("+themessageid+")'>delete</button> &nbsp; &nbsp; <a href='JavaScript:void(0)' onClick='do_cancel("+themessageid+")' style='color: #FFFFFF;'>cancel</a><div style='margin-top: 5px;'><b>Note:</b> This message will be permanently deleted from the database.  However, if an operator has already loaded this message on their operator console, the message will remain visible until they logout and login again.</div></div>" ) ;
	else
		do_cancel( themessageid ) ;
}

function do_cancel( themessageid )
{
	$('#div_delete_message_'+themessageid).remove() ;
}

function get_messageid()
{
	return parent.messageboard_id ;
}

function get_total_messages()
{
	var total = 0 ;
	for ( var this_messageid in parent.messageboard )
		++total ;
	return total ;
}

function get_min_messageid()
{
	var now = unixtime() ;
	var min = now ;
	for ( var this_messageid in parent.messageboard )
	{
		// have to parseInt
		if ( min > parseInt( this_messageid ) )
			min = this_messageid ;
	}
	return ( min == now ) ? 0 : min ;
}

function push_message( themessageid, theopid, thestatus, thetimestamp, themessage )
{
	if ( typeof( parent.messageboard[themessageid] ) == "undefined" )
	{
		var message_object = new Object ;
		message_object["opid"] = theopid ;
		message_object["created"] = thetimestamp ;
		message_object["status"] = thestatus ;
		message_object["message"] = themessage ;
		parent.messageboard[themessageid] = message_object ;
		return message_object ;
	}
	else { return parent.messageboard[themessageid] ; }
}

function init_emoji()
{
	//parent.messageboard_emoji = "" ;
	if ( parent.messageboard_emoji == "" )
	{
		var emoji_exclude = new Object ;
		emoji_exclude[129394] = 1 ;
		emoji_exclude[129452] = 1 ;
		emoji_exclude[129453] = 1 ;
		emoji_exclude[129443] = 1 ;
		emoji_exclude[129444] = 1 ;
		emoji_exclude[129483] = 1 ;
		emoji_exclude[129484] = 1 ;
		emoji_exclude[129399] = 1 ;
		emoji_exclude[129400] = 1 ;
		emoji_exclude[129401] = 1 ;
		emoji_exclude[129350] = 1 ;
		emoji_exclude[129451] = 1 ;
		emoji_exclude[127950] = 1 ;
		emoji_exclude[127949] = 1 ;
		emoji_exclude[127869] = 1 ;
		emoji_exclude[129456] = 1 ;
		emoji_exclude[129457] = 1 ;
		emoji_exclude[129458] = 1 ;
		emoji_exclude[129459] = 1 ;
		emoji_exclude[128063] = 1 ;
		emoji_exclude[128065] = 1 ;
		emoji_exclude[128253] = 1 ;
		emoji_exclude[128254] = 1 ;
		emoji_exclude[129339] = 1 ;
		emoji_exclude[128206] = 1 ;
		emoji_exclude[128177] = 1 ;
		emoji_exclude[128162] = 1 ;
		emoji_exclude[128241] = 1 ;
		emoji_exclude[128242] = 1 ;
		emoji_exclude[128243] = 1 ;
		emoji_exclude[128244] = 1 ;
		emoji_exclude[128245] = 1 ;
		emoji_exclude[128100] = 1 ;
		emoji_exclude[128101] = 1 ;
		emoji_exclude[128702] = 1 ;
		emoji_exclude[128706] = 1 ;
		emoji_exclude[128707] = 1 ;
		emoji_exclude[128708] = 1 ;
		emoji_exclude[128709] = 1 ;
		emoji_exclude[127903] = 1 ;
		emoji_exclude[128690] = 1 ;
		emoji_exclude[127878] = 1 ;
		emoji_exclude[127879] = 1 ;
		emoji_exclude[127905] = 1 ;
		emoji_exclude[129509] = 1 ;
		emoji_exclude[128180] = 1 ;
		emoji_exclude[128181] = 1 ;
		emoji_exclude[128182] = 1 ;
		emoji_exclude[128183] = 1 ;
		emoji_exclude[128185] = 1 ;
		emoji_exclude[128232] = 1 ;
		emoji_exclude[128233] = 1 ;
		emoji_exclude[128218] = 1 ;
		emoji_exclude[128219] = 1 ;
		emoji_exclude[128205] = 1 ;
		emoji_exclude[128160] = 1 ;
		emoji_exclude[128228] = 1 ;
		emoji_exclude[128229] = 1 ;
		emoji_exclude[129324] = 1 ;

		var emoji_range = [
			[128512, 128591],
			[128563, 128563],
			[129296, 129510],
			[128000, 128255],
			[128640, 128709],
			[127789, 127891],
			[127903, 127955],
			[127968, 127984],
			[9877, 9877],
			[128308, 128308],
			[129440, 129440],
			[129524, 129524],
			[129532, 129532],
			[129533, 129533]
		];

		var emoji_array = new Array() ;
		var emoji_hash = new Object ;
		for ( var c = 0; c < emoji_range.length; c++ )
		{
			var range = emoji_range[c] ;
			for ( var x = range[0]; x <= range[1]; x++ )
			{
				if ( ( typeof( emoji_exclude[x] ) == "undefined" ) && ( typeof( emoji_hash[x] ) == "undefined" ) )
				{
					/*
					var temp_div = document.createElement('div') ;
					temp_div.innerHTML = "&#"+x+";" ;
					var temp_html = $(temp_div.html() ;
					*/

					emoji_array.push( x ) ;
					emoji_hash[x] = 1 ;
				}
			}
		}

		var emoji_string = "" ;
		for ( var c = 0; c < emoji_array.length; c++ )
		{
			var this_emoji = emoji_array[c] ;
			var alt_tag = ( debug ) ? "alt=\""+this_emoji+"\" title=\""+this_emoji+"\"" : "alt=\"\" title=\"\"" ;
			emoji_string += "<div style=\"float: left; width: 32px; text-align: center; margin-right: 2px; margin-bottom: 2px; font-size: 22px; cursor: pointer;\" onClick=\"select_emo(this)\" "+alt_tag+" id='div_emoji_id_"+this_emoji+"'>&#"+this_emoji+";</div>" ;
		}
		parent.messageboard_emoji = "<div>"+emoji_string+"</div><div style='clear: both'></div>" ;
	}
	$('#emo_box_content').html( parent.messageboard_emoji ) ;
}

function select_emo( theemoji )
{
	var message = $( "input#input_text" ).val() ;

	$('#emo_box').hide() ;
	$( "input#input_text" ).val( $( "input#input_text" ).val() + $(theemoji).html() ) ;
}

function toggle_emo_box( theforce_close )
{
	if ( $('#emo_box').is(':visible') || theforce_close )
	{
		$('#emo_box').fadeOut("fast") ;
	}
	else
	{
		$('#emo_box').fadeIn("fast") ;
	}
}

function init_scrolling()
{
	$('#chat_body').prop( "scrollTop", $('#chat_body').prop( "scrollHeight" ) ) ;
}

function toggle_pulse( thedemo, theflag )
{
	parent.message_board_pulse = theflag ;

	if ( theflag )
	{
		if (  thedemo )
		{
			$('#chat_pulse').addClass("img_message_board_icon_pulse") ;
			setTimeout( function() { $('#chat_pulse').removeClass("img_message_board_icon_pulse") ; }, 1000 ) ;
		}
		$('#span_pulse_1').removeClass("info_clear").addClass("info_good") ;
		$('#span_pulse_0').removeClass("info_error").addClass("info_clear") ;
	}
	else
	{
		$('#span_pulse_1').removeClass("info_good").addClass("info_clear") ;
		$('#span_pulse_0').removeClass("info_clear").addClass("info_error") ;
	}
}

function toggle_sound( theflag, theplay )
{
	if ( theflag )
	{
		if ( parent.message_board_sound )
			parent.message_board_sound = 0 ;
		else
			parent.message_board_sound = 1 ;
	}

	if ( parent.message_board_sound )
	{
		if ( theplay ) { parent.play_sound( 0, "message_board", "message_board_beep" ) ; }
		$('#chat_sound').attr('src', '../../themes/'+theme+'/sound_on.png') ;
	}
	else
		$('#chat_sound').attr('src', '../../themes/'+theme+'/sound_off.png') ;
}

function input_is_focused()
{
	return $( "input#input_text" ).is(":focus") ;
}

function input_focus()
{
	if ( !focused )
	{
		focused = 1 ;
	}
	if ( parent.$('#img_message_board_icon').hasClass("img_message_board_icon_pulse") )
	{
		parent.$('#td_message_board_icon').css({'opacity': 0.3}) ;
		parent.$('#img_message_board_icon').removeClass("img_message_board_icon_pulse") ;
	}
}

var emoji_regex = /(?:[\u2700-\u27bf]|(?:\ud83c[\udde6-\uddff]){2}|[\ud800-\udbff][\udc00-\udfff]|[\u0023-\u0039]\ufe0f?\u20e3|\u3299|\u3297|\u303d|\u3030|\u24c2|\ud83c[\udd70-\udd71]|\ud83c[\udd7e-\udd7f]|\ud83c\udd8e|\ud83c[\udd91-\udd9a]|\ud83c[\udde6-\uddff]|\ud83c[\ude01-\ude02]|\ud83c\ude1a|\ud83c\ude2f|\ud83c[\ude32-\ude3a]|\ud83c[\ude50-\ude51]|\u203c|\u2049|[\u25aa-\u25ab]|\u25b6|\u25c0|[\u25fb-\u25fe]|\u00a9|\u00ae|\u2122|\u2139|\ud83c\udc04|[\u2600-\u26FF]|\u2b05|\u2b06|\u2b07|\u2b1b|\u2b1c|\u2b50|\u2b55|\u231a|\u231b|\u2328|\u23cf|[\u23e9-\u23f3]|[\u23f8-\u23fa]|\ud83c\udccf|\u2934|\u2935|[\u2190-\u21ff])/g;
String.prototype.emoji = function(){
	return this.replace( emoji_regex, function( $0, $1 ) { return "<span style='font-size: 22px;'>"+$0+"</span>" } ) ;
}

function toggle_confirm()
{
	if ( $('#div_delete_confirm').is(":visible" ) )
	{
		$('#div_delete_confirm').hide() ;
		$('#div_delete').show() ;
	}
	else
	{
		$('#div_delete').hide() ;
		$('#div_delete_confirm').show() ;
	}
}