<?php
	/***************************************/
	//
	//
	// PHP Live! Support
	//
	// https://www.phplivesupport.com
	//
	/***************************************/
	// STANDARD header for Setup
	if ( !is_file( "../../web/config.php" ) ){ HEADER("location: install.php") ; exit ; }
	include_once( "../../web/config.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Format.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Error.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/".Util_Format_Sanatize($CONF["SQLTYPE"], "ln") ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Security.php" ) ;
	if ( !$admininfo = Util_Security_AuthSetup( $dbh ) ){ ErrorHandler( 608, "Invalid setup session or session has expired.", $PHPLIVE_FULLURL, 0, Array() ) ; exit ; }
	// STANDARD header end
	/****************************************/

	include_once( "$CONF[DOCUMENT_ROOT]/API/Depts/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/addons/API/Util_Addons.php" ) ;
	if ( is_file( "$CONF[CONF_ROOT]/addons.php" ) ) { include_once( "$CONF[CONF_ROOT]/addons.php" ) ; }
	$vc_stuns = ( isset( $VALS_ADDONS ) && isset( $VALS_ADDONS["voice_chat"] ) && $VALS_ADDONS["voice_chat"] ) ? unserialize( rawurldecode( base64_decode( $VALS_ADDONS["voice_chat"] ) ) ) : Array() ;
	$file_hash_offset = isset( $VARS_HASH_OFFSET_TURN ) ? $VARS_HASH_OFFSET_TURN : 1 ;
	$external_file_hash_turn = ( !isset( $VARS_PEER_TURN_FILE ) || !preg_match( "/\.txt$/", $VARS_PEER_TURN_FILE ) ) ? md5( $CONF['SALT']."-TURN-$file_hash_offset" ).".txt" : $VARS_PEER_TURN_FILE ;

	$action = Util_Format_Sanatize( Util_Format_GetVar( "action" ), "ln" ) ;
	$jump = Util_Format_Sanatize( Util_Format_GetVar( "jump" ), "ln" ) ; if ( !$jump ) { $jump = "values" ; }

	if ( $action == "update_stun" )
	{
		$stun1 = Util_Format_Sanatize( Util_Format_GetVar( "s1" ), "base_url" ) ;
		$turn1 = Util_Format_Sanatize( Util_Format_GetVar( "t1" ), "base_url" ) ;
		$turn1_login = Util_Format_StripQuotes( Util_Format_Sanatize( Util_Format_GetVar( "t1_l" ), "" ) ) ;
		$turn1_password = Util_Format_StripQuotes( Util_Format_Sanatize( Util_Format_GetVar( "t1_p" ), "" ) ) ;

		$vc_stuns = Array();
		$vc_stuns["stun1"] = $stun1 ;
		$vc_stuns["turn1"] = Array() ;
		$vc_stuns["turn1"]["url"] = $turn1 ;
		$vc_stuns["turn1"]["login"] = $turn1_login ;
		$vc_stuns["turn1"]["password"] = $turn1_password ;

		if ( Util_Addons_WriteToFile( "voice_chat", base64_encode( rawurlencode( serialize( $vc_stuns ) ) ) ) )
			$json_data = "json_data = { \"status\": 1 };" ;
		else
			$json_data = "json_data = { \"status\": 0, \"error\": \"Error writing to Voice Chat addon file.\" };" ;

		if ( isset( $dbh ) && isset( $dbh['con'] ) ) { database_mysql_close( $dbh ) ; }
		$json_data = Util_Format_Trim( $json_data ) ;
		$json_data = preg_replace( "/\t/", "", $json_data ) ;
		HEADER('Content-Type: text/plain; charset=utf-8') ;
		print $json_data ; exit ;
	}

	$external_file_contents = "" ; $external_file_updated = "" ; $external_file_updated_diff = "" ;
	if ( is_file( "$CONF[DOCUMENT_ROOT]/addons/voice_chat/external/$external_file_hash_turn" ) )
	{
		$external_file_contents = Util_Format_ConvertTags( Util_Format_ConvertQuotes( file_get_contents( "$CONF[DOCUMENT_ROOT]/addons/voice_chat/external/$external_file_hash_turn" ) ) ) ;
		$external_file_last_updated = filemtime( "$CONF[DOCUMENT_ROOT]/addons/voice_chat/external/$external_file_hash_turn" ) ;
		$external_file_updated = date( "M j, Y ($VARS_TIMEFORMAT)", $external_file_last_updated ) ;
		$external_file_updated_diff = Util_Format_Duration( $now - $external_file_last_updated ) ;
	}
?>
<?php include_once( "../../inc_doctype.php" ) ?>
<head>
<title> PHP Live! Support </title>

<meta name="description" content="PHP Live! Support <?php echo $VERSION ?>">
<meta name="keywords" content="powered by: PHP Live!  www.phplivesupport.com">
<meta name="robots" content="all,index,follow">
<meta http-equiv="content-type" content="text/html; CHARSET=utf-8">
<?php include_once( "../../inc_meta_dev.php" ) ; ?>

<link rel="Stylesheet" href="../../css/setup.css?<?php echo filemtime( "../../css/setup.css" ) ?>">
<script data-cfasync="false" type="text/javascript" src="../../js/global.js?<?php echo filemtime( "../../js/global.js" ) ; ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../../js/framework.js?<?php echo $VERSION ?>"></script>

<script data-cfasync="false" type="text/javascript">
<!--
	$(document).ready(function()
	{
		$("html, body").css({'background': '#F2F3F5'}) ;

		init_menu() ;
		toggle_menu_setup( "settings" ) ;
		show_div( "<?php echo $jump ?>" ) ;
	});

	function do_update()
	{
		var stun1 = $('#stun1').val().trim() ;
		var turn1 = $('#turn1').val().trim() ;
		var turn1_login = encodeURIComponent( $('#turn1_login').val().trim() ) ;
		var turn1_password = encodeURIComponent( $('#turn1_password').val().trim() ) ;

		var stun_matches = stun1.match( /^stun:(.*?)$/i ) ;
		var stun_domain = ( stun_matches != null ) ? stun_matches[1].trim() : "" ;
		var turn_matches = turn1.match( /^turn:(.*?)$/i ) ;
		var turn_domain = ( turn_matches != null ) ? turn_matches[1].trim() : "" ;

		if ( stun1 && ( ( stun_matches == null ) || !stun_domain ) )
			do_alert( 0, "STUN format is invalid.  (example: stun:domain.com)" ) ;
		else if ( turn1 && ( ( turn_matches == null ) || !turn_domain ) )
			do_alert( 0, "TURN format is invalid.  (example: turn:domain.com)" ) ;
		else
		{
			var json_data = new Object ;

			$.ajax({
				type: "POST",
				url: "./voice_chat_admin.php",
				data: "action=update_stun&s1="+stun1+"&t1="+turn1+"&t1_l="+turn1_login+"&t1_p="+turn1_password,
				success: function(data){
					eval( data ) ;

					if ( json_data.status )
					{
						do_alert( 1, "Update Success" ) ;
					}
					else
						do_alert( 0, json_data.error ) ;
				}
			});
		}
	}

	function show_div( thediv )
	{
		if ( thediv )
		{
			var divs = Array( "values", "file" ) ;
			for ( var c = 0; c < divs.length; ++c )
			{
				$('#div_'+divs[c]).hide() ;
				$('#menu_'+divs[c]).removeClass('op_submenu_focus').addClass('op_submenu3') ;
			}

			$('#div_'+thediv).show() ;
			$('#menu_'+thediv).removeClass('op_submenu3').addClass('op_submenu_focus') ;
		}
	}
//-->
</script>
<?php include_once( "../../setup/inc_header.php" ) ?>

		<div class="op_submenu_wrapper">
			<div class="op_submenu" style="margin-left: 0px;" onClick="location.href='../../setup/settings.php?jump=eips'" id="menu_eips">Excluded IPs</div>
			<div class="op_submenu" onClick="location.href='../../setup/settings.php?jump=sips'" id="menu_sips">Blocked IPs</div>
			<div class="op_submenu" onClick="location.href='../../setup/settings.php?jump=upload'" id="menu_upload">File Upload</div>
			<?php if ( is_file( "$CONF[DOCUMENT_ROOT]/addons/ldap/ldap.php" ) ): ?><div class="op_submenu" onClick="location.href='../../addons/ldap/ldap.php'" id="menu_ldap">LDAP</div><?php endif ; ?>
			<div class="op_submenu" onClick="location.href='../../addons/smtp/smtp.php'" id="menu_smtp">SMTP</div>
			<div class="op_submenu_focus" id="menu_voice_chat">Voice Chat</div>
			<div class="op_submenu" onClick="location.href='../../mapp/settings.php'" id="menu_mapp"><img src="../../pics/icons/mobile.png" width="12" height="12" border="0" alt=""> Mobile App</div>
			<div class="op_submenu" onClick="location.href='../../setup/settings_profile.php'" id="menu_profile"><img src="../../pics/icons/key.png" width="12" height="12" border="0" alt=""> Password</div>
			<div class="op_submenu" onClick="location.href='../../setup/settings.php?jump=props'" id="menu_props">Misc.</div>
			<div class="op_submenu" onClick="location.href='../../setup/system.php'" id="menu_system">System</div>
			<div style="clear: both"></div>
		</div>

		<div style="margin-top: 25px;">
			<div class="op_submenu" style="margin-left: 0px;" onClick="show_div('values')" id="menu_values">TURN Values</div>
			<div class="op_submenu3" onClick="show_div('file')" id="menu_file">External File</div>
			<div style="clear: both"></div>
		</div>

		<div style="margin-top: 45px;">
			<?php if ( $external_file_contents ): ?>
			<div style="margin-bottom: 15px;" class="info_data">
				<div style="font-size: larger;"><img src="../../pics/icons/check.png" width="16" height="16" border="0" alt="" class="info_white" style="padding: 1px;"> <span style="text-decoration: underline; cursor: pointer;" onClick="show_div('file');$('#div_file').fadeTo('fast',.1).fadeTo('fast',1);">External TURN file</span> <span class="info_box" style="padding: 2px;"><?php echo $external_file_hash_turn ?></span> exists on the server.</div>
				<div style="margin-top: 15px;">The file was updated <?php echo $external_file_updated ?> <span class="info_white round_bottom_none" style="padding: 4px; border-bottom: 0px;"><b><?php echo $external_file_updated_diff ?> ago</b></span>.  The file contains the following information:</div>
				<div style="margin-top: 1px;" class="info_white"><pre><?php echo $external_file_contents ?></pre></div>
			</div>
			<?php endif ; ?>

			<div style="margin-bottom: 15px;" class="info_warning">
				<img src="../../pics/icons/warning.gif" width="16" height="16" border="0" alt="" class="info_white" style="padding: 1px;"> <b>Warning:</b> Update this area with caution.  Invalid values will produce errors.
				<div style="margin-top: 5px;"><img src="../../pics/icons/info.png" width="16" height="16" border="0" alt=""> <b style="font-size: larger;"><a href="https://webrtc.github.io/samples/src/content/peerconnection/trickle-ice/" target="_blank"> Test the values on GitHub to make sure they are correct.</a></b></div>
			</div>

			<div id="div_values" style="display: none;">
				Ability to request voice chat with the visitor can be set for each operator at the <a href="../../setup/ops.php">Operators</a> area.  This area is to provide the TURN (Traversal Using Relay NAT) server information.
				
				<div style="margin-top: 15px;">As a default, the system will attempt to connect the operator and the visitor directly, a direct peer-to-peer (browser-to-browser) connection.  However, at times, VPN or other port blocking services may prevent a direct peer-to-peer connection.  For those situations, a TURN server can improve the ability to connect.  Provide the TURN server to use as a fallback when direct peer-to-peer connection is not possible.</div>

				<div style="margin-top: 15px;"><b>All fields are optional.</b>  However, if a TURN Server is provided, the TURN login and the TURN password is usually required as well.</div>
				
				<div style="margin-top: 15px;">
					<table cellspacing=0 cellpadding=0 border=0>
					<tr>
						<td><div class="tab_form_title">STUN Server</div></td>
						<td style="padding-left: 10px;"><input type="text" class="input" name="stun1" id="stun1" size="85" maxlength="160" onKeyPress="return noquotestags(event)" value="<?php echo ( isset( $vc_stuns["stun1"] ) ) ? $vc_stuns["stun1"] : "" ; ?>" autocomplete="off"></td>
					</tr>
					</table>
				</div>
				<div style="margin-top: 15px;">
					<table cellspacing=0 cellpadding=0 border=0>
					<tr>
						<td valign="top"><div class="tab_form_title">TURN Server</div></td>
						<td style="padding-left: 10px;">
							<input type="text" class="input" name="turn1" id="turn1" size="85" maxlength="160" onKeyPress="return noquotestags(event)" value="<?php echo ( isset( $vc_stuns["turn1"] ) && isset( $vc_stuns["turn1"]["url"] ) ) ? $vc_stuns["turn1"]["url"] : "" ; ?>" autocomplete="off">

							<div style="margin-top: 15px;">
								TURN Login (no quotes or tags)<br>
								<input type="text" name="turn1_login" id="turn1_login" size="65" maxlength="160" class="input" style="border: 1px solid; padding: 4px;" value="<?php echo ( isset( $vc_stuns["turn1"] ) && isset( $vc_stuns["turn1"]["login"] ) ) ? $vc_stuns["turn1"]["login"] : "" ; ?>">

								<div style="margin-top: 10px;">
									TURN Password (no quotes or tags)<br>
									<input type="text" name="turn1_password" id="turn1_password" size="65" maxlength="160" class="input" style="border: 1px solid; padding: 4px;" value="<?php echo ( isset( $vc_stuns["turn1"] ) && isset( $vc_stuns["turn1"]["password"] ) ) ? $vc_stuns["turn1"]["password"] : "" ; ?>">
								</div>
							</div>
						</td>
					</tr>
					</table>
				</div>
				<div style="">
					<table cellspacing=0 cellpadding=0 border=0>
					<tr>
						<td><div class="tab_form_title" style="background: #F2F3F5; border: 0px;">&nbsp;</div></td>
						<td style="padding-left: 10px;">
							<div style="margin-top: 20px;"><button type="button" onClick="do_update()" class="btn">Update</button></div>
						</td>
					</tr>
					</table>
				</div>
			</div>
			<div id="div_file" style="display: none;">
				<div class="title">Store the TURN values in an external file.</div>
				<div style="margin-top: 5px;" class="info_box">
					<b>Usage Example</b>
					<div style="margin-top: 5px;">A script writes to the external TURN file to update the values without having to login to the Setup Admin area to update the TURN values.  If the external TURN file exists and contains the TURN values, the values in the file will be used during Voice Chat and Video Chat connections, overriding the <a href="JavaScript:void(0)" onClick="show_div('values')">system stored TURN values</a>.</div>
				</div>

				<div style="margin-top: 25px;">
					<div>Your system's unique TURN file name is: <span style="font-size: 22px;" class="info_white"><?php echo $external_file_hash_turn ?></span></div>

					<div style="margin-top: 25px; font-size: 18px; font-weight: bold;">Create the external TURN file.</div>
					<div style="margin-top: 5px;" class="info_neutral">
						You must manually create your external TURN file at the following server location:
						<div style="margin-top: 15px; font-size: 18px;"><span class="info_black">addons/voice_chat/external/<?php echo $external_file_hash_turn ?></span></div>
						<div style="margin-top: 15px;">The <span class="info_box" style="padding: 3px;"><code><big>addons/voice_chat/external/</big></code></span> is located at the top level of the live chat directory.</div>
						<div style="margin-top: 15px;">The file <span class="info_box" style="padding: 3px;"><?php echo $external_file_hash_turn ?></span> will need to be manually created.  Please do that now if you have not done so already.  The file should be empty.</div>

						<div style="margin-top: 25px; font-size: 14px; font-weight: bold;">How-to use the file.</div>
						<div style="">
							Your script must write the TURN values to the file <span class="info_box" style="padding: 2px;"><?php echo $external_file_hash_turn ?></span>.  The values must be in the following format:
							<div style="display: table; margin-top: 5px;" class="info_white">
								STUN=stun:domain.com<br>
								TURN=turn:domain.com<br>
								TURN_login=the_login<br>
								TURN_password=the_password
							</div>
						</div>

						<div style="margin-top: 15px;">
							If the value is blank, simply omit the line.  This example only has the TURN values, not the STUN:
							<div style="display: table; margin-top: 5px;" class="info_white">
								TURN=turn:domain.com<br>
								TURN_login=the_login<br>
								TURN_password=the_password
							</div>
						</div>

					</div>
				</div>
			</div>

		</div>

<?php include_once( "../../setup/inc_footer.php" ) ?>