<?php
	/***************************************/
	//
	//
	// PHP Live! Support
	//
	// https://www.phplivesupport.com
	//
	/***************************************/
	// STANDARD header for Setup
	include_once( "../web/config.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Format.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/".Util_Format_Sanatize($CONF["SQLTYPE"], "ln") ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Security.php" ) ;
	if ( !$admininfo = Util_Security_AuthSetup( $dbh ) )
	{
		$json_data = "json_data = { \"status\": 0, \"error\": \"Authentication error.\" };" ;
		if ( isset( $dbh ) && isset( $dbh['con'] ) ) { database_mysql_close( $dbh ) ; }
		HEADER('Content-Type: text/plain; charset=utf-8') ;
		print $json_data ; exit ;
	}
	// STANDARD header end
	/****************************************/

	include_once( "$CONF[DOCUMENT_ROOT]/API/Depts/get.php" ) ;

	$traffic = 1 ;
	$action = Util_Format_Sanatize( Util_Format_GetVar( "action" ), "ln" ) ;
	$sort_by = Util_Format_Sanatize( Util_Format_GetVar( "sort_by" ), "ln" ) ;
	$deptid = Util_Format_Sanatize( Util_Format_GetVar( "deptid" ), "n" ) ;

	if ( $action == "fetch_ops" )
	{
		include_once( "$CONF[DOCUMENT_ROOT]/API/Ops/update_itr.php" ) ;
		include_once( "$CONF[DOCUMENT_ROOT]/API/Chat/remove_itr.php" ) ;
		include_once( "$CONF[DOCUMENT_ROOT]/API/Chat/get.php" ) ;
		include_once( "$CONF[DOCUMENT_ROOT]/API/Queue/get.php" ) ;
		include_once( "$CONF[DOCUMENT_ROOT]/API/Footprints/get_itr.php" ) ;
		include_once( "$CONF[DOCUMENT_ROOT]/API/Footprints/remove_itr.php" ) ;
		if ( is_file( "$CONF[DOCUMENT_ROOT]/API/Util_Extra_Pre.php" ) ) { include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Upload_.php" ) ; }
		else { include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Upload.php" ) ; }

		$departments = Depts_get_AllDepts( $dbh ) ;
		$dept_hash = Array() ; $dept_customs = Array() ;
		for ( $c = 0; $c < count( $departments ); ++$c )
		{
			$department = $departments[$c] ;
			$dept_hash[$department["deptID"]] = $department["name"] ;
		}

		Footprints_remove_itr_Expired_U( $dbh ) ;
		Chat_remove_itr_ExpiredOp2OpRequests( $dbh ) ;
		Ops_update_itr_IdleOps( $dbh ) ;
		Chat_remove_itr_OldRequests( $dbh ) ;
		$total_visitors = ( $traffic ) ? Footprints_get_itr_TotalFootprints_U( $dbh ) : -1 ;

		$dept_ops = Array() ;
		$dept_ops_offline = Array() ;
		if ( $deptid )
		{
			$query = "SELECT opID, deptID, status, dept_offline FROM p_dept_ops WHERE deptID = $deptid" ;
			database_mysql_query( $dbh, $query ) ;
			while ( $data = database_mysql_fetchrow( $dbh ) )
			{
				$key_string = $data["opID"]."_".$data["deptID"] ;
				$dept_ops[$key_string] = $data["dept_offline"] ;
				$dept_ops_offline[$data["opID"]] = $data["status"] ;
			}
		}

		$operators = Array() ;
		if ( $sort_by == "status" )
			$query = "SELECT p_operators.*, COUNT(p_requests.requestID) AS total FROM p_operators LEFT JOIN p_requests ON p_operators.opID = p_requests.opID AND p_requests.status = 1 GROUP BY p_operators.opID ORDER BY status DESC, name ASC" ;
		else if ( $sort_by == "chats" )
			$query = "SELECT p_operators.*, COUNT(p_requests.requestID) AS total FROM p_operators LEFT JOIN p_requests ON p_operators.opID = p_requests.opID AND p_requests.status = 1 GROUP BY p_operators.opID ORDER BY total DESC, name ASC" ;
		else
			$query = "SELECT p_operators.*, COUNT(p_requests.requestID) AS total FROM p_operators LEFT JOIN p_requests ON p_operators.opID = p_requests.opID AND p_requests.status = 1 GROUP BY p_operators.opID ORDER BY name ASC" ;
		database_mysql_query( $dbh, $query ) ;

		while ( $data = database_mysql_fetchrow( $dbh ) )
			$operators[] = $data ;

		$json_data = "json_data = { \"status\": 1, \"tv\": $total_visitors, \"ops\": [  " ;
		for ( $c = 0; $c < count( $operators ); ++$c )
		{
			$operator = $operators[$c] ;

			$opid = $operator["opID"] ;
			$login = $operator["login"] ;
			$name = Util_Format_ConvertQuotes( $operator["name"] ) ;
			$status = ( $operator["status"] ) ? 1 : 0 ;
			$mapp_status = ( $operator["mapp"] && $operator["status"] ) ? 1 : 0 ;
			$lastactive = ( $operator["lastactive"] ) ? date( "M j, Y $VARS_TIMEFORMAT", $operator["lastactive"] ) : "" ;

			$profile_image = Util_Upload_GetLogo( "profile", $operator["opID"] ) ;
			$requests = $operator["total"] ;
			$rating = $operator["rating"] ;
			$ces = $operator["ces"] ;

			$key_string = $opid."_".$deptid ;
			if ( $deptid && isset( $dept_ops[$key_string] ) && $dept_ops[$key_string] )
				$status = 0 ;
			else if ( $deptid && isset( $dept_ops_offline[$opid] ) && !$dept_ops_offline[$opid] )
				$status = 0 ;

			if ( !$deptid || ( $deptid && isset( $dept_ops[$key_string] ) ) )
			{
				$json_data .= "{ \"opid\": $opid, \"login\": \"$login\", \"name\": \"$name\", \"status\": $status, \"mapp\": $mapp_status, \"lastactive\": \"$lastactive\", \"profile_image\": \"$profile_image\", \"requests\": $requests, \"ces\": \"$ces\", \"rating\": $rating }," ;
			}
		}
		$json_data = substr_replace( $json_data, "", -1 ) ;
		$json_data .= "	], \"queue\": [  " ;

		$waiting_queue_list = Queue_get_VisitorsWaiting( $dbh, $deptid ) ;
		for ( $c = 0; $c < count( $waiting_queue_list ); ++$c )
		{
			$queueinfo = $waiting_queue_list[$c] ;
			$duration = Util_Format_Duration( $now - $queueinfo["created"] ) ;
			$requestinfo_log = Chat_get_RequestHistCesInfo( $dbh, $queueinfo["ces"] ) ;


			$custom_vars_string = "" ;
			if ( $requestinfo_log["custom"] )
			{
				$custom_vars_string = "" ;
				$customs = explode( "-cus-", $requestinfo_log["custom"] ) ;
				for ( $c2 = 0; $c2 < count( $customs ); ++$c2 )
				{
					$custom_var = $customs[$c2] ;
					if ( $custom_var && preg_match( "/-_-/", $custom_var ) )
					{
						LIST( $cus_name, $cus_val ) = explode( "-_-", rawurldecode( $custom_var ) ) ;
						if ( $cus_val )
						{
							if ( preg_match( "/^((http)|(www))/", $cus_val ) )
							{
								if ( preg_match( "/^(www)/", $cus_val ) ) { $cus_val = "https://$cus_val" ; }
								$cus_val_snap = Util_Format_CreateSnap( $cus_val, 40 ) ;
								$custom_vars_string .= "<div style=\"padding: 2px;\"><b>$cus_name:</b> <a href=\"$cus_val\" target=_blank>$cus_val_snap</a></div>" ;
							}
							else
							{
								$custom_vars_string .= "<div style=\"padding: 2px;\"><b>$cus_name:</b> $cus_val</div>" ;
							}
						}
					}
				}
				$custom_vars_string = ( $custom_vars_string ) ? "<div style=\"margin-top: 15px;\"><img src=\"../pics/icons/ops.png\" width=\"16\" height=\"16\" border=\"0\" alt=\"\"> Custom Fields<div style=\"margin-top: 5px; max-height: 65px; overflow: auto;\">$custom_vars_string</div></div>" : "" ;
			}
			$custom_vars_string  = rawurlencode( $custom_vars_string ) ;

			$json_data .= "{ \"ces\": \"$queueinfo[ces]\", \"duration\": \"$duration\", \"dept\": \"".$dept_hash[$queueinfo["deptID"]]."\", \"vname\": \"$queueinfo[vname]\", \"vquestion\": \"$queueinfo[vquestion]\", \"custom_vars\": \"$custom_vars_string\" }," ;
		}

		$json_data = substr_replace( $json_data, "", -1 ) ;
		$json_data .= "	] };" ;
	}
	else if ( $action == "chats" )
	{
		$opid = Util_Format_Sanatize( Util_Format_GetVar( "opid" ), "n" ) ;

		$departments = Depts_get_AllDepts( $dbh ) ;
		$dept_hash = Array() ;
		for ( $c = 0; $c < count( $departments ); ++$c )
		{
			$department = $departments[$c] ;
			$dept_hash[$department["deptID"]] = $department["name"] ;
		}

		$query = "SELECT * FROM p_requests WHERE opID = $opid AND status = 1 ORDER BY created ASC" ;
		database_mysql_query( $dbh, $query ) ;

		$chats = Array() ;
		while ( $data = database_mysql_fetchrow( $dbh ) )
			$chats[] = $data ;

		$json_data = "json_data = { \"status\": 1, \"chats\": [ " ;
		for ( $c = 0; $c < count( $chats ); ++$c )
		{
			$chat = $chats[$c] ;
			$created = date( "M j ($VARS_TIMEFORMAT)", $chat["created"] ) ;
			$duration = $now - $chat["created"] ; $duration = Util_Format_Duration( $duration ) ;
			$dept_name = isset( $dept_hash[$chat["deptID"]] ) ? $dept_hash[$chat["deptID"]] : "Invalid" ;
			
			$json_data .= "{ \"ces\": \"$chat[ces]\", \"created\": \"$created\", \"duration\": \"$duration\", \"deptid\": $chat[deptID], \"dept_name\": \"$dept_name\" }," ;
		}
		$json_data = substr_replace( $json_data, "", -1 ) ;
		$json_data .= "	] };" ;
	}
	else if ( $action == "decline" )
	{
		include_once( "$CONF[DOCUMENT_ROOT]/API/Queue/update.php" ) ;
		$ces = Util_Format_Sanatize( Util_Format_GetVar( "ces" ), "ln" ) ;

		if ( Queue_update_QueueValueByCes( $dbh, $ces, "created", 615 ) )
			$json_data = "json_data = { \"status\": 1 }" ;
		else
			$json_data = "json_data = { \"status\": 0 }" ;
	}

	if ( isset( $dbh ) && isset( $dbh['con'] ) ) { database_mysql_close( $dbh ) ; }
	$json_data = Util_Format_Trim( $json_data ) ;
	$json_data = preg_replace( "/\t/", "", $json_data ) ;
	HEADER('Content-Type: text/plain; charset=utf-8') ;
	print $json_data ; exit ;
?>