<?php
	/***************************************/
	//
	//
	// PHP Live! Support
	//
	// https://www.phplivesupport.com
	//
	/***************************************/
	// STANDARD header for Setup
	if ( !is_file( "../web/config.php" ) ){ HEADER("location: ../setup/install.php") ; exit ; }
	include_once( "../web/config.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Format.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Error.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/".Util_Format_Sanatize($CONF["SQLTYPE"], "ln") ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Security.php" ) ;
	if ( !$opinfo = Util_Security_AuthOp( $dbh ) ){ ErrorHandler( 602, "Invalid operator session or session has expired.", $PHPLIVE_FULLURL, 0, Array() ) ; exit ; }
	// STANDARD header end
	/****************************************/

	include_once( "$CONF[DOCUMENT_ROOT]/API/Ops/get.php" ) ;

	$action = Util_Format_Sanatize( Util_Format_GetVar( "action" ), "ln" ) ;
	$jump = Util_Format_Sanatize( Util_Format_GetVar( "jump" ), "ln" ) ; if ( !$jump ) { $jump = "themes" ; }
	$error = "" ;
	$win_style = ( isset( $VALS["STYLE"] ) && $VALS["STYLE"] ) ? $VALS["STYLE"] : "modern" ;

	$op_sounds = ( isset( $VALS["op_sounds"] ) && $VALS["op_sounds"] ) ? unserialize( $VALS["op_sounds"] ) : Array() ;
	if ( isset( $op_sounds[$opinfo["opID"]] ) ) { $op_sounds_vals = $op_sounds[$opinfo["opID"]] ; $opinfo["sound1"] = $op_sounds_vals[0] ; $opinfo["sound2"] = $op_sounds_vals[1] ; } else { $opinfo["sound1"] = "default" ; $opinfo["sound2"] = "default" ; }

	if ( $action === "update_theme" )
	{
		include_once( "$CONF[DOCUMENT_ROOT]/API/Ops/update.php" ) ;
		$theme = Util_Format_Sanatize( Util_Format_GetVar( "theme" ), "ln" ) ;

		if ( !Ops_update_OpValue( $dbh, $opinfo["opID"], "theme", $theme ) )
			$error = "Error in updating theme." ;
		else
			$opinfo["theme"] = $theme ;
	}
	else if ( $action === "update_sound" )
	{
		include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Vals.php" ) ;
		$sound1 = Util_Format_Sanatize( Util_Format_GetVar( "sound1" ), "ln" ) ;
		$sound2 = Util_Format_Sanatize( Util_Format_GetVar( "sound2" ), "ln" ) ;

		$op_sounds[$opinfo["opID"]] = Array( $sound1, $sound2 ) ;
		Util_Vals_WriteToFile( "op_sounds", serialize( $op_sounds ) ) ;
		$opinfo["sound1"] = $sound1 ; $opinfo["sound2"] = $sound2 ;
		
		$jump = "sounds" ;
	}
	else
		$error = "invalid action" ;

	$theme = $opinfo["theme"] ;
	if ( !is_file( "$CONF[DOCUMENT_ROOT]/themes/$theme/style.css" ) || isset( $THEMES_EXCLUDE[$theme] ) ) { $theme = "default" ; }
?>
<?php include_once( "../inc_doctype.php" ) ?>
<head>
<title> Operator </title>

<meta name="description" content="v.<?php echo $VERSION ?>">
<meta name="keywords" content="<?php echo md5( $KEY ) ?>">
<meta name="robots" content="all,index,follow">
<meta http-equiv="content-type" content="text/html; CHARSET=utf-8"> 
<?php include_once( "../inc_meta_dev.php" ) ; ?>

<link rel="Stylesheet" href="./bootstrap/bootstrap.min.css">
<style>
.list_group_item, .list_group_focus{ font-size: 14px; }
.list_group_focus{ background: #27C0E1; color: #FFFFFF; }
html, body{ background-color: #FAFAFA; }
</style>
<script data-cfasync="false" type="text/javascript" src="../mapp/js/mapp.js?<?php echo filemtime ( "../mapp/js/mapp.js" ) ; ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../js/global.js?<?php echo filemtime ( "../js/global.js" ) ; ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../js/framework.js?<?php echo $VERSION ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../js/jquery_md5.js?<?php echo $VERSION ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../js/modernizr.js?<?php echo $VERSION ?>"></script>

<script data-cfasync="false" type="text/javascript">
<!--
	"use strict" ;
	var base_url = ".." ;
	var mobile = 1 ;
	var mapp = 1 ;
	var sound_volume = parent.sound_volume ;
	var modal_auto ;

	var theme = "<?php echo $theme ?>" ;
	var audio_supported = HTML5_audio_support() ;
	var mp3_support = ( typeof( audio_supported["mp3"] ) != "undefined" ) ? 1 : 0 ;

	$(document).ready(function()
	{
		reset_mapp_div_height() ;

		toggle_menu_info( "<?php echo $jump ?>" ) ;

		<?php if ( $action && !$error ): ?>parent.do_alert( 1, "Update Success" ) ;<?php endif ; ?>

		if ( ( typeof( parent.isop ) != "undefined" ) && ( ( "<?php echo $action ?>" == "update_theme" ) || ( "<?php echo $action ?>" == "update_sound" ) ) )
		{
			// need to refresh the console because mobile does not process real-time theme change
			parent.refresh_console(0) ;
		}

		if ( parent.chat_sound ) { $('#r_sound_1').prop('checked', true) ; }
		else { $('#r_sound_0').prop('checked', true) ; }

		parent.init_extra_loaded() ;
		modal_auto = new bootstrap.Modal(document.getElementById('div_confirm'), {}) ;
		$('#div_confirm .modal-footer .btn-secondary').on('click', function(event) {
			update_theme_pre(0) ;
		});
	});

	function toggle_menu_info( themenu )
	{
		var divs = Array( "themes", "sounds" ) ;

		for ( var c = 0; c < divs.length; ++c )
		{
			$('#div_settings_'+divs[c]).hide() ;
			$('#menu_settings_'+divs[c]).removeClass('list_group_focus') ;
		}

		demo_sound1(0) ;
		if ( themenu == "sounds" ) { toggle_sound_form( parent.chat_sound ) ; }

		$('#div_settings_'+themenu).show() ;
		$('#menu_settings_'+themenu).addClass('list_group_focus') ;
	}

	function confirm_theme( thetheme, thethumb )
	{
		if ( theme != thetheme )
		{
			$('#theme_'+thetheme).prop('checked', true) ;
			$('#div_theme_thumb').html( "<div style=\"background: url( "+thethumb+" ); background-position: top left; width: 155px; height: 105px;\" class=\"rounded border border-secondary\">&nbsp;</div>") ;
			modal_auto.show() ;
		}
	}

	function update_theme( thetheme )
	{
		location.href = 'mapp_themes.php?action=update_theme&theme='+thetheme ;
		return true ;
	}

	function update_theme_pre( theflag )
	{
		if ( theflag )
		{
			var theme = $('input:radio[name=theme]:checked').val() ;
			update_theme( theme ) ;
		}
		else
		{
			$('#theme_<?php echo $theme ?>').prop('checked', true) ;
			$('#div_confirm').hide() ;
		}
	}

	function demo_sound1( theflag )
	{
		var sound = $('#sound1').val() ;

		clear_sound('new_request') ;
		if ( theflag )
			play_sound(1, 'new_request', 'new_request_'+sound) ;
	}

	function demo_sound2()
	{
		var sound = $('#sound2').val() ;

		clear_sound('new_request') ;
		play_sound(0, 'new_text', 'new_text_'+sound) ;
	}

	function update_sound_doit()
	{
		var sound1 = $('#sound1').val() ;
		var sound2 = $('#sound2').val() ;

		location.href = 'mapp_themes.php?action=update_sound&sound1='+sound1+'&sound2='+sound2 ;
		return true ;
	}

	function update_sound( thevalue )
	{
		if ( thevalue != parent.chat_sound )
		{
			var json_data = new Object ;

			$.ajax({
				type: "POST",
				url: "../ajax/chat_actions_op_ext.php",
				data: "action=console_sound_mapp&value="+thevalue+"&"+unixtime(),
				success: function(data){
					eval(data) ;

					if ( json_data.status )
					{
						parent.chat_sound = thevalue ;
						if ( thevalue ) { $('#r_sound_1').prop('checked', true) ; }
						else { $('#r_sound_0').prop('checked', true) ; }

						toggle_sound_form( thevalue ) ;
						parent.refresh_console(0) ;
					}
					else
						parent.do_alert( 0, "[m] Error: Could not update value.  Please try again." ) ;
				}
			});
		}
	}

	function toggle_sound_form( thevalue )
	{
		if ( thevalue ) { $('#div_settings_sounds_form').show() ; }
		else { $('#div_settings_sounds_form').hide() ; }
	}
//-->
</script>
</head>
<body style="-webkit-text-size-adjust: 100%; font-size: 14px;">

<div id="canned_container" class="p-3 pt-4" style="height: 200px; overflow: auto;">

	<ul class="list-group list-group-horizontal">
		<li id="menu_settings_themes" class="list-group-item list_group_focus" onClick="toggle_menu_info('themes')">Themes</li>
		<li id="menu_settings_sounds" class="list-group-item" onClick="toggle_menu_info('sounds')">Sounds</li>
	</ul>

	<div class="mt-3 pb-3">
		<div id="div_settings_themes" style="display: none;">
			<form style="">
	
				<?php
					$dir_themes = opendir( "$CONF[DOCUMENT_ROOT]/themes/" ) ;

					$themes = Array() ;
					while ( $theme_temp = readdir( $dir_themes ) )
						$themes[] = $theme_temp ;
					closedir( $dir_themes ) ;

					sort( $themes, SORT_STRING ) ;
					$output_string = "" ;
					for ( $c = 0; $c < count( $themes ); ++$c )
					{
						$theme_temp = $themes[$c] ;
						$theme_display = ( strlen( $theme_temp ) > 15 ) ? substr( $theme_temp, 0, 12 )."..." : $theme_temp ;

						$checked = "" ;
						if ( $theme_temp == $theme )
							$checked = "checked" ;

						$path_thumb = ( is_file( "../themes/$theme_temp/thumb.png" ) ) ? "../themes/$theme_temp/thumb.png" : "../pics/screens/thumb_theme_blank.png" ;

						if ( preg_match( "/[a-z]/i", $theme_temp ) && !preg_match( "/^\./", $theme_temp ) && ( $theme_temp != "initiate" ) && !isset( $THEMES_EXCLUDE[$theme_temp] ) )
							$output_string .= "<div class=\"rounded p-1 shadow-lg\" style=\"float: left; width: 115px; margin-bottom: 15px; margin-right: 15px;\"><div style=\"background: url( $path_thumb ); background-position: top left; height: 64px; cursor: pointer;\" onClick=\"confirm_theme('$theme_temp', '$path_thumb')\"><input type=\"radio\" name=\"theme\" id=\"theme_{$theme_temp}\" value=\"$theme_temp\" $checked> <span class=\"alert alert-secondary p-1\" style=\"text-shadow: none; font-size: smaller;\">$theme_display</span></div></div>" ;
					}
					if ( $output_string ) { $output_string .= "<div style=\"clear:both;\"></div>" ; print $output_string ; }
				?>

			</form>
		</div>
		<div id="div_settings_sounds" style="display: none;">
			Sound is not available on the Mobile App.
		</div>
	</div>

</div>

<div id="div_confirm" class="modal fade" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true" style="z-Index: 2000;">
	<div class="modal-dialog modal-dialog-centered">
		<div class="modal-content">
			<div class="modal-body d-flex">
				<div id="confirm_title" class="p-2">Select this theme?</div>
				<div id="div_theme_thumb"></div>
			</div>
			<div class="modal-footer">
				<form><input type="hidden" id="confirm_canid" name="confirm_canid" value=""><input type="hidden" id="confirm_value" name="confirm_value" value=""></form>
				<button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cancel</button> &nbsp; &nbsp; 
				<button type="button" class="btn btn-primary" onClick="update_theme_pre(1)">Yes</button>
			</div>
		</div>
	</div>
</div>

<div id="sounds" style="display: none; position: absolute; width: 1px; height: 1px; overflow: hidden; opacity:0.0; filter:alpha(opacity=0);">
	<span id="div_sounds_new_request"></span>
	<span id="div_sounds_new_text"></span>
	<audio id='div_sounds_audio_new_request'></audio>
	<audio id='div_sounds_audio_new_text'></audio>
</div>
<script data-cfasync="false" type="text/javascript" src="./bootstrap/bootstrap.bundle.js"></script>
</body>
</html>
<?php
	if ( isset( $dbh ) && $dbh['con'] )
		database_mysql_close( $dbh ) ;
?>