<?php
	/***************************************/
	//
	//
	// PHP Live! Support
	//
	// https://www.phplivesupport.com
	//
	/***************************************/
	// STANDARD header for Setup
	if ( !is_file( "../web/config.php" ) ){ HEADER("location: ../setup/install.php") ; exit ; }
	include_once( "../web/config.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Format.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Error.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/".Util_Format_Sanatize($CONF["SQLTYPE"], "ln") ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Security.php" ) ;
	if ( !$opinfo = Util_Security_AuthOp( $dbh ) ){ ErrorHandler( 602, "Invalid operator session or session has expired.", $PHPLIVE_FULLURL, 0, Array() ) ; exit ; }
	// STANDARD header end
	/****************************************/

	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Functions.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Ops/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Depts/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Chat/get_ext.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Chat/remove.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Chat/remove_itr.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Marketing/get.php" ) ;
	use GeoIp2\Database\Reader ;
	if ( is_file( "$CONF[DOCUMENT_ROOT]/API/Util_Extra_Pre.php" ) ) { include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Upload_.php" ) ; }
	else { include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Upload.php" ) ; }
	if ( is_file( "$CONF[CONF_ROOT]/addons.php" ) ) { include_once( "$CONF[CONF_ROOT]/addons.php" ) ; }
	$addon_gravatar = 0 ;
	if ( is_file( "$CONF[DOCUMENT_ROOT]/addons/gravatar/API/Util_Gravatar.php" ) )
	{
		include_once( "$CONF[DOCUMENT_ROOT]/addons/gravatar/API/Util_Gravatar.php" ) ;
		$addon_gravatar = 1 ;
	} $dept_gravatars = ( isset( $VALS_ADDONS ) && isset( $VALS_ADDONS["gravatars"] ) && $VALS_ADDONS["gravatars"] ) ? unserialize( $VALS_ADDONS["gravatars"] ) : Array() ;

	$action = Util_Format_Sanatize( Util_Format_GetVar( "action" ), "ln" ) ;
	$console = Util_Format_Sanatize( Util_Format_GetVar( "console" ), "n" ) ;
	$deptid = Util_Format_Sanatize( Util_Format_GetVar( "deptid" ), "n" ) ;
	$wp = Util_Format_Sanatize( Util_Format_GetVar( "wp" ), "n" ) ;
	$auto = Util_Format_Sanatize( Util_Format_GetVar( "auto" ), "n" ) ;
	$page = Util_Format_Sanatize( Util_Format_GetVar( "page" ), "n" ) ;
	$index = Util_Format_Sanatize( Util_Format_GetVar( "index" ), "n" ) ;
	$tid = Util_Format_Sanatize( Util_Format_GetVar( "tid" ), "n" ) ;
	$rating = Util_Format_Sanatize( Util_Format_GetVar( "rating" ), "n" ) ;

	$menu = "transcripts" ;
	$error = "" ;
	$theme = "default" ;

	$departments = Depts_get_OpDepts( $dbh, $opinfo["opID"] ) ;
	$operators = Ops_get_AllOps( $dbh ) ;
	$markets = Marketing_get_AllMarketing( $dbh ) ;

	// make hash for quick refrence
	$operators_hash = Array() ;
	for ( $c = 0; $c < count( $operators ); ++$c )
	{
		$operator = $operators[$c] ;
		$profile_pic_url = Util_Upload_GetLogo( "profile", $operator["opID"] ) ;
		$operators_hash[$operator["opID"]] = Array( $operator["login"], $operator["name"], $profile_pic_url ) ;
	}

	$tshare = 0 ;
	$dept_hash = Array() ; $dept_customs = Array() ; $dept_rtime = Array() ;
	for ( $c = 0; $c < count( $departments ); ++$c )
	{
		$department = $departments[$c] ;
		$dept_hash[$department["deptID"]] = $department["name"] ; $dept_rtime[$department["deptID"]] = $department["rtime"] ;
		if ( $department["custom"] )
		{
			$custom = unserialize( $department["custom"] ) ;
			$dept_customs = array_merge( $dept_customs, $custom ) ;
		}
		if ( $department["tshare"] ) { $tshare = 1 ; }
		Chat_remove_ExpiredTranscript( $dbh, $department["deptID"], $department["texpire"] ) ;
	}

	$markets_hash = Array() ;
	for ( $c = 0; $c < count( $markets ); ++$c )
	{
		$market = $markets[$c] ;
		$marketid = $market["marketID"] ;
		$markets_hash[$marketid] = Array() ;
		$markets_hash[$marketid]["name"] = $market["name"] ;
		$markets_hash[$marketid]["color"] = $market["color"] ;
	}
	Chat_remove_itr_OldRequests( $dbh ) ;

	$custom_search_options = "" ; $custom_search_field_hash = Array() ;
	for ( $c = 0; $c < count( $dept_customs ); ++$c )
	{
		$custom = $dept_customs[$c] ;
		if ( $custom && !isset( $custom_search_field_hash[$custom] ) && !preg_match( "/,/", $custom ) )
		{
			$custom_search_field_hash[$custom] = 1 ;
			$custom_search_options .= "<option value='cus_$c'>$custom</option>" ;
		}
		++$c ;
	}

	$y_start = date( "Y", Util_Format_TableFirstCreated( $dbh, "p_transcripts" ) ) ;
	$text = Util_Format_Sanatize( Util_Format_GetVar( "text" ), "" ) ; $text = ( $text ) ? $text : "" ; $text_query = urlencode( $text ) ;
	$s_as = Util_Format_Sanatize( Util_Format_GetVar( "s_as" ), "ln" ) ;
	$month = Util_Format_Sanatize( Util_Format_GetVar( "m" ), "n" ) ;
	$year = Util_Format_Sanatize( Util_Format_GetVar( "y" ), "n" ) ;
	if ( $month && $year )
	{
		$stat_start = mktime( 0, 0, 1, $month, 1, $year ) ;
		$stat_end = mktime( 23, 59, 59, $month, date( "t", $stat_start ), $year ) ;
	}
	else
	{
		$stat_start = mktime( 0, 0, 1, 1, 1, $year ) ;
		$stat_end = mktime( 23, 59, 59, 12, date( "t", mktime( 23, 59, 59, 12, 1, $year ) ), $year ) ;
	}
	$transcripts = Chat_ext_get_OpDeptTrans( $dbh, $opinfo["opID"], $s_as, $text, $rating, $year, $stat_start, $stat_end, $tid, $page, 15 ) ;

	$total_index = count($transcripts) - 1 ;
	$pages = Util_Functions_Page( $page, $index, 15, $transcripts[$total_index], "transcripts.php", "tid=$tid&s_as=$s_as&text=$text_query&rating=$rating&opid=$opinfo[opID]" ) ;

	$tags = ( isset( $VALS['TAGS'] ) && $VALS['TAGS'] ) ? unserialize( $VALS['TAGS'] ) : Array() ;
	$has_tags = 0 ;
	foreach ( $tags as $index => $value )
	{
		if ( ( $index != "c" ) && preg_match( "/,/", $value ) )
		{
			LIST( $status, $color, $tag ) = explode( ",", $value ) ;
			if ( $status )
				$has_tags = 1 ;
		}
	}
	$search_reset = ( $year || $text || $s_as || $tid ) ? 1 : 0 ;
	if ( $geoip )
	{
		if ( ( phpversion() >= 5.4 ) && is_file( "$CONF[DOCUMENT_ROOT]/addons/geo_data/vendor/autoload.php" ) )
		{
			require "$CONF[DOCUMENT_ROOT]/addons/geo_data/vendor/autoload.php" ;
			$reader = new Reader( "$CONF[DOCUMENT_ROOT]/addons/geo_data/GeoLite2-City.mmdb" ) ;
		}
	}
	$total_ratings_grand = 0 ; $total_ratings = Array() ; $total_ratings[] = 0 ;
	$total_ratings[] = Chat_ext_get_OpRatingTotal( $dbh, $opinfo["opID"], 1 ) ;
	$total_ratings[] = Chat_ext_get_OpRatingTotal( $dbh, $opinfo["opID"], 2 ) ;
	$total_ratings[] = Chat_ext_get_OpRatingTotal( $dbh, $opinfo["opID"], 3 ) ;
	$total_ratings[] = Chat_ext_get_OpRatingTotal( $dbh, $opinfo["opID"], 4 ) ;
	$total_ratings[] = Chat_ext_get_OpRatingTotal( $dbh, $opinfo["opID"], 5 ) ;
	for ( $c = 0; $c < count( $total_ratings ); ++$c )
		$total_ratings_grand += $total_ratings[$c] ;
	$extra_settings = ( $opinfo["smsnum"] && preg_match( "/extra_settings/", $opinfo["smsnum"] ) ) ? unserialize( $opinfo["smsnum"] ) : Array( "timezone"=>"local" ) ;
?>
<?php include_once( "../inc_doctype.php" ) ?>
<head>
<title> Transcripts </title>

<meta name="description" content="v.<?php echo $VERSION ?>">
<meta name="keywords" content="<?php echo md5( $KEY ) ?>">
<meta name="robots" content="all,index,follow">
<meta http-equiv="content-type" content="text/html; CHARSET=utf-8"> 
<?php include_once( "../inc_meta_dev.php" ) ; ?>

<link rel="Stylesheet" href="../css/setup.css?<?php echo filemtime( "../css/setup.css" ) ?>">
<style> html, body { font-size: 14px; } </style>
<script data-cfasync="false" type="text/javascript" src="../js/global.js?<?php echo filemtime( "../js/global.js" ) ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../js/framework.js?<?php echo $VERSION ?>"></script>

<script data-cfasync="false" type="text/javascript">
<!--
	"use strict" ;
	var wp = ( typeof( parent.wp ) != "undefined" ) ? parent.wp : 0 ;
	var mapp = 0 ; // needed for iframe_blank function
	var time_format = <?php echo ( !isset( $VALS['TIMEFORMAT'] ) || ( $VALS['TIMEFORMAT'] != 24 ) ) ? 12 : 24 ; ?> ;
	var timezone_system = "<?php echo ( isset( $extra_settings["timezone"] ) && ( $extra_settings["timezone"] == "system" ) ) ? $CONF['TIMEZONE'] : "" ; ?>" ; if ( wp ) { timezone_system = "" ; }

	$(document).ready(function()
	{
		$("html, body").css({'background': '#F2F3F5'}) ;

		$("body").show() ;
		init_menu_op() ;
		toggle_menu_op( "trans" ) ;

		$('#form_search').on("submit", function() { return false ; }) ;

		<?php if ( $error ): ?>do_alert( 0, "<?php echo $error ?>" ) ;
		<?php endif ; ?>

		if ( typeof( parent.isop ) != "undefined" ) { parent.init_extra_loaded() ; }

		<?php if ( $search_reset ): ?>toggle_search_trans(0) ;<?php endif ; ?>

		$('#tbody_trans').find('*').each( function(){
			var div_name = this.id ;
			if ( div_name.indexOf("div_created_") != -1 )
			{
				var matches = div_name.match( /_(\d+)$/ ) ;
				var this_created = ( typeof( matches[1] ) != "undefined" ) ? matches[1] : 0 ;
				if ( ( typeof( timezone_system ) == "undefined" ) || ( timezone_system == "" ) )
				{
					var time_expanded = new Date(parseInt( this_created ) * 1000) ;
					var month = time_expanded.getMonth()+1 ;
					var date = pad(time_expanded.getDate(), 2) ;
					var year = time_expanded.getFullYear() ;
					var hours = time_expanded.getHours() ;
					var ampm = ( hours >= 12 ) ? ' pm' : ' am' ;

					if ( ( hours >= 13 ) && ( time_format == 12 ) ) { hours -= 12 ; }
					if ( time_format != 12 ) { ampm = "" ; }

					var output = hours+":"+pad(time_expanded.getMinutes(), 2) ;

					$(this).html( month+"/"+date+"/"+year+"<div style=\"font-size: smaller; margin-top: 3px;\" >("+output+ampm+")</div>" ) ;
				}
			}
		} );
	});
	
	function open_transcript( theces, theopname )
	{
		var url = "./op_trans_view.php?ces="+theces+"&id=<?php echo $opinfo["opID"] ?>&text=<?php echo urlencode( $text ) ?>&auth=operator&"+unixtime() ;

		$('#tbody_trans').find('*').each( function(){
			var div_name = this.id ;
			if ( div_name.indexOf("img_") != -1 )
				$(this).css({ 'opacity': 1 }) ;
		} );

		$('#img_'+theces).css({ 'opacity': '0.4' }) ;

		if ( <?php echo $console ?> && ( self != top ) )
			parent.open_transcript( theces ) ;
		else
		{
			$('#iframe_transcript').attr('src', url ).ready(function() {
				var transcript_iframe_height = window.innerHeight ? window.innerHeight : document.documentElement.clientHeight ? document.documentElement.clientHeight : screen.height ;
				transcript_iframe_height -= 70 ;

				$('#iframe_transcript').css({'height': transcript_iframe_height}) ;
				toggle_transcript_wrapper(1) ;
			});
			//External_lib_PopupCenter( url, theces, <?php echo $VARS_CHAT_WIDTH+100 ?>, <?php echo $VARS_CHAT_HEIGHT+85 ?>, "scrollbars=yes,menubar=no,resizable=1,location=no,width=<?php echo $VARS_CHAT_WIDTH+100 ?>,height=<?php echo $VARS_CHAT_HEIGHT+85 ?>,status=0" ) ;
		}
	}

	function toggle_transcript_wrapper( theflag )
	{
		if ( theflag )
		{
			$('#div_transcript_wrapper').fadeIn("fast") ;
			$( 'body' ).css({'overflow': 'hidden'}) ;
		}
		else if ( $('#div_transcript_wrapper').is(":visible") )
		{
			$( 'body' ).css({'overflow': 'auto'}) ;
			$('#div_transcript_wrapper').fadeOut( "fast", function() {
				iframe_blank( "transcript" ) ;
			});
		}
	}

	function input_text_listen_search( e )
	{
		var key = -1 ;
		var shift ;

		key = e.keyCode ;
		shift = e.shiftKey ;

		if ( !shift && ( ( key == 13 ) || ( key == 10 ) ) )
			e.preventDefault() ;
	}
//-->
</script>
</head>
<?php include_once( "./inc_header.php" ) ; ?>

		<div style="">
			<?php
				$trans_script = "/ops/transcripts.php" ;
			?>
			<div style=""><span class="info_neutral" id="span_search_trans" style="cursor: pointer;" onClick="toggle_search_trans(0)"><img src="../pics/icons/search.png" width="16" height="16" border="0" alt=""> search transcripts</span></div>
			<div class="info_info" id="div_trans_search" style="display: none;">
				<form method="POST" action="" id="form_trans_search" style="">
				<input type="hidden" name="console" id="console" value="<?php echo isset( $console ) ? $console : 0 ; ?>">
				<div style="">
					<table cellspacing=0 cellpadding=0 border=0>
					<tr id="tr_search_criteria">
						<?php if ( $has_tags ): ?>
						<td style="padding-right: 15px;">
							Tag<br>
							<select id="tid" style="font-size: 16px;"><option value="0"></option>
							<?php
								foreach ( $tags as $index => $value )
								{
									if ( ( $index != "c" ) && preg_match( "/,/", $value ) )
									{
										LIST( $status, $color, $tag ) = explode( ",", $value ) ;
										$tag = rawurldecode( $tag ) ;
										if ( $status )
										{
											$selected = ( $index == $tid ) ? "selected" : "" ;
											print "<option value=\"$index\" $selected>$tag</option>" ;
										}
									}
								}
							?>
							</select>
						</td>
						<?php else: ?>
						<td><input type="hidden" id="tid" name="tid" value=0></td>
						<?php endif; ?>
						<td style="padding-right: 15px;">
							Month<br>
							<select name="month" id="month">
							<?php
								for ( $c = 0; $c <= 12; ++$c )
								{
									$selected = ( $month == $c ) ? "selected" : "" ;
									$month_expanded = ( $c ) ? date( "F", mktime( 0, 0, 1, $c, 1, 2010 ) ) : "" ;
									print "<option value='$c' $selected>$month_expanded</option>" ;
								}
							?>
							</select>
						</td>
						<td style="padding-right: 15px;">
							Year<br>
							<?php
								$y = date( "Y", time() ) ;
								$year_string = "<select name='year' id='year' style='font-size: 16px;'>" ;
								$year_string .= ( isset( $page ) ) ? "<option value='0'></option>" : "" ;
								for ( $c = $y; $c >= $y_start; --$c ) { $selected = "" ; if ( $year == $c ) { $selected = "selected" ; } $year_string .= "<option value=$c $selected>$c</option>" ; } $year_string .= "</select>" ;
								print $year_string ;
							?>
						</td>
						<td style="padding-right: 15px;">
							Search Text<br>
							<input type="text" class="input_text_search input" size="15" maxlength="55" style="" id="input_search" value="<?php echo $text ?>" onKeydown="input_text_listen_search(event);" autocomplete="off">
						</td>
						<td style="padding-right: 15px;">
							Search Field<br>
							<select name="s_as" id="s_as" style="">
								<option value=""></option>
								<option value="text">text</option>
								<option value="ces">Chat ID</option>
								<option value="vid">Visitor ID</option> <?php echo $custom_search_options ?>
							</select>
						</td>
						<?php if ( $opinfo["rate"] ): ?>
						<td style="padding-right: 15px;">
							Rating<br>
							<select name="rating" id="rating" style="">
								<option value=0 <?php echo ( $rating == 0 ) ? "selected" : "" ; ?>></option>
								<option value=5 <?php echo ( $rating == 5 ) ? "selected" : "" ; ?>>5 stars</option>
								<option value=4 <?php echo ( $rating == 4 ) ? "selected" : "" ; ?>>4 stars</option>
								<option value=3 <?php echo ( $rating == 3 ) ? "selected" : "" ; ?>>3 stars</option>
								<option value=2 <?php echo ( $rating == 2 ) ? "selected" : "" ; ?>>2 stars</option>
								<option value=1 <?php echo ( $rating == 1 ) ? "selected" : "" ; ?>>1 star</option>
							</select>
						</td>
						<?php endif ; ?>
						<td>
							&nbsp;<br>
							<div>
								<input type="button" id="btn_page_search" style="" class="btn" value="search" onClick="do_search('<?php echo $CONF["BASE_URL"].$trans_script ?>')">
								<?php if ( $search_reset ): ?>
								&nbsp; &nbsp; &nbsp; <span class="info_blue"><a href="transcripts.php?console=<?php echo $console ?>&auto=<?php echo $auto ?>&<?php echo $cache_bypass ?>">reset</a></span>
								<?php endif ; ?>
							</div>
							<script data-cfasync="false" type="text/javascript">
								$('#s_as').val('<?php echo ( $s_as ) ? $s_as : "" ; ?>') ;
							</script>
						</td>
					</tr>
					</table>
				</div>
				</form>
			</div>

		</div>

		<div style="margin-top: 25px;">
			<table cellspacing=0 cellpadding=0 border=0 width="100%">
			<tr>
				<td>
					<div style="margin-bottom: 5px;">The date format is m/dd/yyyy</div>
					<div style="margin-bottom: 5px;">The <img src="../pics/icons/flag_blue.png" width="14" height="14" border="0" alt=""> flag icon indicates the transcript includes the visitor's comment.</div>
					<div style="margin-bottom: 5px;">The <img src="../pics/icons/layers.png" width="16" height="16" border="0" alt=""> stack icon indicates the visitor has multiple chat transcripts matching their Visitor ID.</div>
					<div style="margin-bottom: 5px;">The <span style="padding: 1px; border: 0px; font-size: 1px; width: 25px;" class="info_black"><img src="../pics/space.gif" width="15" height="2" border=0></span> line represents the chat accept speed.</div>
					<div style="margin-bottom: 5px;">The <span style="padding: 1px; border: 0px; font-size: 1px; width: 25px;" class="info_time"><img src="../pics/space.gif" width="15" height="2" border=0></span> line represents the chat duration.</div>
					<div style="margin-bottom: 5px;">The <span style="padding: 1px; border: 0px; font-size: 1px; width: 25px;" class="info_misc"><img src="../pics/space.gif" width="15" height="2" border=0></span> line represents the transcript data size.</div>
				</td>
				<?php if ( $opinfo["rate"] ) { include_once( "$CONF[DOCUMENT_ROOT]/ops/inc_ratings.php" ) ; } ?>
			</tr>
			</table>
		</div>
		<div style="margin-top: 15px;">
			<table cellspacing=0 cellpadding=0 border=0 width="100%">
			<tr><td colspan="10" style="padding-bottom: 15px;"><?php echo $pages ?></td></tr>
			<tr>
				<td width="20" nowrap><div class="td_dept_header"></div></td>
				<td><div class="td_dept_header">Operator</div></td>
				<td><div class="td_dept_header">Visitor</div></td>
				<td><div class="td_dept_header">Created</div></td>
				<td width="90"><div class="td_dept_header">Duration</div></td>
				<td width="100%"><div class="td_dept_header">Question</div></td>
			</tr>
			<tbody id="tbody_trans">
			<?php
				$opinfo["theme"] = "default" ;
				for ( $c = 0; $c < count( $transcripts )-1; ++$c )
				{
					$transcript = $transcripts[$c] ;

					// brute fix of rare bug
					if ( $transcript["opID"] )
					{
						// intercept nulled operator accounts that have been deleted
						if ( !isset( $operators_hash[$transcript["op2op"]] ) ) { $operators_hash[$transcript["op2op"]] = "&nbsp;" ; }
						if ( !isset( $operators_hash[$transcript["opID"]] ) ) { $operators_hash[$transcript["opID"]] = "&nbsp;" ; }

						$operator = ( $transcript["op2op"] ) ? $operators_hash[$transcript["op2op"]][1] : $operators_hash[$transcript["opID"]][1] ;
						$profile_pic_url = "../pics/profile.png" ;
						if ( $operators_hash[$transcript["opID"]][2] )
							$profile_pic_url = $operators_hash[$transcript["opID"]][2] ;

						$created_date = date( "n/d/Y", $transcript["created"] ) ;
						$created_time = date( "$VARS_TIMEFORMAT", $transcript["created"] ) ;
						$duration = $transcript["ended"] - $transcript["created"] ;
						$duration_diff = round( ( round($duration/60)/60 ) * 100 ) ; if ( $duration_diff >= 100 ) { $duration_diff = 99 ; }
						$duration_string = "<div style=\"padding: 1px; border: 0px; font-size: 1px; width: {$duration_diff}%;\" class=\"info_time\">&nbsp;</div>" ;
						$fsize = Util_Functions_Bytes( $transcript["fsize"] ) ;
						$fsize_percentage = round( ( $transcript["fsize"]/$VARS_MAX_CHAT_FILESIZE ) * 100 ) ; if ( !$fsize_percentage ) { $fsize_percentage = "< 1" ; }
						$fsize_percentage_line = 90 ;
						if ( $transcript["fsize"] < 1000 ) { $fsize_percentage_line = 5 ; }
						else if ( $transcript["fsize"] < 10000 ) { $fsize_percentage_line = 10 ; }
						else if ( $transcript["fsize"] < 50000 ) { $fsize_percentage_line = 15 ; }
						else if ( $transcript["fsize"] < 100000 ) { $fsize_percentage_line = 25 ; }
						else if ( $transcript["fsize"] < 250000 ) { $fsize_percentage_line = 40 ; }
						else if ( $transcript["fsize"] < 500000 ) { $fsize_percentage_line = 60 ; }
						else if ( $transcript["fsize"] < 4000000 ) { $fsize_percentage_line = 80 ; }
						$question = preg_replace( "/(\r\n)|(\n)|(\r)/", "<br>", $transcript["question"] ) ;
						$vname = ( $transcript["op2op"] && isset( $operators_hash[$transcript["opID"]] ) ) ? $operators_hash[$transcript["opID"]][1] :  Util_Format_Sanatize( $transcript["vname"], "v" ) ;
						$email = ( $transcript["vemail"] && ( $transcript["vemail"] != "null" ) ) ? "<div style=\"margin-top: 5px; margin-bottom: 5px; font-size: smaller;\">$transcript[vemail]</div>" : "" ;
						$rating = ( $transcript["rating"] ) ? Util_Functions_Stars( "..", $transcript["rating"] ) : "" ;
						$initiated = ( $transcript["initiated"] ) ?  "<img src=\"../pics/icons/info_initiate.gif\" width=\"10\" height=\"10\" border=\"0\" alt=\"\" title=\"Operator Initiated Chat Invite\" alt=\"Operator Initiated Chat Invite\" class=\"info_misc\" style=\"padding: 4px;\"> " : "" ;
						$market = ( $transcript["marketID"] && isset( $markets_hash[$transcript["marketID"]] ) ) ? "<div style=\"margin-top: 15px;\">Campaign: <span class=\"info_clear\" style=\"padding: 2px; background: #".$markets_hash[$transcript["marketID"]]["color"].";\">".$markets_hash[$transcript["marketID"]]["name"]."</span></div>" : "" ;

						$rating_note_seperator = "&nbsp; " ;
						$comment = ( $transcript["noteID"] ) ?  "$rating_note_seperator<img src=\"../pics/icons/flag_blue.png\" width=\"14\" height=\"14\" border=\"0\" alt=\"\" title=\"includes visitor comment\" alt=\"includes visitor comment\" style=\"cursor: pointer;\" onClick=\"open_transcript('$transcript[ces]', '$operator')\">" : "" ;
						$hasnote = ( $transcript["hasnote"] ) ?  "$rating_note_seperator<img src=\"../pics/icons/pin_note.png\" width=\"14\" height=\"14\" border=\"0\" alt=\"\" title=\"includes notes\" alt=\"includes notes\" style=\"cursor: pointer;\" onClick=\"open_transcript('$transcript[ces]', '$operator')\">" : "" ;
						$tag_string = "" ;
						if ( isset( $tags[$transcript["tag"]] ) && preg_match( "/,/", $tags[$transcript["tag"]] ) )
						{
							LIST( $sthistatus, $thiscolor, $thistag ) = explode( ",", $tags[$transcript["tag"]] ) ;
							$tag_string = "<span class=\"info_neutral\" style=\"padding: 2px; background: #$thiscolor; border: 1px solid #C2C2C2; color: #474747; text-shadow: none;\">".rawurldecode( preg_replace( "/(.*?),/", "", $tags[$transcript["tag"]] ) )."</span> " ;
						}
						$accepted = ( !$transcript["initiated"] && $transcript["accepted_op"] ) ? Util_Format_Duration( $transcript["accepted_op"] ) : "" ;
						$accepted_diff = ( isset( $dept_rtime[$transcript["deptID"]] ) ) ? 100 - round( ( ( $dept_rtime[$transcript["deptID"]] - $transcript["accepted_op"] )/$dept_rtime[$transcript["deptID"]] ) * 100 ) : 0 ;
						$accepted_op_string = "<div style=\"margin-top: 5px; padding: 2px; cursor: help;\" class=\"info_neutral\" alt=\"chat accept speed\" title=\"chat accept speed\"><img src=\"../pics/icons/speed.png\" width=\"14\" height=\"14\" border=\"0\" style=\"padding: 1px;\"> $accepted <div style=\"padding: 1px; border: 0px; font-size: 1px; width: {$accepted_diff}%;\" class=\"info_black\">&nbsp;</div></div>" ;	
						$repeat_chatter = ( $transcript["encr"] ) ? $rating_note_seperator.'<img src="../pics/icons/layers.png" width="16" height="16" border="0" alt="repeat chatter" title="repeat chatter">' : "" ;
						$dept_name = isset( $dept_hash[$transcript["deptID"]] ) ? $dept_hash[$transcript["deptID"]] : "&nbsp;" ;

						$op2op_icon = "" ;
						if ( $transcript["op2op"] )
							$question = $op2op_icon = " <img src=\"../themes/initiate/agent.png\" width=\"16\" height=\"16\" border=\"0\" title=\"Operator to Operator Chat\" alt=\"Operator to Operator Chat\" style=\"padding: 2px; cursor: help;\" class=\"info_neutral\"> " ;
						else if ( $transcript["md5_vis"] == "grc" )
							$question = $op2op_icon = " <img src=\"../themes/initiate/group.png\" width=\"16\" height=\"16\" border=\"0\" title=\"Group Chat\" alt=\"Group Chat\" style=\"padding: 2px; cursor: help;\" class=\"info_neutral\"> " ;

						$btn_view = "<div id=\"img_$transcript[ces]\"><a href=\"JavaScript:void(0)\" onClick=\"open_transcript('$transcript[ces]', '$operator')\"><img src=\"../pics/btn_view.png?1\" width=\"64\" height=\"23\" border=\"0\" alt=\"\"></a></div>" ;
						$geo_country_code = $geo_region = $geo_city = "" ; $geo_lat = $geo_long = 0 ;
						$ip = $transcript["ip"] ;
						if ( $opinfo["viewip"] ) { include( "../inc_geo.php" ) ; }
						$country = ( $geo_country_code ) ? "<img src='../pics/maps/".strtolower( $geo_country_code ).".gif' width='18' height='12' border=0 alt='".$geo_country_code." - $geo_city $geo_region' title='".$geo_country_code." - $geo_city $geo_region'> " : "" ;

						$gravatar = "" ;
						if ( $addon_gravatar && ( !isset( $dept_gravatars[$transcript["deptID"]] ) || $dept_gravatars[$transcript["deptID"]] ) )
						{
							$gravatar = ( $transcript["vemail"] && ( $transcript["vemail"] != "null" ) ) ? Util_Gravatar( $transcript["vemail"], 25 ) : "" ;
							if ( $gravatar )
								$gravatar = "<img src=\"$gravatar\" border=0 alt=\"Gravatar\" title=\"Gravatar\" style=\"border-radius: 50%;\">" ;
						}

						$bg_color = ( ($c+1) % 2 ) ? "FFFFFF" : "EDEDED" ;
						$td1 = "td_dept_td" ;

						$custom_vars_string = "" ;
						if ( $transcript["custom"] )
						{
							$custom_vars_string = "" ;
							$customs = explode( "-cus-", $transcript["custom"] ) ;
							for ( $c2 = 0; $c2 < count( $customs ); ++$c2 )
							{
								$custom_var = $customs[$c2] ;
								if ( $custom_var && preg_match( "/-_-/", $custom_var ) )
								{
									LIST( $cus_name, $cus_val ) = explode( "-_-", rawurldecode( $custom_var ) ) ;
									if ( $cus_val )
									{
										if ( preg_match( "/^((http)|(www))/", $cus_val ) )
										{
											if ( preg_match( "/^(www)/", $cus_val ) ) { $cus_val = "https://$cus_val" ; }
											$cus_val_snap = Util_Format_CreateSnap( $cus_val, 40 ) ;
											$custom_vars_string .= "<div style=\"padding: 2px;\"><b>$cus_name:</b> <a href=\"$cus_val\" target=_blank>$cus_val_snap</a></div>" ;
										}
										else
										{
											$custom_vars_string .= "<div style=\"padding: 2px;\"><b>$cus_name:</b> $cus_val</div>" ;
										}
									}
								}
							}
							$custom_vars_string = ( $custom_vars_string ) ? "<div style=\"margin-top: 5px; font-size: smaller;\" class=\"info_neutral\"><img src=\"../pics/icons/ops.png\" width=\"16\" height=\"16\" border=\"0\" alt=\"\"> Custom Fields<div style=\"margin-top: 5px; max-height: 65px; overflow: auto;\">$custom_vars_string</div></div>" : "" ;
						}

						print "<tr id=\"tr_$transcript[ces]\" style=\"background: #$bg_color\">
							<td class=\"$td1\">
								<div>$btn_view</div>
								<div class=\"info_neutral\" style=\"margin-top: 5px; font-size: smaller; padding: 1px; opacity: 0.5; filter: alpha(opacity=50);\" alt=\"chat ID\" title=\"chat ID\">Chat ID<br>$transcript[ces]</div>
							</td>
							<td class=\"$td1\">
								<div id=\"transcript_$transcript[ces]\" style=\"width: 160px;\">
									$initiated <img src='$profile_pic_url' width='25' height='25' border=0 style='border-radius: 50%;'>$op2op_icon<div style=\"margin-top: 5px;\">$operator</div><div style=\"opacity: 0.5;\">$dept_name</div>
								</div>
							</td>
							<td class=\"$td1\" nowrap>
								<div style=\"min-width: 180px;\">
									$gravatar $country$op2op_icon$vname$repeat_chatter$email
									<table cellspacing=0 cellpadding=0 border=0><tr><td>$rating</td><td>$comment</td><td>$hasnote</td></tr></table>
								</div>
							</td>
							<td class=\"$td1\" nowrap id=\"div_created_{$transcript["created"]}\">
								$created_date<div style=\"font-size: smaller; margin-top: 3px;\">($created_time)</div>
							</td>
							<td class=\"$td1\" nowrap>
								$accepted_op_string
								<div style=\"margin-top: 5px; min-width: 100px; padding: 2px; font-size: smaller; cursor: help;\" class=\"info_neutral\" alt=\"chat session duration\" title=\"chat session duration\"><img src=\"../pics/icons/clock3.png\" width=\"14\" height=\"14\" border=\"0\"> ".Util_Format_Duration( $duration ).$duration_string."</div>
								<div style=\"margin-top: 3px; font-size: smaller;\">$fsize</div>
								<div style=\"padding: 1px; border: 0px; font-size: 1px; width: {$fsize_percentage_line}%;\" class=\"info_misc\">&nbsp;</div>
							</td>
							<td class=\"$td1\" style=\"word-break: break-word; word-wrap: break-word;\">
								<div>$tag_string $question</div>
								$market
								$custom_vars_string
							</td>
						</tr>" ;
					}
				}
				if ( $c == 0 )
					print "<tr><td colspan=7 class=\"td_dept_td\">Blank results.</td></tr>" ;
			?>
			<tr><td colspan="10"><?php echo $pages ?></td></tr>
			</tbody>
			</table>
		</div>

<div id="div_transcript_wrapper" style="display: none; position: fixed; top: 0px; left: 0px; width: 100%; height: 100%; background: url( ../themes/initiate/bg_trans.png ) repeat; z-Index: 1001;">
	<div class="info_neutral" style="margin: 0 auto; padding: 0px; width: 750px; box-shadow: <?php echo $VARS_UI_POPUP_BOXSHADOW ?>;">
		<div style="padding: 15px;">
			<div class="info_error" style="text-align: center; cursor: pointer;" onClick="toggle_transcript_wrapper(0)">Close</div>
		</div>
		<iframe id="iframe_transcript" name="iframe_transcript" style="background: #F2F3F5; width: 100%; height: 1px; border: 0px; padding: 0px;" src="about:blank" scrolling="auto" border=0 frameborder=0></iframe>
	</div>
</div>
<?php include_once( "./inc_footer.php" ) ; ?>