<?php
	/***************************************/
	//
	//
	// PHP Live! Support
	//
	// https://www.phplivesupport.com
	//
	/***************************************/
	// STANDARD header for Setup
	if ( !is_file( "../web/config.php" ) ){ HEADER("location: install.php") ; exit ; }
	include_once( "../web/config.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Format.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Error.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/".Util_Format_Sanatize($CONF["SQLTYPE"], "ln") ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Security.php" ) ;
	if ( !$admininfo = Util_Security_AuthSetup( $dbh ) ){ ErrorHandler( 608, "Invalid setup session or session has expired.", $PHPLIVE_FULLURL, 0, Array() ) ; exit ; }
	// STANDARD header end
	/****************************************/

	include_once( "$CONF[DOCUMENT_ROOT]/API/Depts/get.php" ) ;

	$action = Util_Format_Sanatize( Util_Format_GetVar( "action" ), "ln" ) ;
	$gid = Util_Format_Sanatize( Util_Format_GetVar( "gid" ), "n" ) ;

	$departments_all = Depts_get_AllDepts( $dbh, "display ASC, name ASC" ) ;
	$departments = Array() ; $depts_hash = Array() ;
	for ( $c = 0; $c < count( $departments_all ); ++$c )
	{
		$department = $departments_all[$c] ;
		$depts_hash[$department["deptID"]] = $department["name"] ;

		if ( ( $department["name"] != "Archive" ) && $department["visible"] )
			$departments[] = $department ;
	}

	if ( $action == "delete" )
	{
		include_once( "$CONF[DOCUMENT_ROOT]/API/Depts/remove.php" ) ;

		Depts_remove_DeptGroup( $dbh, $gid ) ;
		Util_Format_CleanIcons( $gid ) ;
		$action = "success" ;
	}
	$dept_groups = Depts_get_AllDeptGroups( $dbh ) ;
?>
<?php include_once( "../inc_doctype.php" ) ?>
<head>
<title> PHP Live! Support </title>

<meta name="description" content="PHP Live! Support <?php echo $VERSION ?>">
<meta name="keywords" content="powered by: PHP Live!  www.phplivesupport.com">
<meta name="robots" content="all,index,follow">
<meta http-equiv="content-type" content="text/html; CHARSET=utf-8"> 
<?php include_once( "../inc_meta_dev.php" ) ; ?>

<link rel="Stylesheet" href="../css/setup.css?<?php echo filemtime( "../css/setup.css" ) ?>">
<script data-cfasync="false" type="text/javascript" src="../js/global.js?<?php echo filemtime ( "../js/global.js" ) ; ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../js/framework.js?<?php echo $VERSION ?>"></script>

<script data-cfasync="false" type="text/javascript">
<!--
	var max_depts = <?php echo $VARS_MAX_DEPT_GROUP_DEPTS ?> ; // maximum  departments in a group.  greater than 5 may reduce system performance (loading the chat icon)
	var global_group_deptid = 0 ;

	$(document).ready(function()
	{
		$("html, body").css({'background': '#F2F3F5'}) ;
		init_menu() ;
		toggle_menu_setup( "depts" ) ;

		$('#span_max_depts').html( max_depts ) ;
		$('#span_max_depts2').html( max_depts ) ;

		<?php if ( $action === "success" ): ?>do_alert( 1, "Update Success" ) ;<?php endif ; ?>
	});

	function toggle_checked( thedeptid )
	{
		if ( $('#ck_dept_'+thedeptid).is(':checked') )
			$('#ck_dept_'+thedeptid).prop('checked', false) ;
		else
			$('#ck_dept_'+thedeptid).prop('checked', true) ;
	}

	function do_update()
	{
		var json_data = new Object ;
		var gid = $('#gid').val() ;
		var name = $('#name').val() ;
		var lang = $('#lang_pr').val() ;
		var ok_depts = 0 ; var ok_depts_query = "" ;

		$('#div_list_depts').find('*').each( function () {
			var div_name = this.id ;
			if ( ( div_name.indexOf( "ck_dept_" ) == 0 ) && this.checked )
			{
				++ok_depts ;
				ok_depts_query += ","+$(this).val()+"," ;
			}
		}) ;

		if ( !name )
		{
			do_alert( 0, "Please provide the Group Name." ) ;
			$('#name').focus() ;
			$('#image_1').fadeTo("fast", .1).fadeTo("fast", 1).fadeTo("fast", .1).fadeTo("fast", 1).fadeTo("fast", .1).fadeTo("fast", 1).fadeTo("fast", .1).fadeTo("fast", 1).fadeTo("fast", .1).fadeTo("fast", 1) ;
			return false ;
		}
		else if ( !lang )
		{
			do_alert( 0, "Please select the Language." ) ;
			$('#image_2').fadeTo("fast", .1).fadeTo("fast", 1).fadeTo("fast", .1).fadeTo("fast", 1).fadeTo("fast", .1).fadeTo("fast", 1).fadeTo("fast", .1).fadeTo("fast", 1).fadeTo("fast", .1).fadeTo("fast", 1) ;
			return false ;
		}
		else if ( ok_depts < 2 )
		{
			do_alert( 0, "At least 2 departments must be checked." ) ;
			$('#image_3').fadeTo("fast", .1).fadeTo("fast", 1).fadeTo("fast", .1).fadeTo("fast", 1).fadeTo("fast", .1).fadeTo("fast", 1).fadeTo("fast", .1).fadeTo("fast", 1).fadeTo("fast", .1).fadeTo("fast", 1) ;
			return false ;
		}
		else if ( ok_depts > max_depts )
		{
			$('#div_error_max').fadeIn("fast") ;
			$('#image_4').fadeTo("fast", .1).fadeTo("fast", 1).fadeTo("fast", .1).fadeTo("fast", 1).fadeTo("fast", .1).fadeTo("fast", 1).fadeTo("fast", .1).fadeTo("fast", 1).fadeTo("fast", .1).fadeTo("fast", 1) ;
			return false ;
		}

		$('#btn_submit').attr('disabled', true) ;

		$.ajax({
			type: "POST",
			url: "../ajax/setup_actions_.php",
			data: "action=update_dept_group&gid="+gid+"&name="+encodeURIComponent(name)+"&lang="+lang+"&deptids="+ok_depts_query+"&"+unixtime(),
			success: function(data){
				eval( data ) ;
				$('#btn_submit').attr('disabled', false) ;

				if ( json_data.status )
					location.href = "dept_groups.php?action=success" ;
				else
					do_alert( 0, json_data.error ) ;
			}
		});
	}

	function deptids_uncheck()
	{
		$('#div_list_depts').find('*').each( function () {
			var div_name = this.id ;
			if ( ( div_name.indexOf( "ck_dept_" ) == 0 ) && this.checked )
				$(this).prop('checked', false) ;
		}) ;
	}

	function remove_group( thegroupid, thegroup_name )
	{
		var pos = $('#tr_'+thegroupid).offset() ;
		var width = $('#tr_'+thegroupid).width() + 120 ;
		var height = $('#tr_'+thegroupid).height() ;

		global_group_deptid = thegroupid ;

		$('#span_group_name').html( thegroup_name ) ;
		$('#div_confirm_delete').css({'top': pos.top, 'left': pos.left, 'width': width, 'height': height}).fadeIn('fast') ;
	}

	function remove_group_doit( thegroupid )
	{
		if ( confirm( "Really delete department group?" ) )
		{
			location.href = "dept_groups.php?action=delete&gid="+global_group_deptid+"&"+unixtime() ;
		}
	}

	function edit_group( thegroupid, thename, thelang, thedeptids )
	{
		var deptids = thedeptids.split( "," ) ;

		if ( !$('#div_edit_group').is(':visible') )
			$('#div_edit_group').show() ;

		$('#text_cancel').fadeIn("slow") ;
		$('#gid').val(thegroupid) ;
		$('#name').val( thename ) ;
		$('select#lang_pr').val( thelang ) ;

		deptids_uncheck() ;
		for ( var c = 0; c < deptids.length; ++c )
		{
			var deptid = deptids[c] ;
			$('#ck_dept_'+deptid).prop('checked', true) ;
		}
		scroll_top() ;
	}

	function do_cancel()
	{
		$('#text_cancel').hide() ;
		$('#gid').val(0) ;
		$('#name').val("") ;
		$('select#lang_pr').val("") ;

		deptids_uncheck() ;
	}
//-->
</script>
</head>
<?php include_once( "./inc_header.php" ) ?>

		<?php
			if ( !$admininfo["isadmin"] && ( count( $admininfo["access"] ) && !isset( $admininfo["access"]["depts"] ) ) ):
			include_once( "$CONF[DOCUMENT_ROOT]/setup/inc_access.php" ) ; else:
		?>
		<div class="op_submenu_wrapper">
			<div class="op_submenu" style="margin-left: 0px;" onClick="location.href='depts.php'">Chat Departments</div>
			<div class="op_submenu" onClick="location.href='dept_display.php'">Department Select Display Order</div>
			<div class="op_submenu_focus">Department Groups</div>
			<div class="op_submenu" onClick="location.href='dept_canned_cats.php'">Shared Canned Response Categories</div>
			<div style="clear: both"></div>
		</div>

		<div style="margin-top: 45px;">
			<form>
			<input type="hidden" name="gid" id="gid" value=0>
			<div>For the <a href="code.php">All Departments Live Chat HTML Code</a>, visitors will be able to choose a department from the department select dropdown menu on the chat request window.  Create department groups for a customized department dropdown list rather than displaying all the departments.  Max <span id="span_max_depts"></span> departments can be assigned to a group to maintain optimal system performance.</div>
			<div style="display: none; margin-top: 5px;" class="info_error" id="div_error_max"><img src="../pics/icons/alert.png" width="16" height="16" border="0" alt=""> Max <span id="span_max_depts2"></span> departments can be assigned to a group to maintain optimal system performance.</div>

			<div style="<?php echo ( count( $departments ) <= 2 ) ? "" : "display: none;" ?> margin-top: 35px;">
				<span class="info_error"><img src="../pics/icons/warning.png" width="12" height="12" border="0" alt=""> This feature is available when there are at least 3 visible <a href="depts.php" style="color: #FFFFFF;">Departments</a> created.</span>
			</div>
			<div style="<?php echo ( count( $departments ) <= 2 ) ? "display: none;" : "" ?> margin-top: 35px;" id="div_edit_group">
				<table cellspacing=0 cellpadding=0 border=0>
				<tr>
					<td valign="top">
						<img src="../pics/icons/numbers/1.png" width="22" height="22" border="0" alt="" id="image_1"> Group Name<br>
						<div style="margin-top: 15px;"><input type="text" class="input" name="name" id="name" size="15" maxlength="35" value="" autocomplete="off" onKeyPress="return noquotestags(event)"></div>
					</td>
					<td valign="top" style="padding-left: 45px;">
						<img src="../pics/icons/numbers/2.png" width="22" height="22" border="0" alt="" id="image_2"> Language<br>
						<div style="margin-top: 15px;">
							<select name="lang_pr" id="lang_pr">
							<option value="">&nbsp;</option>
							<?php
								$dir_langs = opendir( "$CONF[DOCUMENT_ROOT]/lang_packs/" ) ;

								$langs = Array() ;
								while ( $this_lang = readdir( $dir_langs ) )
									$langs[] = $this_lang ;
								closedir( $dir_langs ) ;

								sort( $langs, SORT_STRING ) ;
								for ( $c = 0; $c < count( $langs ); ++$c )
								{
									$this_lang = preg_replace( "/.php/", "", $langs[$c] ) ;

									if ( preg_match( "/[a-z]/i", $this_lang ) && !preg_match( "/index/i", $this_lang ) )
										print "<option value=\"$this_lang\">".ucfirst( $this_lang )."</option>" ;
								}
							?>
							</select>
						</div>
					</td>
					<td valign="top" style="padding-left: 45px;">
						<img src="../pics/icons/numbers/3.png" width="22" height="22" border="0" alt="" id="image_3"> Select from available <a href="depts.php">Departments</a>
						<div style="margin-top: 15px;" class="info_box"><img src="../pics/icons/info.png" width="16" height="16" border="0" alt=""> Only the <a href="depts.php?ftab=vis"><b>visible for selection</b></a> departments are displayed.</div>
						<div style="margin-top: 5px; max-height: 300px; overflow: auto;" id="div_list_depts">
							<table cellspacing=0 cellpadding=0 border=0 width="100%">
							<?php
								for ( $c = 0; $c < count( $departments ); ++$c )
								{
									$department = $departments[$c] ;

									$td1 = "td_dept_td" ;
									$bg_color = ( ( $c + 1 ) % 2 ) ? "FFFFFF" : "EDEDED" ;

									print "
									<tr style=\"background: #$bg_color\">
										<td class=\"$td1\" width=\"16\"><input type=\"checkbox\" id=\"ck_dept_$department[deptID]\" name=\"deptids[]\" value=\"$department[deptID]\"></td>
										<td class=\"$td1\" style=\"text-align: left;\">
											<div style=\"cursor: pointer;\" onClick=\"toggle_checked($department[deptID])\">$department[name]</div>
										</td>
									</tr>
									" ;
								}
							?>
							</table>
						</div>
					</td>
					<td valign="top" style="padding-left: 45px;">
						<img src="../pics/icons/numbers/4.png" width="22" height="22" border="0" alt="">
						<div style="margin-top: 15px;">
							<button type="button" class="btn" onClick="do_update()" id="btn_submit">Submit</button> &nbsp; &nbsp; 
							<span style="display: none;" id="text_cancel"><a href="JavaScript:void(0)" onClick="do_cancel()">cancel</a></span>
						</div>
					</td>
				</tr>
				</table>
			</div>
			</form>

			<div style="margin-top: 35px;">
				<div>
					<table cellspacing=0 cellpadding=0 border=0>
					<tr>
						<td width="14"><div class="td_dept_header">&nbsp;</div></td>
						<td width="14"><div class="td_dept_header">&nbsp;</div></td>
						<td><div class="td_dept_header">Group Name</div></td>
						<td><div class="td_dept_header">Departments in Group</div></td>
					</tr>
					<?php
						for ( $c = 0; $c < count( $dept_groups ); ++$c )
						{
							$dept_group = $dept_groups[$c] ;
							$deptids = explode( ",", $dept_group["deptids"] ) ;
							$group_name = Util_Format_ConvertQuotes( $dept_group["name"] ) ;
							$departments_string = "" ;

							$td1 = "td_dept_td" ;
							$bg_color = ( ( $c + 1 ) % 2 ) ? "FFFFFF" : "EDEDED" ;

							for ( $c2 = 0; $c2 < count( $deptids ); ++$c2 )
							{
								if ( $deptids[$c2] && isset( $depts_hash[$deptids[$c2]] ) )
									$departments_string .= "<div style=\"float: left; margin-right: 5px; margin-bottom: 5px;\" class=\"info_neutral\">" . $depts_hash[$deptids[$c2]] . "</div> " ;
							}
							print "
							<tr style=\"background: #$bg_color\" id=\"tr_$dept_group[groupID]\">
								<td class=\"$td1\" width=\"14\"><a href=\"JavaScript:void(0)\" onClick=\"remove_group($dept_group[groupID], '$group_name')\"><img src=\"../pics/icons/delete.png\" width=\"14\" height=\"14\" border=\"0\" alt=\"delete\" title=\"delete\"></a></td><td class=\"$td1\" width=\"14\"><a href=\"JavaScript:void(0)\" onClick=\"edit_group( $dept_group[groupID], '$dept_group[name]', '$dept_group[lang]', '$dept_group[deptids]' )\"><img src=\"../pics/icons/edit.png\" width=\"14\" height=\"14\" border=\"0\" alt=\"edit\" title=\"edit\"></a></td>
								<td class=\"$td1\" nowrap>
									<span class=\"title\"><b>$dept_group[name]</b></span>
									<div style=\"margin-top: 15px;\"><img src=\"../pics/icons/arrows/main_grey.png\" width=\"20\" height=\"10\" border=\"0\" alt=\"\">language: ".ucfirst( $dept_group["lang"] )."</div>
									<div style=\"margin-top: 5px;\"><img src=\"../pics/icons/arrows/main_grey.png\" width=\"20\" height=\"10\" border=\"0\" alt=\"\"><a href=\"interface.php?deptid=$dept_group[groupID]\">Logo & Win Size</a></div>
									<div style=\"margin-top: 5px;\"><img src=\"../pics/icons/arrows/main_grey.png\" width=\"20\" height=\"10\" border=\"0\" alt=\"\"><a href=\"interface_themes.php?deptid=$dept_group[groupID]\">Theme</a></div>
									<div style=\"margin-top: 5px;\"><img src=\"../pics/icons/arrows/main_grey.png\" width=\"20\" height=\"10\" border=\"0\" alt=\"\"><a href=\"interface_lang.php?deptid=$dept_group[groupID]\">Update Texts</a></div>
									<div style=\"margin-top: 5px;\"><img src=\"../pics/icons/arrows/main_grey.png\" width=\"20\" height=\"10\" border=\"0\" alt=\"\"><a href=\"icons.php?deptid=$dept_group[groupID]\">Chat Icons</a></div>
									<div style=\"margin-top: 5px;\"><img src=\"../pics/icons/arrows/main_grey.png\" width=\"20\" height=\"10\" border=\"0\" alt=\"\"><a href=\"code.php?deptid=$dept_group[groupID]&action=switch\">Live Chat HTML Code</a></div>
								</td>
								<td class=\"$td1\">
									$departments_string
									<div style=\"float: left;\"></div>
								</td>
							</tr>
							" ;
						}
						if ( !count( $dept_groups ) )
							print "<tr><td colspan=4 class=\"td_dept_td\">Blank results.</td></tr>" ;
					?>
					</table>
				</div>
			</div>
		</div>
		<?php endif ; ?>

<div style="display: none; position: absolute; top: 0px; left: 0px; z-Index: 10;" class="info_error" id="div_confirm_delete">
	Really delete department group <span class="title" id="span_group_name"></span>?

	<div style="margin-top: 15px;"><img src="../pics/icons/warning.png" width="16" height="16" border="0" alt=""> <b>Reminder:</b> Replace the Live Chat HTML Code on your webpages to a new <a href="code.php" style="color: #FFFFFF;">Live Chat HTML Code</a> if you are using this department group Live Chat HTML Code.</div>

	<div style="margin-top: 15px;"><button type="button" onClick="remove_group_doit()" class="btn">Yes.  Delete.</button> &nbsp; &nbsp; <a href="JavaScript:void(0)" style="color: #FFFFFF;" onClick="$('#div_confirm_delete').fadeOut('fast');">cancel</a></div>
</div>
<?php include_once( "./inc_footer.php" ) ?>
