<?php
	/***************************************/
	//
	//
	// PHP Live! Support
	//
	// https://www.phplivesupport.com
	//
	/***************************************/
	// STANDARD header for Setup
	if ( !is_file( "../web/config.php" ) ){ HEADER("location: install.php") ; exit ; }
	include_once( "../web/config.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Format.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Error.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/".Util_Format_Sanatize($CONF["SQLTYPE"], "ln") ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Security.php" ) ;
	if ( !$admininfo = Util_Security_AuthSetup( $dbh ) ){ ErrorHandler( 608, "Invalid setup session or session has expired.", $PHPLIVE_FULLURL, 0, Array() ) ; exit ; }
	// STANDARD header end
	/****************************************/

	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Vals.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/External/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Depts/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Ops/get.php" ) ;

	$https = $error = "" ;
	if ( isset( $_SERVER["HTTP_CF_VISITOR"] ) && preg_match( "/(https)/i", $_SERVER["HTTP_CF_VISITOR"] ) ) { $https = "s" ; }
	else if ( isset( $_SERVER["HTTP_X_FORWARDED_PROTO"] ) && preg_match( "/(https)/i", $_SERVER["HTTP_X_FORWARDED_PROTO"] ) ) { $https = "s" ; }
	else if ( isset( $_SERVER["HTTPS"] ) && preg_match( "/(on)/i", $_SERVER["HTTPS"] ) ) { $https = "s" ; }

	$action = Util_Format_Sanatize( Util_Format_GetVar( "action" ), "ln" ) ;
	$jump = ( Util_Format_Sanatize( Util_Format_GetVar( "jump" ), "ln" ) ) ? Util_Format_Sanatize( Util_Format_GetVar( "jump" ), "ln" ) : "external" ;
	$deptid = Util_Format_Sanatize( Util_Format_GetVar( "deptid" ), "n" ) ;

	if ( $action === "submit" )
	{
		if ( $jump == "apis" )
		{
			include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Vals.php" ) ;

			$error = ( Util_Vals_WriteToConfFile( "API_KEY", Util_Format_RandomString( 10 ) ) ) ? "" : "Could not write to config file." ;
		}
		else
		{
			include_once( "$CONF[DOCUMENT_ROOT]/API/External/put.php" ) ;
			include_once( "$CONF[DOCUMENT_ROOT]/API/External/remove.php" ) ;

			$extid = Util_Format_Sanatize( Util_Format_GetVar( "extid" ), "n" ) ;
			$name = Util_Format_Sanatize( Util_Format_GetVar( "name" ), "ln" ) ;
			$url = Util_Format_Sanatize( Util_Format_GetVar( "url" ), "url" ) ;
			$opids = Util_Format_Sanatize( Util_Format_GetVar( "opids" ), "a" ) ;

			if ( $id = External_put_External( $dbh, $extid, $name, $url ) )
			{
				External_remove_AllExtOps( $dbh, $id ) ;
				for ( $c = 0; $c < count( $opids ); ++$c )
				{
					$opid = Util_Format_Sanatize( $opids[$c], "n" ) ;
					External_put_ExtOp( $dbh, $id, $opid ) ;
				}
			}
			else	
				$error = "Name ($name) is already in use." ;
		}
	}
	else if ( $action === "delete" )
	{
		include_once( "$CONF[DOCUMENT_ROOT]/API/External/remove.php" ) ;

		$extid = Util_Format_Sanatize( Util_Format_GetVar( "extid" ), "n" ) ;
		External_remove_External( $dbh, $extid ) ;
		$jump = "external" ;
	}

	$departments = Depts_get_AllDepts( $dbh ) ;
	if ( $deptid )
		$deptinfo = Depts_get_DeptInfo( $dbh, $deptid ) ;

	$operators = Ops_get_AllOps( $dbh ) ;
	$externals = External_get_AllExternal( $dbh ) ;
?>
<?php include_once( "../inc_doctype.php" ) ?>
<head>
<title> PHP Live! Support </title>

<meta name="description" content="PHP Live! Support <?php echo $VERSION ?>">
<meta name="keywords" content="powered by: PHP Live!  www.phplivesupport.com">
<meta name="robots" content="all,index,follow">
<meta http-equiv="content-type" content="text/html; CHARSET=utf-8">
<?php include_once( "../inc_meta_dev.php" ) ; ?>

<link rel="Stylesheet" href="../css/setup.css?<?php echo filemtime( "../css/setup.css" ) ?>">
<script data-cfasync="false" type="text/javascript" src="../js/global.js?<?php echo filemtime ( "../js/global.js" ) ; ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../js/framework.js?<?php echo $VERSION ?>"></script>

<script data-cfasync="false" type="text/javascript">
<!--
	"use strict" ;
	var proto = location.protocol ;

	$(document).ready(function()
	{
		$("html, body").css({'background': '#F2F3F5'}) ;
		init_menu() ;
		toggle_menu_setup( "extras" ) ;
		if ( typeof( show_div ) == "function" )
			show_div( "<?php echo $jump ?>" ) ;
		switch_dept_api( 0, false ) ;
		switch_geoip_api( "csv" ) ;

		<?php if ( ( $action === "submit" ) && !$error ): ?>do_alert( 1, "Update Success" ) ;<?php endif ; ?>
	});

	function do_options( theoption, theextid, thename, theurl, theops )
	{
		if ( theoption == "edit" )
		{
			var ops = theops.split( "," ) ;
			$( "input#extid" ).val( theextid ) ;
			$( "input#name" ).val( thename ) ;
			$( "input#url" ).val( theurl ) ;

			check_all( "undefined" ) ;
			for ( var c = 0; c < ops.length; ++c )
				$('#ck_op_'+ops[c]).prop( 'checked', true ) ;

			location.href = "#a_edit" ;
		}
		else if ( theoption == "delete" )
		{
			if ( confirm( "Delete this External URL?" ) )
				location.href = "extras.php?action=delete&extid="+theextid ;
		}
	}

	function do_submit()
	{
		var name = $( "input#name" ).val() ;
		var url = $( "input#url" ).val() ;
		var flag = 0 ;

		$( '*', 'body' ).find('div').each( function () {
			var div_name = this.id ;
			if ( div_name.indexOf( "ck_op_" ) == 0 )
			{
				if ( $(this).prop( 'checked' ) )
					flag = 1 ;
			}
		}) ;

		if ( name == "" )
			do_alert( 0, "Please provide the external url name." ) ;
		else if ( url == "" )
			do_alert( 0, "Please provide the external url." ) ;
		else if ( !url.match( /^http/i ) )
			do_alert( 0, "URL must begin with HTTPS or HTTP." )
		else if ( !flag )
		{
			// let it pass for now to reset if only 1 operator assigned previously
			//do_alert( 0, "At least one operator must be checked." ) ;
			$('#theform').submit() ;
		}
		else
			$('#theform').submit() ;
	}

	function launch_external( theextid, theurl )
	{
		var unique = unixtime() ;
		window.open(theurl, unique, 'scrollbars=yes,menubar=yes,resizable=1,location=yes,toolbar=yes,status=1') ;
	}

	function check_all( theobject )
	{
		if ( ( typeof( theobject ) != "undefined" ) && ( theobject.checked ) )
		{
			$('#theform').find('*').each( function () {
				var div_name = this.id ;
				if ( div_name.indexOf( "ck_op_" ) == 0 )
					this.checked = true ;
			}) ;
		}
		else
		{
			$('#theform').find('*').each( function () {
				var div_name = this.id ;
				if ( div_name.indexOf( "ck_op_" ) == 0 )
					this.checked = false ;
			}) ;
		}
	}

	function reset_check_all()
	{
		$('#ck_op_all').prop( 'checked', false ) ;
	}

	function switch_dept_api( thedeptid, theblink )
	{
		$('#api_status').val( "<?php echo ( !preg_match( "/^(http)/", $CONF["BASE_URL"] ) ) ? "http$https:$CONF[BASE_URL]" : $CONF["BASE_URL"] ; ?>/ajax/status.php?akey=<?php echo $CONF["API_KEY"] ?>&deptid="+thedeptid ) ;
		if ( theblink )
			$('#api_status').fadeTo("fast", .1).fadeTo("fast", 1).fadeTo("fast", .1).fadeTo("fast", 1).fadeTo("fast", .1).fadeTo("fast", 1) ;
	}

	function switch_geoip_api( theformat )
	{
		$('#api_geoip').val( "<?php echo ( !preg_match( "/^(http)/", $CONF["BASE_URL"] ) ) ? "http$https:$CONF[BASE_URL]" : $CONF["BASE_URL"] ; ?>/wapis/geoip.php?akey=<?php echo $CONF["API_KEY"] ?>&f="+theformat+"&ip=124.108.31.255" ) ;
	}

	function gen_new_key()
	{
		var unique = unixtime() ;

		if ( confirm( "This action will cause existing APIs that uses previous API Key to stop working.  Continue?" ) )
		{
			location.href = "extras.php?action=submit&jump=apis&"+unique ;
		}
	}

//-->
</script>
<?php include_once( "./inc_header.php" ) ?>

		<?php
			if ( !$admininfo["isadmin"] && ( count( $admininfo["access"] ) && !isset( $admininfo["access"]["extras"] ) ) ):
			include_once( "$CONF[DOCUMENT_ROOT]/setup/inc_access.php" ) ; else:
		?>
		<?php include_once( "./inc_menu.php" ) ; ?>

		<div style="display: none; margin-top: 45px;" id="extras_external">
			<div>
				External URLs allow operators to easily access a webpage directly from the operator console.  The links will appear on the operator console footer menu.
				<div style="margin-top: 5px;"><img src="../pics/icons/info.png" width="16" height="16" border="0" alt=""> Keep in mind, External URLs can only load URLs that can be <b>embedded inside an iframe</b>.</div>
			</div>

			<?php if ( count( $operators ) ): ?>
				<form>
				<table cellspacing=0 cellpadding=0 border=0 width="100%" style="margin-top: 35px;">
				<tr>
					<td width="40"><div class="td_dept_header">&nbsp;</div></td>
					<td><div class="td_dept_header">Name</div></td>
					<td width="100%"><div class="td_dept_header">URL</div></td>
				</tr>
				<?php
					for ( $c = 0; $c < count( $externals ); ++$c )
					{
						$external = $externals[$c] ;
						$ops = External_get_ExtOps( $dbh, $external["extID"] ) ;

						$ops_string = $ops_js_string = "" ;
						for ( $c2 = 0; $c2 < count( $ops ); ++$c2 )
						{
							$op = $ops[$c2] ;
							$ops_string .= " <div class=\"li_op round\">$op[name]</div>" ;
							$ops_js_string .= "$op[opID]," ;
						}
						$ops_js_string = substr_replace( $ops_js_string, "", -1 ) ;

						$name = preg_replace( "/\"/", "&ldquo;", preg_replace( "/'/", "&lsquo;", $external["name"] ) ) ;

						$edit_delete = "<div onClick=\"do_options( 'edit', $external[extID], '$name', '$external[url]', '$ops_js_string' )\" style=\"cursor: pointer;\"><img src=\"../pics/btn_edit.png\" width=\"64\" height=\"23\" border=\"0\" alt=\"\"></div><div onClick=\"do_options( 'delete', $external[extID], '$external[name]', '$external[url]', '$ops_js_string' )\" style=\"margin-top: 10px; cursor: pointer;\"><img src=\"../pics/btn_delete.png\" width=\"64\" height=\"23\" border=\"0\" alt=\"\"></div>" ;

						$td1 = "td_dept_td" ;

						print "
							<tr>
								<td class=\"$td1\" nowrap>$edit_delete</td>
								<td class=\"$td1\" nowrap>$external[name]</td>
								<td class=\"$td1\">
									<div style=\"margin-bottom: 5px;\"><a href=\"JavaScript:void(0)\" onClick=\"launch_external( '$external[extID]', '$external[url]' )\">$external[url]</a></div>
									$ops_string
								</td>
							</tr>
						" ;
					}
					if ( $c == 0 )
						print "<tr><td colspan=7 class=\"td_dept_td\">Blank results.</td></tr>" ;
				?>
				</table>
				</form>

				<div style="padding: 5px; margin-top: 55px;">
					<a name="a_edit"></a><div class="edit_title">Create/Edit External URL <span class="txt_red"><?php echo $error ?></span></div>
					<div style="margin-top: 5px;">
						<form method="POST" action="extras.php" id="theform">
						<input type="hidden" name="action" value="submit">
						<input type="hidden" name="jump" value="external">
						<input type="hidden" name="extid" id="extid" value="0">
						<div class="info_neutral">
							<table cellspacing=0 cellpadding=5 border=0>
							<tr>
								<td>Display Text (the menu tab name)<br><input type="text" class="input" name="name" id="name" size="50" maxlength="15" value="" autocomplete="off"></td>
							</tr>
							<tr>
								<td>URL<br><input type="text" class="input" name="url" id="url" size="120" maxlength="255" value="" autocomplete="off"></td>
							</tr>
							<tr>
								<td style="padding-top: 15px;">
									<div><img src="../pics/icons/info.png" width="12" height="12" border="0" alt=""> It is recommended that each operator has max 3 external URLs to maintain proper operator console formatting.</div>
									<div style="margin-top: 15px;">Operator(s) who can access this external URL:</div>
									<div id="li_ops" style="margin-top: 5px;" class="info_white">
										<div class="li_op_focus round" style="border: 1px solid #FFFFFF;"><input type="checkbox" id="ck_op_all" name="opids[]" value="all" onClick="check_all(this)"> <label for="ck_op_all" style="cursor: pointer;">Check All</label></div>
										<?php
											for ( $c = 0; $c < count( $operators ); ++$c )
											{
												$operator = $operators[$c] ;

												if ( $operator["name"] != "Archive" )
													print "<div class=\"li_op round\"><input type=\"checkbox\" id=\"ck_op_$operator[opID]\" name=\"opids[]\" value=\"$operator[opID]\" onClick=\"reset_check_all()\"> <label for=\"ck_op_$operator[opID]\" style=\"cursor: pointer;\">$operator[name]</label></div>" ;
											}
										?>
										<div style="clear: both;"></div>
									</div>
								</td>
							</tr>
							<tr>
								<td style="padding-top: 15px;">
									<div id="div_op_online" class="info_warning"><table cellspacing=0 cellpadding=0 border=0><tr><td><img src="../pics/icons/warning.gif" width="16" height="16" border="0" alt="" class="info_white"></td><td style="padding-left: 5px;">If an operator is online, they must logout and login again for the changes to take affect on their operator console.</td></tr></table></div>
									<div style="padding-top: 15px;"><input type="button" value="Submit" onClick="do_submit()" class="btn"> &nbsp; &nbsp; <input type="reset" value="Reset" onClick="$( 'input#extid' ).val(0)" class="btn"></div>
								</td>
							</tr>
							</table>
						</div>
						</form>
					</div>
				</div>
			<?php else: ?>
			<div style="margin-top: 15px;"><span class="info_error"><img src="../pics/icons/warning.png" width="12" height="12" border="0" alt=""> Add an <a href="ops.php" style="color: #FFFFFF;">Operator</a> to access this area.</span></div>
			<?php endif ;?>
		</div>

		<div style="display: none; margin-top: 45px;" id="extras_apis">

			<table cellspacing=0 cellpadding=0 border=0>
			<tr>
				<td><div>API Key: <input type="text" class="input" id="text_api_key" size="10" value="<?php echo $CONF["API_KEY"] ?>" onMouseDown="setTimeout(function(){ $('#text_api_key').select(); }, 200);" readonly></div></td>
				<td style="padding-left: 15px;"><button type="button" onClick="gen_new_key()" class="btn">Generate New API Key</button> &nbsp; The APIs requires the API Key to process the action.</td>
			</tr>
			</table>
			<div style="margin-top: 35px;">
				<div class="info_neutral">
					<div class="td_dept_td">The following API URL returns a 1 (department is online) or 0 (department is offline).</div>
					<div>
						<table cellspacing=0 cellpadding=0 border=0>
						<tr>
							<td class="td_dept_td">
								<select name="deptid" id="deptid" style="width: 200px; font-size: 16px;" onChange="switch_dept_api( this.value, true )">
								<option value="0">All Departments</option>
								<?php
									for ( $c = 0; $c < count( $departments ); ++$c )
									{
										$department = $departments[$c] ;
										if ( $department["name"] != "Archive" )
										{
											$selected = ( $deptid == $department["deptID"] ) ? "selected" : "" ;
											print "<option value=\"$department[deptID]\" $selected>$department[name]</option>" ;
										}
									}
								?>
								</select>
							</td>
							<td class="td_dept_td"><input type="text" class="input" style="background: #CEE0F4;" id="api_status" readonly size="90" value="" onMouseDown="setTimeout(function(){ $('#api_status').select(); }, 200);"></td>
						</tr>
						</table>
					</div>
				</div>

				<div class="info_neutral" style="margin-top: 25px;">
					<div class="td_dept_td">The following API URL will return the number of visitors on your website. (<a href="code.php">Standard Live Chat HTML Code</a> must be on your webpages to track the visitor count)</div>
					<div>
						<table cellspacing=0 cellpadding=0 border=0>
						<tr>
							<td class="td_dept_td">
								<select style="width: 200px; font-size: 16px;">
								<option value="0">All Departments</option>
								</select>
							</td>
							<td class="td_dept_td"><input type="text" class="input" style="background: #CEE0F4;" id="api_traffic" readonly size="90" value="<?php echo ( !preg_match( "/^(http)/", $CONF["BASE_URL"] ) ) ? "http$https:$CONF[BASE_URL]" : $CONF["BASE_URL"] ; ?>/wapis/traffic.php?akey=<?php echo $CONF["API_KEY"] ?>" onMouseDown="setTimeout(function(){ $('#api_traffic').select(); }, 200);"></td>
						</tr>
						</table>
					</div>
				</div>

				<div class="info_neutral" style="margin-top: 25px;">
					<div class="td_dept_td">The following API URL will return the IP's GeoIP location.  The output will be in the format of: <code>country abbreviation,country name,region,city,latitude,longitude</code></div>
					<div>
						<table cellspacing=0 cellpadding=0 border=0>
						<?php if ( $geoip ): ?>
						<tr>
							<td class="td_dept_td">
								<select name="f" id="f" style="width: 200px; font-size: 16px;" onChange="switch_geoip_api( this.value )">
								<option value="csv">Comma Seperated</option>
								<option value="json">Json Format</option>
								</select>
							</td>
							<td class="td_dept_td"><input type="text" class="input" style="background: #CEE0F4;" id="api_geoip" readonly size="90" value="" onMouseDown="setTimeout(function(){ $('#api_geoip').select(); }, 200);"></td>
						</tr>
						<?php else: ?>
						<tr><td class="td_dept_td" style="text-shadow: none;"><span class="info_error"><img src="../pics/icons/warning.png" width="12" height="12" border="0" alt=""> <a href="extras_geo.php" style="color: #FFFFFF;">GeoIP Addon must be enabled.</a></span></td></tr>
						<?php endif ; ?>
						</table>
					</div>
				</div>

			</div>

		</div>
		<?php endif ; ?>

<?php include_once( "./inc_footer.php" ) ?>