<?php
	/***************************************/
	//
	//
	// PHP Live! Support
	//
	// https://www.phplivesupport.com
	//
	/***************************************/
	// STANDARD header for Setup
	if ( !is_file( "../web/config.php" ) ){ HEADER("location: install.php") ; exit ; }
	include_once( "../web/config.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Format.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Error.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/".Util_Format_Sanatize($CONF["SQLTYPE"], "ln") ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Security.php" ) ;
	if ( !$admininfo = Util_Security_AuthSetup( $dbh ) ){ ErrorHandler( 608, "Invalid setup session or session has expired.", $PHPLIVE_FULLURL, 0, Array() ) ; exit ; }
	// STANDARD header end
	/****************************************/

	include_once( "$CONF[DOCUMENT_ROOT]/API/Depts/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Ops/get.php" ) ;

	$action = Util_Format_Sanatize( Util_Format_GetVar( "action" ), "ln" ) ;
	$error = "" ;

	if ( !isset( $CONF["screen"] ) ) { $CONF["screen"] = "same" ; }
	$console = ( isset( $VALS["console"] ) && $VALS["console"] ) ? $VALS["console"] : "auto" ;

	if ( $action == "screen" )
	{
		include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Vals.php" ) ;
		$screen = Util_Format_Sanatize( Util_Format_GetVar( "screen" ), "ln" ) ;

		if ( $CONF["screen"] != $screen )
		{
			$error = ( Util_Vals_WriteToConfFile( "screen", $screen ) ) ? "" : "Could not write to config file." ;
			$CONF["screen"] = $screen ;
		}
	}

	$screen_same = ( $CONF["screen"] == "same" ) ? "checked" : "" ;
	$screen_separate = ( $screen_same == "checked" ) ? "" : "checked" ;

	$operators = Ops_get_AllOps( $dbh ) ;
	$total_operators = 0 ;
	for ( $c = 0; $c < count( $operators ); ++$c )
	{
		$operator = $operators[$c] ;
		if ( $operator["login"] != "phplivebot" )
			++$total_operators ;
	}

	$departments = Depts_get_AllDepts( $dbh ) ;
	$ops_assigned = 0 ;
	for ( $c = 0; $c < count( $departments ); ++$c )
	{
		$department = $departments[$c] ;
		$ops = Depts_get_DeptOps( $dbh, $department["deptID"] ) ;
		if ( count( $ops ) )
			$ops_assigned = 1 ;
	}

	$login_url = $CONF['BASE_URL'] ;
	if ( !preg_match( "/\/\//", $login_url ) ) { $login_url = "//$PHPLIVE_HOST$login_url" ; }
?>
<?php include_once( "../inc_doctype.php" ) ?>
<head>
<title> PHP Live! Support </title>

<meta name="description" content="PHP Live! Support <?php echo $VERSION ?>">
<meta name="keywords" content="powered by: PHP Live!  www.phplivesupport.com">
<meta name="robots" content="all,index,follow">
<meta http-equiv="content-type" content="text/html; CHARSET=utf-8"> 
<?php include_once( "../inc_meta_dev.php" ) ; ?>

<link rel="Stylesheet" href="../css/setup.css?<?php echo filemtime( "../css/setup.css" ) ?>">
<script data-cfasync="false" type="text/javascript" src="../js/global.js?<?php echo filemtime ( "../js/global.js" ) ; ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../js/framework.js?<?php echo $VERSION ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../js/jquery_md5.js?<?php echo $VERSION ?>"></script>

<script data-cfasync="false" type="text/javascript">
<!--
	"use strict" ;
	var global_console = "<?php echo $console ?>" ;

	$(document).ready(function()
	{
		$("html, body").css({'background': '#F2F3F5'}) ;
		init_menu() ;
		toggle_menu_setup( "online" ) ;

		<?php if ( $action && !$error ): ?>
		do_alert( 1, "Update Success" ) ;
		<?php elseif ( $error ): ?>
		do_alert( 0, "<?php echo $error ?>" ) ;
		<?php endif ; ?>

		$('#urls_<?php echo $CONF["screen"] ?>').show() ;
	});

	function confirm_console( thevalue )
	{
		if ( global_console != thevalue )
		{
			var json_data = new Object ;

			$.ajax({
				type: "POST",
				url: "../ajax/setup_actions.php",
				data: "action=update_console&value="+thevalue,
				success: function(data){
					global_console = thevalue ;
					do_alert( 1, "Update Success" ) ;
				}
			});
		}
	}

	function toggle_prefs()
	{
		if ( $('#div_prefs').is(':visible') )
		{
			$('#div_prefs').hide() ;
		}
		else
		{
			$('#div_prefs').show() ;
		}
	}
//-->
</script>
</head>
<?php include_once( "./inc_header.php" ) ?>

		<?php
			if ( !$admininfo["isadmin"] && ( count( $admininfo["access"] ) && !isset( $admininfo["access"]["ops"] ) ) ):
			include_once( "$CONF[DOCUMENT_ROOT]/setup/inc_access.php" ) ; else:
		?>

		<div style="">
			<?php if ( !count( $departments ) ): ?>
			<span class="info_error"><img src="../pics/icons/warning.png" width="12" height="12" border="0" alt=""> Add a <a href="depts.php" style="color: #FFFFFF;">Department</a> to access this area.</span>
			<?php elseif ( !$total_operators ): ?>
			<span class="info_error"><img src="../pics/icons/warning.png" width="12" height="12" border="0" alt=""> Add an <a href="ops.php" style="color: #FFFFFF;">Operator</a> to access this area.</span>
			<?php elseif ( !$ops_assigned ): ?>
			<span class="info_error"><img src="../pics/icons/warning.png" width="12" height="12" border="0" alt=""> <a href="ops.php?jump=assign" style="color: #FFFFFF;">Assign an operator to a department</a> to access this area.</span>
			<?php else: ?>

			<div style=""><span class="info_neutral" id="span_search_trans" style="cursor: pointer;" onClick="toggle_prefs()"><img src="../pics/icons/settings.png" width="16" height="16" border="0" alt="" style="vertical-align: middle;"> Preferences</span></div>
			<div class="info_info" id="div_prefs" style="display: none;">
				<table cellspacing=0 cellpadding=0 border=0 width="100%">
				<tr>
					<td valign="top" width="30%">
						<div class="title" style="margin-bottom: 5px;">Login URL</div>
						Choose whether to display the operator login and the Setup Admin login screens on the same URL or separate URLs.
						<div style="margin-top: 10px;">
							<span class="info_neutral" style="padding: 5px; cursor: pointer;" onclick="$('#screen_one').prop('checked', true); location.href='go_online.php?action=screen&screen=same';"><input type="radio" name="screen" id="screen_one" value="same" <?php echo $screen_same ?>> Same URL</span>
							<span class="info_neutral" style="margin-left: 5px; padding: 5px; cursor: pointer;" onclick="$('#screen_two').prop('checked', true); location.href='go_online.php?action=screen&screen=separate';"><input type="radio" name="screen" id="screen_two" value="separate" <?php echo $screen_separate ?>> Separate URLs</span>
						</div>
					</td>
					<td style="padding-left: 10px; border-right: 1px solid #C9C9C9;">&nbsp;</td>
					<td valign="top" style="padding-left: 15px;">
						<div class="title" style="margin-bottom: 5px;">Open Console Automatically</div>
							<div>
								<table cellspacing=0 cellpadding=0 border=0>
								<tr>
									<td onclick="$('#console_auto').prop('checked', true); confirm_console('auto');" style="cursor: pointer; padding-right: 15px;"><input type="radio" name="console" id="console_auto" value="UTF-8" <?php echo ( $console == "auto" ) ? "checked" : "" ?>></td>
									<td><div style=""><b>Automatic</b> (recommended) - After the operator logs into their account, automatically open the operator console and set their status online, ready to accept chat requests.</div></td>
								</tr>
								</table>
							</div>
							<div style="margin-top: 10px;">
								<table cellspacing=0 cellpadding=0 border=0>
								<tr>
									<td onclick="$('#console_choose').prop('checked', true); confirm_console('choose');" style="cursor: pointer; padding-right: 15px;"><input type="radio" name="console" id="console_choose" value="choose" <?php echo ( $console == "choose" ) ? "checked" : "" ?>></td>
									<td style=""><div style=""><b>Tabbed or Popup</b> - After the operator logs into their account, <b>their status will not be automatically switched online.</b>  The operator must click the option to open the operator console in a tabbed window or popup window.  <b>Note:</b> The best method for poup console is to utilize the Chrome App because Chrome App will also create an icon on the desktop.  For more information about Chrome App, please visit the <a href="https://www.phplivesupport.com/r.php?r=chromeapp" target="_blank">Chrome App how-to page</a>.</div></td>
								</tr>
								</table>
							</div>
						</div>
					</td>
				</tr>
				</table>
			</div>

			<div style="margin-top: 35px;">
				<table cellspacing=0 cellpadding=0 border=0>
				<tr>
					<td><img src="../pics/icons/bulb_big.png" width="38" height="38" border="0" alt=""></td>
					<td style="padding-left: 5px; font-size: 24px;">Go online!</td>
				</tr>
				</table>
				<div id="urls_same" class="info_info" style="display: none;">
					<div style="font-size: large;"><img src="../pics/icons/user_chat_big.png" width="24" height="24" border="0" alt=""> <img src="../pics/icons/settings_big.png" width="24" height="24" border="0" alt=""> <b>Operator and Setup Admin Login URL</b></div>

					<div style="margin-top: 15px; font-size: 32px; font-weight: bold; box-shadow: rgba(100, 100, 111, 0.2) 0px 7px 29px 0px;" class="info_white"><a href="<?php echo ( !preg_match( "/^(http)/", $CONF["BASE_URL"] ) ) ? "http$https:$login_url" : $login_url ; ?>" target="new" style="color: #1DA1F2;" class="nounder"><?php echo ( !preg_match( "/^(http)/", $login_url ) ) ? "http$https:$login_url" : $login_url ; ?></a></div>
					<div style="margin-top: 15px; font-size: larger;"><span class="info_misc" style="box-shadow: rgba(0, 0, 0, 0.16) 0px 10px 36px 0px, rgba(0, 0, 0, 0.06) 0px 0px 0px 1px;">Provide the above URL to your <a href="ops.php">chat operators</a>.</span>  They will need to login at the above URL to go online and to receive visitor chat requests.</div>
				</div>
				<div id="urls_separate" style="display: none;">
					<div class="info_info">
						<div style="font-size: large;"><img src="../pics/icons/user_chat_big.png" width="24" height="24" border="0" alt=""> <b>Operator Login URL</b></div>

						<div style="margin-top: 15px; font-size: 32px; font-weight: bold; box-shadow: rgba(100, 100, 111, 0.2) 0px 7px 29px 0px;" class="info_white"><a href="<?php echo ( !preg_match( "/^(http)/", $login_url ) ) ? "http$https:$login_url" : $login_url ; ?>" target="new" style="color: #1DA1F2;" class="nounder"><?php echo ( !preg_match( "/^(http)/", $login_url ) ) ? "http$https:$login_url" : $login_url ; ?></a></div>
						<div style="margin-top: 15px; font-size: larger;"><span class="info_misc" style="box-shadow: rgba(0, 0, 0, 0.16) 0px 10px 36px 0px, rgba(0, 0, 0, 0.06) 0px 0px 0px 1px;">Provide the above URL to your <a href="ops.php">chat operators</a>.</span>  They will need to login at the above URL to go online and to receive visitor chat requests.</div>
					</div>

					<div class="info_info" style="margin-top: 55px;">
						<div style="font-size: large;"><img src="../pics/icons/settings_big.png" width="24" height="24" border="0" alt=""> <b>Setup Admin Login URL</b></div>
						<div style="margin-top: 15px; font-size: 32px; font-weight: bold; box-shadow: rgba(100, 100, 111, 0.2) 0px 7px 29px 0px;" class="info_white"><a href="<?php echo ( !preg_match( "/^(http)/", $login_url ) ) ? "http$https:$login_url" : $login_url ; ?>/setup" target="new" style="color: #1DA1F2;" class="nounder"><?php echo ( !preg_match( "/^(http)/", $login_url ) ) ? "http$https:$login_url" : $login_url ; ?>/setup</a></div>
					</div>
				</div>
			</div>

			<div style="margin-top: 25px;" class="info_box"><img src="../pics/icons/info.png" width="16" height="16" border="0" alt=""> <b>Important:</b> If you have not done so already, copy/paste the <a href="./code.php">Chattalooga HTML Code</a> onto your webpages.</div>
			<?php endif ; ?>
		</div>
		<?php endif ; ?>

<?php include_once( "./inc_footer.php" ) ?>