<?php
	/***************************************/
	//
	//
	// PHP Live! Support
	//
	// https://www.phplivesupport.com
	//
	/***************************************/
	// STANDARD header for Setup
	if ( !is_file( "../web/config.php" ) ){ HEADER("location: install.php") ; exit ; }
	include_once( "../web/config.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Format.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Error.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/".Util_Format_Sanatize($CONF["SQLTYPE"], "ln") ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Util_Security.php" ) ;
	if ( !$admininfo = Util_Security_AuthSetup( $dbh ) ){ ErrorHandler( 608, "Invalid setup session or session has expired.", $PHPLIVE_FULLURL, 0, Array() ) ; exit ; }
	// STANDARD header end
	/****************************************/

	$error = "" ;

	include_once( "$CONF[DOCUMENT_ROOT]/API/Ops/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Depts/get.php" ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/API/Canned/get.php" ) ;

	$page = Util_Format_Sanatize( Util_Format_GetVar( "page" ), "n" ) ;
	$action = Util_Format_Sanatize( Util_Format_GetVar( "action" ), "ln" ) ;
	$option = Util_Format_Sanatize( Util_Format_GetVar( "option" ), "n" ) ;
	$deptid = Util_Format_Sanatize( Util_Format_GetVar( "deptid" ), "ln" ) ; if ( !$deptid ) { $deptid = 0 ; }
	$canid = Util_Format_Sanatize( Util_Format_GetVar( "canid" ), "n" ) ;
	$bgcolor = Util_Format_Sanatize( Util_Format_GetVar( "bgcolor" ), "ln" ) ;

	$departments = Depts_get_AllDepts( $dbh ) ;
	$operators = Ops_get_AllOps( $dbh ) ;

	if ( $action === "update" )
	{
		include_once( "$CONF[DOCUMENT_ROOT]/API/Canned/get.php" ) ;
		include_once( "$CONF[DOCUMENT_ROOT]/API/Canned/put.php" ) ;

		$sub_deptid = Util_Format_Sanatize( Util_Format_GetVar( "sub_deptid" ), "n" ) ; // original deptid (due to deparment selection dropdown)

		$title = Util_Format_Sanatize( Util_Format_GetVar( "title" ), "ln" ) ;
		$message = Util_Format_ConvertQuotes( Util_Format_Sanatize( Util_Format_GetVar( "message" ), "htmltags" ) ) ;
		$own = Util_Format_Sanatize( Util_Format_GetVar( "own" ), "n" ) ;
		$catid = -1 ;

		if ( preg_match( "/_/", $deptid ) )
			LIST( $deptid, $catid ) = explode( "_", $deptid ) ;

		$caninfo = Canned_get_CanInfo( $dbh, $canid ) ;
		if ( isset( $caninfo["opID"] ) )
		{
			$opid = $caninfo["opID"] ;
			$cats_extra = $caninfo["cats_extra"] ;
			if ( $caninfo["opID"] != 1111111111 )
			{
				$deptid = $caninfo["deptID"] ;
				$catid = $caninfo["catID"] ;
			}
		}
		else
		{
			$opid = 1111111111 ;
			$cats_extra = "" ;
		}

		if ( !$canid = Canned_put_Canned( $dbh, $canid, $opid, $deptid, $catid, $cats_extra, $title, $message ) )
			$error = "Error processing canned message." ;
		else if ( $own && isset( $caninfo["canID"] ) )
		{
			include_once( "$CONF[DOCUMENT_ROOT]/API/Canned/update.php" ) ;
			Canned_update_CanOwner( $dbh, $canid, $caninfo["opID"], 1111111111 ) ;
		}
		$deptid = $sub_deptid ;
	}
	else if ( $action === "delete" )
	{
		include_once( "$CONF[DOCUMENT_ROOT]/API/Canned/get.php" ) ;
		include_once( "$CONF[DOCUMENT_ROOT]/API/Canned/remove.php" ) ;

		$canid = Util_Format_Sanatize( Util_Format_GetVar( "canid" ), "n" ) ;

		$caninfo = Canned_get_CanInfo( $dbh, $canid ) ;
		Canned_remove_Canned( $dbh, $caninfo["opID"], $canid ) ;
		$canid = 0 ;
	}

	$deptinfo = Depts_get_DeptInfo( $dbh, $deptid ) ;
	include_once( "$CONF[DOCUMENT_ROOT]/lang_packs/".Util_Format_Sanatize($deptinfo["lang"], "ln").".php" ) ;
	$deptname = $deptinfo["name"] ;

	// make hash for quick refrence
	$operators_hash = Array() ;
	$operators_hash[1111111111] = "<img src=\"../pics/icons/lock.png\" width=\"16\" height=\"16\" border=\"0\" title=\"Setup Admin\" title=\"Setup Admin\">" ;
	for ( $c = 0; $c < count( $operators ); ++$c )
	{
		$operator = $operators[$c] ;
		$operators_hash[$operator["opID"]] = $operator["name"] ;
	}

	// make hash for quick refrence
	$dept_hash = Array() ;
	$dept_hash[1111111111] = "All Departments" ;
	for ( $c = 0; $c < count( $departments ); ++$c )
	{
		$department = $departments[$c] ;
		$dept_hash[$department["deptID"]] = $department["name"] ;
	}
	$cans = Canned_get_DeptCanned( $dbh, $deptid, $page, 300 ) ;

	// make hash for quick refrence
	$can_cats_prefill = "{ \"1111111111\":[], " ;
	$dept_hash = Array() ;
	$dept_hash[1111111111] = "All Departments" ;
	for ( $c = 0; $c < count( $departments ); ++$c )
	{
		$department = $departments[$c] ;
		$dept_hash[$department["deptID"]] = $department["name"] ;

		$can_cats_prefill .= " \"$department[deptID]\":[], " ;
	} $can_cats_prefill = preg_replace( "/, $/", "", $can_cats_prefill ) ;
	$can_cats_prefill .= " }" ;
?>
<?php include_once( "../inc_doctype.php" ) ?>
<head>
<title> PHP Live! Support </title>

<meta name="description" content="PHP Live! Support <?php echo $VERSION ?>">
<meta name="keywords" content="powered by: PHP Live!  www.phplivesupport.com">
<meta name="robots" content="all,index,follow">
<meta http-equiv="content-type" content="text/html; CHARSET=<?php echo $LANG["CHARSET"] ?>">
<?php include_once( "../inc_meta_dev.php" ) ; ?>

<link rel="Stylesheet" href="../css/setup.css?<?php echo filemtime( "../css/setup.css" ) ?>">
<script data-cfasync="false" type="text/javascript" src="../js/global.js?<?php echo filemtime ( "../js/global.js" ) ; ?>"></script>
<script data-cfasync="false" type="text/javascript" src="../js/framework.js?<?php echo $VERSION ?>"></script>

<script data-cfasync="false" type="text/javascript">
<!--
	var global_canid ; var global_top ;
	var winname = unixtime() ;
	var option = <?php echo $option ?> ; // used to communicate with depts.php to toggle iframe
	var cans = [] ;
	var cats_backup = {} ; var cats = new Object ;
	if ( typeof( JSON ) != "undefined" )
	{
		try{
			cats_backup = ( <?php echo ( isset( $VALS["can_cats"] ) && $VALS["can_cats"] ) ? 1 : 0 ; ?>  ) ? JSON.parse( decodeURIComponent( "<?php echo ( isset( $VALS["can_cats"] ) && $VALS["can_cats"] ) ? rawurlencode( base64_decode( $VALS["can_cats"] ) ) : "" ; ?>" ) ) : JSON.parse( '<?php echo $can_cats_prefill ?>' ) ;
		} catch(e){ }
		cats = jQuery.extend( true, {}, cats_backup ) ;
	}
	var global_can_exists = 0 ;

	$(document).ready(function()
	{
		$.ajaxSetup({ cache: false }) ;
		$("body, html").css({'background-color': '#<?php echo $bgcolor ?>'}) ;

		init_total_cat_cans() ;
		update_sort(<?php echo $deptid ?>) ;

		<?php if ( ( $action === "update" ) && !$error ): ?>
		parent.do_alert( 1, "Update Success" ) ;
		<?php elseif ( $error ): ?>
		parent.do_alert( 0, "<?php echo $error ?>" ) ;
		<?php endif ; ?>

		if ( <?php echo $canid ?> )
		{
			var div_pos = $('#tr_div_'+<?php echo $canid ?>).offset() ;
			var div_height = $('#tr_div_'+<?php echo $canid ?>).height() ;
			var scroll_to = div_pos.top ;

			$('html, body').animate({
				scrollTop: scroll_to
			}, 200) ;
			$('#tr_div_'+<?php echo $canid ?>).fadeOut("fast").fadeIn("fast").fadeOut("fast").fadeIn("fast").fadeOut("fast").fadeIn("fast").fadeOut("fast").fadeIn("fast") ;
		}
	});

	function do_submit()
	{
		var title = $('#title').val() ;
		var deptid = $('#deptid').val() ;
		var message = $('#message').val() ;

		if ( !parseInt( deptid ) )
			do_alert( 0, "Please select a Department." ) ;
		else if ( title == "" )
			do_alert( 0, "Please provide a Title." ) ;
		else if ( message == "" )
			do_alert( 0, "Please provide a Message." ) ;
		else
			$('#theform').submit() ;
	}

	function do_delete( thepos, thecanid )
	{
		var top = thepos.top - 55 ;
		var left = thepos.left - 10 ;
		var width = $('#tr_div_'+thecanid).outerWidth() - 100 ;

		global_canid = thecanid ;

		$('#div_notice_delete').css({'top': top, 'left': left, 'width': '97%'}).fadeIn("fast") ;
	}

	function do_delete_doit()
	{
		location.href = "iframe_edit_3.php?action=delete&sub=canned&deptid=<?php echo $deptid ?>&canid="+global_canid+"&option=<?php echo $option ?>&bgcolor=<?php echo $bgcolor ?>&"+unixtime() ;
	}

	function toggle_new( theflag )
	{
		// theflag = 1 means force show, not toggle
		if ( $('#canned_box_new').is(':visible') && !theflag )
		{
			$( "input#canid" ).val( 0 ) ;
			$( "input#title" ).val( "" ) ;
			$( "#deptid" ).val( <?php echo $deptid ?> ) ;
			$( "#message" ).val( "" ) ;

			$('#canned_box_new').hide() ;
			$('#canned_list').show() ;

			$('body,html').scrollTop(global_top) ;
			global_top = 0 ;
		}
		else
		{
			print_dept_select() ;

			$('#canned_list').hide() ;
			$('#div_deptid').show() ;
			$('#canned_box_new').show() ;
		}

		$('#title').focus() ;
	}

	function do_edit( thecanid, theopid, thetitle, thedeptid, thecatid, themessage )
	{
		print_dept_select() ; // build the select before setting

		var deptid_select = ( parseInt( thecatid ) != -1 ) ? thedeptid+"_"+thecatid+"_" : thedeptid ;
		global_top = $('body,html').scrollTop() ;

		if ( theopid != 1111111111 )
		{
			$('#deptid').val( thedeptid ) ;
			$('#div_deptid').hide() ;
			$('#span_op_owner').html( $('#td_op_owner_'+thecanid).text() ) ;
			$('#div_op_owner').show() ;
		}
		else
		{
			$('#deptid').val( deptid_select ) ;
			$('#div_deptid').show() ;
			$('#div_op_owner').hide() ;
		}

		$( "input#canid" ).val( thecanid ) ;
		$( "input#title" ).val( thetitle.replace( /&-#39;/g, "'" ) ) ;
		$( "#message" ).val( themessage.replace(/<br>/g, "\r\n").replace( /&-#39;/g, "'" ) ) ;

		$('#canned_list').hide() ;
		$('#canned_box_new').show() ;

		$('#title').focus() ;
	}

	var caninfo = new Object ;
	<?php
		$global_can_exists = 0 ;
		for ( $c = 0; $c < count( $cans ); ++$c )
		{
			$caninfo = $cans[$c] ;
			$cats_extra = Array() ;
			$title = preg_replace( "/\"/", "&quot;", preg_replace( "/'/", "&-#39;", $caninfo["title"] ) ) ;
			$title_display = Util_Format_ConvertQuotes( $caninfo["title"] ) ;

			if ( $caninfo["deptID"] == 1111111111 ) { $global_can_exists = 1 ; }

			if ( isset( $dept_hash[$caninfo["deptID"]] ) )
			{
				$message = preg_replace( "/\"/", "&quot;", preg_replace( "/((')|(&apos;)|(&#39;))/", "&-#39;", preg_replace( "/(\r\n)|(\n)|(\r)/", "<br>", $caninfo["message"] ) ) ) ;
				$message = preg_replace( "/▒~@▒/", "", $message ) ;
				$message_display = preg_replace( "/\"/", "&quot;", preg_replace( "/(\r\n)|(\n)|(\r)/", "<br>", Util_Format_ConvertTags( $caninfo["message"] ) ) ) ;

				$this_opid = $caninfo["opID"] ;
				$this_deptid = $caninfo["deptID"] ;
				$catid = $caninfo["catID"] ;

				$op_name = ( $this_opid != 1111111111 ) ? "<span class='info_login'>".$operators_hash[$this_opid]."</span>" : $operators_hash[$this_opid] ;
				$dept_name = $dept_hash[$this_deptid] ;

				$edit_delete = "<div><a href=\"JavaScript:void(0)\" onClick=\"do_edit($caninfo[canID], $this_opid, '$title', '$this_deptid', '$catid', '$message')\"><img src=\"../pics/btn_edit.png\" width=\"64\" height=\"23\" border=\"0\" alt=\"\"></a></div><div style=\"margin-top: 5px;\"><a href=\"JavaScript:void(0)\" onClick=\"do_delete($(this).offset(), $caninfo[canID])\"><img src=\"../pics/btn_delete.png\" width=\"64\" height=\"23\" border=\"0\" alt=\"\"></a></div>" ;

				$can_string = "<tr id=\"tr_div_$caninfo[canID]\" style=\"background: #%%bg_color%%\" name=\"tr_dept_{$this_deptid}_{$catid}_\"><td class=\"td_dept_td\" nowrap align=\"center\">$edit_delete</td><td class=\"td_dept_td\" nowrap><span id=\"span_title_$caninfo[canID]\" style=\"text-shadow: none;\"><b>%%title%%</b></span></td><td class=\"td_dept_td\" nowrap style=\"text-shadow: none;\" id=\"td_op_owner_$caninfo[canID]\">$op_name</td><td class=\"td_dept_td\" nowrap style=\"text-shadow: none;\">$dept_name%%cat_string%%</td><td class=\"td_dept_td\" style=\"padding-right: 25px;\"><div id=\"canned_message_$caninfo[canID]\" style=\"max-height: 200px; overflow: auto; text-shadow: none;\">%%message%%</div></td></tr>" ;

				print "caninfo['template'] = \"".rawurlencode($can_string)."\" ; caninfo['title'] = \"".rawurlencode($title_display)."\" ; caninfo['message'] = \"".rawurlencode($message_display)."\" ; cans.push(caninfo) ; caninfo = new Object ; " ;
			}
		}
		print "global_can_exists = $global_can_exists ; " ;
	?>

	function print_dept_select()
	{
		$('#deptid').empty() ;
		$('#div_op_owner').hide() ;
		$('#own').prop( "checked", false ) ;

		<?php
			for ( $c = 0; $c < count( $departments ); ++$c )
			{
				$department = $departments[$c] ;
				if ( $department["deptID"] == $deptid )
				{
					print "var total_cans = ( typeof( total_cat_cans['tr_dept_".$department["deptID"]."_'] ) != \"undefined\" ) ? ' ('+total_cat_cans['tr_dept_".$department["deptID"]."_']+')' : \"\" ; " ;
					print "\$('#deptid').append('<option value=\"".$department["deptID"]."\">".$department["name"]."</option>') ; print_dept_cats_select( $department[deptID] ) ; " ;
				}
			}
			print "var total_cans = ( typeof( total_cat_cans['tr_dept_1111111111_'] ) != \"undefined\" ) ? \" (\"+total_cat_cans['tr_dept_1111111111_']+\")\" : \"\" ; " ;
			print "\$('#deptid').append('<option value=\"1111111111\">All Departments - make this canned response available in all departments</option>') ; print_dept_cats_select( 1111111111 ) ; " ;
		?>
	}

	function print_dept_cats_select( thedeptid )
	{
		var cats_array = cats[thedeptid] ;

		if ( typeof( cats_array ) != "undefined" )
		{
			for ( var c = 0; c < cats_array.length; ++c )
			{
				var tr_id = 'tr_dept_'+thedeptid+'_'+c+'_' ;
				var total_cans = ( typeof( total_cat_cans[tr_id] ) != "undefined" ) ? " ("+total_cat_cans[tr_id]+")" : "" ;

				$('#deptid').append('<option value="'+thedeptid+'_'+c+'_">&nbsp; &nbsp; &nbsp; '+cats_array[c]+'</option>') ;
			}
		}
	}

	function update_sort( thedeptid )
	{
		var counter = 0 ;
		var bg_color = "" ; var can_string = "" ; var output = "" ;

		global_deptid = thedeptid ;

		var thisdeptid = global_deptid ;
		if ( global_deptid.toString().match( /_/g ) )
		{
			var temp_array = global_deptid.toString().split( "_" ) ;
			thisdeptid = parseInt( temp_array[0] ) ;
		}

		for ( var c = 0; c < cans.length; ++c )
		{
			var caninfo = cans[c] ;
			var template = decodeURIComponent( caninfo["template"] ) ;
			var title = decodeURIComponent( caninfo["title"] ) ;
			var message = decodeURIComponent( caninfo["message"] ) ;

			var matches = template.match( /tr_dept_(.*?)_(.*?)_/i ) ;
			var tempdeptid = ( ( typeof( matches[1] ) != "undefined" ) && ( matches[1] != "" ) ) ? parseInt( matches[1] ) : "" ;
			var thiscatid = ( ( typeof( matches[2] ) != "undefined" ) && ( matches[2] != "" ) ) ? parseInt( matches[2] ) : "" ;
			var cat_name = ( ( typeof( cats[tempdeptid] ) != "undefined" ) && ( typeof( cats[tempdeptid][thiscatid] ) != "undefined" ) ) ? "<div style=\"text-shadow: none;\" class=\"\"><img src=\"../themes/initiate/category.png\" width=\"16\" height=\"16\" border=0 alt=\"category\" title=\"category\"> "+cats[tempdeptid][thiscatid]+"</div>" : "" ;

			var tr_id = "tr_dept_"+global_deptid+"_" ; tr_id = tr_id.replace( /__/, "_" ) ;
			var tr_id_regex = new RegExp( tr_id, "i" ) ;

			var tr_id_all = "tr_dept_1111111111_" ; tr_id_all = tr_id_all.replace( /__/, "_" ) ;
			var tr_id_all_regex = new RegExp( tr_id_all, "i" ) ;

			if ( !parseInt( thisdeptid ) || ( template.match( tr_id_regex ) ) || ( template.match( tr_id_all_regex ) ) )
			{
				bg_color = !( counter % 2 ) ? "FFFFFF" : "EDEDED" ; ++counter ;

				can_string = template.replace( /%%title%%/, title ).replace( /%%message%%/, message ).replace( /%%bg_color%%/, bg_color ) ;
				can_string = can_string.replace( /%%cat_string%%/, cat_name ) ;

				output += can_string ;
			}
		}
		$('#tbody_canned_list').hide().html( output ).fadeIn("slow") ;
	}

	var total_cat_cans = new Object ;
	function init_total_cat_cans()
	{
		for ( var c = 0; c < cans.length; ++c )
		{
			var caninfo = cans[c] ;
			var template = decodeURIComponent( caninfo["template"] ) ;
			var title = decodeURIComponent( caninfo["title"] ) ;
			var message = decodeURIComponent( caninfo["message"] ) ;

			var matches = template.match( /tr_dept_(.*?)_(.*?)_/i ) ;
			var tempdeptid = ( ( typeof( matches[1] ) != "undefined" ) && ( matches[1] != "" ) ) ? parseInt( matches[1] ) : "" ;
			var thiscatid = ( ( typeof( matches[2] ) != "undefined" ) && ( matches[2] != "" ) ) ? parseInt( matches[2] ) : "" ;

			var thedeptid = ( parseInt( thiscatid ) != -1 ) ? tempdeptid+"_"+thiscatid+"_" : tempdeptid ;

			var tr_id = "tr_dept_"+thedeptid+"_" ; tr_id = tr_id.replace( /__/, "_" ) ;

			if ( typeof( total_cat_cans[tr_id] ) == "undefined" )
				total_cat_cans[tr_id] = 0 ;
			++total_cat_cans[tr_id] ;

			if ( parseInt( thiscatid ) != -1 )
			{
				tr_id = tr_id.replace( /^tr_dept_(.*?)_(.*?)_$/, "tr_dept_"+tempdeptid+"_" ) ;
				if ( typeof( total_cat_cans[tr_id] ) == "undefined" )
					total_cat_cans[tr_id] = 0 ;
				++total_cat_cans[tr_id] ;
			}
		}
	}
//-->
</script>
</head>
<body style="">

<div id="iframe_body" style="height: 440px; <?php echo ( $bgcolor ) ? "background: #$bgcolor;" : "" ?>">
	<div id="canned_list" style="overflow: auto;">
		<table cellspacing=0 cellpadding=0 border=0>
		<tr>
			<td><div id="div_new_canned_<?php echo $deptid ?>" class="edit_focus" style="" onClick="toggle_new(1)"><img src="../pics/icons/add.png" width="16" height="16" border="0" alt=""> Add Canned Response</div></td>
			<td style="padding-left: 10px;">Canned responses created here will be available to all operators assigned to this department.  They will not be able to edit the messages but can use the canned responses during a chat session.  Additionally, <a href="dept_canned_cats.php" target="_parent">shared canned categories</a> can also be created.</td>
		</tr>
		</table>

		<table cellspacing=0 cellpadding=0 border=0 width="100%" style="margin-top: 15px;">
		<tr>
			<td width="55" nowrap><div class="td_dept_header">&nbsp;</div></td>
			<td width="120" nowrap><div class="td_dept_header">Title</div></td>
			<td width="100" nowrap><div class="td_dept_header">Created By</div></td>
			<td width="180"><div class="td_dept_header">Department</div></td>
			<td><div class="td_dept_header">Message</div></td>
		</tr>
		<tbody id="tbody_canned_list"></tbody>
		</table>
		<div class="chat_info_end"></div>
	</div>
	<div id="canned_box_new" style="display: none;" class="info_info">
		<a href="JavaScript:void(0)" onClick="toggle_new(0)" style="text-decoration: none;">&larr; back</a>
		<form method="POST" action="iframe_edit_3.php" id="theform" accept-charset="<?php echo $LANG["CHARSET"] ?>">
		<div style="margin-top: 15px;">
			<table cellspacing=0 cellpadding=0 border=0 width="100%">
			<tr>
				<td width="100%">
					<input type="hidden" name="action" value="update">
					<input type="hidden" name="sub" value="<?php echo $action ?>">
					<input type="hidden" name="sub_deptid" value="<?php echo $deptid ?>">
					<input type="hidden" name="option" value="<?php echo $option ?>">
					<input type="hidden" name="canid" id="canid" value="0">
					<input type="hidden" name="bgcolor" value="<?php echo $bgcolor ?>">
					<div>
						Reference (example: "Welcome greeting", "Just a moment")<br>
						<input type="text" name="title" id="title" class="input" style="width: 98%; margin-bottom: 10px;" maxlength="25" onKeydown="input_text_listen_prevent(event);" autocomplete="off"><br>
						<div id="div_deptid">
							Available to all operators assigned to department:<br>
							<select name="deptid" id="deptid" style="width: 99%; margin-bottom: 10px;"></select><br>
						</div>
						Canned Message<br>
						<textarea name="message" id="message" class="input" rows="5" style="width: 98%; resize: vertical;" wrap="virtual"></textarea><br>

						<div id="div_op_owner" style="display: none; margin-top: 15px;">
							<div class="info_login">This canned response is available only to operator <span id="span_op_owner" style="font-weight: bold;"></span>.  Updating the department is not available for this canned response.</div>
							<div style="margin-top: 15px;">
								<table cellspacing=0 cellpadding=0 border=0><tr><td><input type="checkbox" name="own" id="own" value=1></td><td style="padding-left: 5px;"> <label for="own">Check this box to take ownership of the canned response.</label></td></tr></table>
							</div>
						</div>
						<div style="margin-top: 15px;">
							<button type="button" onClick="do_submit()" class="btn">Submit</button> &nbsp; &nbsp; &nbsp; <a href="JavaScript:void(0)" onClick="toggle_new(0)">cancel</a>
						</div>
					</div>
				</td>
				<td style="padding-left: 25px;" valign="bottom" nowrap>
					Variables that will be pre-populated:
					<div style="margin-top: 5px; padding-bottom: 50px;">
						<div><span class="variable">%%visitor%%</span> = visitor's name</div>
						<div style="margin-top: 3px;"><span class="variable">%%operator%%</span> = your name</div>
						<div style="margin-top: 3px;"><span class="variable">%%op_email%%</span> = your email</div>
						<div style="margin-top: 3px;"><span class="variable">%%chatid%%</span> = chat ID of the chat session</div>
					</div>
				</td>
			</tr>
			</table>
		</div>
		</form>
	</div>
</div>

<div id="div_notice_delete" style="display: none; position: absolute; text-align: justify;" class="info_error">
	<div style="padding: 10px;">
		<span class="edit_title">Really delete this canned response?</span> &nbsp; &nbsp; &nbsp; <button type="button" onClick="do_delete_doit()" class="btn">Delete</button> &nbsp; &nbsp; &nbsp; <a href="JavaScript:void(0)" style="color: #FFFFFF" onClick="$('#div_notice_delete').fadeOut('fast');global_mapid='';">cancel</a>
	</div>
</div>

</body>
</html>