<?php
	if ( defined( 'API_Util_Hash' ) ) { return ; }
	define( 'API_Util_Hash', true ) ;

	FUNCTION Util_Hash_Timezones()
	{
		$timezones = Array( 'Africa/Abidjan', 'Africa/Accra', 'Africa/Addis_Ababa', 'Africa/Algiers', 'Africa/Asmara', 'Africa/Bamako', 'Africa/Bangui', 'Africa/Banjul', 'Africa/Bissau', 'Africa/Blantyre', 'Africa/Brazzaville', 'Africa/Bujumbura', 'Africa/Cairo', 'Africa/Casablanca', 'Africa/Ceuta', 'Africa/Conakry', 'Africa/Dakar', 'Africa/Dar_es_Salaam', 'Africa/Djibouti', 'Africa/Douala', 'Africa/El_Aaiun', 'Africa/Freetown', 'Africa/Gaborone', 'Africa/Harare', 'Africa/Johannesburg', 'Africa/Kampala', 'Africa/Khartoum', 'Africa/Kigali', 'Africa/Kinshasa', 'Africa/Lagos', 'Africa/Libreville', 'Africa/Lome', 'Africa/Luanda', 'Africa/Lubumbashi', 'Africa/Lusaka', 'Africa/Malabo', 'Africa/Maputo', 'Africa/Maseru', 'Africa/Mbabane', 'Africa/Mogadishu', 'Africa/Monrovia', 'Africa/Nairobi', 'Africa/Ndjamena', 'Africa/Niamey', 'Africa/Nouakchott', 'Africa/Ouagadougou', 'Africa/Porto-Novo', 'Africa/Sao_Tome', 'Africa/Tripoli', 'Africa/Tunis', 'Africa/Windhoek', 'America/Adak', 'America/Anchorage', 'America/Anguilla', 'America/Antigua', 'America/Araguaina', 'America/Argentina/Buenos_Aires', 'America/Argentina/Catamarca', 'America/Argentina/Cordoba', 'America/Argentina/Jujuy', 'America/Argentina/La_Rioja', 'America/Argentina/Mendoza', 'America/Argentina/Rio_Gallegos', 'America/Argentina/Salta', 'America/Argentina/San_Juan', 'America/Argentina/San_Luis', 'America/Argentina/Tucuman', 'America/Argentina/Ushuaia', 'America/Aruba', 'America/Asuncion', 'America/Atikokan', 'America/Bahia', 'America/Barbados', 'America/Belem', 'America/Belize', 'America/Blanc-Sablon', 'America/Boa_Vista', 'America/Bogota', 'America/Boise', 'America/Cambridge_Bay', 'America/Campo_Grande', 'America/Cancun', 'America/Caracas', 'America/Cayenne', 'America/Cayman', 'America/Chicago', 'America/Chihuahua', 'America/Costa_Rica', 'America/Cuiaba', 'America/Curacao', 'America/Danmarkshavn', 'America/Dawson', 'America/Dawson_Creek', 'America/Denver', 'America/Detroit', 'America/Dominica', 'America/Edmonton', 'America/Eirunepe', 'America/El_Salvador', 'America/Fortaleza', 'America/Glace_Bay', 'America/Godthab', 'America/Goose_Bay', 'America/Grand_Turk', 'America/Grenada', 'America/Guadeloupe', 'America/Guatemala', 'America/Guayaquil', 'America/Guyana', 'America/Halifax', 'America/Havana', 'America/Hermosillo', 'America/Indiana/Indianapolis', 'America/Indiana/Knox', 'America/Indiana/Marengo', 'America/Indiana/Petersburg', 'America/Indiana/Tell_City', 'America/Indiana/Vevay', 'America/Indiana/Vincennes', 'America/Indiana/Winamac', 'America/Inuvik', 'America/Iqaluit', 'America/Jamaica', 'America/Juneau', 'America/Kentucky/Louisville', 'America/Kentucky/Monticello', 'America/La_Paz', 'America/Lima', 'America/Los_Angeles', 'America/Maceio', 'America/Managua', 'America/Manaus', 'America/Marigot', 'America/Martinique', 'America/Mazatlan', 'America/Menominee', 'America/Merida', 'America/Mexico_City', 'America/Miquelon', 'America/Moncton', 'America/Monterrey', 'America/Montevideo', 'America/Montreal', 'America/Montserrat', 'America/Nassau', 'America/New_York', 'America/Nipigon', 'America/Nome', 'America/Noronha', 'America/North_Dakota/Center', 'America/North_Dakota/New_Salem', 'America/Panama', 'America/Pangnirtung', 'America/Paramaribo', 'America/Phoenix', 'America/Port-au-Prince', 'America/Port_of_Spain', 'America/Porto_Velho', 'America/Puerto_Rico', 'America/Rainy_River', 'America/Rankin_Inlet', 'America/Recife', 'America/Regina', 'America/Resolute', 'America/Rio_Branco', 'America/Santarem', 'America/Santiago', 'America/Santo_Domingo', 'America/Sao_Paulo', 'America/Scoresbysund', 'America/Shiprock', 'America/St_Barthelemy', 'America/St_Johns', 'America/St_Kitts', 'America/St_Lucia', 'America/St_Thomas', 'America/St_Vincent', 'America/Swift_Current', 'America/Tegucigalpa', 'America/Thule', 'America/Thunder_Bay', 'America/Tijuana', 'America/Toronto', 'America/Tortola', 'America/Vancouver', 'America/Whitehorse', 'America/Winnipeg', 'America/Yakutat', 'America/Yellowknife', 'Antarctica/Casey', 'Antarctica/Davis', 'Antarctica/DumontDUrville', 'Antarctica/Mawson', 'Antarctica/McMurdo', 'Antarctica/Palmer', 'Antarctica/Rothera', 'Antarctica/South_Pole', 'Antarctica/Syowa', 'Antarctica/Vostok', 'Arctic/Longyearbyen', 'Asia/Aden', 'Asia/Almaty', 'Asia/Amman', 'Asia/Anadyr', 'Asia/Aqtau', 'Asia/Aqtobe', 'Asia/Ashgabat', 'Asia/Baghdad', 'Asia/Bahrain', 'Asia/Baku', 'Asia/Bangkok', 'Asia/Beirut', 'Asia/Bishkek', 'Asia/Brunei', 'Asia/Choibalsan', 'Asia/Chongqing', 'Asia/Colombo', 'Asia/Damascus', 'Asia/Dhaka', 'Asia/Dili', 'Asia/Dubai', 'Asia/Dushanbe', 'Asia/Gaza', 'Asia/Harbin', 'Asia/Ho_Chi_Minh', 'Asia/Hong_Kong', 'Asia/Hovd', 'Asia/Irkutsk', 'Asia/Jakarta', 'Asia/Jayapura', 'Asia/Jerusalem', 'Asia/Kabul', 'Asia/Kamchatka', 'Asia/Karachi', 'Asia/Kashgar', 'Asia/Kathmandu', 'Asia/Kolkata', 'Asia/Krasnoyarsk', 'Asia/Kuala_Lumpur', 'Asia/Kuching', 'Asia/Kuwait', 'Asia/Macau', 'Asia/Magadan', 'Asia/Makassar', 'Asia/Manila', 'Asia/Muscat', 'Asia/Nicosia', 'Asia/Novosibirsk', 'Asia/Omsk', 'Asia/Oral', 'Asia/Phnom_Penh', 'Asia/Pontianak', 'Asia/Pyongyang', 'Asia/Qatar', 'Asia/Qyzylorda', 'Asia/Rangoon', 'Asia/Riyadh', 'Asia/Sakhalin', 'Asia/Samarkand', 'Asia/Seoul', 'Asia/Shanghai', 'Asia/Singapore', 'Asia/Taipei', 'Asia/Tashkent', 'Asia/Tbilisi', 'Asia/Tehran', 'Asia/Thimphu', 'Asia/Tokyo', 'Asia/Ulaanbaatar', 'Asia/Urumqi', 'Asia/Vientiane', 'Asia/Vladivostok', 'Asia/Yakutsk', 'Asia/Yekaterinburg', 'Asia/Yerevan', 'Atlantic/Azores', 'Atlantic/Bermuda', 'Atlantic/Canary', 'Atlantic/Cape_Verde', 'Atlantic/Faroe', 'Atlantic/Madeira', 'Atlantic/Reykjavik', 'Atlantic/South_Georgia', 'Atlantic/St_Helena', 'Atlantic/Stanley', 'Australia/Adelaide', 'Australia/Brisbane', 'Australia/Broken_Hill', 'Australia/Currie', 'Australia/Darwin', 'Australia/Eucla', 'Australia/Hobart', 'Australia/Lindeman', 'Australia/Lord_Howe', 'Australia/Melbourne', 'Australia/Perth', 'Australia/Sydney', 'Europe/Amsterdam', 'Europe/Andorra', 'Europe/Athens', 'Europe/Belgrade', 'Europe/Berlin', 'Europe/Bratislava', 'Europe/Brussels', 'Europe/Bucharest', 'Europe/Budapest', 'Europe/Chisinau', 'Europe/Copenhagen', 'Europe/Dublin', 'Europe/Gibraltar', 'Europe/Guernsey', 'Europe/Helsinki', 'Europe/Isle_of_Man', 'Europe/Istanbul', 'Europe/Jersey', 'Europe/Kaliningrad', 'Europe/Kiev', 'Europe/Lisbon', 'Europe/Ljubljana', 'Europe/London', 'Europe/Luxembourg', 'Europe/Madrid', 'Europe/Malta', 'Europe/Mariehamn', 'Europe/Minsk', 'Europe/Monaco', 'Europe/Moscow', 'Europe/Oslo', 'Europe/Paris', 'Europe/Podgorica', 'Europe/Prague', 'Europe/Riga', 'Europe/Rome', 'Europe/Samara', 'Europe/San_Marino', 'Europe/Sarajevo', 'Europe/Simferopol', 'Europe/Skopje', 'Europe/Sofia', 'Europe/Stockholm', 'Europe/Tallinn', 'Europe/Tirane', 'Europe/Uzhgorod', 'Europe/Vaduz', 'Europe/Vatican', 'Europe/Vienna', 'Europe/Vilnius', 'Europe/Volgograd', 'Europe/Warsaw', 'Europe/Zagreb', 'Europe/Zaporozhye', 'Europe/Zurich', 'Indian/Antananarivo', 'Indian/Chagos', 'Indian/Christmas', 'Indian/Cocos', 'Indian/Comoro', 'Indian/Kerguelen', 'Indian/Mahe', 'Indian/Maldives', 'Indian/Mauritius', 'Indian/Mayotte', 'Indian/Reunion', 'Pacific/Apia', 'Pacific/Auckland', 'Pacific/Chatham', 'Pacific/Easter', 'Pacific/Efate', 'Pacific/Enderbury', 'Pacific/Fakaofo', 'Pacific/Fiji', 'Pacific/Funafuti', 'Pacific/Galapagos', 'Pacific/Gambier', 'Pacific/Guadalcanal', 'Pacific/Guam', 'Pacific/Honolulu', 'Pacific/Johnston', 'Pacific/Kiritimati', 'Pacific/Kosrae', 'Pacific/Kwajalein', 'Pacific/Majuro', 'Pacific/Marquesas', 'Pacific/Midway', 'Pacific/Nauru', 'Pacific/Niue', 'Pacific/Norfolk', 'Pacific/Noumea', 'Pacific/Pago_Pago', 'Pacific/Palau', 'Pacific/Pitcairn', 'Pacific/Ponape', 'Pacific/Port_Moresby', 'Pacific/Rarotonga', 'Pacific/Saipan', 'Pacific/Tahiti', 'Pacific/Tarawa', 'Pacific/Tongatapu', 'Pacific/Truk', 'Pacific/Wake', 'Pacific/Wallis', 'UTC') ;

		return $timezones ;
	}

	FUNCTION Util_Hash_Countries()
	{
		$countries = Array( "A1"=>"Anonymous Proxy", "A2"=>"Satellite Provider", "O1"=>"Other Country", "AD"=>"Andorra", "AE"=>"United Arab Emirates", "AF"=>"Afghanistan", "AG"=>"Antigua and Barbuda", "AI"=>"Anguilla", "AL"=>"Albania", "AM"=>"Armenia", "AN"=>"Netherlands Antilles", "AO"=>"Angola", "AP"=>"Asia/Pacific Region", "AQ"=>"Antarctica", "AR"=>"Argentina", "AS"=>"American Samoa", "AT"=>"Austria", "AU"=>"Australia", "AW"=>"Aruba", "AX"=>"Aland Islands", "AZ"=>"Azerbaijan", "BA"=>"Bosnia and Herzegovina", "BB"=>"Barbados", "BD"=>"Bangladesh", "BE"=>"Belgium", "BF"=>"Burkina Faso", "BG"=>"Bulgaria", "BH"=>"Bahrain", "BI"=>"Burundi", "BJ"=>"Benin", "BL"=>"Saint Bartelemey", "BM"=>"Bermuda", "BN"=>"Brunei Darussalam", "BO"=>"Bolivia", "BR"=>"Brazil", "BS"=>"Bahamas", "BT"=>"Bhutan", "BV"=>"Bouvet Island", "BW"=>"Botswana", "BY"=>"Belarus", "BZ"=>"Belize", "CA"=>"Canada", "CC"=>"Cocos (Keeling) Islands", "CD"=>"Congo", "CF"=>"Central African Republic", "CG"=>"Congo", "CH"=>"Switzerland", "CI"=>"Cote d'Ivoire", "CK"=>"Cook Islands", "CL"=>"Chile", "CM"=>"Cameroon", "CN"=>"China", "CO"=>"Colombia", "CR"=>"Costa Rica", "CU"=>"Cuba", "CV"=>"Cape Verde", "CW"=>"Curacao", "CX"=>"Christmas Island", "CY"=>"Cyprus", "CZ"=>"Czech Republic", "DE"=>"Germany", "DJ"=>"Djibouti", "DK"=>"Denmark", "DM"=>"Dominica", "DO"=>"Dominican Republic", "DZ"=>"Algeria", "EC"=>"Ecuador", "EE"=>"Estonia", "EG"=>"Egypt", "EH"=>"Western Sahara", "ER"=>"Eritrea", "ES"=>"Spain", "ET"=>"Ethiopia", "EU"=>"Europe", "FI"=>"Finland", "FJ"=>"Fiji", "FK"=>"Falkland Islands (Malvinas)", "FM"=>"Micronesia", "FO"=>"Faroe Islands", "FR"=>"France", "FX"=>"France", "GA"=>"Gabon", "GB"=>"United Kingdom", "GD"=>"Grenada", "GE"=>"Georgia", "GF"=>"French Guiana", "GG"=>"Guernsey", "GH"=>"Ghana", "GI"=>"Gibraltar", "GL"=>"Greenland", "GM"=>"Gambia", "GN"=>"Guinea", "GP"=>"Guadeloupe", "GQ"=>"Equatorial Guinea", "GR"=>"Greece", "GS"=>"South Georgia and the South Sandwich Islands", "GT"=>"Guatemala", "GU"=>"Guam", "GW"=>"Guinea-Bissau", "GY"=>"Guyana", "HK"=>"Hong Kong", "HM"=>"Heard Island and McDonald Islands", "HN"=>"Honduras", "HR"=>"Croatia", "HT"=>"Haiti", "HU"=>"Hungary", "ID"=>"Indonesia", "IE"=>"Ireland", "IL"=>"Israel", "IM"=>"Isle of Man", "IN"=>"India", "IO"=>"British Indian Ocean Territory", "IQ"=>"Iraq", "IR"=>"Iran", "IS"=>"Iceland", "IT"=>"Italy", "JE"=>"Jersey", "JM"=>"Jamaica", "JO"=>"Jordan", "JP"=>"Japan", "KE"=>"Kenya", "KG"=>"Kyrgyzstan", "KH"=>"Cambodia", "KI"=>"Kiribati", "KM"=>"Comoros", "KN"=>"Saint Kitts and Nevis", "KP"=>"Korea", "KR"=>"Korea", "KW"=>"Kuwait", "KY"=>"Cayman Islands", "KZ"=>"Kazakhstan", "LA"=>"Lao People's Democratic Republic", "LB"=>"Lebanon", "LC"=>"Saint Lucia", "LI"=>"Liechtenstein", "LK"=>"Sri Lanka", "LR"=>"Liberia", "LS"=>"Lesotho", "LT"=>"Lithuania", "LU"=>"Luxembourg", "LV"=>"Latvia", "LY"=>"Libyan Arab Jamahiriya", "MA"=>"Morocco", "MC"=>"Monaco", "MD"=>"Moldova", "ME"=>"Montenegro", "MF"=>"Saint Martin", "MG"=>"Madagascar", "MH"=>"Marshall Islands", "MK"=>"Macedonia", "ML"=>"Mali", "MM"=>"Myanmar", "MN"=>"Mongolia", "MO"=>"Macao", "MP"=>"Northern Mariana Islands", "MQ"=>"Martinique", "MR"=>"Mauritania", "MS"=>"Montserrat", "MT"=>"Malta", "MU"=>"Mauritius", "MV"=>"Maldives", "MW"=>"Malawi", "MX"=>"Mexico", "MY"=>"Malaysia", "MZ"=>"Mozambique", "NA"=>"Namibia", "NC"=>"New Caledonia", "NE"=>"Niger", "NF"=>"Norfolk Island", "NG"=>"Nigeria", "NI"=>"Nicaragua", "NL"=>"Netherlands", "NO"=>"Norway", "NP"=>"Nepal", "NR"=>"Nauru", "NU"=>"Niue", "NZ"=>"New Zealand", "OM"=>"Oman", "PA"=>"Panama", "PE"=>"Peru", "PF"=>"French Polynesia", "PG"=>"Papua New Guinea", "PH"=>"Philippines", "PK"=>"Pakistan", "PL"=>"Poland", "PM"=>"Saint Pierre and Miquelon", "PN"=>"Pitcairn", "PR"=>"Puerto Rico", "PS"=>"Palestinian Territory", "PT"=>"Portugal", "PW"=>"Palau", "PY"=>"Paraguay", "QA"=>"Qatar", "RE"=>"Reunion", "RO"=>"Romania", "RS"=>"Serbia", "RU"=>"Russian Federation", "RW"=>"Rwanda", "SA"=>"Saudi Arabia", "SB"=>"Solomon Islands", "SC"=>"Seychelles", "SD"=>"Sudan", "SE"=>"Sweden", "SG"=>"Singapore", "SH"=>"Saint Helena", "SI"=>"Slovenia", "SJ"=>"Svalbard and Jan Mayen", "SK"=>"Slovakia", "SL"=>"Sierra Leone", "SM"=>"San Marino", "SN"=>"Senegal", "SO"=>"Somalia", "SR"=>"Suriname", "ST"=>"Sao Tome and Principe", "SV"=>"El Salvador", "SY"=>"Syrian Arab Republic", "SZ"=>"Swaziland", "TC"=>"Turks and Caicos Islands", "TD"=>"Chad", "TF"=>"French Southern Territories", "TG"=>"Togo", "TH"=>"Thailand", "TJ"=>"Tajikistan", "TK"=>"Tokelau", "TL"=>"Timor-Leste", "TM"=>"Turkmenistan", "TN"=>"Tunisia", "TO"=>"Tonga", "TR"=>"Turkey", "TT"=>"Trinidad and Tobago", "TV"=>"Tuvalu", "TW"=>"Taiwan", "TZ"=>"Tanzania", "UA"=>"Ukraine", "UG"=>"Uganda", "UM"=>"United States Minor Outlying Islands", "US"=>"United States", "UY"=>"Uruguay", "UZ"=>"Uzbekistan", "VA"=>"Holy See (Vatican City State)", "VC"=>"Saint Vincent and the Grenadines", "VE"=>"Venezuela", "VG"=>"Virgin Islands", "VI"=>"Virgin Islands", "VN"=>"Vietnam", "VU"=>"Vanuatu", "WF"=>"Wallis and Futuna", "WS"=>"Samoa", "YE"=>"Yemen", "YT"=>"Mayotte", "ZA"=>"South Africa", "ZM"=>"Zambia", "ZW"=>"Zimbabwe", "LS"=>"Lesotho", "SZ"=>"Swaziland", "SC"=>"Seychelles", "ATG"=>"Antigua and Barbuda", "YU"=>"Yugoslavia", "TP"=>"Timor-Leste", "unknown"=>"unknown" ) ;

		return $countries ;
	}
?>